/**
 *
 * THIS SOFTWARE IS THE PROPRIETARY AND CONFIDENTIAL PROPERTY OF STUART HEINRICH
 * CONTACT: sbheinric@gmail.com
 *
 * This notice is intended as a precaution against inadvertent
 * publication and does not constitute an admission or acknowledgement
 * that publication has occurred or constitute a waiver of
 * confidentiality.
 *
 * @copyright (C) 2011 Stuart Heinrich. All Rights Reserved.
 *
 */
 
#pragma once
#pragma once
#pragma once
#pragma once
#pragma once
#define _USE_MATH_DEFINES
#pragma once
#include<cmath>
#ifndef WIN32
#define __forceinline __attribute__((always_inline))
#endif
namespace heinlib
{
template<typename T>
struct constants
{
static __forceinline T sqrt_2(){return sqrt(T(2));}
static __forceinline T e(){return(T)2.71828182845904523536;}
static __forceinline T pi(){return(T)3.14159265358979323846264338327;}
static __forceinline T two_pi(){return T(2*3.14159265358979323846264338327);}
static __forceinline T sqrt_two_pi(){return T(sqrt(2*3.14159265358979323846264338327));}
static __forceinline T sqrt_half_pi(){return T(sqrt(0.5*3.14159265358979323846264338327));}
static __forceinline T half_pi(){return T(3.14159265358979323846264338327/2);}
static __forceinline T golden_ratio(){return(T)1.6180339887498948482;}
static __forceinline T euler_gamma(){return(T)0.5772156649015328606065120;}
static __forceinline T rad_to_deg(){return 180/constants<T>::pi();}
static __forceinline T deg_to_rad(){return constants<T>::pi()/180;}
};
}
#pragma once
#include<climits>
#include<iterator>
#ifdef _WIN32
#include<cstdint>
#else
#include<stdint.h>
#endif
namespace heinlib
{
template<bool a,bool b>
struct both{
enum{value=0};
};
template<>
struct both<true,true>{
enum{value=1};
};
template<void*A,void*B>struct is_same_ptr{enum{value=0};};
template<void*A>struct is_same_ptr<A,A>{enum{value=1};};
template<unsigned A,unsigned B>struct is_same_value{enum{value=0};};
template<unsigned A>struct is_same_value<A,A>{enum{value=1};};
template<typename T,typename U>struct is_same_type{enum{value=0};};
template<typename T>struct is_same_type<T,T>{enum{value=1};};
template<class A,class B,class C>struct is_same_types{enum{value=0};};
template<class A>struct is_same_types<A,A,A>{enum{value=1};};
template<typename T>struct is_pointer{enum{value=0};};
template<typename T>struct is_pointer<T*>{enum{value=1};};
template<typename T>struct is_const_pointer{enum{value=0};};
template<typename T>struct is_const_pointer<const T*>{enum{value=1};};
template<typename T>struct is_non_const_pointer{enum{value=0};};
template<typename T>struct is_non_const_pointer<const T*>{enum{value=0};};
template<typename T>struct is_non_const_pointer<T*>{enum{value=1};};
namespace detail
{
template<typename T>
long is_iter_helper(typename T::iterator_category*);
template<typename T>
char is_iter_helper(...);
}
template<typename T>
struct is_iter{
enum{value=sizeof(detail::is_iter_helper<T>(0))==sizeof(long)};
};
template<typename T,bool ITER=is_iter<T>::value>
struct is_const_iter{
enum{value=is_const_pointer<typename T::pointer>::value};
};
template<typename T>
struct is_const_iter<T,false>{
enum{value=0};
};
template<typename T,bool ITER=is_iter<T>::value>
struct is_non_const_iter{
enum{value=!is_const_pointer<typename T::pointer>::value};
};
template<typename T>
struct is_non_const_iter<T,false>{
enum{value=0};
};
template<typename T,bool ITER=is_iter<T>::value>
struct is_random_access_iter{
enum{value=(is_same_type<typename T::iterator_category,std::random_access_iterator_tag>::value)};
};
template<typename T>
struct is_random_access_iter<T,false>{
enum{value=0};
};
template<typename T>struct is_basic_type{enum{value=0};};
template<>struct is_basic_type<float>{enum{value=1};};
template<>struct is_basic_type<double>{enum{value=1};};
template<>struct is_basic_type<long double>{enum{value=1};};
template<>struct is_basic_type<bool>{enum{value=1};};
template<>struct is_basic_type<char>{enum{value=1};};
template<>struct is_basic_type<signed char>{enum{value=1};};
template<>struct is_basic_type<signed short>{enum{value=1};};
template<>struct is_basic_type<signed int>{enum{value=1};};
template<>struct is_basic_type<signed long>{enum{value=1};};
template<>struct is_basic_type<signed long long>{enum{value=1};};
template<>struct is_basic_type<unsigned char>{enum{value=1};};
template<>struct is_basic_type<unsigned short>{enum{value=1};};
template<>struct is_basic_type<unsigned int>{enum{value=1};};
template<>struct is_basic_type<unsigned long>{enum{value=1};};
template<>struct is_basic_type<unsigned long long>{enum{value=1};};
template<typename T>struct is_floating{enum{value=0};};
template<>struct is_floating<float>{enum{value=1};};
template<>struct is_floating<double>{enum{value=1};};
template<>struct is_floating<long double>{enum{value=1};};
template<typename T>struct is_integral{enum{value=0};};
template<>struct is_integral<bool>{enum{value=1};};
template<>struct is_integral<char>{enum{value=1};};
template<>struct is_integral<signed char>{enum{value=1};};
template<>struct is_integral<signed short>{enum{value=1};};
template<>struct is_integral<signed int>{enum{value=1};};
template<>struct is_integral<signed long>{enum{value=1};};
template<>struct is_integral<signed long long>{enum{value=1};};
template<>struct is_integral<unsigned char>{enum{value=1};};
template<>struct is_integral<unsigned short>{enum{value=1};};
template<>struct is_integral<unsigned int>{enum{value=1};};
template<>struct is_integral<unsigned long>{enum{value=1};};
template<>struct is_integral<unsigned long long>{enum{value=1};};
template<typename T>struct is_signed{enum{value=0};};
template<>struct is_signed<signed char>{enum{value=1};};
template<>struct is_signed<signed short>{enum{value=1};};
template<>struct is_signed<signed int>{enum{value=1};};
template<>struct is_signed<signed long>{enum{value=1};};
template<>struct is_signed<long long>{enum{value=1};};
template<typename T>struct is_unsigned{enum{value=0};};
template<>struct is_unsigned<bool>{enum{value=1};};
template<>struct is_unsigned<unsigned char>{enum{value=1};};
template<>struct is_unsigned<unsigned short>{enum{value=1};};
template<>struct is_unsigned<unsigned int>{enum{value=1};};
template<>struct is_unsigned<unsigned long>{enum{value=1};};
template<>struct is_unsigned<unsigned long long>{enum{value=1};};
#if CHAR_MAX==SCHAR_MAX
template<>struct is_signed<char>{enum{value=1};};
template<>struct is_unsigned<char>{enum{value=0};};
#else
template<>struct is_signed<char>{enum{value=0};};
template<>struct is_unsigned<char>{enum{value=1};};
#endif
template<typename T>struct get_larger_type{};
template<>struct get_larger_type<float>{typedef double type;};
template<>struct get_larger_type<double>{typedef long double type;};
template<>struct get_larger_type<bool>{typedef uint8_t type;};
template<>struct get_larger_type<uint8_t>{typedef uint16_t type;};
template<>struct get_larger_type<uint16_t>{typedef uint32_t type;};
template<>struct get_larger_type<uint32_t>{typedef uint64_t type;};
template<>struct get_larger_type<char>{typedef int16_t type;};
template<>struct get_larger_type<int8_t>{typedef int16_t type;};
template<>struct get_larger_type<int16_t>{typedef int32_t type;};
template<>struct get_larger_type<int32_t>{typedef int64_t type;};
}
#pragma once
namespace heinlib
{
template<bool B,class T=void>
struct enable_if_c{
typedef T type;
};
template<class T>
struct enable_if_c<false,T>{};
template<class Cond,class T=void>
struct enable_if:public enable_if_c<Cond::value,T>{};
template<bool B,class T=void>
struct disable_if_c{
typedef T type;
};
template<class T>
struct disable_if_c<true,T>{};
template<class Cond,class T=void>
struct disable_if:public disable_if_c<Cond::value,T>{};
}
#pragma once
#include<cmath>
#include<iostream>
#include<cassert>
namespace heinlib
{
#ifdef WIN32
#ifndef _WIN64
__forceinline __declspec(naked)
unsigned __fastcall next_power2(unsigned n){
__asm{
dec ecx
mov eax,1
bsr ecx,ecx
inc ecx
shl eax,cl
ret
}
}
#endif
#else
__forceinline
unsigned next_power2(unsigned n)
{
unsigned result=1;
while(result<n)result<<=1;
return result;
}
#endif
__forceinline bool is_power2(unsigned x)
{
if(x==0)return false;
return((x&(x-1))==0);
}
unsigned power2(unsigned p)
{
assert(p<8*sizeof(unsigned));
unsigned res=1;
res<<=p;
return res;
}
using::pow;
template<typename Int>
typename enable_if<is_integral<Int>,Int>::type
pow(Int base,Int e)
{
Int result=1;
while(e)
{
if(e&1)
result*=base;
e>>=1;
base*=base;
}
return result;
}
template<unsigned N,typename T=float>
struct ipow
{
static T eval(T x)
{
return ipow<N-1,T>::eval(x)*x;
}
};
template<typename T>struct ipow<1,T>
{
static T eval(T x)
{return x;}
};
template<typename T>struct ipow<0,T>
{
static T eval(T x)
{return 1;}
};
#define POW(a,b)POWF((a),(b))
#define POWF(a,b)ipow<(b),float>::eval(a)
#define POWD(a,b)ipow<(b),double>::eval(a)
}
#include<cmath>
#include<algorithm>
#include<limits>
#include<cassert>
#define HEINLIB_DEPRECATED_FUNC"function is deprecated in heinlib"
namespace heinlib
{
using::sqrt;
using::floor;
using::ceil;
using::log;
template<class T>
T safe_sqrt(T x)
{
if(x<=0)return 0;
return sqrt(x);
}
template<typename T>
typename enable_if<is_integral<T>,bool>::type
even(T x){return(x%2==0);}
template<typename T>
typename enable_if<is_integral<T>,bool>::type
odd(T x){return(x%2!=0);}
template<typename T>
typename enable_if<is_integral<T>,float>::type
sqrt(T x){return sqrt((float)x);}
template<typename T>
typename enable_if<is_integral<T>,float>::type
floor(T x){return floor((float)x);}
template<typename T>
typename enable_if<is_integral<T>,float>::type
ceil(T x){return ceil((float)x);}
template<typename T>
__forceinline T saturate(T x,T minr=0,T maxr=1)
{
if(x<minr)return minr;
if(x>maxr)return maxr;
return x;
}
template<typename T>
__forceinline typename enable_if<is_floating<T>,T>::type
abs(T x)
{
return::fabs(x);
}
template<typename T>
__forceinline typename enable_if<is_integral<T>,T>::type
abs(T x)
{
return::abs(x);
}
template<typename T>
__forceinline typename enable_if<is_floating<T>,T>::type
wrap(T x)
{
T discard;
x=modf(x,&discard);
if(x<0)return x+1;
else return x;
}
#ifdef WIN32
template<typename T>
__forceinline typename enable_if<is_basic_type<T>,T>::type
hypot(T a,T b)
{
return(T)_hypot((double)a,(double)b);
}
template<typename T>
__forceinline typename disable_if<is_basic_type<T>,T>::type
hypot(const T&a,const T&b)
{
return sqrt(a*a+b*b);
}
#else
template<typename T>
__forceinline T hypot(T a,T b)
{
return sqrt(a*a+b*b);
}
#endif
template<typename T>
__forceinline T ln(const T&x)
{return log(x);}
template<typename T>
__forceinline T lg(const T&x)
{return log2(x);}
template<typename T>
__forceinline T log(const T&x,const T&base)
{return log(x)/log(base);}
template<typename T>
__forceinline typename disable_if<is_integral<T>,T>::type
log2(const T&x)
{return log(x,T(2));}
template<typename T>
__forceinline typename enable_if<is_integral<T>,T>::type
log2(T x)
{
T r=0;
while(x>>=1)++r;
return r;
}
template<class Real>
__forceinline Real cot(Real x)
{
return tan(constants<Real>::half_pi()-x);
}
template<class Real>
__forceinline Real sec(Real x)
{
return 1/cos(x);
}
template<class Real>
__forceinline Real csc(Real x)
{
return 1/sin(x);
}
template<class Real>
__forceinline Real acot(Real x)
{
if(x<0)return-acot(-x);
return constants<Real>::half_pi()-atan(x);
}
template<typename T>
__forceinline T lerp(T x,T x0,T x1,T y0,T y1)
{
return y0+(x-x0)*(y1-y0)/(x1-x0);
}
template<typename T>
__forceinline T det2(T a,T b,T c,T d)
{
return a*d-b*c;
}
template<typename T>
__forceinline typename enable_if<is_unsigned<T>,T>::type
digits(T x)
{
T d=0;
while(x>0)
{
x/=10;
++d;
}
return d;
}
template<typename T>
__forceinline typename enable_if<is_signed<T>,T>::type
digits(T x)
{
T d=(x<0);
while(x>0)
{
x/=10;
++d;
}
return d;
}
template<typename T>
__forceinline typename enable_if<is_integral<T>,T>::type
idivup(T a,T b){
return(a+b-1)/b;
}
template<typename T>
__forceinline typename enable_if<is_integral<T>,T>::type
mod(T a,T b)
{
return((a>=0)?a%b:a+idivup(-a,b)*b);
}
template<typename T>
__forceinline typename enable_if<is_integral<T>,T>::type
gcd(T a,T b)
{
if(a==b)return a;
return(b==0)?a:gcd(b,mod(a,b));
}
#undef min
#undef max
using std::min;
template<typename T>
T min(const T&a,const T&b,const T&c)
{
return std::min(std::min(a,b),c);
}
using std::max;
template<typename T>
__forceinline T max(const T&a,const T&b,const T&c)
{
return std::max(std::max(a,b),c);
}
template<typename T>
__forceinline const T&min_mag(const T&a,const T&b)
{
return(abs(a)<abs(b)?a:b);
}
template<typename T>
__forceinline const T&min_mag(const T&a,const T&b,const T&c)
{
T abs_a=abs(a),abs_b=abs(b),abs_c=abs(c);
if(abs_a<abs_b)
{
if(abs_a<abs_c)
return a;
return c;
}else if(abs_b<abs_c)
return b;
return c;
}
template<typename T>
__forceinline typename enable_if<is_floating<T>,int>::type
round(T x){
return(int)(x<0?x-T(0.5):x+T(0.5));
};
template<typename T>
__forceinline typename disable_if<is_floating<T>,T>::type
round(T x){return x;};
template<typename T>
__forceinline T relative_difference(T a,T b)
{
return abs(a-b)/std::max(abs(a),abs(b));
}
template<typename T>
__forceinline int sign(T x)
{
if(x==0)return 0;
else return(x>0)?1:-1;
}
template<class T>
__forceinline T sign(T a,T b)
{
return(b>0)?abs(a):-abs(a);
}
template<typename T>
__forceinline int sign2(T x)
{
return(x>=0)?1:-1;
}
template<typename T>__forceinline T sq(T x){return x*x;}
template<typename T>__forceinline T cube(T x){return x*x*x;}
template<typename T>__forceinline bool same_sign(T x,T y)
{
return(fabs(x+y)>=fabs(x-y));
}
template<typename T>__forceinline T sigmoid(T x)
{return T(1/(1+exp(-x)));}
template<typename T>
__forceinline T sigmoid(T x,T sat,T center,T minv,T maxv)
{
return(maxv-minv)/(1+exp(-constants<T>::two_pi()*(x-center)/sat))+minv;
}
template<typename Real>
__forceinline Real gauss(Real x,Real sigma,Real norm)
{
return norm*exp(-Real(0.5f)*sq(x/sigma));
}
template<typename T>
__forceinline T Gaussian2D(T x,T y,T mean_x,T mean_y,T sigma_x,T sigma_y,T amp)
{
return amp*exp(-(sq((x-mean_x)/(2*sigma_x))+sq((y-mean_y)/(2*sigma_y))));
}
template<typename T>
__forceinline T NormalDistrib(T x,T mean,T sigma)
{
T norm=1/(sigma*sqrt(constants<T>::two_pi()));
return Gaussian(x,sigma,norm,mean);
}
template<typename T>
__forceinline typename enable_if<is_floating<T>,bool>::type
not_corrupt(T x)
{
return(x>-std::numeric_limits<T>::infinity()&&
x<std::numeric_limits<T>::infinity());
}
template<typename T>
__forceinline typename disable_if<is_floating<T>,bool>::type
not_corrupt(T x)
{
return true;
}
template<typename T>
__forceinline typename enable_if<is_basic_type<T>,bool>::type
corrupt(T x){return!not_corrupt(x);}
template<typename T>
__forceinline T angle_dist(T a,T b)
{return acos(cos(a)*cos(b)+sin(a)*sin(b));}
template<typename Real>
__forceinline Real angle_dist_flip(Real r1,Real r2)
{
using namespace heinlib;
static const Real H_PI=constants<Real>::half_pi(),PI=constants<Real>::pi();
return fabs(fabs(fmod(r1-r2+H_PI,PI))-H_PI);
}
template<class T>
__forceinline T mid_angle(T a,T b)
{
T half_dist=angle_dist(a,b)/2;
T opt1=a+half_dist;
T opt2=a-half_dist;
if(angle_dist(opt1,b)<angle_dist(opt2,b))
return opt1;
else return opt2;
}
template<typename Real>
__forceinline typename enable_if<is_floating<Real>,Real>::type
std_radian(Real r)
{
static const Real TWO_PI=constants<Real>::two_pi();
if(r<0)return TWO_PI-fmod(-r,TWO_PI);
else return fmod(r,TWO_PI);
}
template<typename Unsigned>
typename enable_if<is_unsigned<Unsigned>,Unsigned>::type
absdiff(Unsigned a,Unsigned b)
{
if(a>=b)return a-b;
else return b-a;
}
template<typename Signed>
typename disable_if<is_unsigned<Signed>,Signed>::type
absdiff(Signed a,Signed b)
{
return abs(a-b);
}
}
#pragma once
#include<iomanip>
#ifndef NO_SSE
#include<xmmintrin.h>
#endif
#include<cstdlib>
#include<cassert>
#include<string>
#include<iostream>
#include<vector>
#pragma once
namespace heinlib
{
template<bool B>
struct heinlib_static_assert{
typedef void STATIC_ASSERTION_FAILED;
};
template<>
struct heinlib_static_assert<false>{};
}
#define STATIC_ASSERT(Cond,ErrorMsg)typedef typename heinlib::heinlib_static_assert<(Cond)>::STATIC_ASSERTION_FAILED ErrorMsg
#pragma once
#pragma once
#ifdef WIN32
#define DEP_INEF __declspec(deprecated(INEFFICIENT_CALL))
#else
#define DEP_INEF __attribute__((deprecated))
#define __forceinline __attribute__((always_inline))
#endif
namespace heinlib
{
template<typename Real>
struct dynamic_matrix;
template<unsigned M,unsigned N,typename Real>
struct static_matrix;
template<typename T>struct is_matrix{enum{value=0};};
template<unsigned M,unsigned N,typename Real>
struct is_matrix<static_matrix<M,N,Real> >{enum{value=1};};
template<typename Real>
struct is_matrix<dynamic_matrix<Real> >{enum{value=1};};
template<typename Matrix>
__forceinline typename enable_if<is_matrix<Matrix>,bool>::type
is_square(const Matrix&in)
{
return(in.rows==in.cols);
}
template<typename Matrix>
__forceinline typename disable_if<is_matrix<Matrix>,bool>::type
is_square(const Matrix&in)
{
return false;
}
template<typename Matrix>
__forceinline typename enable_if<is_matrix<Matrix>,bool>::type
size_is(const Matrix&in,unsigned M,unsigned N)
{
return(in.rows==M&&in.cols==N);
}
template<typename MI,typename MI2>
__forceinline typename enable_if_c<is_matrix<MI>::value&&is_matrix<MI2>::value,bool>::type
same_dim(const MI&in,const MI2&in2)
{
return(in.rows==in2.rows&&in.cols==in2.cols);
}
}
#pragma once
#include<istream>
#include<string>
#ifdef WIN32
#define __GXX_EXPERIMENTAL_CXX0X__
#endif
namespace heinlib
{
inline std::istream&getline(
#ifdef __GXX_EXPERIMENTAL_CXX0X__
std::istream&&_Istr,
#else
std::istream&_Istr,
#endif
std::string&_Str,
std::string _Delim)
{
using namespace std;
typedef std::istream _Myis;
typedef std::istream::traits_type _Traits;
ios_base::iostate _State=ios_base::goodbit;
bool _Changed=false;
const _Myis::sentry _Ok(_Istr,true);
if(_Ok)
{
try
{
_Str.erase();
_Istr.rdbuf()->sgetc();
_Traits::int_type _Meta=_Istr.rdbuf()->sgetc();
for(;;_Meta=_Istr.rdbuf()->snextc())
if(_Traits::eq_int_type(_Traits::eof(),_Meta))
{
_State|=ios_base::eofbit;
break;
}
else if(_Delim.find(_Meta)!=string::npos)
{
_Changed=true;
_Istr.rdbuf()->sbumpc();
break;
}
else if(_Str.max_size()<=_Str.size())
{
_State|=ios_base::failbit;
break;
}
else
{
_Str+=_Traits::to_char_type(_Meta);
_Changed=true;
}
}catch(...){
_Istr.setstate(ios_base::badbit);
}
}
if(!_Changed)
_State|=ios_base::failbit;
_Istr.setstate(_State);
return(_Istr);
}
#ifdef __GXX_EXPERIMENTAL_CXX0X__
inline std::istream&getline(
std::istream&_Istr,
std::string&_Str,
std::string _Delim)
{
return heinlib::getline(std::move(_Istr),_Str,_Delim);
}
#endif
}
#pragma once
#include<sstream>
#include<cstdlib>
#include<stdexcept>
#include<typeinfo>
namespace heinlib
{
template<class T>
__forceinline bool convert(T&out,const std::string&in)
{
std::istringstream iss(in);
iss>>out;
return(iss.eof()&&!iss.fail());
}
template<>
__forceinline bool convert<std::string>(std::string&out,const std::string&in)
{
out=in;
return true;
}
template<class T>
__forceinline T convert(const std::string&in)
{
T out;
if(!convert(out,in))throw std::runtime_error("Cannot convert '"+in+"' to "+typeid(out).name());
return out;
}
template<class T>
__forceinline T convert(const std::string&in,const T default_value)
{
T out;
return convert(out,in)?out:default_value;
}
std::string BytesToHex(char*data,unsigned size)
{
using namespace std;
stringstream ss;
for(unsigned i=0;i<size;++i)
ss<<hex<<uppercase<<unsigned(data[i]);
return ss.str();
}
}
namespace heinlib
{
#pragma region FORWARD_DECLARATIONS
template<typename Real>
struct dynamic_matrix;
template<unsigned M,unsigned N,typename Real>
struct static_matrix;
typedef static_matrix<2,2,float>matrix_2x2f;
typedef static_matrix<2,3,float>matrix_2x3f;
typedef static_matrix<3,3,float>matrix_3x3f;
typedef static_matrix<3,4,float>matrix_3x4f;
typedef static_matrix<4,4,float>matrix_4x4f;
typedef static_matrix<2,2,double>matrix_2x2d;
typedef static_matrix<3,3,double>matrix_3x3d;
typedef static_matrix<3,4,double>matrix_3x4d;
typedef static_matrix<4,4,double>matrix_4x4d;
typedef static_matrix<2,1,unsigned>vector_2u;
typedef static_matrix<3,1,unsigned>vector_3u;
typedef static_matrix<4,1,unsigned>vector_4u;
typedef static_matrix<2,1,int>vector_2i;
typedef static_matrix<3,1,int>vector_3i;
typedef static_matrix<4,1,int>vector_4i;
typedef static_matrix<2,1,float>vector_2f;
typedef static_matrix<3,1,float>vector_3f;
typedef static_matrix<4,1,float>vector_4f;
typedef static_matrix<5,1,float>vector_5f;
typedef static_matrix<6,1,float>vector_6f;
typedef static_matrix<2,1,double>vector_2d;
typedef static_matrix<3,1,double>vector_3d;
typedef static_matrix<4,1,double>vector_4d;
#pragma endregion
#pragma region CLASS_DEFS
template<unsigned M,unsigned N,typename Real>
struct static_matrix
{
static const unsigned rows=M,cols=N;
typedef Real real_type;
Real data[M*N];
Real*ptr()
{
return&data[0];
}
const Real*ptr()const
{
return&data[0];
}
__forceinline unsigned size()const{return M*N;}
__forceinline const Real&x()const{return data[0];}
__forceinline Real&x(){return data[0];}
__forceinline const Real&y()const{return data[1];}
__forceinline Real&y(){return data[1];}
__forceinline const Real&z()const{return data[2];}
__forceinline Real&z(){return data[2];}
__forceinline const Real&w()const{return data[3];}
__forceinline Real&w(){return data[3];}
__forceinline const Real&operator[](unsigned i)const
{
assert(i<M*N);
return data[i];
}
__forceinline Real&operator[](unsigned i)
{
assert(i<M*N);
return data[i];
}
__forceinline const Real&operator()(unsigned row,unsigned col)const
{
assert(row<M);
assert(col<N);
return data[row*N+col];
}
__forceinline Real&operator()(unsigned row,unsigned col)
{
assert(row<M);
assert(col<N);
return data[row*N+col];
}
template<class Real2>
__forceinline
typename enable_if<is_basic_type<Real2>,static_matrix&>::type
operator=(const Real2&val)
{
for(unsigned i=0;i<M*N;++i)
data[i]=(Real)val;
return*this;
}
template<typename Real2>
__forceinline static_matrix&operator=(const dynamic_matrix<Real2>&in)
{
assert(rows*cols==in.rows*in.cols);
for(unsigned i=0;i<M*N;++i)
data[i]=(Real)in[i];
return*this;
}
template<typename Real2>
__forceinline static_matrix&operator=(const static_matrix<M,N,Real2>&in)
{
assert(rows*cols==in.rows*in.cols);
for(unsigned i=0;i<M*N;++i)
data[i]=(Real)in.data[i];
return*this;
}
__forceinline bool operator==(const static_matrix&in)const
{
for(unsigned i=0;i<M*N;++i)
if(data[i]!=in[i])return false;
return true;
}
__forceinline bool operator!=(const static_matrix&in)const
{
for(unsigned i=0;i<M*N;++i)
if(data[i]!=in[i])return true;
return false;
}
__forceinline static_matrix<1,N,Real>get_row(unsigned m)const
{
static_matrix<1,N,Real>ret;
for(unsigned n=0;n<N;++n)
ret[n]=(*this)(m,n);
return ret;
}
__forceinline static_matrix<M,1,Real>get_column(unsigned n)const
{
static_matrix<M,1,Real>ret;
for(unsigned m=0;m<M;++m)
ret[m]=(*this)(m,n);
return ret;
}
template<unsigned M1,unsigned N1,unsigned M2,unsigned N2>
__forceinline static_matrix<M2-M1+1,N2-N1+1,Real>submatrix()const
{
assert(M2>=M1&&N2>=N1);
assert(M2<M&&N2<N);
static_matrix<M2-M1+1,N2-N1+1,Real>ret;
for(unsigned m=M1;m<=M2;++m)
for(unsigned n=N1;n<=N2;++n)
ret(m-M1,n-N1)=(*this)(m,n);
return ret;
}
__forceinline dynamic_matrix<Real>submatrix(unsigned M1,unsigned N1,unsigned M2,unsigned N2)const
{
assert(M2>=M1&&N2>=N1);
assert(M2<M&&N2<N);
dynamic_matrix<Real>ret(M2-M1+1,N2-N1+1);
for(unsigned m=M1;m<=M2;++m)
for(unsigned n=N1;n<=N2;++n)
ret(m-M1,n-N1)=(*this)(m,n);
return ret;
}
template<typename MI>
__forceinline void block_insert(unsigned M1,unsigned N1,const MI&in)
{
assert(M1+in.rows<=rows);
assert(N1+in.cols<=cols);
for(unsigned r=0;r<in.rows;++r)
for(unsigned c=0;c<in.cols;++c)
(*this)(r+M1,c+N1)=in(r,c);
}
template<typename MI>
__forceinline void block_insert_add(unsigned M1,unsigned N1,const MI&in)
{
assert(M1+in.rows<=rows);
assert(N1+in.cols<=cols);
for(unsigned r=0;r<in.rows;++r)
for(unsigned c=0;c<in.cols;++c)
(*this)(r+M1,c+N1)+=in(r,c);
}
template<typename MI>
__forceinline void block_insert(unsigned M1,unsigned N1,unsigned M2,unsigned N2,const MI&in)
{
assert(M1+in.rows-M2<=rows);
assert(N1+in.cols-N2<=cols);
for(unsigned r=M2;r<in.rows;++r)
for(unsigned c=N2;c<in.cols;++c)
(*this)(r-M2+M1,c-N2+N1)=in(r,c);
}
template<unsigned P>
__forceinline static_matrix<M,P,Real>operator*(const static_matrix<N,P,Real>&m)const;
__forceinline static_matrix<M,N,Real>operator+(const static_matrix<M,N,Real>&m)const;
__forceinline static_matrix<M,N,Real>operator-(const static_matrix<M,N,Real>&m)const;
__forceinline static_matrix<M,N,Real>&operator*=(const static_matrix<M,N,Real>&m);
__forceinline static_matrix<M,N,Real>&operator+=(const static_matrix<M,N,Real>&m);
__forceinline static_matrix<M,N,Real>&operator-=(const static_matrix<M,N,Real>&m);
__forceinline static_matrix<M,N,Real>operator%(const static_matrix<M,N,Real>&m)const;
__forceinline dynamic_matrix<Real>operator%(const dynamic_matrix<Real>&m)const;
__forceinline dynamic_matrix<Real>operator*(const dynamic_matrix<Real>&m)const;
__forceinline static_matrix<M,N,Real>operator+(const dynamic_matrix<Real>&m)const;
__forceinline static_matrix<M,N,Real>operator-(const dynamic_matrix<Real>&m)const;
__forceinline static_matrix<M,N,Real>&operator+=(const dynamic_matrix<Real>&m);
__forceinline static_matrix<M,N,Real>&operator-=(const dynamic_matrix<Real>&m);
__forceinline static_matrix<M,N,Real>operator+(Real s)const;
__forceinline static_matrix<M,N,Real>operator-(Real s)const;
__forceinline static_matrix<M,N,Real>operator*(Real s)const;
__forceinline static_matrix<M,N,Real>operator/(Real s)const;
__forceinline static_matrix<M,N,Real>&operator+=(Real s);
__forceinline static_matrix<M,N,Real>&operator-=(Real s);
__forceinline static_matrix<M,N,Real>&operator*=(Real s);
__forceinline static_matrix<M,N,Real>&operator/=(Real s);
};
template<typename Real>
struct dynamic_matrix
{
unsigned rows,cols;
typedef Real real_type;
std::vector<Real>data;
__forceinline unsigned size()const{return rows*cols;}
__forceinline dynamic_matrix():rows(0),cols(0){}
__forceinline dynamic_matrix(unsigned M)
:rows(M),cols(1),data(M){}
__forceinline dynamic_matrix(unsigned M,unsigned N)
:rows(M),cols(N),data(M*N){}
__forceinline dynamic_matrix(const dynamic_matrix<Real>&in)
:rows(in.rows),cols(in.cols),data(in.rows*in.cols)
{
std::copy(in.data.begin(),in.data.end(),data.begin());
}
__forceinline dynamic_matrix(const std::vector<Real>&in)
:rows(in.size()),cols(1),data(in.size())
{
std::copy(in.begin(),in.end(),data.begin());
}
template<unsigned M,unsigned N>
__forceinline dynamic_matrix(const static_matrix<M,N,Real>&in)
:rows(in.rows),cols(in.cols),data(in.rows*in.cols)
{
for(unsigned i=0;i<in.rows*in.cols;++i)
data[i]=in[i];
}
__forceinline void resize(unsigned M,unsigned N)
{
data.resize(M*N);
rows=M;
cols=N;
}
__forceinline void operator=(const dynamic_matrix<Real>&in)
{
resize(in.rows,in.cols);
std::copy(in.data.begin(),in.data.end(),data.begin());
}
template<unsigned M,unsigned N>
__forceinline void operator=(const static_matrix<M,N,Real>&in)
{
resize(in.rows,in.cols);
for(unsigned i=0;i<in.rows*in.cols;++i)
data[i]=in[i];
}
template<typename T>
__forceinline void operator=(const dynamic_matrix<T>&in)
{
resize(in.rows,in.cols);
for(unsigned i=0;i<in.rows*in.cols;++i)
data[i]=(Real)in[i];
}
__forceinline const Real&operator[](unsigned i)const
{
assert(i<rows*cols);
return data[i];
}
__forceinline Real&operator[](unsigned i)
{
assert(i<rows*cols);
return data[i];
}
__forceinline const Real&operator()(unsigned row,unsigned col)const
{
assert(row<rows);
assert(col<cols);
return data[row*cols+col];
}
__forceinline Real&operator()(unsigned row,unsigned col)
{
assert(row<rows);
assert(col<cols);
return data[row*cols+col];
}
__forceinline bool operator==(const dynamic_matrix&in)const
{
if(rows!=in.rows||cols!=in.cols)
return false;
for(unsigned i=0;i<rows*cols;++i)
if(data[i]!=in[i])return false;
return true;
}
__forceinline bool operator!=(const dynamic_matrix&in)const
{
if(rows!=in.rows||cols!=in.cols)
return true;
for(unsigned i=0;i<rows*cols;++i)
if(data[i]!=in[i])return true;
return false;
}
__forceinline dynamic_matrix<Real>get_row(unsigned m)const
{
dynamic_matrix<Real>ret(1,cols);
for(unsigned n=0;n<cols;++n)
ret[n]=(*this)(m,n);
return ret;
}
__forceinline dynamic_matrix<Real>get_column(unsigned n)const
{
dynamic_matrix<Real>ret(rows,1);
for(unsigned m=0;m<rows;++m)
ret[m]=(*this)(m,n);
return ret;
}
__forceinline dynamic_matrix<Real>submatrix(unsigned M1,unsigned N1,unsigned M2,unsigned N2)const
{
assert(M2>=M1&&N2>=N1);
assert(M2<rows&&N2<cols);
dynamic_matrix<Real>ret(M2-M1+1,N2-N1+1);
for(unsigned m=M1;m<=M2;++m)
for(unsigned n=N1;n<=N2;++n)
ret(m-M1,n-N1)=(*this)(m,n);
return ret;
}
template<typename MI>
__forceinline void block_insert(unsigned M1,unsigned N1,const MI&in)
{
assert(M1+in.rows<=rows);
assert(N1+in.cols<=cols);
for(unsigned r=0;r<in.rows;++r)
for(unsigned c=0;c<in.cols;++c)
(*this)(r+M1,c+N1)=in(r,c);
}
template<typename MI>
__forceinline void block_insert_add(unsigned M1,unsigned N1,const MI&in)
{
assert(M1+in.rows<=rows);
assert(N1+in.cols<=cols);
for(unsigned r=0;r<in.rows;++r)
for(unsigned c=0;c<in.cols;++c)
(*this)(r+M1,c+N1)+=in(r,c);
}
template<typename MI>
__forceinline void block_insert(unsigned M1,unsigned N1,unsigned M2,unsigned N2,const MI&in)
{
assert(M1+in.rows-M2<=rows);
assert(N1+in.cols-N2<=cols);
for(unsigned r=M2;r<in.rows;++r)
for(unsigned c=N2;c<in.cols;++c)
(*this)(r-M2+M1,c-N2+N1)=in(r,c);
}
__forceinline dynamic_matrix<Real>operator*(const dynamic_matrix<Real>&m)const;
__forceinline dynamic_matrix<Real>operator+(const dynamic_matrix<Real>&m)const;
__forceinline dynamic_matrix<Real>operator-(const dynamic_matrix<Real>&m)const;
__forceinline dynamic_matrix<Real>&operator+=(const dynamic_matrix<Real>&m);
__forceinline dynamic_matrix<Real>&operator-=(const dynamic_matrix<Real>&m);
__forceinline dynamic_matrix<Real>&operator*=(const dynamic_matrix<Real>&m);
template<unsigned M,unsigned N>
__forceinline dynamic_matrix<Real>&operator*=(const static_matrix<M,N,Real>&m);
template<unsigned M,unsigned N>
__forceinline dynamic_matrix<Real>operator*(const static_matrix<M,N,Real>&m)const;
template<unsigned M,unsigned N>
__forceinline static_matrix<M,N,Real>operator+(const static_matrix<M,N,Real>&m)const;
template<unsigned M,unsigned N>
__forceinline static_matrix<M,N,Real>operator-(const static_matrix<M,N,Real>&m)const;
template<unsigned M,unsigned N>
__forceinline dynamic_matrix<Real>&operator+=(const static_matrix<M,N,Real>&m);
template<unsigned M,unsigned N>
__forceinline dynamic_matrix<Real>&operator-=(const static_matrix<M,N,Real>&m);
__forceinline dynamic_matrix<Real>operator+(Real s)const;
__forceinline dynamic_matrix<Real>operator-(Real s)const;
__forceinline dynamic_matrix<Real>operator*(Real s)const;
__forceinline dynamic_matrix<Real>operator/(Real s)const;
__forceinline dynamic_matrix<Real>&operator+=(Real s);
__forceinline dynamic_matrix<Real>&operator-=(Real s);
__forceinline dynamic_matrix<Real>&operator*=(Real s);
__forceinline dynamic_matrix<Real>&operator/=(Real s);
};
#pragma endregion
#pragma region BASIC_MEMFUNCS_STATIC
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>operator-(const static_matrix<M,N,Real>&m)
{return m*Real(-1);}
template<unsigned M,unsigned N,typename Real,typename T>
__forceinline typename enable_if_c<is_basic_type<T>::value||is_same_type<T,Real>::value,static_matrix<M,N,Real> >::type
operator*(T s,const static_matrix<M,N,Real>&m)
{return m*Real(s);}
template<unsigned M,unsigned N,typename Real,typename T>
__forceinline typename enable_if_c<is_basic_type<T>::value||is_same_type<T,Real>::value,static_matrix<M,N,Real> >::type
operator/(T s,const static_matrix<M,N,Real>&m)
{
Real ss=(Real)s;
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M*N;++i)
ret[i]=ss/m[i];
return ret;
}
template<unsigned M,unsigned N,typename Real,typename T>
__forceinline typename enable_if_c<is_basic_type<T>::value||is_same_type<T,Real>::value,static_matrix<M,N,Real> >::type
operator+(T s,const static_matrix<M,N,Real>&m)
{return m+Real(s);}
template<unsigned M,unsigned N,typename Real>
template<unsigned P>
__forceinline static_matrix<M,P,Real>static_matrix<M,N,Real>::operator*(const static_matrix<N,P,Real>&m)const
{
static_matrix<M,P,Real>ret;
for(unsigned i=0;i<M;++i){
for(unsigned j=0;j<P;++j){
Real sum=0;
for(unsigned k=0;k<N;++k)
sum+=(*this)(i,k)*m(k,j);
ret(i,j)=sum;
}
}
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator*=(const static_matrix<M,N,Real>&m)
{
STATIC_ASSERT(M==N,TIMES_EQUAL_OP_ONLY_FOR_SQUARE_MATRICES);
*this=*this*m;
return*this;
}
template<unsigned M,unsigned N,typename Real>
__forceinline dynamic_matrix<Real>static_matrix<M,N,Real>::operator*(const dynamic_matrix<Real>&m)const
{
dynamic_matrix<Real>ret;
assert(cols==m.rows);
ret.resize(rows,m.cols);
for(unsigned i=0;i<rows;++i){
for(unsigned j=0;j<m.cols;++j){
Real sum=0;
for(unsigned k=0;k<cols;++k)
sum+=(*this)(i,k)*m(k,j);
ret(i,j)=sum;
}
}
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator%(const static_matrix<M,N,Real>&m)const
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M*N;++i)
ret[i]=(*this)[i]*m[i];
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline dynamic_matrix<Real>static_matrix<M,N,Real>::operator%(const dynamic_matrix<Real>&m)const
{
dynamic_matrix<Real>ret(m.rows,m.cols);
for(unsigned i=0;i<M*N;++i)
ret[i]=(*this)[i]*m[i];
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator+(const static_matrix<M,N,Real>&m)const
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
ret(i,j)=(*this)(i,j)+m(i,j);
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator-(const static_matrix<M,N,Real>&m)const
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
ret(i,j)=(*this)(i,j)-m(i,j);
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator+=(const static_matrix<M,N,Real>&m)
{
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
(*this)(i,j)+=m(i,j);
return*this;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator-=(const static_matrix<M,N,Real>&m)
{
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
(*this)(i,j)-=m(i,j);
return*this;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator+(const dynamic_matrix<Real>&m)const
{
assert(same_dim(*this,m));
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
ret(i,j)=(*this)(i,j)+m(i,j);
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator-(const dynamic_matrix<Real>&m)const
{
assert(same_dim(*this,m));
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
ret(i,j)=(*this)(i,j)-m(i,j);
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator+=(const dynamic_matrix<Real>&m)
{
assert(same_dim(*this,m));
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
(*this)(i,j)+=m(i,j);
return*this;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator-=(const dynamic_matrix<Real>&m)
{
assert(same_dim(*this,m));
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
(*this)(i,j)-=m(i,j);
return*this;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator+(Real s)const
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M*N;++i)
ret[i]=(*this)[i]+s;
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator-(Real s)const
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M*N;++i)
ret[i]=(*this)[i]-s;
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator*(Real s)const
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M*N;++i)
ret[i]=(*this)[i]*s;
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>static_matrix<M,N,Real>::operator/(Real s)const
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M*N;++i)
ret[i]=(*this)[i]/s;
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator+=(Real s)
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M*N;++i)
(*this)[i]+=s;
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator-=(Real s)
{
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M*N;++i)
(*this)[i]-=s;
return ret;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator*=(Real s)
{
for(unsigned i=0;i<M*N;++i)
(*this)[i]*=s;
return*this;
}
template<unsigned M,unsigned N,typename Real>
__forceinline static_matrix<M,N,Real>&static_matrix<M,N,Real>::operator/=(Real s)
{
for(unsigned i=0;i<M*N;++i)
(*this)[i]/=s;
return*this;
}
#pragma endregion
#pragma region BASIC_MEMFUNCS_DYNAMIC
template<typename Real>
__forceinline dynamic_matrix<Real>operator-(const dynamic_matrix<Real>&m)
{return m*Real(-1);}
template<typename Real,typename T>
__forceinline typename enable_if_c<is_basic_type<T>::value||is_same_type<T,Real>::value,dynamic_matrix<Real> >::type
operator*(T s,const dynamic_matrix<Real>&m)
{return m*Real(s);}
template<typename Real,typename T>
__forceinline typename enable_if_c<is_basic_type<T>::value||is_same_type<T,Real>::value,dynamic_matrix<Real> >::type
operator/(T s,const dynamic_matrix<Real>&m)
{
Real ss=(Real)s;
dynamic_matrix<Real>ret;
for(unsigned i=0;i<m.rows*m.cols;++i)
ret[i]=ss/m[i];
return ret;
}
template<typename Real,typename T>
__forceinline typename enable_if_c<is_basic_type<T>::value||is_same_type<T,Real>::value,dynamic_matrix<Real> >::type
operator+(T s,const dynamic_matrix<Real>&m)
{
return m+Real(s);
}
template<typename Real>
__forceinline dynamic_matrix<Real>dynamic_matrix<Real>::operator*(const dynamic_matrix<Real>&m)const
{
dynamic_matrix<Real>ret(rows,m.cols);
assert(cols==m.rows);
for(unsigned i=0;i<ret.rows;++i){
for(unsigned j=0;j<ret.cols;++j){
Real sum=0;
for(unsigned k=0;k<m.rows;++k)
sum+=(*this)(i,k)*m(k,j);
ret(i,j)=sum;
}
}
return ret;
}
template<typename Real>
__forceinline dynamic_matrix<Real>dynamic_matrix<Real>::operator+(const dynamic_matrix<Real>&m)const
{
assert(same_dim(*this,m));
dynamic_matrix<Real>ret(rows,cols);
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
ret(i,j)=(*this)(i,j)+m(i,j);
return ret;
}
template<typename Real>
__forceinline dynamic_matrix<Real>dynamic_matrix<Real>::operator-(const dynamic_matrix<Real>&m)const
{
assert(same_dim(*this,m));
dynamic_matrix<Real>ret(rows,cols);
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
ret(i,j)=(*this)(i,j)-m(i,j);
return ret;
}
template<typename Real>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator+=(const dynamic_matrix<Real>&m)
{
assert(same_dim(*this,m));
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
(*this)(i,j)+=m(i,j);
return*this;
}
template<typename Real>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator-=(const dynamic_matrix<Real>&m)
{
assert(same_dim(*this,m));
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
(*this)(i,j)-=m(i,j);
return*this;
}
template<typename Real>
template<unsigned M,unsigned N>
__forceinline dynamic_matrix<Real>dynamic_matrix<Real>::operator*(const static_matrix<M,N,Real>&m)const
{
dynamic_matrix<Real>ret(rows,m.cols);
assert(cols==m.rows);
for(unsigned i=0;i<ret.rows;++i){
for(unsigned j=0;j<ret.cols;++j){
Real sum=0;
for(unsigned k=0;k<m.rows;++k)
sum+=(*this)(i,k)*m(k,j);
ret(i,j)=sum;
}
}
return ret;
}
template<typename Real>
template<unsigned M,unsigned N>
__forceinline static_matrix<M,N,Real>dynamic_matrix<Real>::operator+(const static_matrix<M,N,Real>&m)const
{
assert(same_dim(*this,m));
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
ret(i,j)=(*this)(i,j)+m(i,j);
return ret;
}
template<typename Real>
template<unsigned M,unsigned N>
__forceinline static_matrix<M,N,Real>dynamic_matrix<Real>::operator-(const static_matrix<M,N,Real>&m)const
{
assert(same_dim(*this,m));
static_matrix<M,N,Real>ret;
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
ret(i,j)=(*this)(i,j)-m(i,j);
return ret;
}
template<typename Real>
template<unsigned M,unsigned N>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator+=(const static_matrix<M,N,Real>&m)
{
assert(same_dim(*this,m));
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
(*this)(i,j)+=m(i,j);
return*this;
}
template<typename Real>
template<unsigned M,unsigned N>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator-=(const static_matrix<M,N,Real>&m)
{
assert(same_dim(*this,m));
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
(*this)(i,j)-=m(i,j);
return*this;
}
template<typename Real>
__forceinline dynamic_matrix<Real>dynamic_matrix<Real>::operator+(Real s)const
{
dynamic_matrix<Real>ret(rows,cols);
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
ret(i,j)=(*this)(i,j)+s;
return ret;
}
template<typename Real>
__forceinline dynamic_matrix<Real>dynamic_matrix<Real>::operator-(Real s)const
{
dynamic_matrix<Real>ret(rows,cols);
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
ret(i,j)=(*this)(i,j)-s;
return ret;
}
template<typename Real>
__forceinline dynamic_matrix<Real>dynamic_matrix<Real>::operator*(Real s)const
{
dynamic_matrix<Real>ret(rows,cols);
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
ret(i,j)=(*this)(i,j)*s;
return ret;
}
template<typename Real>
__forceinline dynamic_matrix<Real>dynamic_matrix<Real>::operator/(Real s)const
{
dynamic_matrix<Real>ret(rows,cols);
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
ret(i,j)=(*this)(i,j)/s;
return ret;
}
template<typename Real>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator+=(Real s)
{
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
(*this)(i,j)+=s;
return*this;
}
template<typename Real>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator-=(Real s)
{
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
(*this)(i,j)-=s;
return*this;
}
template<typename Real>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator*=(Real s)
{
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
(*this)(i,j)*=s;
return*this;
}
template<typename Real>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator/=(Real s)
{
for(unsigned i=0;i<rows;++i)
for(unsigned j=0;j<cols;++j)
(*this)(i,j)/=s;
return*this;
}
template<typename Real>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator*=(const dynamic_matrix<Real>&m)
{
*this=*this*m;
return*this;
}
template<typename Real>
template<unsigned M,unsigned N>
__forceinline dynamic_matrix<Real>&dynamic_matrix<Real>::operator*=(const static_matrix<M,N,Real>&m)
{
*this=*this*m;
return*this;
}
#pragma endregion
#pragma region OSTREAM_STUFF
template<class Matrix>
__forceinline typename enable_if<is_matrix<Matrix>,std::ostream&>::type
operator<<(std::ostream&os,const Matrix&m)
{
std::streamsize width=os.width();
if(m.cols==1)
{
os<<"(";
unsigned i=0;
while(i+1<m.rows){
os<<std::setw(width)<<m[i]<<", ";
++i;
}
if(m.rows>0)
os<<std::setw(width)<<m[i];
os<<")";
return os;
}else
{
os<<"[ ";
for(unsigned i=0;i+1<m.rows;++i)
{
for(unsigned j=0;j+1<m.cols;++j)
os<<std::setw(width)<<m(i,j)<<" ";
if(m.cols>0)
os<<std::setw(width)<<m(i,m.cols-1)<<"\n  ";
}
for(unsigned j=0;j+1<m.cols;++j)
os<<std::setw(width)<<m(m.rows-1,j)<<" ";
if(m.rows>0&&m.cols>0)
os<<std::setw(width)<<m(m.rows-1,m.cols-1);
os<<" ]";
return os;
}
}
template<unsigned M,unsigned N,typename Real>
__forceinline std::istream&operator>>(std::istream&is,static_matrix<M,N,Real>&m)
{
std::string delims="[](), \n";
while(is.good()&&delims.find(is.peek())!=std::string::npos)
is.get();
std::string token;
for(unsigned i=0;i<M*N;++i)
{
if(!heinlib::getline(is,token,delims))
{
for(unsigned j=i;j<M*N;++j)
m[j]=0;
return is;
}
m[i]=convert<Real>(token);
}
return is;
}
#pragma endregion
}
#pragma once
#include<stdexcept>
#include<limits>
#pragma once
#include<cstdio>
namespace heinlib
{
template<class Matrix>
typename enable_if<is_matrix<Matrix>,std::string>::type
print_size(const Matrix&m)
{
char txt[25];
sprintf(txt,"%u x %u",m.rows,m.cols);
return std::string(txt);
}
template<typename Matrix>
void resize_if_dynamic(Matrix&m,unsigned M,unsigned N){}
template<typename Real>
void resize_if_dynamic(dynamic_matrix<Real>&m,unsigned M,unsigned N)
{m.resize(M,N);}
template<class Mx1,class Nx1>
struct MxN_result
{
typedef dynamic_matrix<typename Mx1::real_type>result_type;
};
template<unsigned M,unsigned N,class Real>
struct MxN_result<static_matrix<M,1,Real>,static_matrix<N,1,Real> >
{
typedef static_matrix<M,N,Real>result_type;
};
template<typename M1,typename M2>
struct multiply_result;
template<typename Real>
struct multiply_result<dynamic_matrix<Real>,dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,unsigned P,typename Real>
struct multiply_result<static_matrix<M,N,Real>,static_matrix<N,P,Real> >
{
typedef static_matrix<M,P,Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct multiply_result<static_matrix<M,N,Real>,dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct multiply_result<dynamic_matrix<Real>,static_matrix<M,N,Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<typename M1,typename M2>
struct augment_result;
template<typename Real>
struct augment_result<dynamic_matrix<Real>,dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct augment_result<static_matrix<M,N,Real>,dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct augment_result<dynamic_matrix<Real>,static_matrix<M,N,Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,unsigned P,typename Real>
struct augment_result<static_matrix<M,N,Real>,static_matrix<M,P,Real> >
{
typedef static_matrix<M,N+P,Real>result_type;
};
template<typename M1,unsigned C>
struct augment_columns;
template<unsigned M,unsigned N,unsigned C,typename Real>
struct augment_columns<static_matrix<M,N,Real>,C>
{
typedef static_matrix<M,N+C,Real>result_type;
};
template<typename Real,unsigned C>
struct augment_columns<dynamic_matrix<Real>,C>
{
typedef dynamic_matrix<Real>result_type;
};
template<typename M1,typename M2>
struct stack_result;
template<typename Real>
struct stack_result<dynamic_matrix<Real>,dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct stack_result<static_matrix<M,N,Real>,dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct stack_result<dynamic_matrix<Real>,static_matrix<M,N,Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,unsigned P,typename Real>
struct stack_result<static_matrix<M,N,Real>,static_matrix<P,N,Real> >
{
typedef static_matrix<M+P,N,Real>result_type;
};
template<typename M1>
struct square_result;
template<typename Real>
struct square_result<dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct square_result<static_matrix<M,N,Real> >
{
typedef static_matrix<M,M,Real>result_type;
};
template<typename M1>
struct big_square;
template<typename Real>
struct big_square<dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct big_square<static_matrix<M,N,Real> >
{
typedef static_matrix<(M>=N)?M:N,(M>=N)?M:N,Real>result_type;
};
template<typename MI>
struct transpose_result;
template<typename Real>
struct transpose_result<dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct transpose_result<static_matrix<M,N,Real> >
{
typedef static_matrix<N,M,Real>result_type;
};
template<typename MI>
struct column_vector;
template<typename Real>
struct column_vector<dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct column_vector<static_matrix<M,N,Real> >
{
typedef static_matrix<M,1,Real>result_type;
};
template<typename MI>
struct row_vector;
template<typename Real>
struct row_vector<dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct row_vector<static_matrix<M,N,Real> >
{
typedef static_matrix<1,N,Real>result_type;
};
template<typename MI>
struct diagonal_vector;
template<typename Real>
struct diagonal_vector<dynamic_matrix<Real> >
{
typedef dynamic_matrix<Real>result_type;
};
template<unsigned M,unsigned N,typename Real>
struct diagonal_vector<static_matrix<M,N,Real> >
{
typedef static_matrix<((M>N)?M:N),1,Real>result_type;
};
}
namespace heinlib
{
template<class Matrix>
typename enable_if<is_matrix<Matrix>,bool>::type
corrupt(const Matrix&m)
{
unsigned sz=m.rows*m.cols;
for(unsigned i=0;i<sz;++i)
if(corrupt(m[i]))return true;
return false;
}
template<unsigned M,unsigned N,class Real>
__forceinline static_matrix<M-1,1,Real>homogeneous_transform(const static_matrix<M,N,Real>&H,const static_matrix<N-1,1,Real>&X)
{
static_matrix<M,1,Real>HX=H*homogenize(X);
if(HX[M-1]==0)throw std::runtime_error("divide by zero");
return realize(HX);
}
template<class Matrix>
__forceinline typename Matrix::real_type standardize_scale(Matrix&A)
{
typedef typename Matrix::real_type Real;
Real largest_abs=0,largest=0;
unsigned elts=A.rows*A.cols;
for(unsigned i=0;i<elts;++i){
if(abs(A[i])>largest_abs)
{
largest=A[i];
largest_abs=abs(largest);
}
}
if(largest_abs>0)
A/=largest;
return largest;
}
template<class Matrix>
__forceinline Matrix standard_scale(const Matrix&A)
{
typedef typename Matrix::real_type Real;
Real largest_abs=0,largest=0;
unsigned elts=A.rows*A.cols;
for(unsigned i=0;i<elts;++i){
if(abs(A[i])>largest_abs)
{
largest=A[i];
largest_abs=abs(largest);
}
}
if(largest_abs>0)return A/largest;
else return A;
}
template<class Matrix>
__forceinline typename Matrix::real_type scale_factor(const Matrix&A)
{
typedef typename Matrix::real_type Real;
Real largest_abs=0,largest=0;
unsigned elts=A.rows*A.cols;
for(unsigned i=0;i<elts;++i){
if(abs(A[i])>largest_abs)
{
largest=A[i];
largest_abs=abs(largest);
}
}
return largest;
}
template<typename MxN>
unsigned num_elements(const MxN&m)
{
return m.rows*m.cols;
}
template<typename MxN>
typename MxN::real_type sum(const MxN&m)
{
typedef typename MxN::real_type Real;
unsigned elts=num_elements(m);
Real s=0;
for(unsigned i=0;i<elts;++i)
s+=m[i];
return s;
}
template<typename Matrix>
typename enable_if<is_matrix<Matrix>,Matrix>::type
log(const Matrix&Q)
{
typedef typename Matrix::real_type Real;
Matrix res;
resize_if_dynamic(res,Q.rows,Q.cols);
Real theta=acos((trace(Q)-1)/2);
if(theta==0)
{
fill(res,0);
return res;
}else{
res=theta/(2*sin(theta))*(Q-transpose(Q));
return res;
}
}
template<typename MxN>
typename MxN::real_type frobenius_norm(const MxN&m)
{
typedef typename MxN::real_type Real;
unsigned elts=num_elements(m);
Real sum=0;
for(unsigned i=0;i<elts;++i)
sum+=m[i]*m[i];
return sqrt(sum);
}
template<typename MxN>
typename MxN::real_type max_relative_diff(const MxN&a,const MxN&b)
{
typedef typename MxN::real_type Real;
unsigned elts=num_elements(a);
if(num_elements(b)!=elts)
return std::numeric_limits<Real>::infinity();
Real max_rdiff=0;
for(unsigned i=0;i<elts;++i)
max_rdiff=std::max(max_rdiff,abs((a[i]-b[i])/a[i]));
return max_rdiff;
}
template<typename MxN>
typename MxN::real_type max_norm(const MxN&m)
{
typedef typename MxN::real_type Real;
unsigned elts=num_elements(m);
Real maxv=m[0];
for(unsigned i=1;i<elts;++i){
if(abs(m[i])>maxv)
maxv=abs(m[i]);
}
return maxv;
}
template<typename MxN>
typename MxN::real_type max_element(const MxN&m)
{
typedef typename MxN::real_type Real;
unsigned elts=num_elements(m);
Real maxv=m[0];
for(unsigned i=1;i<elts;++i){
if(m[i]>maxv)
maxv=m[i];
}
return maxv;
}
template<typename MxN>
typename MxN::real_type min_element(const MxN&m)
{
typedef typename MxN::real_type Real;
unsigned elts=num_elements(m);
Real minv=m[0];
for(unsigned i=1;i<elts;++i){
if(m[i]<minv)
minv=m[i];
}
return minv;
}
template<typename MxM>
void make_symmetric(MxM&A)
{
assert(is_square(A));
for(unsigned r=1;r<A.rows;++r)
for(unsigned c=0;c<r+1;++c)
A(r,c)=A(c,r);
}
template<unsigned M,unsigned N,typename Real>
static_matrix<N,M,Real>transpose(const static_matrix<M,N,Real>&m)
{
static_matrix<N,M,Real>ret;
for(unsigned i=0;i<M;++i)
for(unsigned j=0;j<N;++j)
ret(j,i)=m(i,j);
return ret;
}
template<typename Real>
dynamic_matrix<Real>transpose(const dynamic_matrix<Real>&m)
{
dynamic_matrix<Real>ret(m.cols,m.rows);
for(unsigned i=0;i<m.rows;++i)
for(unsigned j=0;j<m.cols;++j)
ret(j,i)=m(i,j);
return ret;
}
template<unsigned N,class Real>
static_matrix<N,N,Real>diagonal_square_root(const static_matrix<N,N,Real>&D)
{
static_matrix<N,N,Real>ret={};
for(int i=0;i<N;++i)
ret(i,i)=sqrt(D(i,i));
return ret;
}
template<unsigned M,unsigned N,typename Real>
static_matrix<N,N,Real>transpose_premultiply(const static_matrix<M,N,Real>&m)
{
static_matrix<N,N,Real>ret;
for(unsigned i=0;i<N;++i){
for(unsigned j=0;j<N;++j){
Real sum=0;
for(unsigned k=0;k<M;++k)
sum+=m(k,i)*m(k,j);
ret(i,j)=sum;
ret(j,i)=sum;
}
}
return ret;
}
template<typename Real>
dynamic_matrix<Real>transpose_premultiply(const dynamic_matrix<Real>&m)
{
dynamic_matrix<Real>ret(m.cols,m.cols);
for(unsigned i=0;i<m.cols;++i){
for(unsigned j=0;j<m.cols;++j){
Real sum=0;
for(unsigned k=0;k<m.rows;++k)
sum+=m(k,i)*m(k,j);
ret(i,j)=sum;
ret(j,i)=sum;
}
}
return ret;
}
template<typename M1,typename M2,typename M3>
void elementwise_multiply(const M1&m1,const M2&m2,M3&m3)
{
assert(same_dim(m1,m2));
resize_if_dynamic(m3,m1.rows,m1.cols);
for(unsigned i=0;i<m1.rows*m1.cols;++i)
m3[i]=m1[i]*m2[i];
}
template<typename M1,typename M2>
M1 elementwise_multiply(const M1&m1,const M2&m2)
{
assert(same_dim(m1,m2));
M1 m3;
resize_if_dynamic(m3,m1.rows,m1.cols);
assert(same_dim(m1,m3));
for(unsigned i=0;i<m1.rows*m1.cols;++i)
m3[i]=m1[i]*m2[i];
return m3;
}
template<class Real,unsigned M,unsigned N>
Real matrix_scale(const static_matrix<M,N,Real>&A,const static_matrix<M,N,Real>&B)
{
Real ata=0,atb=0;
for(unsigned i=0;i<M*N;++i)
{
ata+=A[i]*A[i];
atb+=A[i]*B[i];
}
return atb/ata;
}
template<typename MI>
inline typename MI::real_type trace(const MI&in)
{
assert(is_square(in));
typedef typename MI::real_type Real;
Real sum=0;
for(unsigned i=0;i<in.rows;++i)
sum+=in(i,i);
return sum;
}
template<typename MI>
inline MI&fill(MI&in,typename MI::real_type val)
{
for(unsigned i=0;i<in.rows;++i)
for(unsigned j=0;j<in.cols;++j)
in(i,j)=val;
return in;
}
template<typename MI,typename MO>
void matrix_copy(MO&out,const MI&in)
{
assert(in.rows*in.cols==out.rows*out.cols);
for(unsigned i=0;i<in.rows*in.cols;++i)
out[i]=in[i];
}
template<typename MI,typename MO>
void matrix_copy(MO&out,const MI&in,unsigned count)
{
assert(in.rows*in.cols>=count);
assert(out.rows*out.cols>=count);
for(unsigned i=0;i<count;++i)
out[i]=in[i];
}
template<typename MI>
inline MI&fill_identity(MI&in)
{
for(unsigned i=0;i<in.rows;++i){
for(unsigned j=0;j<in.cols;++j)
in(i,j)=0;
in(i,i)=1;
}
return in;
}
template<typename MI>
inline MI&fill_diagonal(MI&in,typename MI::real_type val)
{
for(unsigned i=0;i<in.rows;++i){
for(unsigned j=0;j<in.cols;++j)
in(i,j)=0;
in(i,i)=val;
}
return in;
}
template<unsigned N,typename Real>
inline static_matrix<N,N,Real>identity()
{
static_matrix<N,N,Real>ret={0};
for(unsigned i=0;i<N;++i)
ret(i,i)=1;
return ret;
}
template<unsigned Dim,class Real>
inline static_matrix<Dim,Dim,Real>make_diagonal(const Real&s)
{
static_matrix<Dim,Dim,Real>m={};
for(int i=0;i<Dim;++i)
m(i,i)=s;
return m;
}
template<typename Nx1>
inline typename square_result<Nx1>::result_type make_diagonal(const Nx1&diag_elts)
{
unsigned N=diag_elts.rows;
typename square_result<Nx1>::result_type ret;
resize_if_dynamic(ret,N,N);
fill(ret,0);
for(unsigned i=0;i<N;++i)
ret(i,i)=diag_elts[i];
return ret;
}
template<typename NewType,unsigned M,unsigned N,typename Real>
__forceinline typename disable_if<is_same_type<NewType,Real>,static_matrix<M,N,NewType> >::type
change_type(const static_matrix<M,N,Real>&m)
{
static_matrix<M,N,NewType>ret;
for(unsigned i=0;i<M*N;++i)
ret.data[i]=(NewType)(m.data[i]);
return ret;
}
template<typename NewType,unsigned M,unsigned N,typename Real>
__forceinline typename enable_if<is_same_type<NewType,Real>,static_matrix<M,N,NewType> >::type
change_type(const static_matrix<M,N,Real>&m)
{
return m;
}
template<typename NewType,typename Real>
__forceinline typename disable_if<is_same_type<NewType,Real>,dynamic_matrix<NewType> >::type
change_type(const dynamic_matrix<Real>&m)
{
dynamic_matrix<NewType>ret(m.rows*m.cols);
for(unsigned i=0;i<m.rows*m.cols;++i)
ret.data[i]=(NewType)(m.data[i]);
return ret;
}
template<typename NewType,typename Real>
__forceinline typename enable_if<is_same_type<NewType,Real>,dynamic_matrix<NewType> >::type
change_type(const dynamic_matrix<Real>&m)
{
return m;
}
}
#pragma once
namespace heinlib
{
template<typename Vector>struct dot_impl
{
__forceinline static typename Vector::real_type call(const Vector&in,const Vector&in2)
{
typedef typename Vector::real_type Real;
unsigned N=in.rows*in.cols;
Real sum=0;
for(unsigned i=0;i<N;++i)
sum+=in[i]*in2[i];
return sum;
}
};
template<typename Real>struct dot_impl<static_matrix<1,1,Real> >
{
__forceinline static Real call(const static_matrix<1,1,Real>&in,const static_matrix<1,1,Real>&in2)
{
return in[0]*in2[0];
}
};
template<typename Real>struct dot_impl<static_matrix<2,1,Real> >
{
__forceinline static Real call(const static_matrix<2,1,Real>&in,const static_matrix<2,1,Real>&in2)
{
return in[0]*in2[0]+in[1]*in2[1];
}
};
template<typename Real>struct dot_impl<static_matrix<3,1,Real> >
{
__forceinline static Real call(const static_matrix<3,1,Real>&in,const static_matrix<3,1,Real>&in2)
{
return in[2]*in2[2]+in[0]*in2[0]+in[1]*in2[1];
}
};
template<typename Real>struct dot_impl<static_matrix<4,1,Real> >
{
__forceinline static Real call(const static_matrix<4,1,Real>&in,const static_matrix<4,1,Real>&in2)
{
return in[3]*in2[3]+in[0]*in2[0]+in[1]*in2[1]+in[2]*in2[2];
}
};
template<typename Vector>
__forceinline typename Vector::real_type dot(const Vector&in,const Vector&in2)
{
return dot_impl<Vector>::call(in,in2);
}
template<typename Real>
__forceinline Real perp_dot(const static_matrix<2,1,Real>&v1,const static_matrix<2,1,Real>&v2)
{
return v1.x()*v2.y()-v1.y()*v2.x();
}
}
#pragma once
namespace heinlib
{
namespace detail
{
template<typename Vector>
struct length_sq_impl
{
__forceinline static typename Vector::real_type call(const Vector&in)
{
typedef typename Vector::real_type Real;
unsigned N=in.rows*in.cols;
Real dist=0;
for(unsigned i=0;i<N;++i)
dist+=in[i]*in[i];
return dist;
}
};
template<typename Real>
struct length_sq_impl<static_matrix<1,1,Real> >
{
__forceinline static Real call(const static_matrix<1,1,Real>&in)
{
return in[0]*in[0];
}
};
template<typename Real>
struct length_sq_impl<static_matrix<2,1,Real> >
{
__forceinline static Real call(const static_matrix<2,1,Real>&in)
{
return in[0]*in[0]+in[1]*in[1];
}
};
template<typename Real>
struct length_sq_impl<static_matrix<3,1,Real> >
{
__forceinline static Real call(const static_matrix<3,1,Real>&in)
{
return in[2]*in[2]+in[0]*in[0]+in[1]*in[1];
}
};
template<typename Real>
struct length_sq_impl<static_matrix<4,1,Real> >
{
__forceinline static Real call(const static_matrix<4,1,Real>&in)
{
return in[3]*in[3]+in[0]*in[0]+in[1]*in[1]+in[2]*in[2];
}
};
}
template<typename Vector>
__forceinline typename Vector::real_type length_sq(const Vector&in)
{
return detail::length_sq_impl<Vector>::call(in);
}
template<typename Vector>
__forceinline typename Vector::real_type length(const Vector&in)
{
return sqrt(detail::length_sq_impl<Vector>::call(in));
}
template<typename Vector>
__forceinline float lengthf(const Vector&in)
{
return sqrt((float)detail::length_sq_impl<Vector>::call(in));
}
template<typename Vector>
__forceinline typename Vector::real_type distance_sq(const Vector&in,const Vector&in2)
{
return detail::length_sq_impl<Vector>::call(in-in2);
}
template<typename Vector>
__forceinline typename Vector::real_type distance(const Vector&in,const Vector&in2)
{
return sqrt(detail::length_sq_impl<Vector>::call(in-in2));
}
template<typename Vector>
__forceinline float distancef(const Vector&in,const Vector&in2)
{
return sqrt((float)detail::length_sq_impl<Vector>::call(in-in2));
}
}
#pragma once
namespace heinlib
{
template<unsigned N,class Real>
inline typename enable_if<is_floating<Real>,Real>::type
angle(const static_matrix<N,1,Real>&a,const static_matrix<N,1,Real>&b)
{
Real arg=dot(a,b)/(length(a)*length(b));
return(abs(arg)<1)?acos(arg):0;
}
template<unsigned N,class Real>
inline typename disable_if<is_floating<Real>,float>::type
angle(const static_matrix<N,1,Real>&a,const static_matrix<N,1,Real>&b)
{
float arg=dot(a,b)/(float)(length(a)*length(b));
return(abs(arg)<1)?acos(arg):0;
}
template<class Real>
inline Real signed_angle(const static_matrix<2,1,Real>&a,const static_matrix<2,1,Real>&b)
{
return atan2(perp_dot(a,b),dot(a,b));
}
template<class Real>
inline Real angle(const static_matrix<2,1,Real>&in)
{
Real a=atan2(in.y(),in.x());
return(a>=0)?a:(a+constants<Real>::two_pi());
}
}
#pragma once
#pragma once
#include<cmath>
#include<algorithm>
#include<iomanip>
namespace heinlib
{
template<int Loud,typename MxN>
bool gauss_jordan_elimination(MxN&R,typename MxN::real_type eps=0)
{
typedef typename MxN::real_type Real;
unsigned M=R.rows,N=R.cols;
assert(N>=M);
if(Loud>0)std::cout<<"Start:\n"<<R<<"\n";
if(!partial_pivoting(R))
return false;
if(Loud>0)std::cout<<"Pivoted:\n"<<R<<"\n";
unsigned c=0;
for(unsigned r=0;r<M;++r)
{
while(c<N&&abs(R(r,c))<=eps)++c;
if(c==N)return true;
Real pivot=R(r,c);
for(unsigned j=r+1;j<M;++j)
{
Real m=R(j,c)/pivot;
R(j,c)=0;
for(unsigned k=c+1;k<N;++k)
R(j,k)-=m*R(r,k);
}
for(unsigned j=0;j<r;++j)
{
Real m=R(j,c)/pivot;
R(j,c)=0;
for(unsigned k=c+1;k<N;++k)
R(j,k)-=m*R(r,k);
}
R(r,c)=1;
for(unsigned k=c+1;k<N;++k)
R(r,k)/=pivot;
++c;
if(Loud>0){
std::cout<<"Step:\n"<<R<<"\n";
system("pause");
}
}
return true;
}
template<int Loud,typename MxN>
bool gauss_jordan_elimination(const MxN&A,MxN&R,typename MxN::real_type eps=0)
{
unsigned M=A.rows,N=A.cols;
assert(N>=M);
resize_if_dynamic(R,M,N);
assert(same_dim(A,R));
typedef typename MxN::real_type Real;
R=A;
return gauss_jordan_elimination<Loud>(R,eps);
}
template<typename MxM,typename Mx1>
bool gaussian_elimination(const MxM&A,const Mx1&b,Mx1&x)
{
unsigned M=A.rows;
typedef typename MxM::real_type Real;
assert(size_is(A,M,M));
assert(size_is(b,M,1));
resize_if_dynamic(x,M,1);
assert(size_is(x,M,1));
typename augment_result<MxM,Mx1>::result_type R;
resize_if_dynamic(R,M,M+1);
R.block_insert(0,0,A);
R.block_insert(0,M,b);
if(!partial_pivoting(R))
return false;
for(unsigned d=0;d<M;++d)
{
for(unsigned j=d+1;j<M;++j)
{
Real pivot=R(d,d);
Real m=R(j,d)/pivot;
for(unsigned p=d;p<R.cols;++p)
R(j,p)-=m*R(d,p);
for(unsigned p=0;p<=d;++p)
R(j,p)=0;
}
}
back_substitution(R,x);
return true;
}
template<typename MxN,typename Mx1,typename Nx1>
void back_substitution(const MxN&U,const Mx1&y,Nx1&x)
{
unsigned M=U.rows,N=U.cols;
typedef typename MxN::real_type Real;
assert(size_is(U,M,N));
assert(size_is(y,M,1));
resize_if_dynamic(x,N,1);
assert(size_is(x,N,1));
x[N-1]=y[N-1]/U(N-1,N-1);
for(int i=N-2;i>=0;--i)
{
Real sum=0;
for(unsigned j=i+1;j<N;++j)
sum+=U(i,j)*x[j];
x[i]=(y[i]-sum)/U(i,i);
}
}
template<typename M1,typename M2>
void back_substitution(const M1&aug,M2&x)
{
typedef typename M1::real_type Real;
unsigned N=aug.rows;
assert(size_is(aug,N,N+1));
resize_if_dynamic(x,N,1);
assert(size_is(x,N,1));
x[N-1]=aug(N-1,N)/aug(N-1,N-1);
for(int i=N-2;i>=0;--i)
{
Real sum=0;
for(unsigned j=i+1;j<N;++j)
sum+=aug(i,j)*x[j];
x[i]=(aug(i,N)-sum)/aug(i,i);
}
}
template<typename NxN,typename Nx1>
void forward_substitution(const NxN&L,const Nx1&b,Nx1&y)
{
typedef typename NxN::real_type Real;
unsigned N=L.rows;
assert(is_square(L));
assert(size_is(b,N,1));
resize_if_dynamic(y,N,1);
assert(size_is(y,N,1));
y[0]=b[0]/L(0,0);
for(unsigned i=1;i<N;++i){
Real sum=0;
for(unsigned j=0;j<i;++j)
sum+=L(i,j)*y[j];
y[i]=(b[i]-sum)/L(i,i);
}
}
template<typename M1,typename M2>
void forward_substitution(const M1&aug,M2&y)
{
typedef typename M1::real_type Real;
unsigned N=aug.rows;
assert(size_is(aug,N,N+1));
resize_if_dynamic(y,N,1);
assert(size_is(y,N,1));
y[0]=aug(0,N)/aug(0,0);
for(unsigned i=1;i<N;++i){
Real sum=0;
for(unsigned j=0;j<i;++j)
sum+=aug(i,j)*y[j];
y[i]=(aug(i,N)-sum)/aug(i,i);
}
}
template<typename MxN,typename MxM>
bool partial_pivoting(MxN&aug,MxM&P)
{
typedef typename MxN::real_type Real;
unsigned M=aug.rows,N=aug.cols;
assert(N>=M);
assert(size_is(P,M,M));
fill(P,0);
for(unsigned d=0;d<M;++d)
P(d,d)=1;
for(unsigned d=0;d<M;++d)
{
unsigned argmax_r=d;
Real max_v=abs(aug(d,d));
for(unsigned r=d+1;r<M;++r){
Real v=abs(aug(r,d));
if(v>max_v){
max_v=v;
argmax_r=r;
}
}
if(max_v==0)
return false;
if(d!=argmax_r){
for(unsigned c=0;c<N;++c)
std::swap(aug(d,c),aug(argmax_r,c));
if(P!=NULL){
for(unsigned c=0;c<M;++c){
std::swap(P(d,c),P(argmax_r,c));
}
}
}
}
return true;
}
template<typename MxN>
bool partial_pivoting(MxN&aug)
{
typedef typename MxN::real_type Real;
unsigned M=aug.rows,N=aug.cols;
assert(N>=M);
for(unsigned d=0;d<M;++d)
{
unsigned argmax_r=d;
Real max_v=abs(aug(d,d));
for(unsigned r=d+1;r<M;++r){
Real v=abs(aug(r,d));
if(v>max_v){
max_v=v;
argmax_r=r;
}
}
if(d!=argmax_r)
for(unsigned c=0;c<N;++c)
std::swap(aug(d,c),aug(argmax_r,c));
}
return true;
}
template<typename MxN>
bool scaled_partial_pivoting(MxN&aug)
{
typedef typename MxN::real_type Real;
unsigned M=aug.rows,N=aug.cols;
assert(N>=M);
typename column_vector<MxN>::result_type scale;
for(unsigned i=0;i<M;++i){
Real v=abs(aug(i,0));
for(unsigned j=1;j<N;++j)
v=std::max(v,abs(aug(i,j)));
scale[i]=v;
}
for(unsigned d=0;d<M;++d)
{
unsigned argmax_r=d;
Real max_v=abs(aug(d,d))/scale[d];
for(unsigned r=d+1;r<M;++r){
Real v=abs(aug(r,d))/scale[d];
if(v>max_v){
max_v=v;
argmax_r=r;
}
}
if(d!=argmax_r)
for(unsigned c=0;c<N;++c)
std::swap(aug(d,c),aug(argmax_r,c));
}
return true;
}
template<typename NxN,typename Nx1>
bool gauss_seidel_iterations(const NxN&A,const Nx1&b,Nx1&x,
typename NxN::real_type stop_eps,
unsigned max_iters=1,unsigned min_iters=1)
{
using namespace heinlib;
typedef typename NxN::real_type Real;
unsigned N=A.rows;
assert(size_is(b,N,1));
resize_if_dynamic(x,N,1);
assert(size_is(x,N,1));
typename augment_result<NxN,Nx1>::result_type aug;
resize_if_dynamic(aug,N,N+1);
aug.block_insert(0,0,A);
aug.block_insert(0,N,b);
for(unsigned iter=0;iter<max_iters;++iter)
{
Real maxdiff=0;
for(unsigned j=0;j<N;++j)
{
Real sum1=0,sum2=0;
for(unsigned k=0;k<j;++k)
sum1+=aug(j,k)*x[k];
for(unsigned k=j+1;k<N;++k)
sum2+=aug(j,k)*x[k];
Real xn=(aug(j,N)-sum1-sum2)/aug(j,j);
Real diff=abs(x[j]-xn);
x[j]=xn;
if(diff>maxdiff)
maxdiff=diff;
}
if(iter>min_iters&&maxdiff<stop_eps)
return true;
}
return false;
}
}
#pragma once
#include<limits>
namespace heinlib
{
#ifdef WIN32
template<bool WANT_U,bool WANT_V,typename MxN,typename NxN>
bool SVD(const MxN&Arg,MxN&U,NxN&S,NxN&V,typename MxN::real_type eps,unsigned max_iters);
#else
template<bool WANT_U,bool WANT_V,typename MxN,typename NxN>
bool SVD(const MxN&Arg,MxN&U,NxN&S,NxN&V,typename MxN::real_type eps=2.2e-10,unsigned max_iters=1000);
#endif
namespace detail
{
template<bool WANT_U,bool WANT_V,typename MxN,typename NxN>
bool SVD_pad(const MxN&Arg,MxN&U,NxN&S,NxN&V,
typename MxN::real_type eps,unsigned max_iters)
{
typedef typename MxN::real_type Real;
unsigned M=Arg.rows,N=Arg.cols;
assert(M<N);
NxN APad;
resize_if_dynamic(APad,N,N);
fill(APad,0);
APad.block_insert(0,0,Arg);
NxN UPad,SPad,VPad;
resize_if_dynamic(SPad,N,N);
if(WANT_U)resize_if_dynamic(UPad,N,N);
if(WANT_V)resize_if_dynamic(VPad,N,N);
bool ret=SVD<WANT_U,WANT_V>(APad,UPad,SPad,VPad,eps,max_iters);
matrix_copy(S,SPad,M*N);
for(unsigned i=M;i<N;++i)
{
for(unsigned j=0;j<N;++j)
S(i,j)=0;
}
if(WANT_U)matrix_copy(U,UPad,M*N);
if(WANT_V)matrix_copy(V,VPad,N*N);
return ret;
}
}
template<bool WANT_U,bool WANT_V,typename MxN,typename NxN>
bool SVD(const MxN&Arg,MxN&U,NxN&S,NxN&V,
typename MxN::real_type eps=2.2e-10,
unsigned max_iters=1000)
{
typedef typename MxN::real_type Real;
int M=Arg.rows,N=Arg.cols;
if(WANT_V&&M<N)
{
return detail::SVD_pad<WANT_U,WANT_V>(Arg,U,S,V,eps,max_iters);
}
eps=std::numeric_limits<Real>::epsilon();
#ifndef NDEBUG
for(int i=0;i<M*N;++i)
{
if(corrupt(Arg[i]))
{
std::cout<<"SVD Corrupt! M = \n"<<Arg<<"\n";
return false;
}
}
#endif
resize_if_dynamic(U,M,N);
resize_if_dynamic(S,N,N);
resize_if_dynamic(V,N,N);
assert(size_is(S,N,N));
assert(size_is(V,N,N));
fill(U,0);
fill(S,0);
MxN A=Arg;
typename column_vector<NxN>::result_type s,e;
typename column_vector<MxN>::result_type work;
resize_if_dynamic(s,N,1);
resize_if_dynamic(e,N,1);
resize_if_dynamic(work,M,1);
int m=M;
int n=N;
int nu=std::min(M,N);
int i=0,j=0,k=0;
int nct=std::min(M-1,N);
int nrt=std::max(0,std::min(N-2,M));
for(k=0;k<std::max(nct,nrt);k++){
if(k<nct){
s[k]=0;
for(i=k;i<m;i++){
s[k]=hypot(s[k],A(i,k));
}
if(s[k]!=0){
if(A(k,k)<0){
s[k]=-s[k];
}
for(i=k;i<m;i++){
A(i,k)/=s[k];
}
A(k,k)+=1;
}
s[k]=-s[k];
}
for(j=k+1;j<n;j++){
if((k<nct)&&(s[k]!=0)){
Real t(0);
for(i=k;i<m;i++){
t+=A(i,k)*A(i,j);
}
t=-t/A(k,k);
for(i=k;i<m;i++){
A(i,j)+=t*A(i,k);
}
}
e[j]=A(k,j);
}
if(WANT_U&(k<nct)){
for(i=k;i<m;i++){
U(i,k)=A(i,k);
}
}
if(k<nrt){
e[k]=0;
for(i=k+1;i<n;i++){
e[k]=hypot(e[k],e[i]);
}
if(e[k]!=0){
if(e[k+1]<0){
e[k]=-e[k];
}
for(i=k+1;i<n;i++){
e[i]/=e[k];
}
e[k+1]+=1;
}
e[k]=-e[k];
if((k+1<m)&(e[k]!=0)){
for(i=k+1;i<m;i++){
work[i]=0;
}
for(j=k+1;j<n;j++){
for(i=k+1;i<m;i++){
work[i]+=e[j]*A(i,j);
}
}
for(j=k+1;j<n;j++){
Real t(-e[j]/e[k+1]);
for(i=k+1;i<m;i++){
A(i,j)+=t*work[i];
}
}
}
if(WANT_V){
for(i=k+1;i<n;i++){
V(i,k)=e[i];
}
}
}
}
int p=std::min(n,m+1);
if(nct<n){
s[nct]=A(nct,nct);
}
if(m<p){
s[p-1]=0;
}
if(nrt+1<p){
e[nrt]=A(nrt,p-1);
}
e[p-1]=0;
if(WANT_U){
for(j=nct;j<nu;j++){
for(i=0;i<m;i++){
U(i,j)=0;
}
U(j,j)=1;
}
for(k=nct-1;k>=0;k--){
if(s[k]!=0){
for(j=k+1;j<nu;j++){
Real t(0);
for(i=k;i<m;i++){
t+=U(i,k)*U(i,j);
}
t=-t/U(k,k);
for(i=k;i<m;i++){
U(i,j)+=t*U(i,k);
}
}
for(i=k;i<m;i++){
U(i,k)=-U(i,k);
}
U(k,k)=1+U(k,k);
for(i=0;i<k-1;i++){
U(i,k)=0;
}
}else{
for(i=0;i<m;i++){
U(i,k)=0;
}
U(k,k)=1;
}
}
}
if(WANT_V){
for(k=n-1;k>=0;k--){
if((k<nrt)&(e[k]!=0)){
for(j=k+1;j<nu;j++){
Real t(0);
for(i=k+1;i<n;i++){
t+=V(i,k)*V(i,j);
}
t=-t/V(k+1,k);
for(i=k+1;i<n;i++){
V(i,j)+=t*V(i,k);
}
}
}
for(i=0;i<n;i++){
V(i,k)=0;
}
V(k,k)=1;
}
}
int pp=p-1;
int iter=0;
while(p>0){
int k=0;
int kase=0;
if(iter>(int)max_iters)
{
#ifndef NDEBUG
std::cout<<"SVD stuck in infinite loop!\n";
std::cout<<"arg is "<<Arg.rows<<" x "<<Arg.cols<<"\n";
#endif
return false;
}
for(k=p-2;k>=-1;k--){
if(k==-1){
break;
}
if(abs(e[k])<=eps*(abs(s[k])+abs(s[k+1]))){
e[k]=0;
break;
}
}
if(k==p-2){
kase=4;
}else{
int ks;
for(ks=p-1;ks>=k;ks--){
if(ks==k){
break;
}
Real t((ks!=p?abs(e[ks]):0)+
(ks!=k+1?abs(e[ks-1]):0));
if(abs(s[ks])<=eps*t){
s[ks]=0;
break;
}
}
if(ks==k){
kase=3;
}else if(ks==p-1){
kase=1;
}else{
kase=2;
k=ks;
}
}
k++;
switch(kase){
case 1:{
Real f(e[p-2]);
e[p-2]=0;
for(j=p-2;j>=k;j--){
Real t(hypot(s[j],f));
Real cs(s[j]/t);
Real sn(f/t);
s[j]=t;
if(j!=k){
f=-sn*e[j-1];
e[j-1]=cs*e[j-1];
}
if(WANT_V){
for(i=0;i<n;i++){
t=cs*V(i,j)+sn*V(i,p-1);
V(i,p-1)=-sn*V(i,j)+cs*V(i,p-1);
V(i,j)=t;
}
}
}
}
break;
case 2:{
Real f(e[k-1]);
e[k-1]=0;
for(j=k;j<p;j++){
Real t(hypot(s[j],f));
Real cs(s[j]/t);
Real sn(f/t);
s[j]=t;
f=-sn*e[j];
e[j]=cs*e[j];
if(WANT_U){
for(i=0;i<m;i++){
t=cs*U(i,j)+sn*U(i,k-1);
U(i,k-1)=-sn*U(i,j)+cs*U(i,k-1);
U(i,j)=t;
}
}
}
}
break;
case 3:{
Real scale=std::max(std::max(std::max(std::max(
abs(s[p-1]),
abs(s[p-2])),
abs(e[p-2])),
abs(s[k])),
abs(e[k]));
Real sp=s[p-1]/scale;
Real spm1=s[p-2]/scale;
Real epm1=e[p-2]/scale;
Real sk=s[k]/scale;
Real ek=e[k]/scale;
Real b=((spm1+sp)*(spm1-sp)+epm1*epm1)/2;
Real c=(sp*epm1)*(sp*epm1);
Real shift=0;
if((b!=0)||(c!=0)){
shift=sqrt(b*b+c);
if(b<0){
shift=-shift;
}
shift=c/(b+shift);
}
Real f=(sk+sp)*(sk-sp)+shift;
Real g=sk*ek;
for(j=k;j<p-1;j++){
Real t=hypot(f,g);
Real cs=f/t;
Real sn=g/t;
if(j!=k){
e[j-1]=t;
}
f=cs*s[j]+sn*e[j];
e[j]=cs*e[j]-sn*s[j];
g=sn*s[j+1];
s[j+1]=cs*s[j+1];
if(WANT_V){
for(i=0;i<n;i++){
t=cs*V(i,j)+sn*V(i,j+1);
V(i,j+1)=-sn*V(i,j)+cs*V(i,j+1);
V(i,j)=t;
}
}
t=hypot(f,g);
cs=f/t;
sn=g/t;
s[j]=t;
f=cs*e[j]+sn*s[j+1];
s[j+1]=-sn*e[j]+cs*s[j+1];
g=sn*e[j+1];
e[j+1]=cs*e[j+1];
if(WANT_U&&(j<m-1)){
for(i=0;i<m;i++){
t=cs*U(i,j)+sn*U(i,j+1);
U(i,j+1)=-sn*U(i,j)+cs*U(i,j+1);
U(i,j)=t;
}
}
}
e[p-2]=f;
iter=iter+1;
}
break;
case 4:{
if(s[k]<=0){
s[k]=(s[k]<0?-s[k]:0);
if(WANT_V){
for(i=0;i<=pp;i++){
V(i,k)=-V(i,k);
}
}
}
while(k<pp){
if(s[k]>=s[k+1]){
break;
}
Real t=s[k];
s[k]=s[k+1];
s[k+1]=t;
if(WANT_V&&(k<n-1)){
for(i=0;i<n;i++){
t=V(i,k+1);V(i,k+1)=V(i,k);V(i,k)=t;
}
}
if(WANT_U&&(k<m-1)){
for(i=0;i<m;i++){
t=U(i,k+1);U(i,k+1)=U(i,k);U(i,k)=t;
}
}
k++;
}
iter=0;
p--;
}
break;
}
for(int i=0;i<nu;++i)
S(i,i)=s[i];
}
return true;
}
}
#pragma once
#pragma once
namespace heinlib
{
template<typename NxN>
bool LU_decomposition(const NxN&A,NxN&L,NxN&U)
{
typedef typename NxN::real_type Real;
unsigned N=A.rows;
assert(size_is(A,N,N));
resize_if_dynamic(L,N,N);
resize_if_dynamic(U,N,N);
assert(size_is(L,N,N));
assert(size_is(U,N,N));
U=A;
fill(L,0.0f);
for(unsigned d=0;d<N;++d)
{
L(d,d)=1;
for(unsigned j=d+1;j<N;++j)
{
Real pivot=U(d,d);
if(pivot==0)return false;
Real m=U(j,d)/pivot;
for(unsigned p=d;p<U.cols;++p)
U(j,p)-=m*U(d,p);
for(unsigned p=0;p<d;++p)
U(j,p)=0;
L(j,d)=m;
}
}
for(unsigned p=0;p<N-1;++p)
U(N-1,p)=0;
return true;
}
}
namespace heinlib
{
template<typename MI,typename MO>struct matrix_inverse_impl;
template<unsigned N,typename Real>struct matrix_inverse_impl<static_matrix<N,N,Real>,static_matrix<N,N,Real> >{
static inline bool call(const static_matrix<N,N,Real>&in,
static_matrix<N,N,Real>&out,Real*det)
{
heinlib::static_matrix<N,N*2,Real>aug={0},rre;
aug.block_insert(0,0,in);
for(unsigned i=0;i<N;++i)
aug(i,N+i)=1;
if(gauss_jordan_elimination<0>(aug,rre))
{
out.block_insert(0,0,0,N,rre);
if(det!=NULL)
{
*det=determinant(in);
return true;
}
return true;
}else return false;
}
};
template<typename Real>struct matrix_inverse_impl<dynamic_matrix<Real>,dynamic_matrix<Real> >{
static inline bool call(const dynamic_matrix<Real>&in,
dynamic_matrix<Real>&out,Real*det)
{
assert(is_square(in));
resize_if_dynamic(out,in.rows,in.cols);
assert(same_dim(in,out));
unsigned N=in.rows;
dynamic_matrix<Real>aug(in.rows,in.cols*2),rre(aug.rows,aug.cols);
fill(aug,0);
aug.block_insert(0,0,in);
for(unsigned i=0;i<N;++i)
aug(i,N+i)=1;
if(gauss_jordan_elimination<0>(aug,rre))
{
out.block_insert(0,0,0,N,rre);
if(det!=NULL)
{
*det=determinant(in);
return true;
}
return true;
}else return false;
}
};
template<typename MI,typename MO>struct matrix_inverse_sym_impl{
static inline bool call(const MI&in,MO&out,typename MI::real_type*det)
{
matrix_inverse_sym_impl<MI,MO>::call(in,out,det);
}
};
template<typename Real>struct matrix_inverse_impl<static_matrix<1,1,Real>,static_matrix<1,1,Real> >
{
static inline bool call(const static_matrix<1,1,Real>&in,static_matrix<1,1,Real>&out,Real*det)
{
out[0]=1/in[0];
if(det!=NULL)*det=in[0];
return true;
}
};
template<typename Real>struct matrix_inverse_impl<static_matrix<2,2,Real>,static_matrix<2,2,Real> >
{
static inline bool call(const static_matrix<2,2,Real>&in,static_matrix<2,2,Real>&out,Real*det)
{
Real d=in[0]*in[3]-in[1]*in[2];
if(det!=NULL)*det=d;
if(d!=0)
{
Real d_inv=1/d;
out[0]=in[3]*d_inv;
out[3]=in[0]*d_inv;
out[1]=-in[1]*d_inv;
out[2]=-in[2]*d_inv;
return true;
}
return false;
}
};
template<typename Real>struct matrix_inverse_sym_impl<static_matrix<2,2,Real>,static_matrix<2,2,Real> >
{
static inline bool call(const static_matrix<2,2,Real>&in,static_matrix<2,2,Real>&out,Real*det)
{
Real d=in[0]*in[3]-sq(in[1]);
if(det!=NULL)*det=d;
if(d!=0)
{
Real d_inv=1/d;
out[0]=in[3]*d_inv;
out[3]=in[0]*d_inv;
float t=-in[1]*d_inv;
out[1]=t;
out[2]=t;
return true;
}
return false;
}
};
template<typename Real>struct matrix_inverse_impl<static_matrix<3,3,Real>,static_matrix<3,3,Real> >{
static inline bool call(const static_matrix<3,3,Real>&in,static_matrix<3,3,Real>&out,Real*det)
{
const Real&m0=in[0],&m1=in[1],&m2=in[2],
&m3=in[3],&m4=in[4],&m5=in[5],
&m6=in[6],&m7=in[7],&m8=in[8];
Real A0=m4*m8,
A1=m3*m8,
A2=m3*m7,
B0=m5*m7,
B1=m5*m6,
B2=m4*m6;
Real K0=A0-B0,
K1=A1-B1,
K2=A2-B2;
Real d=m0*K0-m1*K1+m2*K2;
if(det!=NULL)*det=d;
if(d!=0){
Real detInv=1/d;
out[0]=K0*detInv;
out[3]=-K1*detInv;
out[6]=K2*detInv;
out[1]=(m2*m7-m1*m8)*detInv;
out[4]=(m0*m8-m2*m6)*detInv;
out[7]=(m1*m6-m0*m7)*detInv;
out[2]=(m1*m5-m2*m4)*detInv;
out[5]=(m2*m3-m0*m5)*detInv;
out[8]=(m0*m4-m1*m3)*detInv;
return true;
}
return false;
}
};
template<typename Real>struct matrix_inverse_sym_impl<static_matrix<3,3,Real>,static_matrix<3,3,Real> >{
static inline bool call(const static_matrix<3,3,Real>&in,static_matrix<3,3,Real>&out,Real*det)
{
const Real&m0=in[0],&m1=in[1],&m2=in[2],
&m3=in[3],&m4=in[4],&m5=in[5],
&m6=in[6],&m7=in[7],&m8=in[8];
Real A0=m4*m8,
A1=m1*m8,
A2=m1*m5,
B0=m5*m5,
B1=m5*m2,
B2=m4*m2;
Real K0=A0-B0,
K1=A1-B1,
K2=A2-B2;
Real d=m0*K0-m1*K1+m2*K2;
if(det!=NULL)*det=d;
if(d!=0){
Real detInv=1/d;
out[0]=K0*detInv;
out[1]=out[3]=-K1*detInv;
out[2]=out[6]=K2*detInv;
out[4]=(m0*m8-m2*m2)*detInv;
out[5]=out[7]=(m1*m2-m0*m5)*detInv;
out[8]=(m0*m4-m1*m1)*detInv;
return true;
}
return false;
}
};
template<typename Real>struct matrix_inverse_impl<static_matrix<4,4,Real>,static_matrix<4,4,Real> >{
static inline bool call(const static_matrix<4,4,Real>&in,static_matrix<4,4,Real>&out,Real*det)
{
Real A0=in[0]*in[5]-in[1]*in[4];
Real A1=in[0]*in[6]-in[2]*in[4];
Real A2=in[0]*in[7]-in[3]*in[4];
Real A3=in[1]*in[6]-in[2]*in[5];
Real A4=in[1]*in[7]-in[3]*in[5];
Real A5=in[2]*in[7]-in[3]*in[6];
Real B0=in[8]*in[13]-in[9]*in[12];
Real B1=in[8]*in[14]-in[10]*in[12];
Real B2=in[8]*in[15]-in[11]*in[12];
Real B3=in[9]*in[14]-in[10]*in[13];
Real B4=in[9]*in[15]-in[11]*in[13];
Real B5=in[10]*in[15]-in[11]*in[14];
Real d=A0*B5-A1*B4+A2*B3+A3*B2-A4*B1+A5*B0;
if(det!=NULL)*det=d;
if(d!=0)
{
Real invD=1/d;
out[0]=(in[5]*B5-in[6]*B4+in[7]*B3)*invD;
out[4]=(-in[4]*B5+in[6]*B2-in[7]*B1)*invD;
out[8]=(in[4]*B4-in[5]*B2+in[7]*B0)*invD;
out[12]=(-in[4]*B3+in[5]*B1-in[6]*B0)*invD;
out[1]=(-in[1]*B5+in[2]*B4-in[3]*B3)*invD;
out[5]=(in[0]*B5-in[2]*B2+in[3]*B1)*invD;
out[9]=(-in[0]*B4+in[1]*B2-in[3]*B0)*invD;
out[13]=(in[0]*B3-in[1]*B1+in[2]*B0)*invD;
out[2]=(in[13]*A5-in[14]*A4+in[15]*A3)*invD;
out[6]=(-in[12]*A5+in[14]*A2-in[15]*A1)*invD;
out[10]=(in[12]*A4-in[13]*A2+in[15]*A0)*invD;
out[14]=(-in[12]*A3+in[13]*A1-in[14]*A0)*invD;
out[3]=(-in[9]*A5+in[10]*A4-in[11]*A3)*invD;
out[7]=(in[8]*A5-in[10]*A2+in[11]*A1)*invD;
out[11]=(-in[8]*A4+in[9]*A2-in[11]*A0)*invD;
out[15]=(in[8]*A3-in[9]*A1+in[10]*A0)*invD;
return true;
}
return false;
}
};
template<typename Real>struct matrix_inverse_sym_impl<static_matrix<4,4,Real>,static_matrix<4,4,Real> >{
static inline bool call(const static_matrix<4,4,Real>&in,static_matrix<4,4,Real>&out,Real*det)
{
const Real&i0=in[0],&i1=in[1],&i2=in[2],&i3=in[3],
&i5=in[5],&i6=in[6],&i7=in[7],
&i10=in[10],&i11=in[11],
&i15=in[15];
Real A0=i0*i5-i1*i1;
Real A1=i0*i6-i2*i1;
Real A2=i0*i7-i3*i1;
Real A3=i1*i6-i2*i5;
Real A4=i1*i7-i3*i5;
Real A5=i2*i7-i3*i6;
Real B0=i2*i7-i6*i3;
Real B1=i2*i11-i10*i3;
Real B2=i2*i15-i11*i3;
Real B3=i6*i11-i10*i7;
Real B4=i6*i15-i11*i7;
Real B5=i10*i15-i11*i11;
Real d=A0*B5-A1*B4+A2*B3+A3*B2-A4*B1+A5*B0;
if(det!=NULL)*det=d;
if(d!=0)
{
Real invD=1/d;
out[0]=(i5*B5-i6*B4+i7*B3)*invD;
out[1]=out[4]=(-i1*B5+i6*B2-i7*B1)*invD;
out[2]=out[8]=(i1*B4-i5*B2+i7*B0)*invD;
out[3]=out[12]=(-i1*B3+i5*B1-i6*B0)*invD;
out[5]=(i0*B5-i2*B2+i3*B1)*invD;
out[6]=out[9]=(-i0*B4+i1*B2-i3*B0)*invD;
out[7]=out[13]=(i0*B3-i1*B1+i2*B0)*invD;
out[10]=(i3*A4-i7*A2+i15*A0)*invD;
out[11]=out[14]=(-i3*A3+i7*A1-i11*A0)*invD;
out[15]=(i2*A3-i6*A1+i10*A0)*invD;
return true;
}
return false;
}
};
template<typename MI,typename MO>
inline bool matrix_inverse(const MI&in,MO&out,typename MI::real_type*det=NULL){
assert(in.rows==in.cols);
assert(out.rows==out.cols);
return matrix_inverse_impl<MI,MO>::call(in,out,det);
}
template<typename MI>
inline MI inverse(const MI&in){
MI out;
resize_if_dynamic(out,in.rows,in.cols);
matrix_inverse_impl<MI,MI>::call(in,out,NULL);
return out;
}
template<typename MI,typename MO>
inline bool matrix_inverse_sym(const MI&in,MO&out,typename MI::real_type*det=NULL){
assert(in.rows==in.cols);
assert(out.rows==out.cols);
return matrix_inverse_sym_impl<MI,MO>::call(in,out,det);
}
template<typename MI,typename MO>
inline bool matrix_inverse_diag(const MI&in,MO&out,typename MI::real_type*det=NULL){
assert(in.rows==in.cols);
assert(out.rows==out.cols);
assert(&in!=&out);
fill(out,0.0f);
for(unsigned i=0;i<in.rows;++i){
float w=in(i,i);
if(w!=0)
out(i,i)=1/w;
else return false;
}
return true;
}
template<typename MI>struct matrix_det_impl
{
static inline typename MI::real_type call(const MI&in)
{
assert(is_square(in));
typedef typename MI::real_type Real;
MI L,U;
if(!LU_decomposition(in,L,U))
throw std::runtime_error("Determinant failed");
Real d=1;
for(unsigned i=0;i<in.rows;++i)
d*=L(i,i)*U(i,i);
return d;
}
};
template<typename Real>struct matrix_det_impl<static_matrix<1,1,Real> >
{
static inline Real call(const static_matrix<1,1,Real>&in)
{
return in[0];
}
};
template<typename Real>struct matrix_det_impl<static_matrix<2,2,Real> >
{
static inline Real call(const static_matrix<2,2,Real>&in)
{
return in[0]*in[3]-in[1]*in[2];
}
};
template<typename Real>struct matrix_det_impl<static_matrix<3,3,Real> >
{
static inline Real call(const static_matrix<3,3,Real>&in)
{
Real A0=in[4]*in[8],
A1=in[3]*in[8],
A2=in[3]*in[7],
B0=in[5]*in[7],
B1=in[5]*in[6],
B2=in[4]*in[6];
Real K0=A0-B0,
K1=A1-B1,
K2=A2-B2;
return in[0]*K0-in[1]*K1+in[2]*K2;
}
};
template<typename Real>struct matrix_det_impl<static_matrix<4,4,Real> >
{
static inline Real call(const static_matrix<4,4,Real>&in)
{
Real A0=in[0]*in[5]-in[1]*in[4];
Real A1=in[0]*in[6]-in[2]*in[4];
Real A2=in[0]*in[7]-in[3]*in[4];
Real A3=in[1]*in[6]-in[2]*in[5];
Real A4=in[1]*in[7]-in[3]*in[5];
Real A5=in[2]*in[7]-in[3]*in[6];
Real B0=in[8]*in[13]-in[9]*in[12];
Real B1=in[8]*in[14]-in[10]*in[12];
Real B2=in[8]*in[15]-in[11]*in[12];
Real B3=in[9]*in[14]-in[10]*in[13];
Real B4=in[9]*in[15]-in[11]*in[13];
Real B5=in[10]*in[15]-in[11]*in[14];
return A0*B5-A1*B4+A2*B3+A3*B2-A4*B1+A5*B0;
}
};
template<typename MI>
inline typename MI::real_type determinant(const MI&in)
{
return matrix_det_impl<MI>::call(in);
}
template<typename MI>
inline typename MI::real_type det(const MI&in)
{
return matrix_det_impl<MI>::call(in);
}
}
#include<iostream>
#include<cstdio>
namespace heinlib
{
template<typename MxN,typename Nx1>
bool null_space_gaussian(const MxN&A,Nx1&x)
{
#pragma message("warning...null_space_basis has rare out-of-bounds access bug!!")
typedef typename MxN::real_type Real;
unsigned M=A.rows,N=A.cols;
resize_if_dynamic(x,N,1);
assert(size_is(x,N,1));
typename augment_columns<MxN,1>::result_type aug,rr;
resize_if_dynamic(aug,M,N+1);
resize_if_dynamic(rr,M,N+1);
aug.block_insert(0,0,A);
for(unsigned i=0;i<M;++i)
aug(i,N)=0;
++N;
gauss_jordan_elimination(aug,rr);
typename augment_columns<typename big_square<MxN>::result_type,1>::result_type B;
int mn=std::max(M,N);
resize_if_dynamic(B,mn,mn);
fill(B,0);
B.block_insert(0,0,rr);
for(int i=mn-1;i>=0;--i){
B(i,i)=1;
bool constr=false;
for(int j=i+1;j<mn;++j){
if(B(i,j)!=0){
constr=true;
break;
}
}
if(!constr)B(i,mn-1)=1;
}
back_substitution(B,x);
return true;
}
template<int Loud,class MxN>
bool null_space_basis(const MxN&A,dynamic_matrix<typename MxN::real_type>&B,typename MxN::real_type eps=0)
{
typedef typename MxN::real_type Real;
unsigned M=A.rows,N=A.cols;
MxN rr;
gauss_jordan_elimination<Loud-1>(A,rr,eps);
if(Loud>0)std::cout<<"RREF = \n"<<rr<<"\n";
typename big_square<MxN>::result_type S;
resize_if_dynamic(S,N,N);
fill(S,0);
S.block_insert(0,0,rr);
if(Loud>0)std::cout<<"S init= \n"<<S<<"\n";
unsigned c=0,basis_dim=0;
unsigned basis_pts[10];
for(unsigned r=0;r<N;++r)
{
while(c<N&&abs(S(r,c))<=eps){
basis_pts[basis_dim]=c;
++c;
++basis_dim;
}
if(c>r&&c<N){
unsigned shift=c-r;
for(unsigned n=N-1;int(n)-int(shift)>=int(r);--n)
{
for(unsigned j=0;j<N;++j)
S(n,j)=S(n-shift,j);
}
for(unsigned n=r;n<r+shift;++n)
for(unsigned j=0;j<N;++j)
S(n,j)=0;
r=c;
}
++c;
}
if(Loud>0)printf("basis dim = %d\n",basis_dim);
if(basis_dim==0)
return false;
if(Loud>0)std::cout<<"Arranged = \n"<<S<<"\n";
B.resize(N,basis_dim);
for(unsigned b=0;b<basis_dim;++b)
{
unsigned basis_pt=basis_pts[b];
for(unsigned r=0;r<basis_pt;++r)
B(r,b)=-S(r,basis_pt);
B(basis_pt,b)=1;
for(unsigned r=basis_pt+1;r<N;++r)
B(r,b)=0;
}
return true;
}
template<unsigned M,unsigned N,unsigned D,typename Real>
bool null_space_basis(const static_matrix<M,N,Real>&A,static_matrix<N,D,Real>&B,Real eps=1e-6)
{
assert(M<N);
static_matrix<M,N,Real>rr;
if(!gauss_jordan_elimination<0>(A,rr,eps))
return false;
typename big_square<static_matrix<M,N,Real> >::result_type S={0};
S.block_insert(0,0,rr);
unsigned c=0,basis_dim=0;
unsigned basis_pts[10];
for(unsigned r=0;r<N;++r)
{
while(c<N&&abs(S(r,c))<=eps){
basis_pts[basis_dim]=c;
++c;
++basis_dim;
}
if(c>r&&c<N){
unsigned shift=c-r;
for(unsigned n=N-1;int(n)-int(shift)>=int(r);--n)
{
for(unsigned j=0;j<N;++j)
S(n,j)=S(n-shift,j);
}
for(unsigned n=r;n<r+shift;++n)
for(unsigned j=0;j<N;++j)
S(n,j)=0;
r=c;
}
++c;
}
if(basis_dim!=D||basis_dim==0)
return false;
for(unsigned b=0;b<basis_dim;++b)
{
unsigned basis_pt=basis_pts[b];
for(unsigned r=0;r<basis_pt;++r)
B(r,b)=-S(r,basis_pt);
B(basis_pt,b)=1;
for(unsigned r=basis_pt+1;r<N;++r)
B(r,b)=0;
}
return true;
}
template<typename MxN,typename Nx1>
bool null_space_SVD(const MxN&A,Nx1&x,typename MxN::real_type eps=1e-20)
{
typedef typename MxN::real_type Real;
typedef typename square_result<Nx1>::result_type NxN;
unsigned M=A.rows,N=A.cols;
resize_if_dynamic(x,N,1);
assert(size_is(x,N,1));
MxN U;
resize_if_dynamic(U,M,N);
NxN V;
resize_if_dynamic(V,N,N);
NxN S;
resize_if_dynamic(S,N,N);
if(!SVD<false,true>(A,U,S,V,eps))
{
return false;
}
for(unsigned i=0;i<N;++i)
x[i]=V(i,N-1);
return true;
}
template<unsigned M,unsigned N,unsigned D,typename Real>
bool null_space_basis_SVD(const static_matrix<M,N,Real>&A,static_matrix<N,D,Real>&B,Real eps=1e-6)
{
static_matrix<M,N,Real>U;
static_matrix<N,N,Real>V,S;
if(!SVD<false,true>(A,U,S,V,eps))
{
return false;
}
for(unsigned i=0;i<D;++i)
B.block_insert(0,i,V.get_column(N-1-i));
return true;
}
namespace detail
{
template<typename T>
__forceinline T det_2x2(const T&m0,const T&m1,
const T&m2,const T&m3)
{
return m0*m3-m1*m2;
}
template<typename T>
__forceinline T det_3x3(const T&m0,const T&m1,const T&m2,
const T&m3,const T&m4,const T&m5,
const T&m6,const T&m7,const T&m8)
{
T A0=m4*m8,
A1=m3*m8,
A2=m3*m7,
B0=m5*m7,
B1=m5*m6,
B2=m4*m6;
T K0=A0-B0,
K1=A1-B1,
K2=A2-B2;
return m0*K0-m1*K1+m2*K2;
}
}
template<typename MxN,typename Nx1>
bool null_space_2x3(const MxN&A,Nx1&x)
{
typedef typename MxN::real_type Real;
assert(size_is(A,2,3)||size_is(A,3,3));
resize_if_dynamic(x,3,1);
assert(size_is(x,3,1));
using namespace detail;
x[0]=det_2x2(A(0,1),A(0,2),
A(1,1),A(1,2));
x[1]=-det_2x2(A(0,0),A(0,2),
A(1,0),A(1,2));
x[2]=det_2x2(A(0,0),A(0,1),
A(1,0),A(1,1));
Real norm=length_sq(x);
if(size_is(A,3,3))
{
Nx1 x2;
x2[0]=det_2x2(A(1,1),A(1,2),
A(2,1),A(2,2));
x2[1]=-det_2x2(A(1,0),A(1,2),
A(2,0),A(2,2));
x2[2]=det_2x2(A(1,0),A(1,1),
A(2,0),A(2,1));
Real norm2=length_sq(x2);
if(norm2>norm)
{
x=x2;
norm=norm2;
}
}
if(norm>0)x/=sqrt(norm);
return true;
}
template<typename MxN,typename Nx1>
bool null_space_3x4(const MxN&A,Nx1&x)
{
assert(size_is(A,3,4));
resize_if_dynamic(x,4,1);
assert(size_is(x,4,1));
using namespace detail;
x[0]=det_3x3(A(0,1),A(0,2),A(0,3),
A(1,1),A(1,2),A(1,3),
A(2,1),A(2,2),A(2,3));
x[1]=-det_3x3(A(0,0),A(0,2),A(0,3),
A(1,0),A(1,2),A(1,3),
A(2,0),A(2,2),A(2,3));
x[2]=det_3x3(A(0,0),A(0,1),A(0,3),
A(1,0),A(1,1),A(1,3),
A(2,0),A(2,1),A(2,3));
x[3]=-det_3x3(A(0,0),A(0,1),A(0,2),
A(1,0),A(1,1),A(1,2),
A(2,0),A(2,1),A(2,2));
return true;
}
template<typename MxN,typename Nx1>
bool null_space(const MxN&A,Nx1&x)
{
if(size_is(A,2,3))
return null_space_2x3(A,x);
else if(size_is(A,3,4))
return null_space_3x4(A,x);
else return null_space_SVD(A,x);
}
}
#include<string>
#include<sstream>
namespace heinlib
{
template<typename Real>
__forceinline static_matrix<2,1,Real>make_vector2(const Real&x,const Real&y)
{
static_matrix<2,1,Real>ret={x,y};
return ret;
}
template<typename Real>
__forceinline static_matrix<3,1,Real>make_vector3(Real x,Real y,Real z)
{
static_matrix<3,1,Real>ret={x,y,z};
return ret;
}
template<typename Real>
__forceinline static_matrix<4,1,Real>make_vector4(const Real&x,const Real&y,const Real&z,const Real&w)
{
static_matrix<4,1,Real>ret={x,y,z,w};
return ret;
}
template<typename T,unsigned M>
__forceinline static_matrix<M,1,T>homogeneous_divide(const static_matrix<M,1,T>&v)
{
if(v[M-1]==1)return v;
else return v/v[M-1];
}
template<unsigned M,unsigned M2,typename T>
__forceinline static_matrix<M+M2,1,T>append(const static_matrix<M,1,T>&v1,const static_matrix<M2,1,T>&v2)
{
static_matrix<M+M2,1,T>res;
for(unsigned i=0;i<M;++i)
res[i]=v1[i];
for(unsigned i=0;i<M2;++i)
res[M+i]=v2[i];
return res;
}
template<unsigned N,unsigned M,typename T>
__forceinline static_matrix<M+N,1,T>append(const static_matrix<M,1,T>&v1,const T&v2)
{
static_matrix<M+N,1,T>res;
unsigned i=0;
while(i<M){
res[i]=v1[i];
++i;
}
while(i<M+N){
res[i]=v2;
++i;
}
return res;
}
template<unsigned S,unsigned M,typename T>
__forceinline static_matrix<S,1,T>resize(const static_matrix<M,1,T>&v1)
{
static_matrix<S,1,T>res={0};
for(unsigned i=0,last=std::min(S,M);i<last;++i)
res[i]=v1[i];
return res;
}
template<unsigned S,typename T>
__forceinline dynamic_matrix<T>resize(const dynamic_matrix<T>&v1)
{
dynamic_matrix<T>res(S);
for(unsigned i=0,last=std::min(S,v1.rows*v1.cols);i<last;++i)
res[i]=v1[i];
return res;
}
template<typename T,unsigned M>
__forceinline static_matrix<M-1,1,T>realize(const static_matrix<M,1,T>&v)
{
return resize<M-1>(v/v[M-1]);
}
template<typename T,unsigned M>
__forceinline static_matrix<M+1,1,T>homogenize(const static_matrix<M,1,T>&v)
{
return append<1>(v,T(1));
}
template<typename Vector,typename Func>
__forceinline Vector binary_element_map(const Vector&a,const Vector&b,Func f)
{
assert(same_dim(a,b));
Vector out;
resize_if_dynamic(out,a.rows,1);
for(unsigned i=0;i<a.rows;++i)
out[i]=f(a[i],b[i]);
return out;
}
template<typename Vector,typename Func>
__forceinline Vector unary_element_map(const Vector&a,Func f)
{
Vector out;
resize_if_dynamic(out,a.rows,1);
for(unsigned i=0;i<a.rows;++i)
out[i]=f(a[i]);
return out;
}
template<typename Vector>
__forceinline Vector normalize(const Vector&m)
{
return m/length(m);
}
template<typename Real>
__forceinline static_matrix<3,3,Real>cross_product_matrix(const static_matrix<3,1,Real>&v)
{
static_matrix<3,3,Real>sk={0,-v.z(),v.y(),
v.z(),0,-v.x(),
-v.y(),v.x(),0};
return sk;
}
template<typename Vector>
__forceinline Vector lerp(const Vector&left,const Vector&right,typename Vector::real_type time)
{
return left*(1-time)+right*time;
}
template<typename Real>
__forceinline static_matrix<2,1,Real>rotate(const static_matrix<2,1,Real>&vec,Real rad)
{
Real cos_rad=cos(rad),sin_rad=sin(rad);
static_matrix<2,1,Real>out={cos_rad*vec.x()+sin_rad*vec.y(),-sin_rad*vec.x()+cos_rad*vec.y()};
return out;
}
template<typename Real>
__forceinline static_matrix<2,1,Real>rotate90(const static_matrix<2,1,Real>&vec)
{
static_matrix<2,1,Real>out={vec.y(),-vec.x()};
return out;
}
template<typename Real>
__forceinline static_matrix<3,1,Real>cross(const static_matrix<3,1,Real>&u,const static_matrix<3,1,Real>&v)
{
static_matrix<3,1,Real>out={u.y()*v.z()-u.z()*v.y(),
u.z()*v.x()-u.x()*v.z(),
u.x()*v.y()-u.y()*v.x()};
return out;
}
template<typename Real>
__forceinline Real cross(const static_matrix<2,1,Real>&u,const static_matrix<2,1,Real>&v)
{
return u.x()*v.y()-u.y()*v.x();
}
template<typename Vector>
__forceinline Vector reflect(const Vector&in,const Vector&norm)
{
return in-2*dot(in,norm)*norm;
}
template<typename Vector>
__forceinline Vector refract(const Vector&in,const Vector&norm,float IOR_in,float IOR_out)
{
float dp=dot(in,norm);
return in-dp*in+sqrt(sq(IOR_out)-sq(IOR_in)+sq(dp))*norm;
}
template<typename Vector>
__forceinline Vector project(const Vector&a,const Vector&b)
{
return b*(dot(a,b)/dot(b,b));
}
template<class Vector>
__forceinline Vector mirror(const Vector&X,
const Vector&pt,const Vector&normal)
{
assert(length(normal)==1);
return X-2*normal*dot(X-pt,normal);
}
template<class Real>
__forceinline static_matrix<3,1,Real>join_line(const static_matrix<3,1,Real>&p1,const static_matrix<3,1,Real>&p2)
{
return cross(p1,p2);
}
template<class Real>
__forceinline static_matrix<3,1,Real>join_line(const static_matrix<2,1,Real>&p1,const static_matrix<2,1,Real>&p2)
{
return cross(homogenize(p1),homogenize(p2));
}
template<class Real>
__forceinline static_matrix<3,1,Real>join_line(Real x1,Real y1,Real x2,Real y2)
{
return cross(make_vector3<Real>(x1,y1,1),make_vector3<Real>(x2,y2,1));
}
template<class Real>
static_matrix<3,1,Real>intersect(const static_matrix<3,1,Real>&line1,const static_matrix<3,1,Real>&line2)
{
return cross(line1,line2);
}
template<class Real>
bool intersect(
const static_matrix<2,1,Real>&s1,const static_matrix<2,1,Real>&e1,
const static_matrix<2,1,Real>&s2,const static_matrix<2,1,Real>&e2,
static_matrix<2,1,Real>*x=NULL)
{
static_matrix<2,2,Real>A={s1.x()-e1.x(),e2.x()-s2.x(),s1.y()-e1.y(),e2.y()-s2.y()};
static_matrix<2,1,Real>b={e2.x()-e1.x(),e2.y()-e1.y()};
static_matrix<2,1,Real>time;
if(!gaussian_elimination(A,b,time))
return false;
Real t1=time[0],t2=time[1];
if(t1>0&&t2>0&&t1<1&&t2<1)
{
if(x)*x=s1*t1+(1-t1)*e1;
return true;
}else return false;
}
template<class Real>
bool fuzzy_intersect(
const static_matrix<2,1,Real>&s1,const static_matrix<2,1,Real>&e1,
const static_matrix<2,1,Real>&s2,const static_matrix<2,1,Real>&e2,
Real dist_tol=0,
static_matrix<2,1,Real>*x=NULL)
{
static_matrix<2,1,Real>dir1=normalize(e1-s1),dir2=normalize(e2-s2);
static_matrix<2,2,Real>A={dir1.x(),-dir2.x(),dir1.y(),-dir2.y()};
static_matrix<2,1,Real>b={s2.x()-s1.x(),s2.y()-s1.y()};
static_matrix<2,1,Real>time;
if(!gaussian_elimination(A,b,time))
return false;
Real t1=time[0],t2=time[1];
if(t1>-dist_tol&&
t2>-dist_tol&&
t1<distance(s1,e1)+dist_tol&&
t2<distance(s2,e2)+dist_tol)
{
if(x)*x=s1+t1*dir1;
return true;
}else return false;
}
template<class Real>
static_matrix<3,1,Real>intersect(
const static_matrix<3,1,Real>&p0,
const static_matrix<3,1,Real>&p1,
const static_matrix<4,1,Real>&plane,
Real*intersect_time=NULL)
{
static_matrix<3,1,Real>dir=normalize(p1-p0);
static_matrix<3,1,float>point,normal;
point_normal_form(point,normal,plane);
Real t=(dot(point,normal)-dot(p0,normal))/dot(dir,normal);
if(intersect_time)*intersect_time=t;
return p0+t*dir;
}
template<class Real>
bool intersect(
static_matrix<3,1,Real>&pt,
static_matrix<3,1,Real>&dir,
const static_matrix<4,1,Real>&plane1,
const static_matrix<4,1,Real>&plane2)
{
static_matrix<3,1,float>n1=resize<3>(plane1),n2=resize<3>(plane2);
dir=cross(n1,n2);
Real len=length(dir);
if(len==0)return false;
dir/=len;
static_matrix<2,4,float>A;
A.block_insert(0,0,transpose(plane1));
A.block_insert(1,0,transpose(plane2));
static_matrix<4,1,float>x;
if(!null_space_SVD(A,x))
return false;
pt=realize(x);
return true;
}
template<unsigned D,class Real>
__forceinline Real point_line_dist(
const static_matrix<D,1,Real>&p,
const static_matrix<D,1,Real>&p0,
const static_matrix<D,1,Real>&p1)
{
static_matrix<D,1,Real>uL=normalize(p1-p0),w=p-p0;
return length(w-dot(w,uL)*uL);
}
template<unsigned D,class Real>
__forceinline static_matrix<D,1,Real>closest_point_on_line(
const static_matrix<D,1,Real>&p,
const static_matrix<D,1,Real>&p0,
const static_matrix<D,1,Real>&p1)
{
static_matrix<D,1,Real>uL=normalize(p1-p0),w=p-p0;
return p0+dot(w,uL)*uL;
}
template<unsigned D,class Real>
__forceinline Real sq_point_line_dist(
const static_matrix<D,1,Real>&p,
const static_matrix<D,1,Real>&p0,
const static_matrix<D,1,Real>&p1)
{
static_matrix<D,1,Real>uL=normalize(p1-p0),w=p-p0;
return length_sq(w-dot(w,uL)*uL);
}
template<unsigned D,class Real>
__forceinline Real sq_point_hyperplane_dist(
const static_matrix<D,1,Real>&x,
const static_matrix<D,1,Real>&p,
const static_matrix<D,1,Real>&n)
{
Real len=length(n);
return sq(abs(dot(x-p,n))/len);
}
template<unsigned D,class Real>
__forceinline static_matrix<D,1,Real>closest_pt_on_hyperplane(
const static_matrix<D,1,Real>&x,
const static_matrix<D,1,Real>&p,
const static_matrix<D,1,Real>&n)
{
return x-(dot(x-p,n)/dot(n,n))*n;
}
template<class Real>
__forceinline Real point_line_dist(const static_matrix<3,1,Real>&pt,const static_matrix<3,1,Real>&line)
{
return abs(dot(homogeneous_divide(pt),line))/sqrt(sq(line.x())+sq(line.y()));
}
template<class Real>
__forceinline Real point_line_dist(const static_matrix<2,1,Real>&pt,const static_matrix<3,1,Real>&line)
{
return abs(dot(homogenize(pt),line))/sqrt(sq(line.x())+sq(line.y()));
}
template<class Real>
__forceinline Real signed_point_line_dist(const static_matrix<2,1,Real>&pt,const static_matrix<3,1,Real>&line)
{
return dot(homogenize(pt),line)/sqrt(sq(line.x())+sq(line.y()));
}
template<class Real>
__forceinline static_matrix<3,1,Real>orthogonal_shift_line(const static_matrix<3,1,Real>&line,Real shift)
{
Real a=line.x(),b=line.y(),c=line.z();
Real delta=-shift*sqrt(a*a+b*b);
static_matrix<3,1,Real>l2=line;
l2.z()+=delta;
return l2;
}
template<class Real>
std::string print_line_yint_form(const static_matrix<3,1,Real>&line)
{
Real m=-line.x()/line.y(),b=-line.z()/line.y();
std::stringstream ss;
ss<<m<<"*x + "<<b;
return ss.str();
}
template<class Real>
__forceinline Real sq_point_line_dist(const static_matrix<3,1,Real>&pt,const static_matrix<3,1,Real>&line)
{
return sq(dot(homogeneous_divide(pt),line))/(sq(line.x())+sq(line.y()));
}
template<class Real>
__forceinline Real sq_point_line_dist(const static_matrix<2,1,Real>&pt,const static_matrix<3,1,Real>&line)
{
return sq(dot(homogenize(pt),line))/(sq(line.x())+sq(line.y()));
}
template<class Real>
__forceinline static_matrix<3,1,Real>closest_point_on_line(const static_matrix<3,1,Real>&pt,const static_matrix<3,1,Real>&line)
{
static_matrix<3,1,Real>v;
v[0]=(-line.z()*pt.z()-line.y()*pt.y())*line.x()+sq(line.y())*pt.x();
v[1]=sq(line.x())*pt.y()+(-line.z()*pt.z()-line.x()*pt.x())*line.y();
v[2]=sq(line.x())*pt.z()+sq(line.y())*pt.z();
return v;
}
template<class Real>
__forceinline static_matrix<2,1,Real>closest_point_on_line(const static_matrix<2,1,Real>&pt,const static_matrix<3,1,Real>&line)
{
static_matrix<3,1,Real>v;
v[0]=(-line.z()-line.y()*pt.y())*line.x()+sq(line.y())*pt.x();
v[1]=sq(line.x())*pt.y()+(-line.z()-line.x()*pt.x())*line.y();
v[2]=sq(line.x())+sq(line.y());
return realize(v);
}
template<class Real>
__forceinline static_matrix<2,1,Real>closest_point_on_segment(
const static_matrix<2,1,Real>&pt,
const static_matrix<2,1,Real>&segStart,
const static_matrix<2,1,Real>&segEnd,
int*pttype=NULL,
Real*dist=NULL)
{
Real seg_len=distance(segStart,segEnd);
static_matrix<2,1,Real>dir=(segEnd-segStart)/seg_len,w=pt-segStart;
Real t=dot(w,dir);
if(t>0&&t<seg_len)
{
if(pttype)*pttype=0;
if(dist)*dist=distance(pt,segStart+t*dir);
return segStart+t*dir;
}else
{
Real d1=distance(pt,segStart);
Real d2=distance(pt,segEnd);
if(d1<d2)
{
if(pttype)*pttype=1;
if(dist)*dist=d1;
return segStart;
}
else
{
if(pttype)*pttype=2;
if(dist)*dist=d2;
return segEnd;
}
}
}
template<class Real>
__forceinline Real point_segment_dist(
const static_matrix<2,1,Real>&pt,
const static_matrix<2,1,Real>&segStart,
const static_matrix<2,1,Real>&segEnd)
{
return distance(pt,closest_point_on_segment(pt,segStart,segEnd));
}
template<class Real>
__forceinline Real segment_distance(
const static_matrix<2,1,Real>&startA,
const static_matrix<2,1,Real>&endA,
const static_matrix<2,1,Real>&startB,
const static_matrix<2,1,Real>&endB)
{
static_matrix<2,1,Real>test=closest_point_on_segment(startB,startA,endA);
Real min_dist_sq=distance_sq(test,startB);
test=closest_point_on_segment(endB,startA,endA);
Real dist_sq=distance_sq(test,endB);
if(dist_sq<min_dist_sq)
min_dist_sq=dist_sq;
test=closest_point_on_segment(startA,startB,endB);
dist_sq=distance_sq(test,startA);
if(dist_sq<min_dist_sq)
min_dist_sq=dist_sq;
test=closest_point_on_segment(endA,startB,endB);
dist_sq=distance_sq(test,endA);
if(dist_sq<min_dist_sq)
min_dist_sq=dist_sq;
return sqrt(min_dist_sq);
}
template<typename Real>
__forceinline void closest_point_to_origin(const static_matrix<3,1,Real>&line,static_matrix<3,1,Real>&pt)
{
pt.x()=-line.x()*line.z();
pt.y()=-line.y()*line.z();
pt.z()=sq(line.x())+sq(line.y());
}
template<typename Real>
__forceinline static_matrix<2,1,Real>closest_point_to_origin(const static_matrix<3,1,Real>&line)
{
static_matrix<3,1,Real>pt=
{
-line.x()*line.z(),
-line.y()*line.z(),
sq(line.x())+sq(line.y())
};
return realize(pt);
}
template<class Real>
__forceinline Real dist_to_origin(const static_matrix<3,1,Real>&line)
{
return length(closest_point_to_origin(line));
}
template<class Real>
__forceinline Real dist_to_point(const static_matrix<2,1,float>&point,const static_matrix<3,1,Real>&line)
{
return distance(point,closest_point_on_line(point,line));
}
template<class Real>
__forceinline Real signed_point_plane_dist(
const static_matrix<4,1,Real>&point,
const static_matrix<4,1,Real>&plane)
{
return dot(homogeneous_divide(point),plane)/
sqrt(sq(plane[0])+sq(plane[1])+sq(plane[2]));
}
template<class Real>
__forceinline Real signed_point_plane_dist(
const static_matrix<3,1,Real>&point,
const static_matrix<4,1,Real>&plane)
{
return(point[0]*plane[0]+point[1]*plane[1]+point[2]*plane[2]+plane[3])/
sqrt(sq(plane[0])+sq(plane[1])+sq(plane[2]));
}
template<class Real>
__forceinline Real point_plane_dist(
const static_matrix<3,1,Real>&point,
const static_matrix<4,1,Real>&plane)
{
return abs(signed_point_plane_dist(point,plane));
}
template<class Real>
static_matrix<4,1,Real>plane_through_point(
const static_matrix<3,1,Real>&point,
const static_matrix<3,1,Real>&normal)
{
return append<1>(normal,-dot(point,normal));
}
template<class Real>
void point_normal_form(
static_matrix<3,1,Real>&point,
static_matrix<3,1,Real>&normal,
const static_matrix<4,1,Real>&plane)
{
normal=resize<3>(plane);
point=-plane[3]*normal/length_sq(normal);
}
template<class Real>
static_matrix<4,1,Real>plane_through_points(
const static_matrix<3,1,Real>&p0,
const static_matrix<3,1,Real>&p1,
const static_matrix<3,1,Real>&p2)
{
static_matrix<3,1,Real>n=cross(p2-p0,p1-p0);
return append<1>(n,-dot(p0,n));
}
}
#pragma once
namespace heinlib
{
template<typename T>
struct constants;
template<typename Real>
struct constants<static_matrix<3,1,Real> >
{
static inline static_matrix<3,1,Real>e1()
{
static const static_matrix<3,1,Real>ret={1,0,0};
return ret;
}
static inline static_matrix<3,1,Real>e2()
{
static const static_matrix<3,1,Real>ret={0,1,0};
return ret;
}
static inline static_matrix<3,1,Real>e3()
{
static const static_matrix<3,1,Real>ret={0,0,1};
return ret;
}
};
template<typename Real>
struct constants<static_matrix<4,1,Real> >
{
static inline static_matrix<4,1,Real>e1()
{
static const static_matrix<4,1,Real>ret={1,0,0,0};
return ret;
}
static inline static_matrix<4,1,Real>e2()
{
static const static_matrix<4,1,Real>ret={0,1,0,0};
return ret;
}
static inline static_matrix<4,1,Real>e3()
{
static const static_matrix<4,1,Real>ret={0,0,1,0};
return ret;
}
static inline static_matrix<4,1,Real>e4()
{
static const static_matrix<4,1,Real>ret={0,0,0,1};
return ret;
}
};
template<typename Real>
struct constants<static_matrix<2,2,Real> >
{
static inline static_matrix<2,2,Real>identity()
{
static const static_matrix<2,2,Real>ret={1,0,0,1};
return ret;
}
};
template<typename Real>
struct constants<static_matrix<3,3,Real> >
{
static inline static_matrix<3,3,Real>identity()
{
static const static_matrix<3,3,Real>ret={1,0,0,0,1,0,0,0,1};
return ret;
}
};
template<typename Real>
struct constants<static_matrix<4,4,Real> >
{
static inline static_matrix<4,4,Real>identity()
{
static const static_matrix<4,4,Real>ret={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
return ret;
}
};
};
#pragma once
namespace heinlib
{
template<typename MxN,typename NxM>
bool pseudo_inverse_SVD(const MxN&A,NxM&Apinv,typename MxN::real_type eps=2.2e-10)
{
typedef typename square_result<NxM>::result_type NxN;
unsigned M=A.rows,N=A.cols;
resize_if_dynamic(Apinv,N,M);
assert(size_is(Apinv,N,M));
MxN U;
resize_if_dynamic(U,M,N);
NxN S,V;
resize_if_dynamic(S,N,N);
resize_if_dynamic(V,N,N);
if(!SVD<true,true>(A,U,S,V,eps))return false;
for(unsigned i=0;i<std::min(M,N);++i)
{
if(S(i,i)!=0)
S(i,i)=1/S(i,i);
}
Apinv=V*transpose(S)*transpose(U);
return true;
}
}
#include<vector>
namespace heinlib
{
template<typename T>
struct constants;
template<typename Real>
struct constants<static_matrix<3,4,Real> >
{
__forceinline static const static_matrix<3,4,Real>canonical_camera()
{
static const static_matrix<3,4,Real>ret={1,0,0,0,0,1,0,0,0,0,1,0};
return ret;
}
__forceinline static const static_matrix<3,4,Real>reduced_canonical_camera()
{
static const static_matrix<3,4,Real>ret={1,0,0,1,0,1,0,1,0,0,1,1};
return ret;
}
};
template<class Real>
bool is_canonical(const static_matrix<3,4,Real>&P)
{
return(P==constants<static_matrix<3,4,Real> >::canonical_camera());
}
template<class Real,unsigned Dim>
__forceinline static_matrix<2,1,Real>project(
const static_matrix<3,4,Real>&P,
const static_matrix<Dim,1,Real>&X,
const static_matrix<2,1,Real>&pp,
Real radial_distortion=0)
{
Real pX=P[0]*X[0]+P[1]*X[1]+P[2]*X[2]+P[3],
pY=P[4]*X[0]+P[5]*X[1]+P[6]*X[2]+P[7],
pZ=P[8]*X[0]+P[9]*X[1]+P[10]*X[2]+P[11];
static_matrix<2,1,Real>p={pX/pZ,pY/pZ};
p-=pp;
Real sqrad=length_sq(p);
p*=(1+sqrad*radial_distortion);
return p+pp;
}
template<typename T>
__forceinline static_matrix<2,1,T>project(const static_matrix<3,4,T>&P,const static_matrix<4,1,T>&X)
{
T pX=P[0]*X[0]+P[1]*X[1]+P[2]*X[2]+P[3]*X[3],
pY=P[4]*X[0]+P[5]*X[1]+P[6]*X[2]+P[7]*X[3],
pZ=P[8]*X[0]+P[9]*X[1]+P[10]*X[2]+P[11]*X[3];
static_matrix<2,1,T>res={pX/pZ,pY/pZ};
return res;
}
template<class Real>
__forceinline Real projective_depth(const static_matrix<3,4,Real>&P,const static_matrix<4,1,Real>&X)
{
return P[8]*X[0]+P[9]*X[1]+P[10]*X[2]+P[11]*X[3];
}
template<typename Real>
__forceinline bool get_camera_center(const static_matrix<3,4,Real>&P,static_matrix<4,1,Real>&C)
{
null_space_3x4(P,C);
if(C[3]==0)null_space_SVD(P,C);
if(C[3]==0)return false;
C/=abs(C[3]);
return true;
}
template<typename Real>
__forceinline bool get_camera_center(const static_matrix<3,4,Real>&P,static_matrix<3,1,Real>&C)
{
static_matrix<3,3,Real>Minv;
const static_matrix<3,3,Real>&M=P.template submatrix<0,0,2,2>();
if(!matrix_inverse(M,Minv))
return false;
C=-Minv*P.get_column(3);
return true;
}
template<typename Real>
__forceinline bool back_projected_ray(
static_matrix<3,1,Real>&start,
static_matrix<3,1,Real>&dir,
const static_matrix<2,1,Real>&x,
const static_matrix<3,4,Real>&P)
{
static_matrix<3,3,Real>Minv;
const static_matrix<3,3,Real>&M=P.template submatrix<0,0,2,2>();
if(!matrix_inverse(M,Minv))
return false;
start=-Minv*P.get_column(3);
dir=Minv*homogenize(x);
return true;
}
template<class Real>
static_matrix<3,1,Real>unproject(const static_matrix<3,4,Real>&P,const static_matrix<2,1,Real>&x,Real depth=1)
{
static_matrix<3,1,Real>start,dir;
back_projected_ray(start,dir,x,P);
return start+depth*dir;
}
template<typename Real>
static_matrix<4,1,Real>plane_at_infinity(const static_matrix<4,4,Real>&H)
{
static_matrix<4,4,Real>Ih={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0};
static_matrix<4,4,Real>Q=H*Ih*transpose(H);
static_matrix<4,1,Real>pInf;
null_space_SVD(Q,pInf);
return pInf;
}
template<class Real>
bool pseudo_inverse_camera(static_matrix<4,3,Real>&Pinv,const static_matrix<3,4,Real>&P)
{
static_matrix<3,3,Real>inv;
const static_matrix<3,3,Real>&M=P.template submatrix<0,0,2,2>();
if(!matrix_inverse(M,inv))
return false;
Pinv.block_insert(0,0,inv);
Pinv(3,0)=0;
Pinv(3,1)=0;
Pinv(3,2)=0;
return true;
}
inline float focal_length_from_fov(unsigned image_dim,float fov_rad=50*constants<float>::deg_to_rad())
{
return image_dim/(2*tan(fov_rad*0.5f));
}
inline float fov_from_focal_length(unsigned image_dim,float focal_length)
{
return 2*atan(image_dim/(2*focal_length));
}
}
#pragma once
#include<vector>
#pragma once
#pragma once
#if!defined(WIN32)&&!defined(__forceinline)
#define __forceinline __attribute__((always_inline))
#endif
namespace heinlib
{
template<class T>
struct remove_pointer
{
typedef T type;
__forceinline static const type&strip(const T&x)
{
return x;
}
__forceinline static type&strip(T&x)
{
return x;
}
};
template<class T>
struct remove_pointer<const T*>
{
typedef T type;
__forceinline static const type&strip(const T*x)
{
return*x;
}
};
template<class T>
struct remove_pointer<T*>
{
typedef T type;
__forceinline static type&strip(T*x)
{
return*x;
}
};
template<class T>
struct remove_pointer<T**>
{
typedef T type;
__forceinline static type&strip(T**x)
{
return**x;
}
};
template<class T>
struct remove_pointer<const T**>
{
typedef T type;
__forceinline static const type&strip(const T**x)
{
return**x;
}
};
template<class T>
struct remove_pointer<T***>
{
typedef T type;
__forceinline static type&strip(T***x)
{
return***x;
}
};
template<class T>
struct remove_pointer<const T***>
{
typedef T type;
__forceinline static const type&strip(const T***x)
{
return***x;
}
};
}
namespace heinlib
{
template<typename T>
struct cmp_mag
{
bool operator()(T a,T b)const
{
return(abs(remove_pointer<T>::strip(a))<abs(remove_pointer<T>::strip(b)));
}
};
template<typename T>
struct cmp_mag_equal
{
bool operator()(T a,T b)const
{
return(abs(remove_pointer<T>::strip(a))==abs(remove_pointer<T>::strip(b)));
}
};
template<typename T>
struct cmp_ptr
{
bool operator()(T a,T b)const
{
return(remove_pointer<T>::strip(a)<remove_pointer<T>::strip(b));
}
};
template<typename T>
struct cmp_ptr_equal
{
bool operator()(T a,T b)const
{
return(remove_pointer<T>::strip(a)==remove_pointer<T>::strip(b));
}
};
template<typename T>
struct cmp_ptr_dim
{
unsigned dim;
cmp_ptr_dim(unsigned _dim):dim(_dim){}
bool operator()(const T*a,const T*b)const
{
return((*a)[dim]<(*b)[dim]);
}
};
template<typename T>
struct cmp_ptr_dim_equal
{
unsigned dim;
cmp_ptr_dim_equal(unsigned _dim):dim(_dim){}
bool operator()(const T*a,const T*b)const
{
return((*a)[dim]==(*b)[dim]);
}
};
template<typename T>
struct cmp_dim
{
unsigned dim;
cmp_dim(unsigned _dim):dim(_dim){}
bool operator()(const T&a,const T&b)const
{
return(a[dim]<b[dim]);
}
};
template<typename T>
struct cmp_dim_equal
{
unsigned dim;
cmp_dim_equal(unsigned _dim):dim(_dim){}
bool operator()(const T&a,const T&b)const
{
return(a[dim]==b[dim]);
}
};
template<typename T1,typename T2>
struct cmp_pair_first
{
bool operator()(const std::pair<T1,T2>&a,const std::pair<T1,T2>&b)const
{
return(a.first<b.first);
}
};
template<typename T1,typename T2>
struct cmp_pair_first_equal
{
bool operator()(const std::pair<T1,T2>&a,const std::pair<T1,T2>&b)const
{
return(a.first==b.first);
}
};
template<typename T1,typename T2>
struct cmp_pair_second
{
bool operator()(const std::pair<T1,T2>&a,const std::pair<T1,T2>&b)const
{
return(a.second<b.second);
}
};
template<typename T1,typename T2>
struct cmp_pair_second_equal
{
bool operator()(const std::pair<T1,T2>&a,const std::pair<T1,T2>&b)const
{
return(a.second==b.second);
}
};
template<class Matrix>
struct cmp_index
{
unsigned index;
cmp_index(unsigned index):index(index){}
bool operator()(const Matrix&a,const Matrix&b)const
{
return(a[index]<b[index]);
}
};
}
namespace heinlib
{
template<class Element>
bool is_sorted(const std::vector<std::pair<unsigned,Element> >&indexed_list)
{
for(unsigned i=1;i<indexed_list.size();++i)
if(indexed_list[i].first<indexed_list[i-1].first)
return false;
return true;
}
template<class Element>
void sort_indexed_list(std::vector<std::pair<unsigned,Element> >&indexed_list)
{
std::sort(indexed_list.begin(),indexed_list.end(),cmp_pair_first<unsigned,Element>());
indexed_list.erase(std::unique(indexed_list.begin(),indexed_list.end(),cmp_pair_first_equal<unsigned,Element>()),indexed_list.end());
}
template<class Element>
__forceinline Element*lookup(std::vector<std::pair<unsigned,Element> >&indexed_list,unsigned index)
{
if(indexed_list.empty()||indexed_list[0].first>index)return NULL;
int i=min<int>(index-indexed_list[0].first,indexed_list.size()-1u);
while(indexed_list[i].first>index&&i>0)--i;
if(indexed_list[i].first==index){
return&indexed_list[i].second;
}else return NULL;
}
template<class Element>
__forceinline const Element*lookup(const std::vector<std::pair<unsigned,Element> >&indexed_list,unsigned index)
{
if(indexed_list.empty()||indexed_list[0].first>index)return NULL;
int i=min<int>(index-indexed_list[0].first,indexed_list.size()-1u);
while(indexed_list[i].first>index&&i>0)--i;
if(indexed_list[i].first==index){
return&indexed_list[i].second;
}else return NULL;
}
template<class Element>
__forceinline int lookup_index(const std::vector<std::pair<unsigned,Element> >&indexed_list,unsigned index)
{
if(indexed_list.empty()||indexed_list[0].first>index)return-1;
int i=min(index-indexed_list[0].first,indexed_list.size()-1u);
while(indexed_list[i].first>index&&i>0)--i;
if(indexed_list[i].first==index){
return i;
}else return-1;
}
__forceinline int lookup_index(const std::vector<unsigned>&listIDs,unsigned ID)
{
if(listIDs.empty()||ID<listIDs.front()||ID>listIDs.back())
return-1;
unsigned midID=listIDs[0];
if(midID==ID)return 0;
unsigned listMax=listIDs.size()-1u;
unsigned mini=0,maxi=std::min(ID-midID,listMax);
unsigned mid=maxi;
midID=listIDs[mid];
while(mini<=maxi)
{
if(midID==ID)return mid;
mid=mini+((maxi-mini)>>1);
midID=listIDs[mid];
if(midID<ID)
{
mini=mid+1;
maxi=std::min(mid+ID-midID,listMax);
}else if(midID>ID)
maxi=mid-1;
}
return-1;
}
}
#pragma once
#include<vector>
#include<cassert>
#include<algorithm>
namespace heinlib
{
template<class T>
void sort_permutation(std::vector<unsigned>&permutation_list,const std::vector<T>&vec)
{
std::vector<std::pair<T,unsigned> >temp(vec.size());
for(unsigned i=0;i<vec.size();++i)
{
temp[i].first=vec[i];
temp[i].second=i;
}
std::sort(temp.begin(),temp.end(),cmp_pair_first<T,unsigned>());
permutation_list.resize(temp.size());
for(unsigned i=0;i<vec.size();++i)
permutation_list[i]=temp[i].second;
}
template<class T>
void apply_permutation(std::vector<T>&vec,const std::vector<unsigned>&permutation_list)
{
assert(vec.size()==permutation_list.size());
std::vector<T>vec2(vec.size());
for(unsigned i=0;i<permutation_list.size();++i)
{
unsigned get_ind=permutation_list[i];
assert(get_ind<vec.size());
vec2[i]=vec[get_ind];
}
std::swap(vec,vec2);
}
}
#pragma once
#pragma once
#include<exception>
#pragma once
#pragma once
namespace heinlib
{
template<class Real>
struct quaternion
{
Real x,y,z,w;
__forceinline quaternion operator*(const quaternion&q)const;
__forceinline quaternion operator+(const quaternion&q)const;
__forceinline quaternion operator*(const Real&s)const;
__forceinline static_matrix<3,1,Real>rotate(const static_matrix<3,1,Real>&v)const;
__forceinline static_matrix<3,1,Real>operator*(const static_matrix<3,1,Real>&v)const;
__forceinline static_matrix<3,3,Real>to_matrix()const;
__forceinline static_matrix<3,1,Real>to_axis_angle()const;
__forceinline static_matrix<3,1,Real>get_axis()const;
__forceinline Real get_angle()const;
__forceinline bool is_real()const
{
return(x==0&&y==0&&z==0);
}
__forceinline bool is_pure()const
{
return(w=0);
}
};
template<typename T>struct constants;
template<typename Real>
struct constants<quaternion<Real> >
{
static inline quaternion<Real>identity()
{
static const quaternion<Real>ret={0,0,0,1};
return ret;
}
};
template<class Real>
std::ostream&operator<<(std::ostream&os,const quaternion<Real>&q)
{
os<<"("<<q.x<<", "<<q.y<<", "<<q.z<<", "<<q.w<<")";
return os;
}
template<class Real>
__forceinline quaternion<Real>make_quaternion(Real x,Real y,Real z,Real w)
{
quaternion<Real>q={x,y,z,w};
return q;
}
template<class Real>
__forceinline Real norm_sq(const quaternion<Real>&q)
{
return sq(q.x)+sq(q.y)+sq(q.z)+sq(q.w);
}
template<class Real>
__forceinline Real norm(const quaternion<Real>&q)
{
return sqrt(norm_sq(q));
}
template<class Real>
__forceinline quaternion<Real>normalize(const quaternion<Real>&q)
{
Real len=norm(q);
quaternion<Real>r={q.x/len,q.y/len,q.z/len,q.w/len};
return r;
}
template<class Real>
__forceinline quaternion<Real>make_quaternion(const static_matrix<3,1,Real>&axis,const Real&angle)
{
Real sin_a=sin(angle/2);
Real cos_a=cos(angle/2);
quaternion<Real>q=
{
axis.x()*sin_a,
axis.y()*sin_a,
axis.z()*sin_a,
cos_a
};
return normalize(q);
}
template<class Real>
__forceinline quaternion<Real>make_quaternion(const static_matrix<3,1,Real>&axis_angle)
{
Real angle=length(axis_angle);
if(angle==0)
return constants<quaternion<Real> >::identity();
else
return make_quaternion(axis_angle/angle,angle);
}
template<class Real>
__forceinline quaternion<Real>quaternion<Real>::operator*(const quaternion<Real>&q)const
{
quaternion<Real>r=
{
q.w*x+q.x*w-q.y*z+q.z*y,
q.w*y+q.x*z+q.y*w-q.z*x,
q.w*z-q.x*y+q.y*x+q.z*w,
q.w*w-q.x*x-q.y*y-q.z*z
};
return r;
}
template<class Real>
__forceinline quaternion<Real>quaternion<Real>::operator*(const Real&s)const
{
quaternion<Real>r={x*s,y*s,z*s,w*s};
return r;
}
template<class Real>
__forceinline quaternion<Real>operator*(const Real&s,const quaternion<Real>&q)
{
quaternion<Real>r={q.x*s,q.y*s,q.z*s,q.w*s};
return r;
}
template<class Real>
__forceinline quaternion<Real>quaternion<Real>::operator+(const quaternion<Real>&q)const
{
quaternion<Real>r={x+q.x,y+q.y,z+q.z,w+q.w};
return r;
}
template<class Real>
__forceinline quaternion<Real>conjugate(const quaternion<Real>&q)
{
quaternion<Real>r={-q.x,-q.y,-q.z,q.w};
return r;
}
template<class Real>
__forceinline quaternion<Real>inverse(const quaternion<Real>&q)
{
return conjugate(normalize(q));
}
template<class Real>
__forceinline quaternion<Real>as_quaternion(const static_matrix<3,1,Real>&v)
{
quaternion<Real>q={v.x(),v.y(),v.z(),0};
return q;
}
template<class Real>
__forceinline static_matrix<3,1,Real>as_vector(const quaternion<Real>&q)
{
static_matrix<3,1,Real>v={q.x,q.y,q.z};
return v;
}
template<class Real>
__forceinline static_matrix<3,1,Real>quaternion<Real>::rotate(const static_matrix<3,1,Real>&v)const
{
quaternion<Real>q=normalize(*this);
return as_vector(q*as_quaternion(v)*conjugate(q));
}
template<class Real>
__forceinline static_matrix<3,1,Real>quaternion<Real>::operator*(const static_matrix<3,1,Real>&v)const
{
return this->rotate(v);
}
template<class Real>
__forceinline static_matrix<3,3,Real>quaternion<Real>::to_matrix()const
{
static_matrix<3,3,Real>R;
quaternion<Real>q=normalize(*this);
Real xx=q.x*q.x;
Real xy=q.x*q.y;
Real xz=q.x*q.z;
Real xw=q.x*q.w;
Real yy=q.y*q.y;
Real yz=q.y*q.z;
Real yw=q.y*q.w;
Real zz=q.z*q.z;
Real zw=q.z*q.w;
R[0]=1-2*(yy+zz);
R[1]=2*(xy-zw);
R[2]=2*(xz+yw);
R[3]=2*(xy+zw);
R[4]=1-2*(xx+zz);
R[5]=2*(yz-xw);
R[6]=2*(xz-yw);
R[7]=2*(yz+xw);
R[8]=1-2*(xx+yy);
return R;
}
template<class Real>
__forceinline static_matrix<3,1,Real>quaternion<Real>::to_axis_angle()const
{
quaternion<Real>q=normalize(*this);
Real angle=2*acos(q.w);
static_matrix<3,1,Real>axis={};
Real denom=1-sq(q.w);
if(denom==0)return axis;
Real temp=1/denom;
axis.x()=q.x*temp;
axis.y()=q.y*temp;
axis.z()=q.z*temp;
return normalize(axis)*angle;
}
template<class Real>
__forceinline static_matrix<3,1,Real>quaternion<Real>::get_axis()const
{
return normalize(to_axis_angle());
}
template<class Real>
__forceinline Real quaternion<Real>::get_angle()const
{
return length(to_axis_angle());
}
namespace detail
{
template<typename Real>
void quat_from_perfect_matrix(static_matrix<4,1,Real>&q,const static_matrix<3,3,Real>&R)
{
Real tr=trace(R);
if(tr>0)
{
Real s=Real(0.5)/heinlib::sqrt(tr+1);
q.w()=Real(0.25)/s;
q.x()=(R(2,1)-R(1,2))*s;
q.y()=(R(0,2)-R(2,0))*s;
q.z()=(R(1,0)-R(0,1))*s;
}else{
if(R(0,0)>R(1,1)&&R(0,0)>R(2,2)){
Real s=2*heinlib::sqrt(1+R(0,0)-R(1,1)-R(2,2));
q.w()=(R(2,1)-R(1,2))/s;
q.x()=Real(0.25)*s;
q.y()=(R(0,1)+R(1,0))/s;
q.z()=(R(0,2)+R(2,0))/s;
}else if(R(1,1)>R(2,2)){
Real s=2*heinlib::sqrt(1+R(1,1)-R(0,0)-R(2,2));
q.w()=(R(0,2)-R(2,0))/s;
q.x()=(R(0,1)+R(1,0))/s;
q.y()=Real(0.25)*s;
q.z()=(R(1,2)+R(2,1))/s;
}else{
Real s=2*heinlib::sqrt(1+R(2,2)-R(0,0)-R(1,1));
q.w()=(R(1,0)-R(0,1))/s;
q.x()=(R(0,2)+R(2,0))/s;
q.y()=(R(1,2)+R(2,1))/s;
q.z()=Real(0.25)*s;
}
}
return;
}
template<typename Real>
void q_method(static_matrix<4,1,Real>&q,const static_matrix<3,3,Real>&R,unsigned power_iters=5)
{
if(power_iters>0)
{
static_matrix<4,4,Real>K={R(0,0)-R(1,1)-R(2,2),R(1,0)+R(0,1),R(2,0)+R(0,2),R(1,2)-R(2,1),
K[1],R(1,1)-R(0,0)-R(2,2),R(2,1)+R(1,2),R(2,0)-R(0,2),
K[2],K[6],R(2,2)-R(0,0)-R(1,1),R(0,1)-R(1,0),
K[3],K[7],K[11],R(0,0)+R(1,1)+R(2,2)};
q.w()*=Real(-1);
for(unsigned iter=0;iter<power_iters;++iter)
q=normalize(K*q);
q.w()*=Real(-1);
}
}
}
template<class Real>
__forceinline quaternion<Real>make_quaternion(const static_matrix<3,3,Real>&R,unsigned iters=20)
{
static_matrix<4,1,Real>q;
detail::quat_from_perfect_matrix(q,R);
detail::q_method(q,R,iters);
return make_quaternion(q.x(),q.y(),q.z(),q.w());
}
template<class Real>
__forceinline Real angle(const quaternion<Real>&a,const quaternion<Real>&b)
{
quaternion<Real>na=normalize(a),nb=normalize(b);
Real dp=na.x*nb.x+na.y*nb.y+na.z*nb.z+na.w*nb.w;
return 2*acos(dp);
}
template<class Real>
Real geodesic_distance(const quaternion<Real>&a,const quaternion<Real>&b)
{
Real theta=angle(a,b);
return constants<Real>::sqrt_2()*abs(theta);
}
template<class Real>
quaternion<Real>slerp(const quaternion<Real>&a,const quaternion<Real>&b,Real t)
{
Real cosHalfTheta=a.w*b.w+a.x*b.x+a.y*b.y+a.z*b.z;
if(abs(cosHalfTheta)>=1.0)
return a;
Real halfTheta=acos(cosHalfTheta);
Real sinHalfTheta=sqrt(1.0-cosHalfTheta*cosHalfTheta);
if(abs(sinHalfTheta)<0.001)
return 0.5*a+0.5*b;
Real ratioA=sin((1-t)*halfTheta)/sinHalfTheta;
Real ratioB=sin(t*halfTheta)/sinHalfTheta;
return normalize(ratioA*a+ratioB*b);
}
}
namespace heinlib
{
template<class Real>
void fix_rotation_matrix(static_matrix<3,3,Real>&R,unsigned power_iters=5)
{
static_matrix<4,1,Real>q;
robust_quat_from_matrix(q,R,power_iters);
quat_to_matrix(R,q);
}
template<typename Real>
void standardize_axis_angle(static_matrix<3,1,Real>&axis,Real&angle)
{
if(axis[0]<0)
{
axis*=-1;
angle=constants<Real>::two_pi()-angle;
}
while(angle>constants<Real>::pi())
angle-=constants<Real>::two_pi();
while(angle<0)
angle+=constants<Real>::two_pi();
}
template<typename Real>
void split_axis_angle(static_matrix<3,1,Real>&axis,Real&angle,const static_matrix<3,1,Real>&axis_angle)
{
angle=length(axis_angle);
axis=axis_angle;
standardize_axis_angle(axis,angle);
}
template<class Real>
__forceinline void rotation_matrix(static_matrix<2,2,Real>&R,Real angle_rad)
{
Real cos_theta=cos(angle_rad),sin_theta=sin(angle_rad);
static_matrix<2,2,Real>myR={cos_theta,-sin_theta,sin_theta,cos_theta};
R=myR;
}
template<class Real>
__forceinline void rotation_matrix(
static_matrix<3,3,Real>&R,
Real heading=0,
Real attitude=0,
Real bank=0)
{
static_matrix<3,3,Real>R1,R2,R3;
rotation_matrix(R1,make_vector3<Real>(0,0,1)*heading);
rotation_matrix(R2,make_vector3<Real>(1,0,0)*attitude);
rotation_matrix(R3,make_vector3<Real>(0,1,0)*bank);
R=R3*R2*R1;
}
template<typename Real>
__forceinline static_matrix<3,1,Real>rotate(const static_matrix<3,1,Real>&vec,const static_matrix<3,1,Real>&axis,Real angle_rad)
{
static_matrix<3,3,Real>R;
rotation_matrix(R,normalize(axis)*angle_rad);
return R*vec;
}
template<class Real>
void translation_matrix(static_matrix<4,4,Real>&M,const static_matrix<3,1,Real>&t)
{
fill_identity(M);
M(0,3)=t.x();
M(1,3)=t.y();
M(2,3)=t.z();
}
template<unsigned D,class Real>
static_matrix<D+1,D+1,Real>translation_matrix(const static_matrix<D,1,Real>&t)
{
static_matrix<D+1,D+1,Real>ret;
fill_identity(ret);
for(unsigned i=0;i<D;++i)
ret(i,D)=t[i];
return ret;
}
template<class Real>
__forceinline void rotation_matrix(static_matrix<3,3,Real>&R,const static_matrix<3,1,Real>&axis_angle)
{
Real angle=length(axis_angle);
static_matrix<3,1,Real>v=(angle==0)?axis_angle:axis_angle/angle;
Real c=cos(angle),s=sin(angle),C=1-c;
const Real&x=v.x(),&y=v.y(),&z=v.z();
Real xs=x*s,ys=y*s,zs=z*s,
xC=x*C,yC=y*C,zC=z*C,
xyC=x*yC,yzC=y*zC,zxC=z*xC;
R(0,0)=x*xC+c;R(0,1)=xyC-zs;R(0,2)=zxC+ys;
R(1,0)=xyC+zs;R(1,1)=y*yC+c;R(1,2)=yzC-xs;
R(2,0)=zxC-ys;R(2,1)=yzC+xs;R(2,2)=z*zC+c;
}
template<typename Real>
void matrix_from_axis_angle(static_matrix<3,3,Real>&R,const static_matrix<3,1,Real>&axis,Real theta)
{
Real t1=cos(theta);
Real t2=1-t1;
Real t3=axis.x()*axis.x();
Real t6=t2*axis.x();
Real t7=t6*axis.y();
Real t8=sin(theta);
Real t9=t8*axis.z();
Real t11=t6*axis.z();
Real t12=t8*axis.y();
Real t15=axis.y()*axis.y();
Real t19=t2*axis.y()*axis.z();
Real t20=t8*axis.x();
Real t24=axis.z()*axis.z();
R(0,0)=t1+t2*t3;
R(0,1)=t7-t9;
R(0,2)=t11+t12;
R(1,0)=t7+t9;
R(1,1)=t1+t2*t15;
R(1,2)=t19-t20;
R(2,0)=t11-t12;
R(2,1)=t19+t20;
R(2,2)=t1+t2*t24;
}
template<class Real>
__forceinline void rodrigues_rotation(static_matrix<3,3,Real>&R,const static_matrix<3,1,Real>&vin)
{
Real angle=length(vin);
static_matrix<3,1,Real>v=(angle==0)?vin:vin/angle;
static_matrix<3,3,Real>sk={0,-v.z(),v.y(),
v.z(),0,-v.x(),
-v.y(),v.x(),0};
R=constants<static_matrix<3,3,Real> >::identity();
R+=sk*sin(angle)+(1-cos(angle))*(sk*sk);
}
template<class Real>
void mirror_matrix(static_matrix<4,4,Real>&m,
const static_matrix<3,1,Real>&p,
const static_matrix<3,1,Real>&n)
{
Real k=dot(p,n);
Real nx=n.x(),ny=n.y(),nz=n.z();
static_matrix<4,4,Real>ret={1-2*nx*nx,-2*nx*ny,-2*nx*nz,2*nx*k,
-2*ny*nx,1-2*ny*ny,-2*ny*nz,2*ny*k,
-2*nz*nx,-2*nz*ny,1-2*nz*nz,2*nz*k,
0,0,0,1};
m=ret;
}
template<class Real>
void rotation_between_vectors(
static_matrix<3,1,Real>&axis,
Real&angle,
const static_matrix<3,1,Real>&v1,
const static_matrix<3,1,Real>&v2)
{
static_matrix<3,1,Real>v1n=normalize(v1),v2n=normalize(v2);
static_matrix<3,1,Real>cr=cross(v1n,v2n);
Real len=length(cr);
if(len>0)
{
axis=cr/len;
angle=acos(dot(v1n,v2n));
}else
{
axis.x()=1;
axis.y()=0;
axis.z()=0;
angle=0;
}
}
template<class Real>
__forceinline Real angle(const static_matrix<3,3,Real>&A,const static_matrix<3,3,Real>&B)
{
return acos((trace(transpose(A)*B)-1)*0.5f);
}
template<class Real>
Real geodesic_distance(const static_matrix<3,3,Real>&A,const static_matrix<3,3,Real>&B)
{
Real theta=angle(A,B);
return constants<Real>::sqrt_2()*abs(theta);
}
}
#pragma once
#pragma once
namespace heinlib
{
template<class NxN>
typename enable_if<is_matrix<NxN>,bool>::type
LDL_factorization(NxN&A)
{
assert(is_square(A));
unsigned N=A.rows;
typedef typename NxN::real_type Real;
typename column_vector<NxN>::result_type v;
resize_if_dynamic(v,N,1);
assert(size_is(v,N,1));
for(unsigned j=0;j<N;++j)
{
for(unsigned i=0;i<j;++i)
v[i]=A(j,i)*A(i,i);
v[j]=A(j,j);
for(unsigned i=0;i<j;++i)
v[j]-=A(j,i)*v[i];
if(v[j]==0)return false;
A(j,j)=v[j];
for(unsigned i=j+1;i<N;++i)
{
Real sum=0;
for(unsigned k=0;k<j;++k)
sum+=A(i,k)*v[k];
A(i,j)=(A(i,j)-sum)/v[j];
}
}
return true;
}
template<class NxN>
typename enable_if<is_matrix<NxN>,bool>::type
LDL_factorization(const NxN&A,NxN&L,NxN&D)
{
unsigned N=A.rows;
assert(is_square(A));
assert(size_is(L,N,N));
assert(size_is(D,N,N));
NxN At=A;
fill(L,0);
fill(D,0);
if(!LDL_factorization(At))
return false;
for(unsigned i=0;i<N;++i){
for(unsigned j=0;j<i;++j)
L(i,j)=At(i,j);
L(i,i)=1;
D(i,i)=At(i,i);
}
return true;
}
}
namespace heinlib
{
template<typename MxM>
bool cholesky_RRt(const MxM&A,MxM&R)
{
MxM Ainv;
if(!matrix_inverse(A,Ainv))
return false;
if(!cholesky_decomposition(Ainv,R))
return false;
R=transpose(inverse(R));
return true;
}
template<typename MxM>
bool cholesky_decomposition(const MxM&A,MxM&L)
{
typedef typename MxM::real_type Real;
unsigned M=A.rows;
assert(is_square(A));
resize_if_dynamic(L,M,M);
assert(size_is(L,M,M));
for(unsigned r=0;r<M-1;++r)
for(unsigned c=M-1;c>r;--c)
L(r,c)=0;
if(A(0,0)<=0){
return false;
}
Real l00=sqrt(A(0,0));
L(0,0)=l00;
for(unsigned r=1;r<M;++r)
L(r,0)=A(r,0)/l00;
for(unsigned c=1;c<M;++c){
Real sum=0,l;
for(unsigned s=0;s<c;++s){
l=L(c,s);
sum+=l*l;
}
Real temp=A(c,c)-sum;
if(temp<=0){
return false;
}
L(c,c)=sqrt(temp);
for(unsigned r=c+1;r<M;++r){
Real sum=0;
for(unsigned s=0;s<c;++s)
sum+=L(c,s)*L(r,s);
L(r,c)=(A(r,c)-sum)/L(c,c);
}
}
return true;
}
template<typename MxM>
bool cholesky_decomposition_enforce(const MxM&A,MxM&L)
{
typedef typename MxM::real_type Real;
unsigned M=A.rows;
assert(is_square(A));
resize_if_dynamic(L,M,M);
assert(size_is(L,M,M));
MxM D;
resize_if_dynamic(D,M,M);
assert(size_is(D,M,M));
if(!LDL_factorization(A,L,D))
return false;
for(unsigned i=0;i<M;++i)
{
Real&d=D(i,i);
if(d<-1)return false;
d=(d<0)?0:sqrt(d);
}
L*=D;
return true;
}
}
#pragma once
namespace heinlib
{
template<class Real>
struct rigid_motion
{
quaternion<Real>qrot;
static_matrix<3,1,Real>translation;
rigid_motion()
{
make_identity();
}
rigid_motion(const quaternion<Real>&qrot,
const static_matrix<3,1,Real>&translation)
:qrot(qrot),translation(translation)
{
}
rigid_motion(const quaternion<Real>&qrot)
:qrot(qrot)
{
fill(translation,0);
}
rigid_motion(const static_matrix<3,1,Real>&translation)
:translation(translation)
{
qrot=constants<quaternion<Real> >::identity();
}
rigid_motion(
const static_matrix<3,3,Real>&R,
const static_matrix<3,1,Real>&translation,
unsigned iters=10)
:translation(translation)
{
qrot=make_quaternion(R,iters);
}
void make_identity()
{
qrot=constants<quaternion<Real> >::identity();
fill(translation,0);
}
static_matrix<3,4,Real>get_matrix()const
{
static_matrix<3,4,Real>ret;
ret.block_insert(0,0,qrot.to_matrix());
ret.block_insert(0,3,translation);
return ret;
}
static_matrix<3,1,Real>get_position()const
{
return-(inverse(qrot)*translation);
}
void set_position(const static_matrix<3,1,Real>&pos)
{
translation=qrot*(-pos);
}
static_matrix<3,1,Real>get_forward()const
{
static_matrix<3,3,Real>Rt=qrot.to_matrix();
Rt=transpose(Rt);
return normalize(Rt.get_column(2));
}
void get_basis(
static_matrix<3,1,Real>&pos,
static_matrix<3,1,Real>&right,
static_matrix<3,1,Real>&down,
static_matrix<3,1,Real>&forward)const
{
static_matrix<3,3,Real>Rt=qrot.to_matrix();
Rt=transpose(Rt);
pos=-Rt*translation;
right=normalize(Rt.get_column(0));
down=normalize(Rt.get_column(1));
forward=normalize(Rt.get_column(2));
}
};
template<class Real>
bool is_canonical(const rigid_motion<Real>&cam)
{
if(cam.translation.x()!=0||
cam.translation.y()!=0||
cam.translation.z()!=0||
cam.qrot.x!=0||
cam.qrot.y!=0||
cam.qrot.z!=0||
cam.qrot.w!=1)
return false;
return true;
}
template<class Real>
struct similarity_transform
{
quaternion<Real>qrot;
static_matrix<3,1,Real>translation;
Real scale;
similarity_transform()
{
make_identity();
}
similarity_transform(const static_matrix<4,4,Real>&H)
{
from_matrix(H);
}
similarity_transform(const quaternion<Real>&qrot,
const static_matrix<3,1,Real>&translation,
Real scale=1)
:qrot(qrot),translation(translation),scale(scale)
{
}
similarity_transform(const quaternion<Real>&qrot,Real scale=1)
:qrot(qrot),scale(scale)
{
fill(translation,0);
}
similarity_transform(const static_matrix<3,1,Real>&translation,Real scale=1)
:translation(translation),scale(scale)
{
qrot=constants<quaternion<Real> >::identity();
}
similarity_transform(Real scale)
:scale(scale)
{
fill(translation,0);
qrot=constants<quaternion<Real> >::identity();
}
similarity_transform(
const static_matrix<3,3,Real>&R,
const static_matrix<3,1,Real>&translation,
Real scale,unsigned iters=10)
:translation(translation),scale(scale)
{
robust_quat_from_matrix(qrot,R,iters);
scale*=matrix_scale(qrot.to_matrix(),R);
}
void make_identity()
{
qrot=constants<quaternion<Real> >::identity();
fill(translation,0);
scale=1;
}
void from_matrix(const static_matrix<4,4,Real>&H);
static_matrix<4,4,Real>get_matrix()const;
similarity_transform<Real>inverse()const;
};
template<class Real>
__forceinline void similarity_transform<Real>::from_matrix(const static_matrix<4,4,Real>&_H)
{
static_matrix<4,4,Real>H=_H;
H/=H(3,3);
static_matrix<3,3,Real>R=H.template submatrix<0,0,2,2>();
translation=H.template submatrix<0,3,2,3>();
qrot=make_quaternion(R,100);
static_matrix<3,3,Real>R2=qrot.to_matrix();
scale=matrix_scale(R2,R);
}
template<class Real>
__forceinline static_matrix<4,4,Real>similarity_transform<Real>::get_matrix()const
{
static_matrix<4,4,Real>H;
static_matrix<3,3,Real>R=qrot.to_matrix();
H.block_insert(0,0,scale*R);
H.block_insert(0,3,translation);
H(3,0)=H(3,1)=H(3,2)=0;
H(3,3)=1;
return H;
}
template<class Real>
__forceinline similarity_transform<Real>similarity_transform<Real>::inverse()const
{
similarity_transform<Real>inv;
inverse_similarity(inv,*this);
return inv;
}
template<class Real>
void inverse_similarity(similarity_transform<Real>&xform_inv,const similarity_transform<Real>&xform)
{
xform_inv.qrot=inverse(xform.qrot);
xform_inv.translation=-(xform_inv.qrot*xform.translation)/xform.scale;
xform_inv.scale=1/xform.scale;
}
template<class Real>
static_matrix<4,1,Real>transform_point(const static_matrix<4,1,Real>&X,const similarity_transform<Real>&xform)
{
return homogenize(xform.scale*(xform.qrot*realize(X))+xform.translation);
}
template<class Real>
static_matrix<3,1,Real>transform_point(const static_matrix<3,1,Real>&X,const similarity_transform<Real>&xform)
{
return xform.scale*(xform.qrot*X)+xform.translation;
}
template<class Real>
__forceinline static_matrix<4,1,Real>operator*(const similarity_transform<Real>&H,const static_matrix<4,1,Real>&X)
{
return transform_point(X,H);
}
template<class Real>
__forceinline static_matrix<3,1,Real>operator*(const similarity_transform<Real>&H,const static_matrix<3,1,Real>&X)
{
return transform_point(X,H);
}
template<class Real>
__forceinline std::ostream&operator<<(std::ostream&os,const similarity_transform<Real>&H)
{
os<<"sim_xform{ qrot:"<<H.qrot<<", t:"<<H.translation<<", scale:"<<H.scale<<" }";
return os;
}
template<class Real>
__forceinline std::ostream&operator<<(std::ostream&os,const rigid_motion<Real>&H)
{
os<<"rigid_motion{ qrot:"<<H.qrot<<", t:"<<H.translation<<" }";
return os;
}
template<class Real>
__forceinline rigid_motion<Real>operator*(const rigid_motion<Real>&cam,const similarity_transform<Real>&H)
{
rigid_motion<Real>result(cam);
transform_metric_camera(result,H);
return result;
}
template<class Real>
void camera_align_xform(similarity_transform<Real>&xform,const rigid_motion<Real>&src,const rigid_motion<Real>&dst)
{
quaternion<Real>R1inv=inverse(src.qrot);
xform.translation=R1inv*(dst.translation-src.translation);
xform.qrot=R1inv*dst.qrot;
xform.scale=1;
}
template<class Real>
void camera_align_xform_canonical(similarity_transform<Real>&xform,const rigid_motion<Real>&src)
{
static_matrix<3,3,Real>R=src.qrot.to_matrix();
xform.translation=-transpose(R)*src.translation;
xform.qrot=inverse(src.qrot);
xform.scale=1;
}
template<class Real>
void transform_metric_camera(rigid_motion<Real>&cam,const similarity_transform<Real>&xform)
{
cam.translation=(cam.translation+cam.qrot*xform.translation)/xform.scale;
cam.qrot=normalize(cam.qrot*xform.qrot);
}
}
#pragma once
#pragma once
namespace heinlib
{
template<typename NxN>
void QR_method_givens(const NxN&A,NxN&Q,NxN&R,
typename NxN::real_type stop_eps=1e-15,
unsigned max_iters=1,unsigned min_iters=1)
{
unsigned N=A.rows;
typedef typename NxN::real_type Real;
assert(size_is(A,N,N));
resize_if_dynamic(Q,N,N);
resize_if_dynamic(R,N,N);
NxN I,C;
resize_if_dynamic(I,N,N);
resize_if_dynamic(C,N,N);
fill_identity(I);
R=A;
for(unsigned it=0;it<max_iters;++it)
{
Q=I;
for(unsigned n=0;n<N-1;++n)
{
Real r=R(n+1,n)/R(n,n),r2=r*r;
Real cosT=1/sqrt(1+r2),sinT=r*cosT;
C=I;
C(n,n)=C(n+1,n+1)=cosT;
C(n+1,n)=-sinT;
C(n,n+1)=sinT;
R=C*R;
Q*=transpose(C);
}
R*=Q;
if(it>=min_iters){
Real maxv=0,v;
for(unsigned i=0;i<N-1;++i){
v=abs(R(i,i+1));
if(v>maxv)maxv=v;
}
if(maxv<stop_eps)
return;
}
}
}
template<typename MxM,typename MxN>
void QR_decomposition_householder(const MxN&A,MxM&Q,MxN&R)
{
unsigned M=A.rows,N=A.cols;
typedef typename MxN::real_type Real;
assert(M>=N);
resize_if_dynamic(Q,M,M);
resize_if_dynamic(R,M,N);
assert(size_is(Q,M,M));
assert(size_is(R,M,N));
MxM I,C;
resize_if_dynamic(I,M,M);
resize_if_dynamic(C,M,M);
fill_identity(I);
R=A;
Q=I;
for(unsigned n=0;n<std::min(M-1,N);++n)
{
dynamic_matrix<Real>v(M-n,1);
Real len=0;
for(unsigned i=n;i<M;++i)
{
Real a=R(i,n);
len+=a*a;
v[i-n]=a;
}
len=sqrt(len);
if(v[0]>0)v[0]+=len;
else v[0]-=len;
v/=length(v);
fill(C,0);
dynamic_matrix<Real>vvT=v*transpose(v)*Real(-2);
C.block_insert(n,n,vvT);
for(unsigned i=0;i<M;++i)
C(i,i)+=1;
R=C*R;
Q*=C;
}
}
}
namespace heinlib
{
template<class Real>
bool RQ_decomposition(
static_matrix<3,3,Real>&R,
static_matrix<3,3,Real>&Q,
const static_matrix<3,3,Real>&A)
{
Real tmp=hypot(A(2,1),A(2,2));
if(tmp==0){
std::cout<<"fail1\n";
return false;
}
Real s=A(2,1)/tmp;
Real c=-A(2,2)/tmp;
static_matrix<3,3,Real>Qx={1,0,0,0,c,-s,0,s,c};
R=A*Qx;
tmp=hypot(R(2,0),R(2,2));
if(tmp==0){
std::cout<<"fail2\n";
return false;
}
s=R(2,0)/tmp;
c=R(2,2)/tmp;
static_matrix<3,3,Real>Qy={c,0,s,0,1,0,-s,0,c};
R=R*Qy;
tmp=hypot(R(1,0),R(1,1));
if(tmp==0)return false;
s=R(1,0)/tmp;
c=-R(1,1)/tmp;
static_matrix<3,3,Real>Qz={c,-s,0,s,c,0,0,0,1};
R=R*Qz;
Q=transpose(Qx*Qy*Qz);
static_matrix<3,3,Real>P={};
if(R(0,0)<0)P(0,0)=-1;
else P(0,0)=1;
if(R(1,1)<0)P(1,1)=-1;
else P(1,1)=1;
if(R(2,2)<0)P(2,2)=-1;
else P(2,2)=1;
R=R*P;
R(1,0)=R(2,0)=R(2,1)=0;
Q=P*Q;
return true;
}
}
#pragma once
#include<complex>
#include<iostream>
#pragma once
#include<complex>
#include<cassert>
#include<cmath>
#pragma once
namespace heinlib
{
namespace cuberoot_detail
{
__forceinline float cbrt_5f(float f)
{
unsigned int*p=(unsigned int*)&f;
*p=*p/3+709921077;
return f;
}
__forceinline double cbrt_5d(double d)
{
const unsigned int B1=715094163;
double t=0.0;
unsigned int*pt=(unsigned int*)&t;
unsigned int*px=(unsigned int*)&d;
pt[1]=px[1]/3+B1;
return t;
}
template<typename T>
__forceinline T cbrta_halley(T a,T R)
{
T a3=a*a*a;
T b=a*(a3+R+R)/(a3+a3+R);
return b;
}
}
template<typename T>
T cuberoot(T x)
{
#pragma message("Using 'pow(x, 1/3)' for cuberoot,  this is slow and can give wrong results!!!")
if(x<0)return-pow(x,1/T(3));
return pow(x,1/T(3));
}
template<>
float cuberoot<float>(float x)
{
using namespace cuberoot_detail;
if(x<0)return-cuberoot<float>(-x);
float a=cbrt_5f(x);
a=cbrta_halley(a,x);
return cbrta_halley(a,x);
}
template<>
double cuberoot<double>(double x)
{
using namespace cuberoot_detail;
if(x<0)return-cuberoot<double>(-x);
double a=cbrt_5d(x);
a=cbrta_halley(a,x);
a=cbrta_halley(a,x);
return cbrta_halley(a,x);
}
}
namespace heinlib
{
using::acos;
template<typename T>
std::complex<T>acos(const std::complex<T>&x)
{
static const std::complex<T>i(0,1);
return constants<T>::half_pi()+i*log(i*x+sqrt(T(1)-x*x));
}
template<typename T>
T acosh(T x)
{
assert(x>=1);
return log(x+sqrt(x*x-1));
}
template<typename T>
T asinh(T x)
{
return log(x+sqrt(1+x*x));
}
template<typename T>
std::complex<T>acosh(std::complex<T>x)
{
return ln(x+sqrt(x+T(1))*sqrt(x-T(1)));
}
template<typename T>
T chebyshev_cube_root(T t)
{
assert(t>-2);
if(abs(t)<=2)return 2*cos(acos(t/2)/3);
else return 2*cosh(acosh(t/2)/3);
}
template<typename T>
std::complex<T>chebyshev_cube_root(std::complex<T>t)
{
if(abs(t)<=2){
return T(2)*cos(acos(t/T(2))/T(3));
}else{
return T(2)*cosh(acosh(t/T(2))/T(3));
}
}
template<typename T>
int chebyshev_cubic_roots(T a,T b,T c,T&x1,T&x2,T&x3)
{
const T pi=constants<T>::pi();
T test=(a*a-3*b);
T p=test/9;
if(test>=0)
{
T t=-(2*a*a*a-9*a*b+27*c)/sqrt(cube(test));
if(t<-2)
{
std::cout<<"Bad t = "<<t<<"\n";
x1=-chebyshev_cube_root(-t);
return 1;
}
x1=sqrt(p)*chebyshev_cube_root(t)-a/3;
x2=-sqrt(p)*chebyshev_cube_root(-t)-a/3;
x3=-(x1+x2+a);
return 3;
}else
{
std::complex<T>t=-(2*a*a*a-9*a*b+27*c)/sqrt(std::complex<T>(cube(test)));
std::cout<<"Bad test! t = "<<t<<"\n";
std::cout<<"root = "<<sqrt(p)*chebyshev_cube_root(t)-a/3<<"\n";
x1=(sqrt(p)*chebyshev_cube_root(t)-a/3).real();
return 1;
}
}
}
#pragma once
#include<complex>
#include<cmath>
namespace heinlib
{
template<typename T>
int cardano_cubic_roots(T a,T b,T c,std::complex<T>*const roots)
{
static const T twopi3=constants<T>::two_pi()/3;
typedef std::complex<T>cmplx;
static const cmplx j(T(-0.5),sqrt(T(3))/2);
static const cmplx j2(T(-0.5),-sqrt(T(3))/2);
std::complex<T>&x1=roots[0],&x2=roots[1],&x3=roots[2];
T aa=a*a;
T p=b-aa/3;
T q=c+(2*aa*a-9*a*b)/27;
T at=a/3;
if(p==0)
{
if(q==0)
{
x1=-at;
return 1;
}else{
T v1=cuberoot<T>(-q);
cmplx v2=v1*j;
cmplx v3=v1*j2;
x1=v1-at;
x2=v2-at;
x3=v3-at;
return 3;
}
}else if(q==0)
{
if(p>0)
{
x1=-at;
x2=cmplx(-at,sqrt(p));
x3=cmplx(-at,-sqrt(p));
return 3;
}else{
x1=-a/3;
x2=x1+sqrt(-p);
x3=x1-sqrt(-p);
return 3;
}
}else{
T ppp27=p*p*p/27;
T test=q*q/4+ppp27;
if(test<0)
{
T r=sqrt(-ppp27);
T phi=acos(-q/(2*r));
T rt2=2*cuberoot<T>(r);
T phi3=phi/3;
x1=rt2*cos(phi3)-at;
x2=rt2*cos(phi3+twopi3)-at;
x3=rt2*cos(phi3-twopi3)-at;
return 3;
}else
{
T temp1=sqrt(test);
T q2=q/2;
T u1=cuberoot<T>(temp1-q2);
T v1=cuberoot<T>(temp1+q2);
x1=u1-v1-at;
if(test==0){
x2=-(u1-v1)/2-at;
return 2;
}else{
x2=cmplx(-(u1-v1)/2-a/3,(u1+v1)*sqrt(T(3))/2);
x3=cmplx(real(x2),-imag(x2));
return 3;
}
}
}
}
template<typename T>
int cardano_cubic_roots_real(T a,T b,T c,T*const roots)
{
static const T twopi3=constants<T>::two_pi()/3;
T&x1=roots[0],&x2=roots[1],&x3=roots[2];
T aa=a*a;
T p=b-aa/3;
T q=c+(2*aa*a-9*a*b)/27;
T at=a/3;
if(p==0)
{
if(q==0)
{
x1=-at;
return 1;
}else{
x1=cuberoot<T>(-q)-at;
return 1;
}
}else if(q==0)
{
if(p>0)
{
x1=-at;
return 1;
}else{
x1=-at;
T sqrtp=sqrt(-p);
x2=x1+sqrtp;
x3=x1-sqrtp;
return 3;
}
}else{
T ppp27=p*p*p/27;
T test=q*q/4+ppp27;
if(test<0)
{
T r=sqrt(-ppp27);
T phi=acos(-q/(2*r));
T rt2=2*cuberoot<T>(r);
T phi3=phi/3;
x1=rt2*cos(phi3)-at;
x2=rt2*cos(phi3+twopi3)-at;
x3=rt2*cos(phi3-twopi3)-at;
return 3;
}else
{
T temp1=sqrt(test);
T q2=q/2;
T u1=cuberoot<T>(temp1-q2);
T v1=cuberoot<T>(temp1+q2);
x1=u1-v1-at;
if(test==0){
x2=-(u1-v1)/2-at;
return 2;
}
return 1;
}
}
}
}
namespace heinlib
{
template<class Vector>
dynamic_matrix<typename Vector::real_type>make_monic(const Vector&poly)
{
typedef typename Vector::real_type Real;
unsigned last_ind=poly.rows*poly.cols-1;
while(last_ind>0&&poly[last_ind]==0)--last_ind;
assert(last_ind>=1);
dynamic_matrix<Real>monic(last_ind);
Real v=poly[last_ind];
for(unsigned i=0;i<last_ind;++i)
monic[i]=poly[i]/v;
return monic;
}
template<typename T>
__forceinline T quadratic_roots(T a,T b,T c,T&x1,T&x2)
{
T disc=b*b-4*a*c;
T f1=-b/(2*a);
T f2=sqrt(disc)/(2*a);
x1=f1+f2;
x2=f1-f2;
return disc;
}
template<class Vector,class Real>
Real eval_polynomial(const Vector&coeffs,const Real&t)
{
Real res=0,temp=1;
for(unsigned i=0;i<coeffs.size();++i){
res+=coeffs[i]*temp;
temp*=t;
}
return res;
}
template<class Vector,class Real>
std::complex<Real>eval_polynomial(const Vector&coeffs,const std::complex<Real>&t)
{
std::complex<Real>res(0,0),temp(1,0);
for(unsigned i=0;i<coeffs.size();++i){
res+=coeffs[i]*temp;
temp*=t;
}
return res;
}
template<class Vector,class Real>
std::complex<Real>eval_monic_polynomial(const Vector&coeffs,const std::complex<Real>&t)
{
std::complex<Real>res(0,0),temp(1,0);
for(unsigned i=0;i<coeffs.size();++i){
res+=temp*coeffs[i];
temp*=t;
}
res+=temp;
return res;
}
template<class Vector,class Real>
Real eval_monic_polynomial(const Vector&coeffs,const Real&t)
{
Real res=0,temp=1;
for(unsigned i=0;i<coeffs.size();++i){
res+=temp*coeffs[i];
temp*=t;
}
res+=temp;
return res;
}
template<class Vector,class Real>
Real eval_monic_polynomial_deriv(const Vector&coeffs,const Real&t)
{
Real res=0,temp=1;
for(unsigned i=1;i<coeffs.size();++i){
res+=i*temp*coeffs[i];
temp*=t;
}
res+=temp;
return res;
}
template<class Real>
Real eval_cubic(Real a,Real b,Real c,Real x)
{
return x*x*x+x*x*a+x*b+c;
}
template<class T>
void improve_cubic_root(T a,T b,T c,T&x,unsigned max_iter=3,T eps=1e-10)
{
unsigned iter=0;
T f=x*x*x+x*x*a+x*b+c;
while(iter<max_iter&&f>eps)
{
T df=3*x*x+2*x*a+b;
x-=f/df;
f=x*x*x+x*x*a+x*b+c;
++iter;
}
}
template<bool Loud,class Vector,typename Real>
Real improve_monic_polynomial_root(
const Vector&coeffs,
Real&t,
unsigned bad_steps_lim=20,unsigned max_iters=1000)
{
unsigned bad_steps=0;
Real test_t;
Real lambda=Real(0.0001);
Real prev_err=eval_monic_polynomial(coeffs,t);
if(Loud)std::cout<<std::setprecision(40)<<"ini   = "<<prev_err<<"		\n";
for(unsigned iter=0;iter<max_iters;++iter)
{
Real deriv=eval_monic_polynomial_deriv(coeffs,t);
test_t=t-prev_err*deriv/(sq(deriv)+lambda);
Real new_err=eval_monic_polynomial(coeffs,test_t);
if(abs(new_err)<abs(prev_err))
{
if(Loud)std::cout<<std::setprecision(40)<<"error = "<<new_err<<"		\n";
lambda*=0.1f;
bad_steps=0;
prev_err=new_err;
t=test_t;
}else{
++bad_steps;
if(lambda==Real(0))
lambda=std::numeric_limits<Real>::min();
else
{
if(bad_steps>bad_steps_lim)
return prev_err;
lambda*=Real(10);
if(lambda==std::numeric_limits<Real>::infinity()){
printf("Absolute min.\n");
return prev_err;
}
}
}
}
return prev_err;
}
}
namespace heinlib
{
template<class Real>
struct camera_intrinsics
{
static_matrix<3,3,Real>K;
unsigned Sw,Sh;
void enforce_zero_skew()
{
K(0,1)=0;
}
void enforce_aspect_ratio()
{
Real f=(K(0,0)+K(1,1))/2;
K(0,0)=K(1,1)=f;
}
void enforce_principal_point(const static_matrix<2,1,Real>&pp)
{
K(0,2)=pp.x();
K(1,2)=pp.y();
}
Real radial_distortion;
camera_intrinsics(Real f=1,unsigned Sw=0,unsigned Sh=0,Real radial_distortion=0)
:Sw(Sw),Sh(Sh),radial_distortion(radial_distortion)
{
static_matrix<3,3,Real>tempK={f,0,Sw*0.5,0,f,Sh*0.5,0,0,1};
K=tempK;
assert(distortion_is_reasonable());
}
camera_intrinsics(const static_matrix<3,3,Real>&K,unsigned Sw,unsigned Sh,Real radial_distortion=0)
:K(K),Sw(Sw),Sh(Sh),radial_distortion(radial_distortion)
{
assert(distortion_is_reasonable());
}
static_matrix<3,3,Real>inverseK()const
{
Real invF=1/K(0,0);
static_matrix<3,3,Real>ret={invF,0,-K(0,2)*invF,0,invF,-K(1,2)*invF,0,0,1};
return ret;
}
void set_focal_length(Real f,Real pixel_aspect=1)
{
K(0,0)=f;
K(1,1)=pixel_aspect*f;
}
Real get_focal_length()const
{
return K(0,0);
}
Real effective_focal_length(Real sensor_width_mm=35)const
{
return sensor_width_mm*(get_focal_length()/Sw);
}
Real get_fovw()const
{
return focal_length_to_fov(K(0,0),Sw);
}
Real get_fovh()const
{
return focal_length_to_fov(K(0,0),Sh);
}
Real get_skew_parameter()const
{
return K(0,1);
}
Real get_skew_angle()const
{
Real au=K(0,0);
return acot(-K(0,1)/au);
}
static_matrix<2,1,Real>get_principal_point()const
{
static_matrix<2,1,Real>pt={K(0,2),K(1,2)};
return pt;
}
void get_faugeras_parameters(Real&au,Real&av,Real&theta,Real&u,Real&v)
{
assert(K(1,0)==0);
assert(K(2,0)==0);
assert(K(2,1)==0);
assert(K(2,2)==1);
au=K(0,0);
theta=acot(-K(0,1)/au);
if(theta<0)theta+=ceil(-theta/constants<Real>::pi())*constants<Real>::pi();
else theta=fmod(theta,constants<Real>::pi());
assert((0<=theta)&&(theta<=constants<Real>::pi()));
av=K(1,1)*sin(theta);
u=K(0,2);
v=K(1,2);
}
void set_faugeras_parameters(Real au,Real av,Real theta,Real u,Real v)
{
fill(K,0);
K(0,0)=au;
K(0,2)=u;
K(1,2)=v;
K(2,2)=1;
if(theta==constants<Real>::half_pi())
{
K(0,1)=0;
K(1,1)=av;
}else
{
K(0,1)=-au*cot(theta);
K(1,1)=av/sin(theta);
}
}
static_matrix<2,1,Real>undistort(const static_matrix<2,1,Real>&x)const
{
if(radial_distortion!=0)
{
static_matrix<2,1,Real>pp=get_principal_point();
static_matrix<2,1,Real>p=x-pp;
Real divisor=(1+radial_distortion*length_sq(p));
if(divisor<=0)
return make_vector2<Real>(0,0);
p=p/divisor;
p+=pp;
return p;
}else return x;
}
Real get_max_undistort_radius()const
{
if(radial_distortion<0)
return sqrt(1/(-radial_distortion));
else return 0;
}
bool can_undistort(const static_matrix<2,1,Real>&x)const
{
if(radial_distortion==0)return true;
static_matrix<2,1,Real>pp=get_principal_point();
static_matrix<2,1,Real>p=x-pp;
return(radial_distortion*length_sq(p)>-1);
}
bool can_distort(const static_matrix<2,1,Real>&p)const
{
static_matrix<2,1,Real>p2=p-get_principal_point();
Real r=length(p2);
return r<get_max_distortion_radius();
}
Real get_max_distortion_radius()const
{
return sqrt(1/(4*abs(radial_distortion)));
}
bool distortion_is_reasonable()const
{
if(radial_distortion==0)
return true;
if(hypotf((float)Sw,(float)Sh)*0.5f>=get_max_distortion_radius())
return false;
static_matrix<2,1,Real>corner={};
if(distance(corner,distort(corner))>0.5*Sw)
return false;
return true;
}
static_matrix<2,1,Real>distort(const static_matrix<2,1,Real>&p)const
{
if(radial_distortion!=0)
{
static_matrix<2,1,Real>pp=get_principal_point();
static_matrix<2,1,Real>x=p-pp;
Real r=length(x);
Real d1,d2;
Real disc=quadratic_roots(radial_distortion*r,(Real)(-1),r,d1,d2);
if(disc>=0)
x*=(d2/r);
else
{
std::cout<<"ERROR: Distance to origin is too large, distortion is undefined!\n";
}
return x+pp;
}
return p;
}
};
template<class Real>
__forceinline Real focal_length_to_fov(Real f,Real screen_width)
{
return 2*atan(screen_width/(2*f));
}
template<class Real>
__forceinline Real fov_to_focal_length(Real fov_radian,Real screen_width)
{
return screen_width/(2*tan(fov_radian/2));
}
template<class Real>
bool get_calibration_matrix(static_matrix<3,3,Real>&K,const static_matrix<3,4,Real>&Pm)
{
static_matrix<4,4,Real>Ih={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0};
static_matrix<3,3,Real>w=Pm*Ih*transpose(Pm);
w/=w[8];
if(w[0]<=0||w[4]<=0)return false;
if(!cholesky_decomposition_enforce(inverse(w),K))
{
fill(K,0);
K(0,0)=K(1,1)=(sqrt(w[0])+sqrt(w[4]))/2;
K(2,2)=1;
}else{
K=transpose(inverse(K));
K/=K(2,2);
}
return true;
}
template<class Real>
void form_projection_matrix(
static_matrix<3,4,Real>&P,
const static_matrix<3,3,Real>&K,
const static_matrix<3,3,Real>&R,
const static_matrix<3,1,Real>&t)
{
P.block_insert(0,0,R);
P.block_insert(0,3,t);
P=K*P;
}
template<class Real>
void form_projection_matrix(
static_matrix<3,4,Real>&P,
const static_matrix<3,3,Real>&K,
const quaternion<Real>&qrot,
const static_matrix<3,1,Real>&t)
{
static_matrix<3,3,Real>R=qrot.to_matrix();
P.block_insert(0,0,R);
P.block_insert(0,3,t);
P=K*P;
}
}
namespace heinlib
{
template<class Real>
struct camera_view
{
rigid_motion<Real>pose;
camera_intrinsics<Real>*intrinsics;
camera_view(camera_intrinsics<Real>*intrinsics=NULL)
:intrinsics(intrinsics)
{
}
camera_view(const rigid_motion<Real>&pose,camera_intrinsics<Real>*intrinsics=NULL)
:pose(pose),intrinsics(intrinsics)
{
}
__forceinline static_matrix<3,1,Real>get_position()const
{
return pose.get_position();
}
__forceinline static_matrix<3,4,Real>get_projection_matrix()const
{
assert(intrinsics!=NULL);
static_matrix<3,4,Real>P;
form_projection_matrix(P,intrinsics->K,pose.qrot,pose.translation);
return P;
}
bool from_projection_matrix(const static_matrix<3,4,Real>&P)
{
if(!intrinsics)
{
std::cout<<"Must assign intrinsics first\n";
return false;
}
static_matrix<3,3,Real>R;
if(!factor_projection_matrix(intrinsics->K,R,pose.translation,P))
return false;
pose.qrot=make_quaternion(R,100);
return true;
}
bool from_projection_matrix_knownK(const static_matrix<3,4,Real>&Pm,Real*error=NULL)
{
assert(intrinsics!=NULL);
if(!intrinsics)return false;
static_matrix<3,4,Real>Rt=inverse(intrinsics->K)*Pm;
static_matrix<3,3,Real>R=Rt.template submatrix<0,0,2,2>();
pose.translation=Rt.template submatrix<0,3,2,3>();
pose.qrot=make_quaternion(R);
static_matrix<3,3,Real>R2=pose.qrot.to_matrix();
Real scale=matrix_scale(R,R2);
pose.translation*=scale;
if(error!=NULL)
*error=frobenius_norm(R*scale-R2);
return true;
}
__forceinline void from_basis(
const static_matrix<3,1,Real>&pos,
const static_matrix<3,1,Real>&right,
const static_matrix<3,1,Real>&down,
const static_matrix<3,1,Real>&forward)
{
static_matrix<3,3,Real>R;
R.block_insert(0,0,normalize(right));
R.block_insert(0,1,normalize(down));
R.block_insert(0,2,normalize(forward));
R=transpose(R);
pose.qrot=make_quaternion(R,100);
R=pose.qrot.to_matrix();
pose.translation=-R*pos;
}
__forceinline void get_camera_basis(
static_matrix<3,1,Real>&pos,
static_matrix<3,1,Real>&right,
static_matrix<3,1,Real>&down,
static_matrix<3,1,Real>&forward)const
{
static_matrix<3,3,Real>Rt;
quat_to_matrix(Rt,pose.qrot);
Rt=transpose(Rt);
pos=-Rt*pose.translation;
right=normalize(Rt.get_column(0));
down=normalize(Rt.get_column(1));
forward=normalize(Rt.get_column(2));
}
Real focal_length()const
{
assert(intrinsics!=NULL);
return intrinsics->K(0,0);
}
camera_view<Real>&operator*=(const similarity_transform<Real>&H)
{
transform_metric_camera(pose,H);
return*this;
}
static_matrix<3,1,Real>unproject(const static_matrix<2,1,Real>&x,const Real&depth)const
{
quaternion<Real>invQ=inverse(pose.qrot);
static_matrix<3,1,Real>cam_pos=-(invQ*pose.translation);
static_matrix<3,1,Real>dir=normalize(invQ*(intrinsics->inverseK()*homogenize(intrinsics->undistort(x))));
return cam_pos+dir*depth;
}
static_matrix<2,1,Real>project(const static_matrix<3,1,Real>&X)const
{
return intrinsics->distort(realize(intrinsics->K*(pose.qrot*X+pose.translation)));
}
bool visible(const static_matrix<3,1,Real>&X)const
{
static_matrix<3,1,Real>pr=intrinsics->K*(pose.qrot*X+pose.translation);
if(pr.z()<0)
return false;
static_matrix<2,1,Real>pt=realize(pr);
return(pt.x()>0&&pt.y()>0&&pt.x()<intrinsics->Sw&&pt.y()<intrinsics->Sh);
}
void make_canonical()
{
pose.make_identity();
}
};
template<class Real>
__forceinline std::ostream&operator<<(std::ostream&os,const camera_view<Real>&m)
{
os<<"f = "<<m.focal_length()<<", qrot = "<<m.pose.qrot<<", t = "<<m.pose.translation;
return os;
}
template<class Real>
bool is_canonical(const camera_view<Real>&cam)
{
return is_canonical(cam.pose);
}
template<class Real>
bool factor_projection_matrix(
static_matrix<3,3,Real>&K,
static_matrix<3,3,Real>&R,
static_matrix<3,1,Real>&t,
const static_matrix<3,4,Real>&P)
{
static_matrix<3,3,Real>A=P.template submatrix<0,0,2,2>();
if(!RQ_decomposition(K,R,A))
{
std::cout<<"RQ failed..use more robust decomposition\n";
return false;
}
t=inverse(K)*P.template submatrix<0,3,2,3>();
if(determinant(R)<0)
{
R*=-1;
t*=-1;
}
K/=K(2,2);
return true;
}
}
#pragma once
#include<cassert>
namespace heinlib
{
template<typename Iter>
__forceinline typename remove_pointer<typename Iter::value_type>::type
&iter_val(const Iter&it)
{
return remove_pointer<typename Iter::value_type>::strip(*it);
}
template<typename Iter>
__forceinline const typename remove_pointer<typename Iter::value_type>::type
&const_iter_val(const Iter&it)
{
return remove_pointer<typename Iter::value_type>::strip(*it);
}
template<typename Iter,class EnableConstIter=void>
class iter_container
{
STATIC_ASSERT((is_random_access_iter<Iter>::value),MUST_BE_RANDOM_ACCESS_ITER);
const Iter&begin,&end;
const unsigned _size;
public:
typedef typename remove_pointer<typename Iter::value_type>::type value_type;
iter_container(const Iter&begin,const Iter&end):begin(begin),end(end),_size(end-begin){}
__forceinline value_type&operator[](unsigned i)const
{
assert(i<_size);
return iter_val(begin+i);
}
__forceinline unsigned size()const{return _size;};
};
template<typename Iter>
class iter_container<Iter,typename enable_if<is_const_iter<Iter> >::type>
{
STATIC_ASSERT((is_random_access_iter<Iter>::value),MUST_BE_RANDOM_ACCESS_ITER);
const Iter&begin,&end;
const unsigned _size;
public:
typedef typename remove_pointer<typename Iter::value_type>::type value_type;
iter_container(const Iter&begin,const Iter&end):begin(begin),end(end),_size(end-begin){}
__forceinline const value_type&operator[](unsigned i)const
{
assert(i<_size);
return const_iter_val(begin+i);
}
__forceinline unsigned size()const{return _size;};
};
}
#pragma once
#pragma once
#include<vector>
#include<complex>
#pragma once
#include<complex>
#include<cmath>
namespace heinlib
{
template<class Vector,class Real>
void durand_kerner_monic_polynomial_roots(const Vector&coeffs,
std::vector<std::complex<Real> >&roots,
Real eps_stop,unsigned max_iter,unsigned min_iter=1)
{
unsigned M=coeffs.size();
roots.resize(M);
using namespace std;
typedef std::complex<Real>cmplx;
std::vector<std::complex<Real> >old_roots(M);
cmplx init(1,0),c(Real(0.4),Real(0.9));
for(unsigned i=0;i<M;++i){
old_roots[i]=roots[i]=init;
init*=c;
}
cmplx denom(1,0);
unsigned iter=0;
while(iter<min_iter)
{
for(unsigned i=0;i<M;++i)
{
denom=1;
for(unsigned j=0;j<M;++j)
if(j!=i)denom*=(roots[i]-roots[j]);
roots[i]-=eval_monic_polynomial(coeffs,old_roots[i])/denom;
}
for(unsigned i=0;i<M;++i)
old_roots[i]=roots[i];
++iter;
}
Real change;
while(iter<max_iter)
{
for(unsigned i=0;i<M;++i)
{
denom=1;
for(unsigned j=0;j<M;++j)
if(j!=i)denom*=(roots[i]-roots[j]);
roots[i]-=eval_monic_polynomial(coeffs,old_roots[i])/denom;
}
change=0;
for(unsigned i=0;i<M;++i){
change+=norm(old_roots[i]-roots[i]);
old_roots[i]=roots[i];
}
if(change<=eps_stop)
return;
++iter;
}
}
}
#pragma once
#include<cmath>
#pragma once
namespace heinlib
{
template<typename NxN>
void schur_decomposition(const NxN&A,NxN&Q,NxN&T)
{
unsigned N=A.rows;
assert(size_is(A,N,N));
resize_if_dynamic(Q,N,N);
resize_if_dynamic(T,N,N);
NxN U,R;
fill_identity(Q);
T=A;
for(unsigned i=0;i<1000;++i)
{
QR_decomposition_householder(T,U,R);
T=R*U;
Q*=U;
}
}
template<typename NxN>
void QR_method(const NxN&A,NxN&T,unsigned iters=1000)
{
unsigned N=A.rows;
assert(size_is(A,N,N));
resize_if_dynamic(T,N,N);
NxN U,R;
T=A;
for(unsigned i=0;i<iters;++i)
{
QR_decomposition_householder(T,U,R);
T=R*U;
}
}
}
namespace heinlib
{
template<typename NxN,typename Nx1>
void eigenvalues(const NxN&A,Nx1&eigs,unsigned iters=1000)
{
unsigned N=A.rows;
assert(size_is(A,N,N));
resize_if_dynamic(eigs,N,1);
assert(size_is(eigs,N,1));
NxN T;
QR_method(A,T,iters);
for(unsigned i=0;i<N;++i)
eigs[i]=T(i,i);
}
template<typename Real>
void eigen_decomposition(const static_matrix<2,2,Real>&A,
Real&e1,Real&e2,
static_matrix<2,1,Real>&v1,static_matrix<2,1,Real>&v2)
{
const Real&a=A[0],&b=A[1],&c=A[2],&d=A[3];
Real tr=a+d;
Real det=a*d-b*c;
assert(4*det<tr*tr);
Real temp=sqrt(tr*tr-4*det);
e1=(tr+temp)/2;
e2=(tr-temp)/2;
if(c!=0){
v1.x()=e1-d;
v1.y()=c;
v2.x()=e2-d;
v2.y()=c;
}else if(b!=0){
v1.x()=b;
v1.y()=e1-a;
v2.x()=b;
v2.y()=e2-a;
}else if(a>d){
v1.x()=1;
v1.y()=0;
v2.x()=0;
v2.y()=1;
}else{
v1.x()=0;
v1.y()=1;
v2.x()=1;
v2.y()=0;
}
}
template<typename T>
void cardano_eigenvalues_sym(const static_matrix<3,3,T>&A,T&e1,T&e2,T&e3)
{
T a=-A[0]-A[4]-A[8];
T a11=A[1]*A[1],a22=A[2]*A[2],a55=A[5]*A[5],a48=A[4]*A[8];
T b=A[0]*A[4]+A[0]*A[8]+a48-a11-a22-a55;
T c=a22*A[4]+A[0]*a55+a11*A[8]-A[0]*a48-2*A[1]*A[5]*A[2];
static const T i3=1/T(3);
static const T twopi3=constants<T>::two_pi()/3;
T aa=a*a;
T p=b-aa*i3;
T q=c+(2*aa*a-9*a*b)/27;
T at=a*i3;
T r=sqrt(-p*p*p/27);
T phi=acos(-q/(2*r));
T rt2=2*cuberoot(r);
T phi3=phi*i3;
static const T sin_twopi3=sin(twopi3);
static const T cos_twopi3=cos(twopi3);
T sin_phi3=sin(phi3),cos_phi3=cos(phi3);
e1=rt2*cos_phi3-at;
e2=rt2*cos_phi3*cos_twopi3+sin_phi3*sin_twopi3-at;
e3=rt2*cos_phi3*cos_twopi3-sin_phi3*sin_twopi3-at;
}
template<typename T>
void chebyshev_eigenvalues_sym(const static_matrix<3,3,T>&A,T&e1,T&e2,T&e3)
{
T a=-A[0]-A[4]-A[8];
T a11=A[1]*A[1],a22=A[2]*A[2],a55=A[5]*A[5],a48=A[4]*A[8];
T b=A[0]*A[4]+A[0]*A[8]+a48-a11-a22-a55;
T c=a22*A[4]+A[0]*a55+a11*A[8]-A[0]*a48-2*A[1]*A[5]*A[2];
static const T pi=constants<T>::pi();
static const T i3=1/T(3),i9=1/T(9),i227=2/T(27);
T aa=a*a;
T p=(aa-3*b)*i9;
T q=-(aa*a*i227-a*b*i3+c);
T t=q/sqrt(p*p*p);
T ac=acos(t*T(0.5));
T sqrtp2=sqrt(p)*2,ai3=a*i3;
e1=sqrtp2*cos(ac*i3)-ai3;
e2=-sqrtp2*cos((ac-pi)*i3)-ai3;
e3=-e1-e2-a;
}
template<typename NxN,typename Nx1>
void power_iterations(const NxN&A,Nx1&x,typename NxN::real_type&lambda,
typename NxN::real_type stop_eps,unsigned max_iters=1,unsigned min_iters=1)
{
unsigned N=A.rows;
assert(size_is(A,N,N));
resize_if_dynamic(x,N,1);
assert(size_is(x,N,1));
assert(length(x)>0);
for(unsigned iter=0;iter<min_iters;++iter){
x=normalize(A*x);
}
Nx1 y=x;
for(unsigned iter=std::min(max_iters-1,min_iters);
iter<max_iters;++iter)
{
x=normalize(y);
y=A*x;
lambda=dot(x,y);
if(length(y-lambda*x)<=stop_eps)
return;
}
}
template<unsigned N,class Real>
Real spectral_norm(const static_matrix<N,N,Real>&A)
{
static_matrix<N,1,Real>x;
Real lambda;
power_iterations(A,x,lambda,1e-6);
return sqrt(lambda);
}
}
namespace heinlib
{
template<unsigned Degree,class Real>
struct polynomial;
template<unsigned Degree,unsigned Degree2,class Real>
struct poly_result
{
typedef polynomial<(Degree2>=Degree)?Degree2:Degree,Real>add_result_type;
typedef polynomial<Degree+Degree2,Real>multiply_result_type;
};
enum Method
{
METHOD_COMPANION_EIGENVALUES,
METHOD_DURAND_KERNER,
METHOD_STURM_BRACKETING
};
template<unsigned Degree,class Real>
struct polynomial
{
static_matrix<Degree,1,Real>get_monic_coeffs()const
{
Real divisor=coeffs[Degree];
static_matrix<Degree,1,Real>monic_coeffs;
for(int i=0;i<Degree;++i)
monic_coeffs[i]=coeffs[i]/divisor;
return monic_coeffs;
}
void real_roots_companion_matrix(std::vector<Real>&roots,Real eps=1e-6,unsigned qr_iters=1000)const
{
static_matrix<Degree,1,Real>monic_coeffs=get_monic_coeffs();
static_matrix<Degree,Degree,Real>companion={};
companion.block_insert(0,Degree-1,-monic_coeffs);
for(int i=1;i<Degree;++i)
companion(i,i-1)=1;
static_matrix<Degree,1,Real>eigs;
eigenvalues(companion,eigs,qr_iters);
for(unsigned i=0;i<eigs.size();++i)
{
Real err=abs(eval(eigs[i]));
if(err<eps)
roots.push_back(eigs[i]);
}
}
void real_roots_durand_kerner(std::vector<Real>&roots,Real eps=1e-15,unsigned iters=10000)const
{
static_matrix<Degree,1,Real>monic_coeffs=get_monic_coeffs();
std::vector<std::complex<Real> >complex_roots;
durand_kerner_monic_polynomial_roots(monic_coeffs,complex_roots,eps,iters);
for(unsigned i=0;i<complex_roots.size();++i)
{
Real im_part=complex_roots[i].imag();
if(abs(im_part)<1e-6)
{
Real re_part=complex_roots[i].real();
bool repeat=false;
for(unsigned j=0;j<roots.size();++j)
{
if(abs(re_part-roots[j])<1e-3)
{
repeat=true;
break;
}
}
if(!repeat)roots.push_back(re_part);
}
}
}
void real_roots_sturm_bracketing(std::vector<Real>&roots)const
{
}
static_matrix<Degree+1,1,Real>coeffs;
Real eval(Real x)const
{
Real sum=0,temp=1;
for(unsigned i=0;i<coeffs.size();++i)
{
sum+=coeffs[i]*temp;
temp*=x;
}
return sum;
}
std::complex<Real>eval(std::complex<Real>&x)const
{
std::complex<Real>sum=0,temp=1;
for(int i=0;i<coeffs.size();++i)
{
sum+=coeffs[i]*temp;
temp*=x;
}
return sum;
}
Real eval_deriv(Real x)const
{
Real res=0,temp=1;
for(unsigned i=1;i<coeffs.size();++i)
{
res+=i*temp*coeffs[i];
temp*=x;
}
return res;
}
Real improve_root(Real&x,unsigned bad_steps_lim=20,unsigned max_iters=1000)
{
unsigned bad_steps=0;
Real test_x;
Real lambda=Real(0.0001);
Real prev_err=eval(x);
for(unsigned iter=0;iter<max_iters;++iter)
{
Real deriv=eval_deriv(x);
test_x=x-prev_err*deriv/(sq(deriv)+lambda);
Real new_err=eval(test_x);
if(abs(new_err)<abs(prev_err))
{
lambda*=0.1f;
bad_steps=0;
prev_err=new_err;
x=test_x;
}else{
++bad_steps;
if(lambda==Real(0))
lambda=std::numeric_limits<Real>::min();
else
{
if(bad_steps>bad_steps_lim)
return prev_err;
lambda*=Real(10);
if(lambda==std::numeric_limits<Real>::infinity())
{
return prev_err;
}
}
}
}
return prev_err;
}
int real_roots(std::vector<Real>&roots,int method=METHOD_DURAND_KERNER,Real eps=1e-15,unsigned iters=10000)const
{
roots.clear();
if(Degree==2)
{
Real a=coeffs[2],b=coeffs[1],c=coeffs[0];
Real disc=b*b-4*a*c;
Real f1=-b/(2*a);
Real f2=sqrt(disc)/(2*a);
roots.push_back(f1+f2);
roots.push_back(f1-f2);
}else if(Degree==3)
{
Real croots[3];
Real a=coeffs[2]/coeffs[3],b=coeffs[1]/coeffs[3],c=coeffs[0]/coeffs[3];
int num=cardano_cubic_roots_real(a,b,c,croots);
for(int i=0;i<num;++i)
roots.push_back(croots[i]);
}else
{
if(method==METHOD_DURAND_KERNER)
real_roots_durand_kerner(roots,eps,iters);
else if(method==METHOD_COMPANION_EIGENVALUES)
real_roots_companion_matrix(roots,eps,iters);
else if(method==METHOD_STURM_BRACKETING)
real_roots_sturm_bracketing(roots);
else std::cout<<"Unknown method!\n";
}
return roots.size();
}
int complex_roots(std::vector<std::complex<Real> >&roots)const
{
Real divisor=coeffs[Degree];
static_matrix<Degree,1,Real>monic_coeffs;
for(int i=0;i<Degree;++i)
monic_coeffs[i]=coeffs[i]/divisor;
durand_kerner_monic_polynomial_roots(monic_coeffs,roots,(Real)1e-6,10000);
return roots.size();
}
polynomial<Degree+1,Real>mult_x()const
{
polynomial<Degree+1,Real>ret={};
ret.coeffs.block_insert(1,0,coeffs);
return ret;
}
template<unsigned Degree2>
typename poly_result<Degree,Degree2,Real>::multiply_result_type
operator*(const polynomial<Degree2,Real>&p)const
{
typename poly_result<Degree,Degree2,Real>::multiply_result_type res={};
for(unsigned i=0;i<coeffs.size();++i)
for(unsigned j=0;j<p.coeffs.size();++j)
res.coeffs[i+j]+=coeffs[i]*p.coeffs[j];
return res;
}
template<unsigned Degree2>
typename poly_result<Degree,Degree2,Real>::add_result_type
operator+(const polynomial<Degree2,Real>&p)const
{
typename poly_result<Degree,Degree2,Real>::add_result_type res={};
for(unsigned i=0;i<coeffs.size();++i)
res.coeffs[i]+=coeffs[i];
for(unsigned i=0;i<p.coeffs.size();++i)
res.coeffs[i]+=p.coeffs[i];
return res;
}
template<unsigned Degree2>
typename poly_result<Degree,Degree2,Real>::add_result_type
operator-(const polynomial<Degree2,Real>&p)const
{
typename poly_result<Degree,Degree2,Real>::add_result_type res={};
for(unsigned i=0;i<coeffs.size();++i)
res.coeffs[i]=coeffs[i];
for(unsigned i=0;i<p.coeffs.size();++i)
res.coeffs[i]-=p.coeffs[i];
return res;
}
};
template<unsigned Degree,class Real>
inline std::ostream&operator<<(std::ostream&os,const polynomial<Degree,Real>&p)
{
for(int i=Degree;i>=0;--i)
{
os<<p.coeffs[i];
if(i>0)
{
if(i==1)os<<"x";
else os<<"x^"<<i;
}
if(i>0)os<<" + ";
}
return os;
}
}
#pragma once
namespace heinlib
{
template<typename MxN,typename NxP,typename MxP>
bool least_squares_SVD(const MxN&A,NxP&X,const MxP&B)
{
unsigned M=A.rows,N=A.cols,P=B.cols;
assert(B.rows==M);
resize_if_dynamic(X,N,P);
assert(size_is(X,N,P));
typedef typename transpose_result<MxN>::result_type NxM;
NxM Apinv;
resize_if_dynamic(Apinv,N,M);
if(!pseudo_inverse_SVD(A,Apinv))
return false;
X=Apinv*B;
return true;
}
template<typename MxN,typename NxP,typename MxP>
void least_squares_inverse(const MxN&A,NxP&X,const MxP&B)
{
unsigned M=A.rows,N=A.cols,P=B.cols;
assert(size_is(B,M,P));
resize_if_dynamic(X,N,P);
X=inverse(transpose_premultiply(A))*transpose(A)*B;
}
template<typename MxN,typename Mx1,typename Nx1>
bool least_squares_cholesky(const MxN&X,const Mx1&Y,Nx1&B)
{
typedef typename transpose_result<MxN>::result_type NxM;
typedef typename square_result<Nx1>::result_type NxN;
NxM Xt=transpose(X);
Nx1 XtY,Z;
XtY=Xt*Y;
NxN XtX,L;
XtX=Xt*X;
if(!cholesky_decomposition(XtX,L))
return false;
forward_substitution(L,XtY,Z);
back_substitution(transpose(L),Z,B);
return true;
}
template<typename MxN,typename Mx1,typename Nx1>
bool least_squares_cholesky_enforce(const MxN&X,const Mx1&Y,Nx1&B)
{
typedef typename transpose_result<MxN>::result_type NxM;
typedef typename square_result<Nx1>::result_type NxN;
NxM Xt=transpose(X);
Nx1 XtY,Z;
XtY=Xt*Y;
NxN XtX,L;
XtX=Xt*X;
if(!cholesky_decomposition_enforce(XtX,L))
return false;
forward_substitution(L,XtY,Z);
back_substitution(transpose(L),Z,B);
return true;
}
template<typename MxN,typename Mx1,typename Nx1>
void least_squares_QR(const MxN&A,const Mx1&B,Nx1&X)
{
typedef typename square_result<MxN>::result_type MxM;
unsigned M=A.rows,N=A.cols;
resize_if_dynamic(B,M,1);
resize_if_dynamic(X,N,1);
MxM Q;
MxN R;
QR_decomposition_householder(A,Q,R);
back_substitution(R,transpose(Q)*B,X);
}
}
#pragma once
namespace heinlib
{
template<unsigned Count,typename Type>
struct tuple
{
static const unsigned count=Count;
Type element[Count];
__forceinline Type operator[](unsigned i)const
{return element[i];}
__forceinline Type&operator[](unsigned i)
{return element[i];}
};
template<class Type>
__forceinline tuple<2,Type>make_tuple(const Type&x1,const Type&x2)
{
tuple<2,Type>c;
c[0]=x1;
c[1]=x2;
return c;
}
template<class Type>
__forceinline tuple<3,Type>make_tuple(const Type&x1,const Type&x2,const Type&x3)
{
tuple<3,Type>c;
c[0]=x1;
c[1]=x2;
c[1]=x3;
return c;
}
}
#pragma once
#pragma once
namespace heinlib
{
template<unsigned M,unsigned N,typename Real>
bool linear_solution_space(const static_matrix<M,N,Real>&A,
const static_matrix<M,1,Real>&b,
static_matrix<N,N-M,Real>&X,
static_matrix<N,1,Real>&c)
{
assert(M<N);
static_matrix<M,N+1,Real>aug,rref;
aug.block_insert(0,0,A);
aug.block_insert(0,N,b);
if(!gauss_jordan_elimination<0>(aug,rref))
return false;
unsigned i,j;
for(i=0;i<M;++i)
for(j=M;j<N;++j)
X(i,j-M)=rref(i,j);
for(i=M;i<N;++i)
for(j=0;j<N-M;++j)
X(i,j)=0;
for(i=0;i<N-M;++i)
X(i+M,i)=-1;
for(i=0;i<M;++i)
c[i]=rref(i,N);
for(i=M;i<N;++i)
c[i]=0;
return true;
}
}
#pragma once
namespace heinlib
{
template<typename MxN>
void reduce_rank(const MxN&in,MxN&out,unsigned rank)
{
typedef typename square_result<typename transpose_result<MxN>::result_type>::result_type NxN;
typedef typename MxN::real_type Real;
unsigned M=in.rows,N=in.cols;
resize_if_dynamic(out,M,N);
assert(size_is(in,M,N));
MxN U;
resize_if_dynamic(U,M,N);
NxN S,V;
resize_if_dynamic(S,N,N);
resize_if_dynamic(V,N,N);
SVD<true,true>(in,U,S,V);
for(unsigned i=rank;i<std::min(M,N);++i)
S(i,i)=0;
out=U*S*transpose(V);
}
template<typename MxN>
unsigned rank(const MxN&in,typename MxN::real_type thresh=(typename MxN::real_type)(1e-5))
{
unsigned M=std::min(in.rows,in.cols);
MxN U;
typedef typename square_result<typename transpose_result<MxN>::result_type>::result_type NxN;
NxN S,V;
SVD<false,false>(in,U,S,V);
for(unsigned i=0;i<M;++i)
{
if(abs(S(i,i))<thresh)
return i;
}
return M;
}
}
#pragma once
namespace heinlib
{
template<class Real>
bool normalizing_transform(static_matrix<3,3,Real>&T,const std::vector<static_matrix<2,1,Real> >&points)
{
static_matrix<2,1,Real>mean={};
for(unsigned i=0;i<points.size();++i)
mean+=points[i];
mean/=(Real)points.size();
static_matrix<2,2,Real>covar={};
for(unsigned i=0;i<points.size();++i)
{
static_matrix<2,1,Real>diff=points[i]-mean;
covar+=diff*transpose(diff);
}
covar/=(Real)points.size();
static_matrix<2,2,Real>L;
if(!cholesky_decomposition(covar,L))
{
std::cout<<"covar failed = \n"<<covar<<"\n";
return false;
}
static_matrix<3,3,Real>N={};
N.block_insert(0,0,L);
N.block_insert(0,2,mean);
N(2,2)=1;
return matrix_inverse(N,T);
}
template<class Real,unsigned Dim>
bool normalizing_transform(static_matrix<3,3,Real>&T,const std::vector<tuple<Dim,static_matrix<2,1,Real> > >&corrs,unsigned d)
{
static_matrix<2,1,Real>mean={};
for(unsigned i=0;i<corrs.size();++i)
mean+=corrs[i][d];
mean/=(Real)corrs.size();
static_matrix<2,2,Real>covar={};
for(unsigned i=0;i<corrs.size();++i)
{
static_matrix<2,1,Real>diff=corrs[i][d]-mean;
covar+=diff*transpose(diff);
}
covar/=(Real)corrs.size();
static_matrix<2,2,Real>L;
if(!cholesky_decomposition(covar,L))
{
std::cout<<"covar failed = \n"<<covar<<"\n";
return false;
}
static_matrix<3,3,Real>N={};
N.block_insert(0,0,L);
N.block_insert(0,2,mean);
N(2,2)=1;
return matrix_inverse(N,T);
}
template<unsigned Dim,class Real,class Iter>
bool normalizing_transform(static_matrix<Dim+1,Dim+1,Real>&T,const Iter&begin,const Iter&end,unsigned d)
{
iter_container<Iter>corrs(begin,end);
static_matrix<Dim,1,Real>mean={};
for(unsigned i=0;i<corrs.size();++i)
mean+=corrs[i][d];
mean/=(Real)corrs.size();
static_matrix<Dim,Dim,Real>covar={};
for(unsigned i=0;i<corrs.size();++i)
{
static_matrix<Dim,1,Real>diff=corrs[i][d]-mean;
covar+=diff*transpose(diff);
}
covar/=(Real)corrs.size();
static_matrix<Dim,Dim,Real>L;
if(!cholesky_decomposition(covar,L))
{
std::cout<<"covar failed = \n"<<covar<<"\n";
return false;
}
static_matrix<Dim+1,Dim+1,Real>N={};
N.block_insert(0,0,L);
N.block_insert(0,Dim,mean);
N(Dim,Dim)=1;
return matrix_inverse(N,T);
}
}
namespace heinlib
{
template<typename Real>
__forceinline bool get_fundamental_matrix(const static_matrix<3,4,Real>&P2,
static_matrix<3,3,Real>&F)
{
F=cross_product_matrix(P2.get_column(3))*P2.template submatrix<0,0,2,2>();
standardize_scale(F);
return true;
}
template<bool Canonical,typename Real>
bool get_fundamental_matrix(const static_matrix<3,4,Real>&P1,
const static_matrix<3,4,Real>&P2,
static_matrix<3,3,Real>&F)
{
if(Canonical)
{
assert(is_canonical(P1));
F=cross_product_matrix(P2.get_column(3))*P2.template submatrix<0,0,2,2>();
}else
{
static_matrix<4,1,Real>C;
get_camera_center(P1,C);
if(C[3]==0)return false;
C=homogeneous_divide(C);
static_matrix<3,1,Real>e2=P2*C;
static_matrix<4,3,Real>P1pinv;
pseudo_inverse_camera(P1pinv,P1);
F=cross_product_matrix(e2)*P2*P1pinv;
}
standardize_scale(F);
return true;
}
template<typename Real>
bool get_fundamental_matrix2(const static_matrix<3,4,Real>&P1,
const static_matrix<3,4,Real>&P2,
static_matrix<3,3,Real>&F)
{
static_matrix<4,4,Real>A;
for(int i=0;i<3;++i)for(int j=0;j<3;++j)
{
A.block_insert(0,0,P1.get_row((i+1)%3));
A.block_insert(1,0,P1.get_row((i+2)%3));
A.block_insert(2,0,P2.get_row((j+1)%3));
A.block_insert(3,0,P2.get_row((j+2)%3));
F(j,i)=determinant(A);
}
standardize_scale(F);
return true;
}
template<bool Canonical,typename Real>
static_matrix<3,3,Real>get_fundamental_matrix(const static_matrix<3,4,Real>&P1,const static_matrix<3,4,Real>&P2)
{
static_matrix<3,3,Real>F;
get_fundamental_matrix<Canonical>(P1,P2,F);
return F;
}
template<typename Real>
__forceinline void right_epipole(const static_matrix<3,3,Real>&F,static_matrix<3,1,Real>&e1)
{
null_space_2x3(F,e1);
if(e1.z()!=0)e1=homogeneous_divide(e1);
}
template<typename Real>
__forceinline void left_epipole(const static_matrix<3,3,Real>&F,static_matrix<3,1,Real>&e2)
{
null_space_2x3(transpose(F),e2);
if(e2.z()!=0)e2=homogeneous_divide(e2);
}
template<typename Real>
void P2_from_F(const static_matrix<3,3,Real>&F,static_matrix<3,4,Real>&P2)
{
static_matrix<3,1,Real>e2;
left_epipole(F,e2);
P2.block_insert(0,0,cross_product_matrix(e2)*F);
P2.block_insert(0,3,e2);
}
}
namespace heinlib
{
namespace triang_detail
{
template<class Real>
bool optimal_corr_adjust(
tuple<2,static_matrix<2,1,Real> >&exact_corr,
const tuple<2,static_matrix<2,1,Real> >&corr,
const static_matrix<3,3,Real>&F)
{
typedef static_matrix<3,3,Real>matrix_3x3;
typedef static_matrix<3,1,Real>pointP2;
const static_matrix<2,1,Real>&x1=corr[0],&x2=corr[1];
matrix_3x3 T={1,0,-x1.x(),
0,1,-x1.y(),
0,0,1},Tinv;
matrix_3x3 T2={1,0,-x2.x(),
0,1,-x2.y(),
0,0,1},T2inv;
matrix_inverse(T,Tinv);
matrix_inverse(T2,T2inv);
matrix_3x3 Fp=transpose(T2inv)*F*Tinv;
pointP2 e1,e2;
right_epipole(Fp,e1);
left_epipole(Fp,e2);
Real norm1=sq(e1.x())+sq(e1.y());
if(norm1==0)return false;
Real norm2=sq(e2.x())+sq(e2.y());
if(norm2==0)return false;
e1*=1/sqrt(norm1);
e2*=1/sqrt(norm2);
matrix_3x3 R1={e1.x(),e1.y(),0,
-e1.y(),e1.x(),0,
0,0,1};
matrix_3x3 R1tr=transpose(R1);
matrix_3x3 R2={e2.x(),e2.y(),0,
-e2.y(),e2.x(),0,
0,0,1};
Fp=R2*Fp*R1tr;
Real f=e1.z(),fp=e2.z(),a=Fp(1,1),b=Fp(1,2),c=Fp(2,1),d=Fp(2,2);
Real tmp1=a*d-b*c;
Real f2=f*f,f4=f2*f2;
Real fp2=fp*fp;
Real a2=a*a,b2=b*b,c2=c*c,d2=d*d;
Real top_coeff=-tmp1*f4*a*c;
if(top_coeff==0)return false;
polynomial<6,Real>p;
p.coeffs[6]=top_coeff;
p.coeffs[5]=sq(a2+fp2*c2)-tmp1*f4*b*c-tmp1*f4*a*d;
p.coeffs[4]=(2*(2*b*a+2*fp2*d*c))*(a2+fp2*c2)-(2*tmp1)*f2*a*c-tmp1*f4*b*d;
p.coeffs[3]=-(2*tmp1)*f2*b*c-(2*tmp1)*f2*a*d+(2*(b2+fp2*d2))*(a2+fp2*c2)+sq(2*b*a+2*fp2*d*c);
p.coeffs[2]=-tmp1*a*c-(2*tmp1)*f2*b*d+(2*(b2+fp2*d2))*(2*b*a+2*fp2*d*c);
p.coeffs[1]=sq(b2+fp2*d2)-tmp1*b*c-tmp1*a*d;
p.coeffs[0]=-tmp1*b*d;
std::vector<Real>roots;
p.real_roots(roots);
Real lowest_err=std::numeric_limits<Real>::max();
Real best_t=0;
for(int i=0;i<roots.size();++i)
{
Real t=roots[i],t2=t*t,tmp=sq(c*t+d);
Real err=abs(t2/(1+f2*t2)+tmp/(sq(a*t+b)+fp2*tmp));
if(err<lowest_err)
{
lowest_err=err;
best_t=t;
}
}
pointP2 l1={best_t*f,1,-best_t};
pointP2 l2={-fp*(c*best_t+d),a*best_t+b,c*best_t+d};
pointP2 x1p,x2p;
closest_point_to_origin<Real>(l1,x1p);
closest_point_to_origin<Real>(l2,x2p);
exact_corr[0]=realize(Tinv*R1tr*x1p);
exact_corr[1]=realize(T2inv*transpose(R2)*x2p);
return true;
}
template<bool Canonical,unsigned Views,class Real>
__forceinline void zero_baseline_triangulate(
static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
if(Canonical)
{
X.block_insert(0,0,corr[0]);
X[3]=1;
}else{
static_matrix<3,3,Real>M=projs[0].template submatrix<0,0,2,2>();
static_matrix<3,1,Real>m=projs[0].template submatrix<0,3,2,3>();
X.block_insert(0,0,inverse(M)*(homogenize(corr[0])-m));
X[3]=1;
}
for(unsigned i=0;i<Views;++i)
std::cout<<corr[i]<<" == "<<realize(projs[i]*X)<<"\n";
system("pause");
}
template<unsigned Views,class Real>
bool inhomogeneous_triangulate(
static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
static_matrix<Views*2,3,Real>A;
static_matrix<Views*2,1,Real>B;
unsigned row=0;
for(unsigned i=0;i<Views;++i)
{
const static_matrix<3,4,Real>&P=projs[i];
const static_matrix<2,1,Real>&pt=corr[i];
A(row,0)=P[8]*pt.y()-P[4];
A(row,1)=P[9]*pt.y()-P[5];
A(row,2)=P[10]*pt.y()-P[6];
B[row]=P[7]-P[11]*pt.y();
++row;
A(row,0)=P[0]-P[8]*pt.x();
A(row,1)=P[1]-P[9]*pt.x();
A(row,2)=P[2]-P[10]*pt.x();
B[row]=P[11]*pt.x()-P[3];
++row;
}
static_matrix<3,1,Real>Xsol;
if(!least_squares_cholesky(A,B,Xsol))
return false;
if(corrupt(Xsol[0])||corrupt(Xsol[1])||corrupt(Xsol[2]))
return false;
matrix_copy(X,Xsol,3);
X[3]=1;
return true;
}
template<unsigned Views,class Real>
bool DLT_triangulate(
static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
static_matrix<2*Views,4,Real>A;
for(unsigned i=0;i<Views;++i)
{
const static_matrix<3,4,Real>&P=projs[i];
const static_matrix<2,1,Real>&pt=corr[i];
A.block_insert(2*i,0,P.get_row(2)*pt.y()-P.get_row(1));
A.block_insert(2*i+1,0,P.get_row(0)-P.get_row(2)*pt.x());
}
if(!null_space_SVD(A,X))return false;
if(X[3]!=0)X=homogeneous_divide(X);
return true;
}
template<unsigned Views,class Real>
bool DLT_triangulate(
static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<3,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
static_matrix<2*Views,4,Real>A;
for(unsigned i=0;i<Views;++i)
{
const static_matrix<3,4,Real>&P=projs[i];
const static_matrix<3,1,Real>&pt=corr[i];
A.block_insert(2*i,0,P.get_row(2)*pt.y()-P.get_row(1)*pt.z());
A.block_insert(2*i+1,0,P.get_row(0)*pt.z()-P.get_row(2)*pt.x());
}
if(!null_space_SVD(A,X))return false;
if(X[3]!=0)X=homogeneous_divide(X);
return true;
}
template<bool Canonical,unsigned Views,class Real>
__forceinline bool linear_triangulate(
static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
return triang_detail::DLT_triangulate(X,corr,projs);
}
template<unsigned j,unsigned Views,class Real>
struct unroll_error
{
__forceinline static void call(Real&sq_err,
const static_matrix<4,1,Real>&S,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
const static_matrix<3,4,Real>&P=projs[j];
const Real&X=S.x(),&Y=S.y(),&Z=S.z();
Real xp=P[0]*X+P[1]*Y+P[2]*Z+P[3];
Real yp=P[4]*X+P[5]*Y+P[6]*Z+P[7];
Real zp=P[8]*X+P[9]*Y+P[10]*Z+P[11];
sq_err+=sq(xp/zp-corr[j].x())+sq(yp/zp-corr[j].y());
unroll_error<j+1,Views,Real>::call(sq_err,S,corr,projs);
}
};
template<unsigned Views,class Real>
struct unroll_error<Views,Views,Real>
{
__forceinline static void call(Real&sq_err,
const static_matrix<4,1,Real>&S,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
}
};
template<bool Canonical,unsigned Views,class Real>
__forceinline Real triang_error(
const static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
Real sq_err=0;
if(Canonical)
{
sq_err+=sq(X.x()/X.z()-corr[0].x())+sq(X.y()/X.z()-corr[0].y());
triang_detail::unroll_error<1,Views,Real>::call(sq_err,X,corr,projs);
}else{
triang_detail::unroll_error<0,Views,Real>::call(sq_err,X,corr,projs);
}
return sq_err;
}
template<bool Canonical,unsigned Views,class Real>
__forceinline Real triang_error(
const static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<3,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
Real sq_err=0;
sq_err+=angle(corr[0],projs[0]*X);
sq_err+=angle(corr[1],projs[1]*X);
return sq_err;
}
template<bool Canonical,unsigned Views,class Real>
Real LM_triangulate(
static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs,
unsigned max_bad_steps=5,
Real relative_eps=1e-3)
{
static const unsigned Dim=2*Views;
static_matrix<Dim,3,Real>J;
static_matrix<Dim,1,Real>E;
static_matrix<3,3,Real>JtJ,L;
static_matrix<3,1,Real>JtE,Delta,Z,T;
static_matrix<4,1,Real>Xnew=X;
Real lambda=0.001;
unsigned bad_steps=0;
Real prevErr=triang_error<Canonical>(Xnew,corr,projs);
if(corrupt(prevErr))return prevErr;
for(int iter=0;iter<10;++iter)
{
for(unsigned i=0;i<Views;++i)
{
const static_matrix<3,4,Real>&P=projs[i];
const static_matrix<2,1,Real>&pt=corr[i];
T=P*X;
Real div=1/sq(T[2]);
unsigned r1=i*2,r2=r1+1;
J(r1,0)=P[0]/T[2]-T[0]*P[8]*div;
J(r1,1)=P[1]/T[2]-T[0]*P[9]*div;
J(r1,2)=P[2]/T[2]-T[0]*P[10]*div;
J(r2,0)=P[4]/T[2]-T[1]*P[8]*div;
J(r2,1)=P[5]/T[2]-T[1]*P[9]*div;
J(r2,2)=P[6]/T[2]-T[1]*P[10]*div;
E[r1]=T[0]/T[2]-pt.x();
E[r2]=T[1]/T[2]-pt.y();
}
JtJ=transpose(J)*J;
for(unsigned i=0;i<3;++i)
JtJ(i,i)*=1+lambda;
JtE=transpose(J)*E;
cholesky_decomposition(JtJ,L);
forward_substitution(L,JtE,Z);
back_substitution(transpose(L),Z,Delta);
for(unsigned i=0;i<3;++i)
Xnew[i]=X[i]-Delta[i];
Real new_err=triang_error<Canonical>(Xnew,corr,projs);
if(new_err<prevErr)
{
X=Xnew;
Real eps_step=(prevErr-new_err)/prevErr;
if(eps_step<relative_eps)
return prevErr;
prevErr=new_err;
lambda*=Real(0.1);
bad_steps=0;
}else{
if(lambda==Real(0))
lambda=std::numeric_limits<Real>::min();
else{
++bad_steps;
if(bad_steps>max_bad_steps)
return prevErr;
lambda*=Real(10);
if(lambda==std::numeric_limits<Real>::infinity()){
return prevErr;
}
}
}
}
return prevErr;
}
}
template<bool Canonical,typename Real>
__forceinline Real triangulate_pair(
static_matrix<4,1,Real>&X,
const tuple<2,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs,
const static_matrix<3,3,Real>&F)
{
assert(length_sq(F)>0);
tuple<2,static_matrix<2,1,Real> >exact_corr;
if(triang_detail::optimal_corr_adjust(exact_corr,corr,F))
{
triang_detail::linear_triangulate<Canonical>(X,exact_corr,projs);
return triang_detail::triang_error<Canonical>(X,corr,projs);
}else
{
triang_detail::linear_triangulate<Canonical>(X,corr,projs);
return triang_detail::LM_triangulate<Canonical>(X,corr,projs);
}
}
template<bool Canonical,unsigned Views,class Real>
__forceinline Real triangulate(
static_matrix<4,1,Real>&X,
const tuple<Views,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
if(Canonical)assert(is_canonical(projs[0]));
if(!triang_detail::linear_triangulate<Canonical>(X,corr,projs))
return false;
return triang_detail::LM_triangulate<Canonical>(X,corr,projs);
}
#ifdef USE_MLE_TRIANG_CORR_ADJUST
template<bool Canonical,class Real>
__forceinline Real triangulate(
static_matrix<4,1,Real>&X,
const tuple<2,static_matrix<2,1,Real> >&corr,
const static_matrix<3,4,Real>*projs)
{
static_matrix<3,3,Real>F;
if(get_fundamental_matrix<Canonical>(projs[0],projs[1],F))
{
return triangulate_pair<Canonical>(X,corr,projs,F);
}else
{
return std::numeric_limits<Real>::infinity();
}
}
#endif
}
#include<map>
#include<fstream>
namespace heinlib
{
template<class Real>
struct metric_recon;
template<class Real>
struct projective_recon;
template<class T>struct is_recon{enum{value=0};};
template<class Real>struct is_recon<projective_recon<Real> >{enum{value=1};};
template<class Real>struct is_recon<metric_recon<Real> >{enum{value=1};};
template<class T>struct is_metric_recon{enum{value=0};};
template<class Real>struct is_metric_recon<metric_recon<Real> >{enum{value=1};};
template<class T>struct is_proj_recon{enum{value=0};};
template<class Real>struct is_proj_recon<projective_recon<Real> >{enum{value=1};};
template<class Real>
struct projective_recon
{
typedef Real real_type;
typedef static_matrix<4,1,Real>point_type;
std::vector<unsigned>viewIDs,pointIDs;
std::vector<static_matrix<4,1,Real> >points;
std::vector<static_matrix<3,4,Real> >pmats;
void remove_view_by_index(unsigned index)
{
pmats.erase(pmats.begin()+index);
viewIDs.erase(viewIDs.begin()+index);
}
void remove_point_by_index(unsigned index)
{
points.erase(points.begin()+index);
pointIDs.erase(pointIDs.begin()+index);
}
static_matrix<3,4,Real>*get_pmat(unsigned viewID)
{
int ind=lookup_index(viewIDs,viewID);
if(ind<0)return NULL;
return&pmats[ind];
}
const static_matrix<3,4,Real>*get_pmat(unsigned viewID)const
{
int ind=lookup_index(viewIDs,viewID);
if(ind<0)return NULL;
return&pmats[ind];
}
static_matrix<4,1,Real>*get_point(unsigned pointID)
{
int ind=lookup_index(pointIDs,pointID);
if(ind<0)return NULL;
return&points[ind];
}
const static_matrix<4,1,Real>*get_point(unsigned pointID)const
{
int ind=lookup_index(pointIDs,pointID);
if(ind<0)return NULL;
return&points[ind];
}
void clear()
{
pmats.clear();
points.clear();
pointIDs.clear();
viewIDs.clear();
}
void reorder_points()
{
std::vector<unsigned>permutation_list;
sort_permutation(permutation_list,pointIDs);
apply_permutation(pointIDs,permutation_list);
apply_permutation(points,permutation_list);
}
void reorder_views()
{
std::vector<unsigned>permutation_list;
sort_permutation(permutation_list,viewIDs);
apply_permutation(viewIDs,permutation_list);
apply_permutation(pmats,permutation_list);
}
void default_indices()
{
viewIDs.resize(pmats.size());
pointIDs.resize(points.size());
for(unsigned i=0;i<viewIDs.size();++i)
viewIDs[i]=i;
for(unsigned i=0;i<pointIDs.size();++i)
pointIDs[i]=i;
}
projective_recon(){}
template<class Recon>
projective_recon(const Recon&recon)
{
STATIC_ASSERT((is_recon<Recon>::value),NOT_A_RECONSTRUCTION);
*this=recon;
}
template<class Recon>
typename enable_if<is_recon<Recon>,projective_recon&>::type
operator=(const Recon&recon)
{
viewIDs=recon.viewIDs;
pointIDs=recon.pointIDs;
points=recon.points;
pmats=recon.pmats;
return*this;
}
template<class Iter>
void retriangulate_points(const Iter&begin_corrs,const Iter&end_corrs)
{
iter_container<Iter>corrs(begin_corrs,end_corrs);
if(pointIDs.size()<corrs.size())
{
pointIDs.resize(corrs.size());
for(unsigned i=0;i<corrs.size();++i)
pointIDs[i]=i;
}
points.resize(corrs.size());
if(is_canonical(pmats[0]))
{
for(unsigned i=0;i<corrs.size();++i)
triangulate<true>(points[i],corrs[i],&pmats[0]);
}else
{
for(unsigned i=0;i<corrs.size();++i)
triangulate<false>(points[i],corrs[i],&pmats[0]);
}
}
void merge(const projective_recon&recon)
{
std::vector<unsigned>add_inds;
for(unsigned i=0;i<recon.viewIDs.size();++i)
{
if(!get_view(recon.viewIDs[i]))
add_inds.push_back(i);
}
for(unsigned i=0;i<add_inds.size();++i)
{
viewIDs.push_back(recon.viewIDs[i]);
pmats.push_back(recon.pmats[i]);
}
reorder_views();
add_inds.clear();
for(unsigned i=0;i<recon.pointIDs.size();++i)
{
if(!get_point(recon.pointIDs[i]))
add_inds.push_back(i);
}
for(unsigned i=0;i<add_inds.size();++i)
{
pointIDs.push_back(recon.pointIDs[i]);
points.push_back(recon.points[i]);
}
reorder_points();
}
__forceinline static_matrix<2,1,Real>project(unsigned camera_ind,const static_matrix<4,1,Real>&X)const
{
const static_matrix<3,4,Real>&P=pmats[camera_ind];
Real pX=P[0]*X[0]+P[1]*X[1]+P[2]*X[2]+P[3]*X[3],
pY=P[4]*X[0]+P[5]*X[1]+P[6]*X[2]+P[7]*X[3],
pZ=P[8]*X[0]+P[9]*X[1]+P[10]*X[2]+P[11]*X[3];
static_matrix<2,1,Real>res={pX/pZ,pY/pZ};
return res;
}
__forceinline static_matrix<2,1,Real>project(unsigned camera_ind,unsigned structure_ind)const
{
const static_matrix<3,4,Real>&P=pmats[camera_ind];
const static_matrix<4,1,Real>&X=points[structure_ind];
Real pX=P[0]*X[0]+P[1]*X[1]+P[2]*X[2]+P[3]*X[3],
pY=P[4]*X[0]+P[5]*X[1]+P[6]*X[2]+P[7]*X[3],
pZ=P[8]*X[0]+P[9]*X[1]+P[10]*X[2]+P[11]*X[3];
static_matrix<2,1,Real>res={pX/pZ,pY/pZ};
return res;
}
void save(const char*filename)const
{
std::cout<<"Saving projective: "<<filename<<"\n";
std::ofstream file(filename);
file<<pmats.size()<<" "<<points.size()<<"\n";
for(unsigned i=0;i<pmats.size();++i)
{
const static_matrix<3,4,Real>&P=pmats[i];
file<<viewIDs[i]<<" ";
for(unsigned j=0;j<12;++j)
file<<P[j]<<" ";
file<<"\n";
}
for(unsigned i=0;i<points.size();++i)
{
const static_matrix<4,1,Real>&pt=points[i];
file<<pointIDs[i]<<" ";
for(unsigned j=0;j<4;++j)
file<<pt[j]<<" ";
file<<"\n";
}
file.close();
}
template<int Loud>
bool load(const char*filename)
{
std::ifstream file(filename);
unsigned numViews,numPoints;
file>>numViews>>numPoints;
if(Loud>0)std::cout<<"Loading: "<<numViews<<" views, "<<numPoints<<" points.\n";
pmats.resize(numViews);
viewIDs.resize(numViews);
for(unsigned i=0;i<pmats.size();++i)
{
file>>viewIDs[i];
static_matrix<3,4,Real>&P=pmats[i];
for(unsigned j=0;j<12;++j)
file>>P[j];
if(!file.good())return false;
}
pointIDs.resize(numPoints);
points.resize(numPoints);
for(unsigned i=0;i<points.size();++i)
{
static_matrix<4,1,Real>&pt=points[i];
file>>pointIDs[i];
for(unsigned j=0;j<4;++j)
file>>pt[j];
if(!file.good())return false;
}
file.close();
return true;
}
};
template<class Real>
struct metric_recon
{
typedef Real real_type;
typedef static_matrix<3,1,Real>point_type;
std::vector<unsigned>viewIDs,pointIDs;
std::vector<static_matrix<3,1,Real> >points;
std::vector<static_matrix<3,4,Real> >pmats;
std::vector<camera_intrinsics<Real>*>intrinsics;
std::vector<camera_view<Real> >camera_views;
metric_recon(const metric_recon&recon)
{
*this=recon;
}
metric_recon&operator=(const metric_recon&recon)
{
viewIDs=recon.viewIDs;
pointIDs=recon.pointIDs;
points=recon.points;
pmats=recon.pmats;
camera_views=recon.camera_views;
clear_intrinsics();
intrinsics.resize(recon.intrinsics.size());
std::map<camera_intrinsics<Real>*,camera_intrinsics<Real>*>imap;
for(unsigned i=0;i<recon.intrinsics.size();++i)
{
camera_intrinsics<Real>*old_intr=recon.intrinsics[i];
camera_intrinsics<Real>*new_intr=new camera_intrinsics<Real>(*old_intr);
intrinsics[i]=new_intr;
imap[old_intr]=new_intr;
}
for(unsigned i=0;i<camera_views.size();++i)
camera_views[i].intrinsics=imap[camera_views[i].intrinsics];
return*this;
}
camera_view<Real>*get_view(unsigned viewID)
{
int ind=lookup_index(viewIDs,viewID);
if(ind<0)return NULL;
return&camera_views[ind];
}
const camera_view<Real>*get_view(unsigned viewID)const
{
int ind=lookup_index(viewIDs,viewID);
if(ind<0)return NULL;
return&camera_views[ind];
}
static_matrix<3,4,Real>*get_pmat(unsigned viewID)
{
int ind=lookup_index(viewIDs,viewID);
if(ind<0)return NULL;
return&pmats[ind];
}
const static_matrix<3,4,Real>*get_pmat(unsigned viewID)const
{
int ind=lookup_index(viewIDs,viewID);
if(ind<0)return NULL;
return&pmats[ind];
}
static_matrix<3,1,Real>*get_point(unsigned pointID)
{
int ind=lookup_index(pointIDs,pointID);
if(ind<0)return NULL;
return&points[ind];
}
const static_matrix<3,1,Real>*get_point(unsigned pointID)const
{
int ind=lookup_index(pointIDs,pointID);
if(ind<0)return NULL;
return&points[ind];
}
void reorder_points()
{
std::vector<unsigned>permutation_list;
sort_permutation(permutation_list,pointIDs);
apply_permutation(pointIDs,permutation_list);
apply_permutation(points,permutation_list);
}
void remove_view_by_index(unsigned index)
{
pmats.erase(pmats.begin()+index);
viewIDs.erase(viewIDs.begin()+index);
camera_views.erase(camera_views.begin()+index);
}
void remove_point_by_index(unsigned index)
{
points.erase(points.begin()+index);
pointIDs.erase(pointIDs.begin()+index);
}
void reorder_views()
{
std::vector<unsigned>permutation_list;
sort_permutation(permutation_list,viewIDs);
apply_permutation(viewIDs,permutation_list);
apply_permutation(pmats,permutation_list);
apply_permutation(camera_views,permutation_list);
}
void clear_intrinsics()
{
for(unsigned i=0;i<intrinsics.size();++i)
delete intrinsics[i];
intrinsics.clear();
}
void clear()
{
clear_intrinsics();
camera_views.clear();
pmats.clear();
points.clear();
pointIDs.clear();
viewIDs.clear();
}
void default_indices()
{
viewIDs.resize(camera_views.size());
pointIDs.resize(points.size());
for(unsigned i=0;i<viewIDs.size();++i)
viewIDs[i]=i;
for(unsigned i=0;i<pointIDs.size();++i)
pointIDs[i]=i;
}
template<class Iter>
void retriangulate_points(const Iter&begin_corrs,const Iter&end_corrs)
{
iter_container<Iter>corrs(begin_corrs,end_corrs);
if(pointIDs.size()<corrs.size())
{
pointIDs.resize(corrs.size());
for(unsigned i=0;i<corrs.size();++i)
pointIDs[i]=i;
}
rebuild_projection_matrices();
points.resize(corrs.size());
static_matrix<4,1,Real>X;
if(is_canonical(camera_views[0]))
{
for(unsigned i=0;i<corrs.size();++i)
{
triangulate<true>(X,corrs[i],&pmats[0]);
points[i]=realize(X);
}
}else
{
for(unsigned i=0;i<corrs.size();++i)
{
triangulate<false>(X,corrs[i],&pmats[0]);
points[i]=realize(X);
}
}
}
template<class Iter>
void retriangulate_points(const std::vector<unsigned>&inliers,const Iter&begin_corrs,const Iter&end_corrs)
{
if(pointIDs.size()<inliers.size())
{
pointIDs.resize(inliers.size());
for(unsigned i=0;i<inliers.size();++i)
pointIDs[i]=i;
}
rebuild_projection_matrices();
points.resize(inliers.size());
static_matrix<4,1,Real>X;
if(is_canonical(camera_views[0]))
{
iter_container<Iter>corrs(begin_corrs,end_corrs);
for(unsigned i=0;i<inliers.size();++i)
{
triangulate<true>(X,corrs[inliers[i]],&pmats[0]);
points[i]=realize(X);
}
}else
{
iter_container<Iter>corrs(begin_corrs,end_corrs);
for(unsigned i=0;i<inliers.size();++i)
{
triangulate<false>(X,corrs[inliers[i]],&pmats[0]);
points[i]=realize(X);
}
}
}
void rebuild_projection_matrices()
{
pmats.resize(camera_views.size());
for(unsigned i=0;i<camera_views.size();++i)
pmats[i]=camera_views[i].get_projection_matrix();
}
void rebuild_from_projection_matrices(
unsigned Sw,unsigned Sh,Real radial_distortion=0)
{
clear_intrinsics();
camera_views.resize(pmats.size());
for(unsigned i=0;i<pmats.size();++i)
{
camera_views[i].intrinsics=new camera_intrinsics<Real>(0,Sw,Sh,radial_distortion);
if(!camera_views[i].from_projection_matrix(pmats[i]))
std::cout<<i<<" : failed to conver to metric\n";
intrinsics.push_back(camera_views[i].intrinsics);
}
}
metric_recon(){}
~metric_recon()
{
for(unsigned i=0;i<intrinsics.size();++i)
delete intrinsics[i];
}
template<class Recon>
metric_recon(const Recon&recon)
{
*this=recon;
}
template<class ProjRecon>
metric_recon(const ProjRecon&recon,const static_matrix<4,4,Real>&H,
unsigned Sw,unsigned Sh,Real radial_distortion=0)
{
STATIC_ASSERT((is_proj_recon<ProjRecon>::value),NOT_A_PROJECTIVE_RECONSTRUCTION);
metric_upgrade(recon,H,Sw,Sh,radial_distortion);
}
template<class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,void>::type
metric_upgrade(
const ProjRecon&recon,
const static_matrix<4,4,Real>&H,
unsigned Sw,unsigned Sh,Real radial_distortion=0)
{
viewIDs=recon.viewIDs;
pointIDs=recon.pointIDs;
pmats.resize(recon.pmats.size());
for(unsigned i=0;i<recon.pmats.size();++i)
pmats[i]=recon.pmats[i]*H;
static_matrix<4,4,Real>Hinv=inverse(H);
points.resize(recon.points.size());
for(unsigned i=0;i<points.size();++i)
points[i]=realize(Hinv*recon.points[i]);
rebuild_from_projection_matrices(Sw,Sh,radial_distortion);
}
projective_recon<Real>operator*(const static_matrix<4,4,Real>&H)
{
projective_recon<Real>recon;
recon.pmats.resize(pmats.size());
for(unsigned i=0;i<pmats.size();++i)
recon.pmats[i]=pmats[i]*H;
recon.points.resize(points.size());
static_matrix<4,4,Real>Hinv=inverse(H);
for(unsigned i=0;i<points.size();++i)
recon.points[i]=Hinv*homogenize(points[i]);
recon.pointIDs=pointIDs;
recon.viewIDs=viewIDs;
return recon;
}
void share_all_intrinsics()
{
static_matrix<3,3,Real>mean_K={};
Real mean_radial_distortion=0;
Real Sw=intrinsics[0]->Sw,Sh=intrinsics[0]->Sh;
for(unsigned i=0;i<intrinsics.size();++i)
{
mean_K+=intrinsics[i]->K;
mean_radial_distortion+=intrinsics[i]->radial_distortion;
}
mean_K/=intrinsics.size();
mean_radial_distortion/=intrinsics.size();
clear_intrinsics();
camera_intrinsics<Real>*shared_intrinsics=new camera_intrinsics<Real>(mean_K,Sw,Sh,mean_radial_distortion);
intrinsics.push_back(shared_intrinsics);
for(unsigned i=0;i<camera_views.size();++i)
camera_views[i].intrinsics=shared_intrinsics;
}
__forceinline static_matrix<2,1,Real>project(unsigned camera_ind,const static_matrix<3,1,Real>&X)const
{
assert(camera_ind<camera_views.size());
return camera_views[camera_ind].project(X);
}
__forceinline static_matrix<2,1,Real>project(unsigned camera_ind,unsigned structure_ind)const
{
assert(structure_ind<points.size());
assert(camera_ind<camera_views.size());
return camera_views[camera_ind].project(points[structure_ind]);
}
void save_projective(const char*filename)const
{
std::cout<<"Saving projective: "<<filename<<"\n";
std::ofstream file(filename);
file<<pmats.size()<<" "<<points.size()<<"\n";
for(unsigned i=0;i<pmats.size();++i)
{
const static_matrix<3,4,Real>&P=pmats[i];
file<<viewIDs[i]<<" ";
for(unsigned j=0;j<12;++j)
file<<P[j]<<" ";
file<<"\n";
}
for(unsigned i=0;i<points.size();++i)
{
const static_matrix<3,1,Real>&pt=points[i];
file<<pointIDs[i]<<" ";
for(unsigned j=0;j<4;++j)
file<<pt[j]<<" ";
file<<"\n";
}
file.close();
}
void save(const char*filename)const
{
std::cout<<"Saving metric: "<<filename<<"\n";
std::ofstream file(filename);
file<<intrinsics.size()<<" "<<pmats.size()<<" "<<points.size()<<"\n";
for(unsigned i=0;i<intrinsics.size();++i)
{
const camera_intrinsics<Real>&intr=*intrinsics[i];
file<<intr.K(0,0)<<" "<<intr.K(0,1)<<" "<<intr.K(0,2)<<" "
<<intr.K(1,1)<<" "<<intr.K(1,2)<<" "
<<intr.Sw<<" "<<intr.Sh<<" "<<intr.radial_distortion<<"\n";
}
for(unsigned i=0;i<camera_views.size();++i)
{
const camera_view<Real>&view=camera_views[i];
unsigned intrID=std::min<unsigned>(intrinsics.size()-1u,i);
while(intrinsics[intrID]!=view.intrinsics)--intrID;
file<<viewIDs[i]<<" "<<intrID<<" ";
file<<view.pose.qrot.x<<" "
<<view.pose.qrot.y<<" "
<<view.pose.qrot.z<<" "
<<view.pose.qrot.w<<" "
<<view.pose.translation[0]<<" "
<<view.pose.translation[1]<<" "
<<view.pose.translation[2]<<"\n";
}
for(unsigned i=0;i<points.size();++i)
{
const static_matrix<3,1,Real>&pt=points[i];
file<<pointIDs[i]<<" ";
for(unsigned j=0;j<3;++j)
file<<pt[j]<<" ";
file<<"\n";
}
file.close();
}
template<int Loud>
bool load(const char*filename)
{
std::ifstream file(filename);
unsigned numIntrinsics,numViews,numPoints;
file>>numIntrinsics>>numViews>>numPoints;
if(Loud>0)std::cout<<numViews<<" views, "<<numPoints<<" points.\n";
static_matrix<3,3,Real>K={};
K(2,2)=1;
unsigned Sw,Sh;
Real radial_distortion;
clear_intrinsics();
intrinsics.resize(numIntrinsics);
for(unsigned i=0;i<intrinsics.size();++i)
{
file>>K(0,0)>>K(0,1)>>K(0,2)
>>K(1,1)>>K(1,2)>>Sw>>Sh>>radial_distortion;
intrinsics[i].reset(new camera_intrinsics<Real>(K,Sw,Sh,radial_distortion));
if(!file.good())return false;
}
viewIDs.resize(numViews);
camera_views.resize(numViews);
for(unsigned i=0;i<camera_views.size();++i)
{
camera_view<Real>&view=camera_views[i];
unsigned intrID;
file>>viewIDs[i]>>intrID;
view.intrinsics=intrinsics[intrID];
file>>view.pose.qrot[0]
>>view.pose.qrot[1]
>>view.pose.qrot[2]
>>view.pose.qrot[3]
>>view.pose.translation[0]
>>view.pose.translation[1]
>>view.pose.translation[2];
if(!file.good())return false;
}
rebuild_projection_matrices();
points.resize(numPoints);
pointIDs.resize(numPoints);
for(unsigned i=0;i<points.size();++i)
{
static_matrix<3,1,Real>&pt=points[i];
file>>pointIDs[i];
for(unsigned j=0;j<3;++j)
file>>pt[j];
if(!file.good())return false;
}
file.close();
return true;
}
};
}
#pragma once
#pragma once
namespace heinlib
{
template<class Real,class MetricRecon>
typename enable_if<is_metric_recon<MetricRecon>,void>::type
align_reconstruction_struct(MetricRecon&recon,const similarity_transform<Real>&H)
{
similarity_transform<Real>Hinv=H.inverse();
for(unsigned i=0;i<recon.camera_views.size();++i)
recon.camera_views[i].pose=recon.camera_views[i].pose*Hinv;
recon.rebuild_projection_matrices();
for(unsigned i=0;i<recon.points.size();++i)
{
recon.points[i]=H*recon.points[i];
}
}
template<class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,void>::type
align_reconstruction_struct(ProjRecon&recon,const static_matrix<4,4,Real>&H)
{
static_matrix<4,4,Real>Hinv;
matrix_inverse(H,Hinv);
for(unsigned i=0;i<recon.pmats.size();++i)
{
static_matrix<3,4,Real>&P=recon.pmats[i];
P=P*Hinv;
}
for(unsigned i=0;i<recon.points.size();++i)
{
static_matrix<4,1,Real>&X=recon.points[i];
X=homogeneous_divide(H*X);
}
}
template<class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,void>::type
align_reconstruction(ProjRecon&recon,const static_matrix<4,4,Real>&H,bool fix_structure=true)
{
for(unsigned i=0;i<recon.pmats.size();++i)
{
static_matrix<3,4,Real>&cam=recon.pmats[i];
cam=cam*H;
}
if(fix_structure)
{
static_matrix<4,4,Real>Hinv=inverse(H);
for(unsigned i=0;i<recon.points.size();++i)
{
static_matrix<4,1,Real>&X=recon.points[i];
X=homogeneous_divide(Hinv*X);
}
}
}
template<class Real,class MetricRecon>
typename enable_if<is_metric_recon<MetricRecon>,void>::type
align_reconstruction(MetricRecon&recon,const similarity_transform<Real>&H)
{
for(unsigned i=0;i<recon.camera_views.size();++i)
recon.camera_views[i].pose=recon.camera_views[i].pose*H;
recon.rebuild_projection_matrices();
if(recon.points.size()>0)
{
similarity_transform<Real>Hinv=H.inverse();
for(unsigned i=0;i<recon.points.size();++i)
recon.points[i]=Hinv*recon.points[i];
}
}
template<class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,void>::type
align_with_camera(ProjRecon&recon,const static_matrix<3,4,Real>&P,unsigned view=0)
{
static_matrix<4,4,Real>H;
under_determined_homography(H,recon.pmats[view],P);
align_reconstruction(recon,H);
recon.pmats[view]=P;
}
template<class Real,class MetricRecon>
typename enable_if<is_metric_recon<MetricRecon>,void>::type
align_with_camera(MetricRecon&recon,const rigid_motion<Real>&pose,unsigned view=0)
{
similarity_transform<Real>H;
camera_align_xform(H,recon.camera_views[view].pose,pose);
align_reconstruction(recon,H);
}
template<class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,void>::type
make_view_canonical(ProjRecon&recon,unsigned view=0)
{
typedef typename ProjRecon::real_type Real;
align_with_camera(recon,constants<static_matrix<3,4,Real> >::canonical_camera(),view);
}
template<class MetricRecon>
typename enable_if<is_metric_recon<MetricRecon>,void>::type
make_view_canonical(MetricRecon&recon,unsigned view=0)
{
typedef typename MetricRecon::real_type Real;
similarity_transform<Real>H;
camera_align_xform_canonical(H,recon.camera_views[view].pose);
align_reconstruction(recon,H);
recon.camera_views[view].make_canonical();
}
template<class Real>
bool under_determined_homography(
static_matrix<4,4,Real>&H,
const static_matrix<3,4,Real>&P1,
const static_matrix<3,4,Real>&P2)
{
static_matrix<4,3,Real>P1inv;
if(!pseudo_inverse_camera(P1inv,P1))
return false;
static_matrix<4,1,Real>C;
if(!get_camera_center(P1,C))
return false;
C/=C[3];
H=P1inv*P2+C*transpose(make_vector4<Real>(0,0,0,1));
return true;
}
template<class Real>
bool make_canonical_homography(
static_matrix<4,4,Real>&H,
const static_matrix<3,4,Real>&P1)
{
static_matrix<4,3,Real>P1inv;
pseudo_inverse_camera(P1inv,P1);
static_matrix<4,1,Real>C;
get_camera_center(P1,C);
C/=C[3];
static_matrix<3,4,Real>P2=constants<static_matrix<3,4,Real> >::canonical_camera();
static_matrix<4,4,Real>A=P1inv*P2;
Real a00=A(0,0),a01=A(0,1),a02=A(0,2),
a10=A(1,0),a11=A(1,1),a12=A(1,2),
a20=A(2,0),a21=A(2,1),a22=A(2,2),
b0=C[0],b1=C[1],b2=C[2];
Real numer=-(a00*a11*a22-a00*a12*a21+a10*a21*a02-a10*a01*a22+a20*a01*a12-a20*a11*a02-1);
Real denom=(b0*a11*a22-b0*a12*a21+b1*a21*a02-b1*a01*a22+b2*a01*a12-b2*a11*a02);
Real v0=(denom==0)?0:numer/denom;
std::cout<<"P1 = \n"<<P1<<"\n";
std::cout<<"P1inv = \n"<<P1inv<<"\n";
std::cout<<"A = \n"<<A<<"\n";
std::cout<<"C = "<<C<<"\n";
std::cout<<"v0 = "<<v0<<"\n";
H=A+C*transpose(make_vector4<Real>(v0,0,0,1));
std::cout<<"det H_3x3 = "<<determinant(H.template submatrix<0,0,2,2>())<<"\n";
return true;
}
}
namespace heinlib
{
template<int Loud,class Real>
bool dual_stratified_pair(
static_matrix<4,4,Real>&Hm,
const static_matrix<3,3,Real>&K1,
const static_matrix<3,4,Real>&P1,
const static_matrix<3,3,Real>&K2,
const static_matrix<3,4,Real>&P2)
{
static_matrix<4,4,Real>H;
if(!under_determined_homography(H,P1,constants<static_matrix<3,4,Real> >::canonical_camera()))
{
std::cout<<"Could not find under det homog!\n";
return false;
}
if(Loud>0)
{
std::cout<<"H = \n"<<H<<"\n";
std::cout<<"detH = "<<determinant(H)<<"\n";
}
static_matrix<3,4,Real>P2p=P2*H;
if(Loud>0)
{
std::cout<<"P1 = \n"<<P1<<"\n";
std::cout<<"P2 = \n"<<P2<<"\n";
std::cout<<"K1 = \n"<<K1<<"\n";
std::cout<<"K2 = \n"<<K2<<"\n";
}
static_matrix<3,3,Real>K2inv=inverse(K2);
static_matrix<3,1,Real>q2=P2p.get_column(3);
static_matrix<3,1,Real>t2_alpha=K2inv*q2;
if(Loud>0)std::cout<<"t2_alpha = "<<t2_alpha<<"\n";
static_matrix<3,1,Real>axis;
Real angle;
rotation_between_vectors(axis,angle,t2_alpha,constants<static_matrix<3,1,Real> >::e1());
static_matrix<3,3,Real>R;
matrix_from_axis_angle(R,axis,angle);
if(Loud>0)
{
std::cout<<"Rotated = \n"<<normalize(R*t2_alpha)<<"\n";
}
static_matrix<3,3,Real>Q2=P2p.template submatrix<0,0,2,2>();
static_matrix<3,3,Real>W=R*K2inv*Q2*K1;
static_matrix<3,1,Real>w1={W(0,0),W(0,1),W(0,2)},
w2={W(1,0),W(1,1),W(1,2)},
w3={W(2,0),W(2,1),W(2,2)};
if(length(w3)==0||length(t2_alpha)==0)
return false;
if(Loud>0)
{
std::cout<<"w3 = "<<w3<<", length = "<<length(w3)<<"\n";
std::cout<<"length t2_alpha = "<<length(t2_alpha)<<"\n";
std::cout<<"cross w2 w3 = "<<cross(w2,w3)<<"\n";
}
static_matrix<3,1,Real>v=(cross(w2,w3)/length(w3)-w1)/length(t2_alpha);
if(Loud>0)std::cout<<"v = "<<v<<"\n";
static_matrix<4,4,Real>Hmp={};
Hmp.block_insert(0,0,K1);
Hmp.block_insert(3,0,transpose(v));
Hmp(3,3)=1;
Hm=normalize(H*Hmp);
return true;
}
}
#pragma once
#pragma once
namespace heinlib
{
namespace autocalibrate_detail
{
template<int Loud,class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,void>::type
autocalibrate_linear(static_matrix<10,1,Real>&q,
const ProjRecon&recon,
Real ws=1,Real wr=1,Real wu=0.2,Real wv=0.2)
{
if(Loud>0)std::cout<<"Autocalibrate ADQ Linear... \n";
unsigned Views=recon.pmats.size();
dynamic_matrix<Real>A(4*Views,10);
unsigned row=0;
for(unsigned j=0;j<Views;++j)
{
const static_matrix<3,4,Real>&P=recon.pmats[j];
A(row,0)=P[0]*P[4]*ws;
A(row,1)=(P[1]*P[4]+P[0]*P[5])*ws;
A(row,2)=(P[2]*P[4]+P[0]*P[6])*ws;
A(row,3)=(P[3]*P[4]+P[0]*P[7])*ws;
A(row,4)=P[1]*P[5]*ws;
A(row,5)=(P[2]*P[5]+P[1]*P[6])*ws;
A(row,6)=(P[3]*P[5]+P[1]*P[7])*ws;
A(row,7)=P[2]*P[6]*ws;
A(row,8)=(P[3]*P[6]+P[2]*P[7])*ws;
A(row,9)=P[3]*P[7]*ws;
++row;
A(row,0)=P[0]*P[8]*wu;
A(row,1)=(P[1]*P[8]+P[0]*P[9])*wu;
A(row,2)=(P[2]*P[8]+P[0]*P[10])*wu;
A(row,3)=(P[3]*P[8]+P[0]*P[11])*wu;
A(row,4)=P[1]*P[9]*wu;
A(row,5)=(P[2]*P[9]+P[1]*P[10])*wu;
A(row,6)=(P[3]*P[9]+P[1]*P[11])*wu;
A(row,7)=P[2]*P[10]*wu;
A(row,8)=(P[3]*P[10]+P[2]*P[11])*wu;
A(row,9)=P[3]*P[11]*wu;
++row;
A(row,0)=P[4]*P[8]*wv;
A(row,1)=(P[5]*P[8]+P[4]*P[9])*wv;
A(row,2)=(P[6]*P[8]+P[4]*P[10])*wv;
A(row,3)=(P[7]*P[8]+P[4]*P[11])*wv;
A(row,4)=P[5]*P[9]*wv;
A(row,5)=(P[6]*P[9]+P[5]*P[10])*wv;
A(row,6)=(P[7]*P[9]+P[5]*P[11])*wv;
A(row,7)=P[6]*P[10]*wv;
A(row,8)=(P[7]*P[10]+P[6]*P[11])*wv;
A(row,9)=P[7]*P[11]*wv;
++row;
A(row,0)=(sq(P[0])-sq(P[4]))*wr;
A(row,1)=2*(P[1]*P[0]-P[5]*P[4])*wr;
A(row,2)=2*(P[2]*P[0]-P[6]*P[4])*wr;
A(row,3)=2*(P[3]*P[0]-P[7]*P[4])*wr;
A(row,4)=(sq(P[1])-sq(P[5]))*wr;
A(row,5)=2*(P[2]*P[1]-P[6]*P[5])*wr;
A(row,6)=2*(P[3]*P[1]-P[7]*P[5])*wr;
A(row,7)=(sq(P[2])-sq(P[6]))*wr;
A(row,8)=2*(P[3]*P[2]-P[6]*P[7])*wr;
A(row,9)=(sq(P[3])-sq(P[7]))*wr;
++row;
}
null_space_SVD(A,q);
if(q[0]<0)q*=-1;
}
}
}
#pragma once
#pragma once
#include<limits>
#include<fstream>
#include<ctime>
namespace heinlib
{
template<typename Datum,unsigned M,typename Real>
Real gauss_newton_nonlinear_least_squares(const std::vector<Datum>&data,
static_matrix<M,1,Real>&X,
Real(*jacobian_step)(const std::vector<Datum>&data,
static_matrix<M,1,Real>&X,
static_matrix<M,M,Real>&JtJ,
static_matrix<M,1,Real>&JtE),
Real eps_stop,unsigned max_iters=1000,unsigned min_iters=1
)
{
Real err;
static_matrix<M,1,Real>JtE,Z,Delta;
static_matrix<M,M,Real>JtJ,L;
unsigned iter=0;
while(iter<max_iters)
{
err=jacobian_step(data,X,JtJ,JtE);
cholesky_decomposition(JtJ,L);
forward_substitution(L,-JtE,Z);
back_substitution(transpose(L),Z,Delta);
X+=Delta;
++iter;
if(err<=eps_stop&&iter>=min_iters)
return err;
}
}
template<typename Datum,unsigned M,typename Real>
Real levenberg_marquardt_nonlinear_least_squares(const std::vector<Datum>&data,
static_matrix<M,1,Real>&X,
Real(*jacobian_step)(const std::vector<Datum>&data,
static_matrix<M,1,Real>&X,
static_matrix<M,M,Real>&JtJ,
static_matrix<M,1,Real>&JtE),
Real(*error)(const std::vector<Datum>&data,
static_matrix<M,1,Real>&X),
Real eps_stop,unsigned max_iters=1000,unsigned min_iters=1
)
{
Real lambda=Real(0.001);
Real prevErr=error(data,X);
static_matrix<M,1,Real>JtE,Z,Delta,Xnew;
static_matrix<M,M,Real>JtJ,L;
unsigned iter=0;
while(iter<max_iters)
{
jacobian_step(data,X,JtJ,JtE);
for(unsigned i=0;i<M;++i)
JtJ(i,i)*=1+lambda;
cholesky_decomposition(JtJ,L);
forward_substitution(L,-JtE,Z);
back_substitution(transpose(L),Z,Delta);
Xnew=X+Delta;
Real err=error(data,Xnew);
if(err<prevErr){
lambda*=Real(0.1);
X=Xnew;
if(iter>=min_iters&&err<=eps_stop)
return err;
prevErr=err;
}else{
if(lambda==0)
lambda=std::numeric_limits<Real>::min();
else{
lambda*=Real(10);
if(lambda==std::numeric_limits<Real>::infinity())
return prevErr;
}
}
++iter;
}
return prevErr;
}
template<int Loud,class Functor,class Mx1,class Nx1>
typename Mx1::real_type levenberg_marquardt_generic(
const Mx1&Goal,Nx1&Params,Functor&function,
unsigned max_bad_steps=20,
typename Mx1::real_type eps_stop=0,
unsigned max_iters=1000,unsigned min_iters=1,
typename Mx1::real_type eps_deriv=0.0001)
{
unsigned M=Goal.rows,N=Params.rows;
assert(Goal.cols==1);
assert(Params.cols==1);
typedef typename Mx1::real_type Real;
Real lambda=Real(0.001);
typedef typename MxN_result<Mx1,Nx1>::result_type MxN;
typedef typename square_result<Nx1>::result_type NxN;
MxN J;
resize_if_dynamic(J,M,N);
Mx1 X,X2,E;
resize_if_dynamic(X,M,1);
resize_if_dynamic(X2,M,1);
resize_if_dynamic(E,M,1);
Nx1 Params2,Z,Delta,JtE;
resize_if_dynamic(Params2,N,1);
resize_if_dynamic(Z,N,1);
resize_if_dynamic(Delta,N,1);
resize_if_dynamic(JtE,N,1);
NxN JtJ,L;
resize_if_dynamic(JtJ,N,N);
resize_if_dynamic(L,N,N);
if(!function(Params,X2))
{
if(Loud>0)std::cout<<"LM: Aborting from bad initialization.\n";
return std::numeric_limits<Real>::infinity();
}
X2-=Goal;
Real prevErr=length_sq(X2);
if(Loud>0)std::cout<<"Starting error = "<<prevErr<<"\n";
clock_t start=clock();
unsigned bad_steps=0;
Real err;
for(unsigned iter=0;iter<max_iters;++iter)
{
if(Loud>1)std::cout<<"Computing "<<M<<" x "<<N<<" Jacobian..\n";
if(!function(Params,X))goto badstep;
Params2=Params;
for(unsigned n=0;n<N;++n){
Params2[n]+=eps_deriv;
if(!function(Params2,X2))goto badstep;
Params2[n]=Params[n];
for(unsigned m=0;m<M;++m){
J(m,n)=(X2[m]-X[m])/eps_deriv;
}
}
for(unsigned i=0;i<M;++i)
E[i]=X[i]-Goal[i];
if(Loud>1)std::cout<<"Computing JtJ ("<<N<<" x "<<N<<")...\n";
JtJ=transpose_premultiply(J);
if(Loud>1)std::cout<<"Computing JtE ("<<N<<" x 1)...\n";
JtE=transpose(J)*E;
for(unsigned i=0;i<N;++i)
JtJ(i,i)*=1+lambda;
if(Loud>1)std::cout<<"Solving normal equations...\n";
if(!least_squares_SVD(JtJ,Delta,-JtE))
{
if(Loud>0)printf("SVD fail!\n");
goto badstep;
}
if(Loud>1)std::cout<<"Testing...\n";
Params2=Params+Delta;
if(!function(Params2,X2))goto badstep;
X2-=Goal;
err=length_sq(X2);
if(Loud>1)
{
std::cout<<"iter = "<<iter<<", err = "<<err<<", badstep = "<<bad_steps<<"\n";
}else if(Loud>0&&err<prevErr)
{
std::cout<<"\r iter = "<<iter<<", err = "<<err<<", badstep = "<<bad_steps<<"    ";
}
if(err<prevErr)
{
lambda*=Real(0.3);
bad_steps=0;
Params=Params2;
Real err_change=prevErr-err;
prevErr=err;
if(err_change<eps_stop)
break;
}else
{
badstep:if(++bad_steps>max_bad_steps)
break;
if(lambda==Real(0))
lambda=std::numeric_limits<Real>::min();
else
{
lambda*=Real(10);
if(lambda==std::numeric_limits<Real>::infinity())
break;
}
}
}
if(Loud>0)std::cout<<"\n";
return prevErr;
}
template<int Loud,class Real,class Functor,class Nx1,class MxM>
typename Nx1::real_type levenberg_marquardt_generic_mah(
Nx1&Params,
Functor&function,
const MxM&inv_covar,
unsigned max_bad_steps=20,
Real eps_stop=0,
unsigned max_iters=1000,unsigned min_iters=1,
Real eps_deriv=0.0001)
{
unsigned M=inv_covar.rows,N=Params.rows;
assert(Params.cols==1);
Real lambda=Real(0.001);
typedef typename MxN_result<MxM,Nx1>::result_type MxN;
typedef typename square_result<Nx1>::result_type NxN;
typedef typename column_vector<MxM>::result_type Mx1;
MxN J;
resize_if_dynamic(J,M,N);
Mx1 E,E2;
resize_if_dynamic(E,M,1);
resize_if_dynamic(E2,M,1);
Nx1 Params2,Z,Delta,JtE;
resize_if_dynamic(Params2,N,1);
resize_if_dynamic(Z,N,1);
resize_if_dynamic(Delta,N,1);
resize_if_dynamic(JtE,N,1);
NxN JtJ,L;
resize_if_dynamic(JtJ,N,N);
resize_if_dynamic(L,N,N);
if(!function(Params,E))
{
if(Loud>0)std::cout<<"LM: Aborting from bad initialization.\n";
return std::numeric_limits<Real>::infinity();
}
Real prevErr=(transpose(E)*inv_covar*E)[0];
if(Loud>0)std::cout<<"Starting error = "<<prevErr<<"\n";
clock_t start=clock();
unsigned bad_steps=0;
Real err;
for(unsigned iter=0;iter<max_iters;++iter)
{
if(!function(Params,E))goto badstep;
Params2=Params;
for(unsigned n=0;n<N;++n){
Params2[n]+=eps_deriv;
if(!function(Params2,E2))goto badstep;
Params2[n]=Params[n];
for(unsigned m=0;m<M;++m){
J(m,n)=(E2[m]-E[m])/eps_deriv;
}
}
JtJ=transpose(J)*inv_covar*J;
JtE=transpose(J)*inv_covar*E;
for(unsigned i=0;i<N;++i)
JtJ(i,i)*=1+lambda;
if(!least_squares_SVD(JtJ,Delta,-JtE))
{
if(Loud>0)printf("SVD fail!\n");
goto badstep;
}
Params2=Params+Delta;
if(!function(Params2,E2))goto badstep;
err=(transpose(E2)*inv_covar*E2)[0];
if(err<prevErr)
{
if(Loud>0)
{
std::cout<<"\r"<<iter<<", "<<err<<"               ";
std::cout<<"\n";
}
lambda*=Real(0.3);
bad_steps=0;
Params=Params2;
Real err_change=prevErr-err;
prevErr=err;
if(err_change<eps_stop)
break;
}else
{
badstep:if(++bad_steps>max_bad_steps)
break;
if(lambda==Real(0))
lambda=std::numeric_limits<Real>::min();
else
{
lambda*=Real(10);
if(lambda==std::numeric_limits<Real>::infinity())
break;
}
}
}
if(Loud>0)std::cout<<"\n";
return prevErr;
}
}
namespace heinlib
{
namespace autocalibrate_detail
{
template<class Real,class ProjRecon>
struct ADQ_nonlinear_functor_const
{
const ProjRecon&recon;
Real ws,wf,wu,wv;
ADQ_nonlinear_functor_const(const ProjRecon&recon,Real wf=0,Real ws=1,Real wu=0.2,Real wv=0.2)
:recon(recon),ws(ws),wf(wf),wu(wu),wv(wv)
{
}
bool operator()(const dynamic_matrix<Real>&Params,dynamic_matrix<Real>&Output)
{
static_matrix<4,4,Real>H={Params[0],Params[1],Params[2],0,
Params[3],Params[4],Params[5],0,
Params[6],Params[7],Params[8],0,
Params[9],Params[10],Params[11],1};
static const static_matrix<4,4,Real>Ih={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0};
static_matrix<4,4,Real>Q=H*Ih*transpose(H);
Real ff=sq(Params[12]);
static_matrix<3,3,Real>KKt={ff,0,0,
0,ff,0,
0,0,1};
KKt=normalize(KKt);
unsigned k=0;
for(unsigned j=0;j<recon.pmats.size();++j)
{
const static_matrix<3,4,Real>&P=recon.pmats[j];
static_matrix<3,3,Real>w=P*Q*transpose(P);
if(w[8]<0)w*=-1;
static_matrix<3,3,Real>Diff=KKt-normalize(w);
Output[k++]=Diff[0]*wf;
Output[k++]=Diff[1]*ws;
Output[k++]=Diff[2]*wu;
Output[k++]=Diff[4]*wf;
Output[k++]=Diff[5]*wv;
Output[k++]=Diff[8];
}
return true;
}
};
template<int Loud,class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,Real>::type
autocalibrate_nonlinear_const(
static_matrix<13,1,Real>&Params,const ProjRecon&recon,
Real wf=1,Real ws=1,Real wu=1,Real wv=1)
{
if(Loud>0)std::cout<<"Autocalibrate ADQ nonlinear..\n";
ADQ_nonlinear_functor_const<Real,ProjRecon>functor(recon,wf,ws,wu,wv);
dynamic_matrix<Real>Goal(6*recon.pmats.size());
fill(Goal,0);
Real err=levenberg_marquardt_generic<Loud>(Goal,Params,functor);
return err;
}
}
}
namespace heinlib
{
template<int Loud,class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,bool>::type
nonlinear_autocalibrate(
static_matrix<4,4,Real>&H,
const ProjRecon&recon,
Real sigma_s=0.1,Real sigma_r=0.1,Real sigma_u=5,Real sigma_v=5);
template<int Loud,class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,bool>::type
linear_autocalibrate(
static_matrix<4,4,Real>&H,
const ProjRecon&recon,
const static_matrix<2,1,Real>&pp,
bool nonlinear=true,
Real sigma_s=0.1,Real sigma_r=0.1,Real sigma_u=5,Real sigma_v=5)
{
static_matrix<3,3,Real>ppshift={1,0,-pp.x(),
0,1,-pp.y(),
0,0,1};
projective_recon<Real>ppshift_recon(recon);
for(unsigned i=0;i<recon.pmats.size();++i)
ppshift_recon.pmats[i]=ppshift*ppshift_recon.pmats[i];
return linear_autocalibrate<Loud>(H,ppshift_recon,nonlinear,sigma_s,sigma_r,sigma_u,sigma_v);
}
template<int Loud,class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,bool>::type
linear_autocalibrate(
static_matrix<4,4,Real>&H,
const ProjRecon&recon,
bool nonlinear=true,
Real sigma_s=0.1,Real sigma_r=0.1,Real sigma_u=5,Real sigma_v=5)
{
using namespace autocalibrate_detail;
if(Loud>0)std::cout<<"Linear autocalibrating\n";
static_matrix<10,1,Real>q;
autocalibrate_linear<Loud-1>(q,recon);
static_matrix<4,4,Real>Q={q[0],q[1],q[2],q[3],
q[1],q[4],q[5],q[6],
q[2],q[5],q[7],q[8],
q[3],q[6],q[8],q[9]};
if(Loud>0)std::cout<<"Q = \n"<<Q<<"\n";
static_matrix<4,4,Real>A,B;
schur_decomposition(Q,A,B);
static_matrix<4,4,Real>D={sqrt(abs(B[0])),0,0,0,
0,sqrt(abs(B[5])),0,0,
0,0,sqrt(abs(B[10])),0,
0,0,0,0};
H=A*D;
H/=H(2,2);
H(3,3)=1;
if(Loud>0)std::cout<<"H = \n"<<H<<"\n";
if(nonlinear)
return nonlinear_autocalibrate<Loud>(H,recon,sigma_s,sigma_r,sigma_u,sigma_v);
else return true;
}
template<int Loud,class Real,class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,bool>::type
nonlinear_autocalibrate(
static_matrix<4,4,Real>&H,
const ProjRecon&recon,
Real sigma_s,Real sigma_r,Real sigma_u,Real sigma_v)
{
using namespace autocalibrate_detail;
if(Loud>0)std::cout<<"NonLinear autocalibrating\n";
static_matrix<4,4,Real>Ih={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0};
static_matrix<4,4,Real>Q=H*Ih*transpose(H);
Real est_focal_length=0;
unsigned Views=recon.pmats.size();
for(unsigned i=0;i<Views;++i)
{
const static_matrix<3,4,Real>&P=recon.pmats[i];
static_matrix<3,3,Real>w=P*Q*transpose(P);
w/=w[8];
est_focal_length+=sqrt(abs(w[0]));
est_focal_length+=sqrt(abs(w[4]));
}
est_focal_length/=(2*Views);
if(Loud>0)std::cout<<"f est = "<<est_focal_length<<"\n";
static_matrix<13,1,Real>Params={H[0],H[1],H[2],
H[4],H[5],H[6],
H[8],H[9],H[10],
H[12],H[13],H[14],est_focal_length};
autocalibrate_nonlinear_const<Loud-1>(Params,recon);
if(Loud>0)std::cout<<"Noninear f1 = "<<Params[12]<<"\n";
H[0]=Params[0];
H[1]=Params[1];
H[2]=Params[2];
H[3]=0;
H[4]=Params[3];
H[5]=Params[4];
H[6]=Params[5];
H[7]=0;
H[8]=Params[6];
H[9]=Params[7];
H[10]=Params[8];
H[11]=0;
H[12]=Params[9];
H[13]=Params[10];
H[14]=Params[11];
H[15]=1;
return true;
}
}
#pragma once
#pragma once
#pragma once
#include<cstring>
#include<list>
#include<map>
#include<vector>
#include<fstream>
#include<iterator>
#pragma once
#ifdef WIN32
#include"windows.h"
#include"Shlobj.h"
#undef min
#undef max
#endif
#include<string>
#include<fstream>
#include<cassert>
#include<stdexcept>
namespace heinlib
{
void lowercase(std::string&str)
{
for(unsigned i=0;i<str.size();++i)
str[i]=(char)tolower(str[i]);
}
std::string to_lowercase(const std::string&_str)
{
std::string str=_str;
for(unsigned i=0;i<str.size();++i)
{
if(isalpha(str[i]))
str[i]=(char)tolower(str[i]);
}
return str;
}
bool parse_full_path(const std::string&filename,std::string&dir,std::string&prefix,std::string&suffix)
{
for(int i=(int)filename.size()-1;i>=0;--i){
if(filename[i]=='.'){
suffix=filename.substr(i+1);
for(int j=i-1;j>=0;--j)
{
if(filename[j]=='\\'||filename[j]=='/')
{
dir=filename.substr(0,j+1);
prefix=filename.substr(j+1,i-j-1);
lowercase(suffix);
return true;
}
}
return false;
}
}
return false;
}
bool parse_path(const std::string&filename,std::string&prefix,std::string&suffix)
{
for(int i=(int)filename.size()-1;i>=0;--i){
if(filename[i]=='.'){
prefix=filename.substr(0,i);
suffix=filename.substr(i+1);
lowercase(suffix);
return true;
}
}
return false;
}
std::pair<std::string,std::string>split_filename(const std::string&filename)
{
std::pair<std::string,std::string>pr;
parse_path(filename,pr.first,pr.second);
return pr;
}
std::string make_full_path(const std::string&dir,const std::string&prefix,const std::string&suffix)
{
return dir+prefix+"."+suffix;
}
std::string make_filename(const std::string&prefix,const std::string&suffix)
{
return prefix+"."+suffix;
}
#pragma warning(push)
#pragma warning(disable:4996)
bool incrementable(const std::string&str)
{
return(isdigit(str[str.size()-1])>0);
}
bool decrementable(const std::string&str)
{
char c=str[str.size()-1];
return(isdigit(c)>0&&c>0);
}
void increment_count(std::string&str)
{
assert(isdigit(str[str.size()-1]));
for(int i=(int)str.size()-1;i>0;--i)
{
if(!isdigit(str[i-1]))
{
int count=atoi(&str[i])+1;
int len=(int)str.size()-i;
if(digits(count)>len)
str.resize(str.length()+1);
sprintf(&str[i],"%0*u",len,count);
return;
}
}
}
void decrement_count(std::string&str)
{
assert(isdigit(str[str.size()-1]));
for(int i=(int)str.size()-1;i>0;--i)
{
if(!isdigit(str[i-1]))
{
int count=atoi(&str[i])-1;
int len=(int)str.size()-i;
if(digits(count)>len)
str.resize(str.length()+1);
sprintf(&str[i],"%0*u",len,count);
return;
}
}
}
#pragma warning(pop)
void increment_filename(std::string&filename)
{
std::string prefix,suffix;
if(parse_path(filename,prefix,suffix))
{
if(incrementable(prefix))
{
increment_count(prefix);
filename=prefix+"."+suffix;
}
}
}
void decrement_filename(std::string&filename)
{
std::string prefix,suffix;
if(parse_path(filename,prefix,suffix))
{
if(decrementable(prefix))
{
decrement_count(prefix);
filename=prefix+"."+suffix;
}
}
}
bool file_exists(const char*filename)
{
std::ifstream file(filename);
if(file.good()){
file.close();
return true;
}return false;
}
bool file_exists(const std::string&filename)
{
return file_exists(filename.c_str());
}
#ifdef WIN32
bool folder_exists(const char*fname)
{
DWORD attribs=::GetFileAttributesA(fname);
if(attribs==INVALID_FILE_ATTRIBUTES){
return false;
}
return(attribs&FILE_ATTRIBUTE_DIRECTORY)>0;
}
bool folder_exists(const std::string&fname)
{
return folder_exists(fname.c_str());
}
bool create_folder(const char*fname)
{
return CreateDirectoryA(fname,NULL)>0;
}
bool create_folder(const std::string&fname)
{
return create_folder(fname.c_str());
}
#endif
size_t filesize(std::fstream&file)
{
file.seekg(0,std::ios::end);
size_t length=(size_t)file.tellg();
file.seekg(0,std::ios::beg);
return length;
}
size_t filesize(std::ifstream&file)
{
file.seekg(0,std::ios::end);
size_t length=(size_t)file.tellg();
file.seekg(0,std::ios::beg);
return length;
}
char*buffer_file(const char*filename,size_t*buffer_len=NULL)
{
std::fstream file(filename,std::ios::in|::std::ios::binary);
if(!file)return NULL;
file.seekg(0,std::ios::end);
size_t length=(size_t)file.tellg();
if(buffer_len)*buffer_len=length;
file.seekg(0,std::ios::beg);
char*filebuf=new char[length+1];
file.read(filebuf,length);
filebuf[length]='\0';
file.close();
return filebuf;
}
bool buffer_file(std::string&buffer,const char*filename)
{
std::fstream file(filename,std::ios::in|::std::ios::binary);
if(!file)return false;
file.seekg(0,std::ios::end);
size_t length=(size_t)file.tellg();
buffer.resize(length);
file.seekg(0,std::ios::beg);
file.read(&(buffer[0]),length);
file.close();
return true;
}
#ifdef WIN32
bool open_file_dialog(std::string&filename,
const char*title="Open",
const char*strfilter="All Files (*.*)\0*.*\0")
{
char buffer[300];
OPENFILENAME ofn={0};
ofn.lStructSize=sizeof(ofn);
ofn.hwndOwner=NULL;
ofn.lpstrFile=buffer;
ofn.lpstrFile[0]='\0';
ofn.nMaxFile=sizeof(buffer);
ofn.lpstrFilter=strfilter;
ofn.nFilterIndex=1;
ofn.lpstrFileTitle=NULL;
ofn.lpstrInitialDir=NULL;
ofn.lpstrTitle=title;
ofn.Flags=OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_NOCHANGEDIR;
BOOL res=GetOpenFileName(&ofn);
filename=buffer;
return(res==TRUE);
}
bool open_folder_dialog(std::string&foldername,const char*title="Browse Folder")
{
TCHAR szDir[MAX_PATH];
BROWSEINFO bInfo;
bInfo.hwndOwner=NULL;
bInfo.pidlRoot=NULL;
bInfo.pszDisplayName=szDir;
bInfo.lpszTitle=title;
bInfo.ulFlags=0;
bInfo.lpfn=NULL;
bInfo.lParam=0;
bInfo.iImage=-1;
LPITEMIDLIST lpItem=SHBrowseForFolder(&bInfo);
if(lpItem==NULL||SHGetPathFromIDList(lpItem,szDir)==FALSE)
return false;
foldername=szDir;
return true;
}
std::string GetLastErrorMessage()
{
LPVOID lpMsgBuf;
DWORD dw=GetLastError();
FormatMessage(
FORMAT_MESSAGE_ALLOCATE_BUFFER|
FORMAT_MESSAGE_FROM_SYSTEM|
FORMAT_MESSAGE_IGNORE_INSERTS,
NULL,
dw,
MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),
(LPTSTR)&lpMsgBuf,
0,NULL);
std::string ret((char*)lpMsgBuf);
LocalFree(lpMsgBuf);
return ret;
}
#else
bool open_file_dialog(std::string&filename,
const char*title="Open",
const char*strfilter="All Files (*.*)\0*.*\0")
{
throw std::runtime_error("Function not implemented");
}
#endif
}
namespace heinlib
{
template<class Real>
static_matrix<2,1,Real>image_point(const static_matrix<2,1,Real>&feature)
{
return feature;
}
template<class Feature>
struct feature_observations
{
struct observation
{
unsigned pointId,viewId;
Feature*feature;
friend std::ostream&operator<<(std::ostream&os,const observation&o)
{
os<<"{ pointId:"<<o.pointId<<", viewId:"<<o.viewId<<", "<<*(o.feature)<<" }";
return os;
}
};
struct const_observation
{
unsigned pointId,viewId;
const Feature*feature;
friend std::ostream&operator<<(std::ostream&os,const const_observation&o)
{
os<<"{ pointId:"<<o.pointId<<", viewId:"<<o.viewId<<", "<<*(o.feature)<<" }";
return os;
}
};
struct observation_cluster
{
Feature feature;
unsigned orig_pointId,viewId;
mutable observation_cluster*parent;
std::list<observation_cluster*>observations;
observation_cluster(unsigned pointId,unsigned viewId,const Feature&f)
:parent(NULL),orig_pointId(pointId),viewId(viewId),feature(f)
{
observations.push_back(this);
}
observation_cluster*find()
{
if(parent==NULL)return this;
else
{
parent=parent->find();
return parent;
}
}
const observation_cluster*find()const
{
if(parent==NULL)return this;
else
{
parent=parent->find();
return parent;
}
}
unsigned pointId()const
{
return find()->orig_pointId;
}
observation_cluster*adopt(observation_cluster*child)
{
child->parent=this;
observations.splice(observations.begin(),child->observations);
return this;
}
};
unsigned unique_pointId;
std::vector<observation_cluster*>all_observations;
std::map<unsigned,observation_cluster*>observations_of_point;
std::map<unsigned,std::vector<observation_cluster*>*>observations_in_view;
std::map<std::pair<unsigned,unsigned>,observation_cluster*>lookup_observations;
public:
feature_observations():unique_pointId(0)
{
}
bool save_ascii(const char*filename)const
{
typedef typename Feature::real_type Real;
std::ofstream file(filename);
if(!file.good())return false;
for(typename std::vector<observation_cluster*>::const_iterator obs_it=all_observations.begin();obs_it!=all_observations.end();++obs_it)
{
observation_cluster*po=(*obs_it);
unsigned pointId=po->pointId();
const static_matrix<2,1,Real>&pt=image_point(po->feature);
file<<pointId<<" "<<po->viewId<<" "<<pt.x()<<" "<<pt.y()<<"\n";
}
file.close();
return true;
}
bool load_ascii(const char*filename)
{
typedef typename Feature::real_type Real;
std::ifstream file(filename);
if(!file)return false;
clear();
std::string line;
static_matrix<2,1,Real>pt;
unsigned pointId,viewId;
while(std::getline(file,line))
{
std::stringstream ss(line);
ss>>pointId>>viewId>>pt.x()>>pt.y();
if(!ss.fail())
{
add_observation(pointId,viewId,pt);
}
}
return true;
}
bool save(const char*filename)const
{
std::ofstream file(filename,std::ios::binary);
if(!file.good())return false;
unsigned count=all_observations.size();
unsigned buffer_size=sizeof(unsigned)+count*(sizeof(unsigned)*2+sizeof(Feature));
std::vector<unsigned char>vec_buffer(buffer_size);
unsigned char*buffer=&vec_buffer[0];
unsigned char*write_pos=buffer;
memcpy(write_pos,&count,sizeof(unsigned));
write_pos+=sizeof(unsigned);
for(typename std::vector<observation_cluster*>::const_iterator obs_it=all_observations.begin();obs_it!=all_observations.end();++obs_it)
{
observation_cluster*po=(*obs_it);
memcpy(write_pos,&(po->viewId),sizeof(unsigned));
write_pos+=sizeof(unsigned);
unsigned pointId=po->pointId();
memcpy(write_pos,&pointId,sizeof(unsigned));
write_pos+=sizeof(unsigned);
memcpy(write_pos,&(po->feature),sizeof(Feature));
write_pos+=sizeof(Feature);
}
file.write((char*)buffer,buffer_size);
return true;
}
bool load(const char*filename)
{
clear();
std::fstream file(filename,std::ios::in|::std::ios::binary);
if(!file)return false;
file.seekg(0,std::ios::end);
size_t length=(size_t)file.tellg();
file.seekg(0,std::ios::beg);
char*buffer=new char[length+1];
file.read(buffer,length);
buffer[length]='\0';
file.close();
char*read_pos=buffer;
unsigned count;
memcpy(&count,read_pos,sizeof(unsigned));
read_pos+=sizeof(unsigned);
if(sizeof(unsigned)+count*(sizeof(unsigned)*2+sizeof(Feature))!=length)
{
std::cout<<"Wrong size.\n";
return false;
}
unsigned viewId,pointId;
Feature f;
for(unsigned i=0;i<count;++i)
{
memcpy(&viewId,read_pos,sizeof(unsigned));
read_pos+=sizeof(unsigned);
memcpy(&pointId,read_pos,sizeof(unsigned));
read_pos+=sizeof(unsigned);
if(pointId>unique_pointId)
unique_pointId=pointId;
memcpy(&f,read_pos,sizeof(Feature));
read_pos+=sizeof(Feature);
add_observation(pointId,viewId,f);
}
delete[]buffer;
return true;
}
void clear()
{
for(typename std::map<unsigned,std::vector<observation_cluster*>*>::iterator it=observations_in_view.begin();it!=observations_in_view.end();++it)
delete(*it).second;
observations_in_view.clear();
for(typename std::vector<observation_cluster*>::iterator it=all_observations.begin();it!=all_observations.end();++it)
delete*it;
all_observations.clear();
observations_of_point.clear();
unique_pointId=0;
}
~feature_observations()
{
clear();
}
unsigned add_observation(unsigned pointId,unsigned viewId,const Feature&f)
{
if(pointId>unique_pointId)
unique_pointId=pointId;
observation_cluster*p=new observation_cluster(pointId,viewId,f);
all_observations.push_back(p);
observations_of_point[p->orig_pointId]=p;
lookup_observations[std::make_pair(pointId,viewId)]=p;
typename std::map<unsigned,std::vector<observation_cluster*>*>::iterator found_view=observations_in_view.find(viewId);
if(found_view!=observations_in_view.end())
(*found_view).second->push_back(p);
else
{
std::vector<observation_cluster*>*vec=new std::vector<observation_cluster*>();
vec->push_back(p);
observations_in_view[viewId]=vec;
}
return p->orig_pointId;
}
unsigned highest_pointID()const
{
return unique_pointId;
}
unsigned new_pointID()
{
return unique_pointId++;
}
unsigned add_observation(unsigned viewId,const Feature&f)
{
return add_observation(viewId,f,new_pointID());
}
Feature*get_observation(unsigned pointId,unsigned viewId)
{
typename std::map<std::pair<unsigned,unsigned>,observation_cluster*>::const_iterator found_obs=lookup_observations.find(std::make_pair(pointId,viewId));
if(found_obs!=lookup_observations.end())
{
return&((*found_obs).second->feature);
}else
return NULL;
}
const Feature*get_observation(unsigned pointId,unsigned viewId)const
{
typename std::map<std::pair<unsigned,unsigned>,observation_cluster*>::const_iterator found_obs=lookup_observations.find(std::make_pair(pointId,viewId));
if(found_obs!=lookup_observations.end())
{
return&((*found_obs).second->feature);
}else
return NULL;
}
observation_cluster*merge_points(unsigned pointId1,unsigned pointId2)
{
typename std::map<unsigned,observation_cluster*>::iterator it1=observations_of_point.find(pointId1),
it2=observations_of_point.find(pointId2);
if(it1!=observations_of_point.end()&&it2!=observations_of_point.end())
{
observation_cluster*A=(*it1).second->find(),*B=(*it2).second->find();
if(A==B)return A;
if(A->orig_pointId<B->orig_pointId)
return A->adopt(B);
else return B->adopt(A);
}
return NULL;
}
unsigned count_observations()const
{
return all_observations.size();
}
unsigned count_observations_in_view(unsigned viewId)const
{
typename std::map<unsigned,std::vector<observation_cluster*>*>::const_iterator found_view=observations_in_view.find(viewId);
if(found_view!=observations_in_view.end())
return(*found_view).second->size();
else return 0;
}
unsigned count_observations_of_point(unsigned pointId)const
{
typename std::map<unsigned,observation_cluster*>::const_iterator found_point=observations_of_point.find(pointId);
if(found_point!=observations_of_point.end())
{
observation_cluster*po=(*found_point).second->find();
return po->observations.size();
}else return 0;
}
void list_all_observations()const
{
for(typename std::vector<observation_cluster*>::const_iterator obs_it=all_observations.begin();obs_it!=all_observations.end();++obs_it)
{
observation_cluster*po=(*obs_it);
std::cout<<po->viewId<<", "<<po->pointId()<<" : "<<po->feature<<"\n";
}
}
void list_observations_of_point(unsigned pointId)const
{
typename std::map<unsigned,observation_cluster*>::const_iterator found_point=observations_of_point.find(pointId);
if(found_point!=observations_of_point.end())
{
observation_cluster*po=(*found_point).second->find();
for(typename std::list<observation_cluster*>::const_iterator obs_it=po->observations.begin();obs_it!=po->observations.end();++obs_it)
{
observation_cluster*o=*obs_it;
std::cout<<o->viewId<<", "<<o->pointId()<<" : "<<o->feature<<"\n";
}
}
}
void list_observations_in_view(unsigned viewId)const
{
typename std::map<unsigned,std::vector<observation_cluster*>*>::const_iterator found_view=observations_in_view.find(viewId);
if(found_view!=observations_in_view.end())
{
std::vector<observation_cluster*>*vec=(*found_view).second;
for(typename std::vector<observation_cluster*>::const_iterator po_it=vec->begin();po_it!=vec->end();++po_it)
{
observation_cluster*o=*po_it;
std::cout<<o->viewId<<", "<<o->pointId()<<" : "<<o->feature<<"\n";
}
}
}
class all_observations_iterator:std::iterator<std::forward_iterator_tag,void,void,void,void>
{
friend class const_all_observations_iterator;
typename std::vector<observation_cluster*>::iterator cur_it,end_it;
observation o;
void set()
{
if(cur_it!=end_it)
{
o.pointId=(*cur_it)->pointId();
o.viewId=(*cur_it)->viewId;
o.feature=&((*cur_it)->feature);
}else
{
o.pointId=0;
o.viewId=0;
o.feature=NULL;
}
}
public:
all_observations_iterator(const typename std::vector<observation_cluster*>::iterator&cur_it,const typename std::vector<observation_cluster*>::iterator&end_it)
:cur_it(cur_it),end_it(end_it)
{
set();
}
const observation&operator*()const
{
return o;
}
bool operator==(const all_observations_iterator&it)const
{
return(cur_it==it.cur_it);
}
bool operator!=(const all_observations_iterator&it)const
{
return!(*this==it);
}
all_observations_iterator&operator++()
{
++cur_it;
set();
return*this;
}
all_observations_iterator&operator++(int)
{
all_observations_iterator it(*this);
++(*this);
return it;
}
};
all_observations_iterator begin_all_observations()
{
return all_observations_iterator(all_observations.begin(),all_observations.end());
}
all_observations_iterator end_all_observations()
{
return all_observations_iterator(all_observations.end(),all_observations.end());
}
class const_all_observations_iterator:std::iterator<std::forward_iterator_tag,void,void,void,void>
{
typename std::vector<observation_cluster*>::iterator cur_it,end_it;
const_observation o;
void set()
{
if(cur_it!=end_it)
{
o.pointId=(*cur_it)->pointId();
o.viewId=(*cur_it)->viewId;
o.feature=&((*cur_it)->feature);
}else
{
o.pointId=0;
o.viewId=0;
o.feature=NULL;
}
}
public:
const_all_observations_iterator(const typename std::vector<observation_cluster*>::const_iterator&cur_it,
const typename std::vector<observation_cluster*>::const_iterator&end_it)
:cur_it(cur_it),end_it(end_it)
{
set();
}
const_all_observations_iterator(const all_observations_iterator&it)
:cur_it(it.cur_it),end_it(it.end_it)
{
set();
}
const const_observation&operator*()const
{
return o;
}
bool operator==(const const_all_observations_iterator&it)const
{
return(cur_it==it.cur_it);
}
bool operator!=(const const_all_observations_iterator&it)const
{
return!(*this==it);
}
const_all_observations_iterator&operator++()
{
++cur_it;
set();
return*this;
}
const_all_observations_iterator&operator++(int)
{
const_all_observations_iterator cur_it(*this);
++(*this);
return cur_it;
}
};
const_all_observations_iterator begin_all_observations()const
{
return const_all_observations_iterator(all_observations.begin(),all_observations.end());
}
const_all_observations_iterator end_all_observations()const
{
return const_all_observations_iterator(all_observations.end(),all_observations.end());
}
class observations_of_point_iterator:std::iterator<std::forward_iterator_tag,void,void,void,void>
{
friend class const_observations_of_point_iterator;
typename std::list<observation_cluster*>::iterator cur_it,end_it;
observation o;
bool is_end;
void set()
{
if(cur_it!=end_it)
{
o.pointId=(*cur_it)->pointId();
o.viewId=(*cur_it)->viewId;
o.feature=&((*cur_it)->feature);
}else
{
o.pointId=0;
o.viewId=0;
o.feature=NULL;
is_end=true;
}
}
public:
observations_of_point_iterator(const typename std::list<observation_cluster*>::iterator&cur_it,
const typename std::list<observation_cluster*>::iterator&end_it)
:cur_it(cur_it),end_it(end_it),is_end(false)
{
set();
}
observations_of_point_iterator()
:is_end(true)
{
}
const observation&operator*()const
{
return o;
}
bool operator==(const observations_of_point_iterator&it)const
{
if(!is_end&&!it.is_end)
return(cur_it==it.cur_it);
else return(is_end&&it.is_end);
}
bool operator!=(const observations_of_point_iterator&it)const
{
return!(*this==it);
}
observations_of_point_iterator&operator++()
{
++cur_it;
set();
return*this;
}
observations_of_point_iterator&operator++(int)
{
observations_of_point_iterator it(*this);
++(*this);
return it;
}
};
observations_of_point_iterator begin_observations_of_point(unsigned pointId)
{
typename std::map<unsigned,observation_cluster*>::const_iterator found_point=observations_of_point.find(pointId);
if(found_point!=observations_of_point.end())
{
observation_cluster*po=(*found_point).second->find();
return observations_of_point_iterator(po->observations.begin(),po->observations.end());
}else
{
return end_observations_of_point();
}
}
observations_of_point_iterator end_observations_of_point()
{
return observations_of_point_iterator();
}
class const_observations_of_point_iterator:std::iterator<std::forward_iterator_tag,void,void,void,void>
{
typename std::list<observation_cluster*>::const_iterator cur_it,end_it;
const_observation o;
bool is_end;
void set()
{
if(cur_it!=end_it)
{
o.pointId=(*cur_it)->pointId();
o.viewId=(*cur_it)->viewId;
o.feature=&((*cur_it)->feature);
}else
{
o.pointId=0;
o.viewId=0;
o.feature=NULL;
is_end=true;
}
}
public:
const_observations_of_point_iterator(const typename std::list<observation_cluster*>::const_iterator&cur_it,
const typename std::list<observation_cluster*>::const_iterator&end_it)
:cur_it(cur_it),end_it(end_it),is_end(false)
{
set();
}
const_observations_of_point_iterator()
:is_end(true)
{
}
const_observations_of_point_iterator(const observations_of_point_iterator&it)
:cur_it(it.cur_it),end_it(it.end_it),is_end(it.is_end)
{
if(!is_end)set();
}
const const_observation&operator*()const
{
return o;
}
bool operator==(const const_observations_of_point_iterator&it)const
{
if(!is_end&&!it.is_end)
return(cur_it==it.cur_it);
else return(is_end&&it.is_end);
}
bool operator!=(const const_observations_of_point_iterator&it)const
{
return!(*this==it);
}
const_observations_of_point_iterator&operator++()
{
++cur_it;
set();
return*this;
}
const_observations_of_point_iterator&operator++(int)
{
const_observations_of_point_iterator it(*this);
++(*this);
return it;
}
};
const_observations_of_point_iterator begin_observations_of_point(unsigned pointId)const
{
typename std::map<unsigned,observation_cluster*>::const_iterator found_point=observations_of_point.find(pointId);
if(found_point!=observations_of_point.end())
{
observation_cluster*po=(*found_point).second->find();
return const_observations_of_point_iterator(po->observations.begin(),po->observations.end());
}else
{
return end_observations_of_point();
}
}
const_observations_of_point_iterator end_observations_of_point()const
{
return const_observations_of_point_iterator();
}
class observations_in_view_iterator:std::iterator<std::forward_iterator_tag,void,void,void,void>
{
friend class const_observations_in_view_iterator;
typename std::vector<observation_cluster*>::iterator cur_it,end_it;
observation o;
bool is_end;
void set()
{
if(cur_it!=end_it)
{
o.pointId=(*cur_it)->pointId();
o.viewId=(*cur_it)->viewId;
o.feature=&((*cur_it)->feature);
}else
{
o.pointId=0;
o.viewId=0;
o.feature=NULL;
is_end=true;
}
}
public:
observations_in_view_iterator(const typename std::vector<observation_cluster*>::iterator&cur_it,
const typename std::vector<observation_cluster*>::iterator&end_it)
:cur_it(cur_it),end_it(end_it),is_end(false)
{
set();
}
observations_in_view_iterator()
:is_end(true)
{
}
const observation&operator*()const
{
return o;
}
bool operator==(const observations_in_view_iterator&it)const
{
if(!is_end&&!it.is_end)
return(cur_it==it.cur_it);
else return(is_end&&it.is_end);
}
bool operator!=(const observations_in_view_iterator&it)const
{
return!(*this==it);
}
observations_in_view_iterator&operator++()
{
++cur_it;
set();
return*this;
}
observations_in_view_iterator&operator++(int)
{
observations_in_view_iterator it(*this);
++(*this);
return it;
}
};
observations_in_view_iterator begin_observations_in_view(unsigned viewId)
{
typename std::map<unsigned,std::vector<observation_cluster*>*>::const_iterator found_view=observations_in_view.find(viewId);
if(found_view!=observations_in_view.end())
{
std::vector<observation_cluster*>*vec=(*found_view).second;
return observations_in_view_iterator(vec->begin(),vec->end());
}else
{
return end_observations_in_view();
}
}
observations_in_view_iterator end_observations_in_view()
{
return observations_in_view_iterator();
}
class const_observations_in_view_iterator:std::iterator<std::forward_iterator_tag,void,void,void,void>
{
typename std::vector<observation_cluster*>::const_iterator cur_it,end_it;
const_observation o;
bool is_end;
void set()
{
if(cur_it!=end_it)
{
o.pointId=(*cur_it)->pointId();
o.viewId=(*cur_it)->viewId;
o.feature=&((*cur_it)->feature);
}else
{
o.pointId=0;
o.viewId=0;
o.feature=NULL;
is_end=true;
}
}
public:
const_observations_in_view_iterator(const typename std::vector<observation_cluster*>::const_iterator&cur_it,
const typename std::vector<observation_cluster*>::const_iterator&end_it)
:cur_it(cur_it),end_it(end_it),is_end(false)
{
set();
}
const_observations_in_view_iterator()
:is_end(true)
{
}
const_observations_in_view_iterator(const observations_in_view_iterator&it)
:cur_it(it.cur_it),end_it(it.end_it),is_end(it.is_end)
{
if(!is_end)set();
}
const const_observation&operator*()const
{
return o;
}
bool operator==(const const_observations_in_view_iterator&it)const
{
if(!is_end&&!it.is_end)
return(cur_it==it.cur_it);
else return(is_end&&it.is_end);
}
bool operator!=(const const_observations_in_view_iterator&it)const
{
return!(*this==it);
}
const_observations_in_view_iterator&operator++()
{
++cur_it;
set();
return*this;
}
const_observations_in_view_iterator&operator++(int)
{
const_observations_in_view_iterator it(*this);
++(*this);
return it;
}
};
const_observations_in_view_iterator begin_observations_in_view(unsigned viewId)const
{
typename std::map<unsigned,std::vector<observation_cluster*>*>::const_iterator found_view=observations_in_view.find(viewId);
if(found_view!=observations_in_view.end())
{
std::vector<observation_cluster*>*vec=(*found_view).second;
return const_observations_in_view_iterator(vec->begin(),vec->end());
}else
{
return end_observations_in_view();
}
}
const_observations_in_view_iterator end_observations_in_view()const
{
return const_observations_in_view_iterator();
}
};
}
#pragma once
namespace heinlib
{
template<class Real>
int metric_chirality_canonical(const static_matrix<3,1,Real>&X)
{
return sign(X.z());
}
template<class Real>
int metric_chirality_canonical(const static_matrix<4,1,Real>&X)
{
return sign(X.z()*X.w());
}
template<class Real>
int metric_chirality(const static_matrix<4,1,Real>&X,const static_matrix<3,4,Real>&P)
{
return sign((P*X).z()*X.w());
}
template<class Real>
int metric_chirality(const static_matrix<3,1,Real>&X,const static_matrix<3,4,Real>&P)
{
return sign((P*homogenize(X)).z());
}
template<class Real>
int chirality(const static_matrix<4,1,Real>&X,const static_matrix<3,4,Real>&P)
{
int sgn_detM=sign(determinant(P.template submatrix<0,0,2,2>()));
Real w=projective_depth(P,X);
return sign(w*X.w()*sgn_detM);
}
template<class Real>
bool visible(const static_matrix<4,1,Real>&X,const static_matrix<3,4,Real>&P,unsigned image_width,unsigned image_height)
{
if(chirality(X,P)<0)return false;
static_matrix<2,1,Real>pr=project(P,X);
unsigned x=(unsigned)pr.x(),y=(unsigned)pr.y();
return(x<image_width&&y<image_height);
}
}
namespace heinlib
{
template<class Real>
class depth_measure
{
const static_matrix<3,4,Real>*P;
Real lenm3;
int sgn_detM;
public:
depth_measure(){}
depth_measure(const static_matrix<3,4,Real>&Pin)
{
set_camera(Pin);
}
void set_camera(const static_matrix<3,4,Real>&Pin)
{
P=&Pin;
static_matrix<3,3,Real>M=Pin.template submatrix<0,0,2,2>();
sgn_detM=sign(determinant(M));
lenm3=length(M.get_row(2));
}
Real depth(const static_matrix<4,1,Real>&X)const
{
Real w=projective_depth(*P,X);
return sgn_detM*w/(X.w()*lenm3);
}
int chirality(const static_matrix<4,1,Real>&X)const
{
Real w=projective_depth(*P,X);
return sign(w*X.w()*sgn_detM);
}
};
template<int Loud,class Recon,class Feature>
typename enable_if<is_recon<Recon>,bool>::type
test_chirality(const Recon&recon,const feature_observations<Feature>&observations)
{
unsigned Views=recon.pmats.size();
bool all_good=true;
if(Loud>0)std::cout<<"Testing chirality:\n";
for(unsigned j=0;j<recon.pmats.size();++j)
{
if(Loud>0)std::cout<<"view "<<recon.viewIDs[j]<<": ";
for(unsigned i=0;i<recon.pointIDs.size();++i)
{
const Feature*o=observations.get_observation(recon.pointIDs[i],recon.viewIDs[j]);
if(o)
{
int ch=chirality(recon.points[i],recon.pmats[j]);
if(ch<1)
{
if(Loud>0)all_good=false;
else return false;
}
if(Loud>0)std::cout<<std::setw(2)<<ch<<" ";
}
}
if(Loud>0)std::cout<<"\n";
}
return all_good;
}
template<class Real>
void flip_chirality(projective_recon<Real>&recon)
{
static_matrix<4,4,Real>Hf={1,0,0,0,0,1,0,0,0,0,-1,0,0,0,0,1};
align_reconstruction_struct(recon,Hf);
}
template<class MetricRecon>
typename enable_if<is_metric_recon<MetricRecon>,void>::type
flip_chirality(MetricRecon&recon)
{
typedef typename MetricRecon::real_type Real;
for(unsigned i=0;i<recon.points.size();++i)
{
recon.points[i].x()*=-1;
recon.points[i].y()*=-1;
recon.points[i].z()*=-1;
}
for(unsigned j=0;j<recon.camera_views.size();++j)
{
recon.camera_views[j].pose.translation*=-1;
static_matrix<3,4,Real>&P=recon.pmats[j];
P(0,3)*=-1;
P(1,3)*=-1;
P(2,3)*=-1;
}
}
template<int Loud,class Recon,class Feature>
typename enable_if<is_recon<Recon>,bool>::type
fix_chirality(Recon&recon,const feature_observations<Feature>&observations,bool remove=true)
{
typedef typename Recon::real_type Real;
if(Loud>0)std::cout<<"Fixing chirality \n";
unsigned total_count=0,neg_count=0;
for(unsigned i=0;i<recon.pointIDs.size();++i)
{
const Feature*o=observations.get_observation(recon.pointIDs[i],recon.viewIDs[0]);
if(o)
{
++total_count;
int ch=chirality(recon.points[i],recon.pmats[0]);
if(ch<1)++neg_count;
}
}
if(neg_count*2>total_count)
{
if(Loud>0)printf("flipping scene\n");
flip_chirality(recon);
}
if(Loud>0)printf("Testing all observations for chirality..\n");
unsigned prev_pts=recon.points.size(),removed=0;
typename std::vector<static_matrix<4,1,Real> >::iterator it=recon.points.begin();
while(it!=recon.points.end())
{
unsigned i=it-recon.points.begin();
bool good=true;
for(unsigned j=0;j<recon.pmats.size();++j)
{
const Feature*o=observations.get_observation(recon.pointIDs[i],recon.viewIDs[j]);
if(o&&chirality(recon.points[i],recon.pmats[j])<1)
{
good=false;
break;
}
}
if(good)++it;
else
{
++removed;
if(remove)
{
it=recon.points.erase(it);
recon.pointIDs.erase(recon.pointIDs.begin()+i);
}else++it;
}
}
if(Loud>0){
if(remove)
std::cout<<"Removed "<<removed<<"/"<<prev_pts<<" structure points for Chirality!\n";
else
std::cout<<removed<<"/"<<prev_pts<<" structure points with bad Chirality! (unfixed)\n";
}
return true;
}
}
#pragma once
#include<iostream>
namespace heinlib
{
template<class Print>
struct ioprec
{
unsigned prec;
const Print&p;
ioprec(const Print&p,unsigned prec)
:p(p),prec(prec)
{
}
};
template<class Print>
std::ostream&operator<<(std::ostream&os,const ioprec<Print>&pr)
{
unsigned temp=os.precision();
os.precision(pr.prec);
os<<pr.p;
os.precision(temp);
return os;
}
}
#pragma once
#pragma once
namespace heinlib
{
#ifdef WIN32
__forceinline unsigned number_of_processors()
{
SYSTEM_INFO System;
GetSystemInfo(&System);
return(unsigned)System.dwNumberOfProcessors;
}
#else
inline unsigned number_of_processors()
{
return(unsigned)sysconf(_SC_NPROCESSORS_ONLN);
}
#endif
}
#ifdef _WIN32
#include"windows.h"
#undef min
#undef max
#else
#include<pthread.h>
#define __forceinline __attribute__((always_inline))
#define MAXIMUM_WAIT_OBJECTS 64
#define HANDLE pthread_t
#endif
namespace heinlib
{
template<class Problem>
class parallel_params
{
Problem*problem;
unsigned start,end,thread_id;
public:
__forceinline void init(Problem*_problem,unsigned _start,unsigned _end,unsigned _thread_id)
{
problem=_problem;
start=_start;
end=_end;
thread_id=_thread_id;
}
__forceinline void begin()
{
problem->begin(start,end,thread_id);
}
__forceinline void finish()
{
problem->join(start,end,thread_id);
}
};
#ifndef WIN32
template<class Problem>
void*parallel_thread_proc(void*lpParameter)
{
parallel_params<Problem>*params=static_cast<parallel_params<Problem>*>(lpParameter);
params->begin();
return 0;
}
#else
template<class Problem>
DWORD WINAPI parallel_thread_proc(__in LPVOID lpParameter)
{
parallel_params<Problem>*params=static_cast<parallel_params<Problem>*>(lpParameter);
params->begin();
return 0;
}
#endif
template<class Problem>
void parallelize(Problem&prob,unsigned threads=0)
{
if(threads<1||threads>MAXIMUM_WAIT_OBJECTS)
{
threads=number_of_processors();
}
unsigned total_work=prob.problem_size();
unsigned work_per_thread=total_work/threads;
unsigned time_spent=work_per_thread+
total_work-std::min(total_work,threads*work_per_thread);
unsigned alt_work_per_thread=work_per_thread+1;
unsigned alt_threads=idivup(total_work,alt_work_per_thread);
unsigned alt_time_spent=alt_work_per_thread+
total_work-std::min(total_work,alt_threads*alt_work_per_thread);
if((alt_time_spent<time_spent)||
(alt_time_spent==time_spent&&
alt_work_per_thread<work_per_thread))
{
work_per_thread=alt_work_per_thread;
threads=alt_threads;
}
if(threads>1)
{
prob.prepare_threads(threads);
parallel_params<Problem>*thread_params=new parallel_params<Problem>[threads];
HANDLE*handles=new HANDLE[threads];
#ifndef NOT_PARALLEL
unsigned start=0,end=work_per_thread;
for(unsigned i=0;i<threads;++i)
{
if(i==threads-1)end=total_work;
thread_params[i].init(&prob,start,end,i);
#ifndef WIN32
pthread_create(&handles[i],(const pthread_attr_t*)NULL,parallel_thread_proc<Problem>,(void*)&thread_params[i]);
#else
handles[i]=CreateThread(NULL,0,parallel_thread_proc<Problem>,&thread_params[i],0,NULL);
#endif
start=end;
end+=work_per_thread;
}
#ifndef WIN32
for(unsigned i=0;i<threads;++i)
pthread_join(handles[i],NULL);
#else
WaitForMultipleObjects(threads,handles,TRUE,INFINITE);
#endif
for(unsigned i=0;i<threads;++i)
thread_params[i].finish();
#else
unsigned start=0,end=work_per_thread;
for(unsigned i=0;i<threads;++i)
{
if(i==threads-1)end=total_work;
thread_params[i].init(&prob,start,end,i);
#ifndef WIN32
pthread_create(handles[i],(const pthread_attr_t*)NULL,parallel_thread_proc<Problem>,(void*)&thread_params[i]);
pthread_join(handles[i],NULL);
#else
handles[i]=CreateThread(NULL,0,parallel_thread_proc<Problem>,&thread_params[i],0,NULL);
WaitForSingleObject(handles[i],INFINITE);
#endif
thread_params[i].finish();
start=end;
end+=work_per_thread;
}
#endif
#ifdef WIN32
for(unsigned i=0;i<threads;++i)
CloseHandle(handles[i]);
#endif
delete[]handles;
delete[]thread_params;
}else{
prob.prepare_threads(1);
parallel_params<Problem>thread_params;
thread_params.init(&prob,0,total_work,0);
parallel_thread_proc<Problem>(&thread_params);
thread_params.finish();
}
}
}
#pragma once
#ifdef WIN32
#include"windows.h"
#undef min
#undef max
#endif
namespace heinlib
{
int threadsafe_rand(int&seed)
{
static const int IA=16807,
IM=2147483647,
IQ=127773,
IR=2836,
MASK=123459876;
long k;
seed^=MASK;
k=seed/IQ;
seed=IA*(seed-k*IQ)-IR*k;
if(seed<0)seed+=IM;
int ans=seed;
seed^=MASK;
return ans;
}
template<class Real,class Enable=void>
struct random
{
static Real sign()
{
return(::rand()%2)?Real(1):Real(-1);
}
static Real uniform()
{
return::rand()/Real(RAND_MAX);
}
static Real uniform(Real minv,Real maxv)
{
return Real(::rand())/(Real(RAND_MAX))*(maxv-minv)+minv;
}
};
template<typename Integral>
struct random<Integral,typename enable_if<is_integral<Integral> >::type>
{
static Integral sign()
{
return(::rand()%2)?Integral(1):Integral(-1);
}
static Integral uniform()
{
return::rand();
}
static Integral uniform(Integral minv,Integral maxv)
{
assert((1+maxv-minv)<RAND_MAX);
return::rand()%(1+maxv-minv)+minv;
}
};
}
#pragma once
#ifdef WIN32
#include"windows.h"
#undef min
#undef max
#else
#include<pthread.h>
#endif
namespace heinlib
{
#ifdef WIN32
class mutex
{
HANDLE hMutex;
public:
mutex()
{
hMutex=CreateMutex(NULL,FALSE,NULL);
}
~mutex()
{
CloseHandle(hMutex);
}
void wait()
{
WaitForSingleObject(hMutex,INFINITE);
}
void release()
{
ReleaseMutex(hMutex);
}
};
#else
class mutex
{
pthread_mutex_t hMutex;
public:
mutex()
{
pthread_mutex_init(&hMutex,NULL);
}
~mutex()
{
pthread_mutex_destroy(&hMutex);
}
void wait()
{
pthread_mutex_lock(&hMutex);
}
void release()
{
pthread_mutex_unlock(&hMutex);
}
};
#endif
}
#pragma once
#ifdef WIN32
#include"windows.h"
#undef min
#undef max
#else
#include<unistd.h>
#endif
namespace heinlib
{
#ifdef WIN32
class counter
{
volatile LONG*count;
public:
counter()
{
count=(volatile LONG*)_aligned_malloc(sizeof(LONG),32);
*count=0;
}
~counter()
{
_aligned_free((void*)count);
}
void increment()
{
InterlockedIncrement(count);
}
long operator*()const
{
return*count;
}
volatile long&operator*()
{
return*count;
}
};
#else
class counter
{
volatile long count;
public:
counter()
{
count=0;
}
~counter()
{
}
void increment()
{
__sync_fetch_and_add(&count,1);
}
void decrememnt()
{
__sync_fetch_and_sub(&count,1);
}
long operator*()const
{
return count;
}
volatile long&operator*()
{
return count;
}
};
#endif
}
namespace heinlib
{
template<class Real,class Feature>
struct parallel_eval_H
{
const projective_recon<Real>&recon;
const static_matrix<4,4,Real>&H;
const feature_observations<Feature>&observations;
double error_sum;
static_matrix<4,4,Real>Hinv;
Real min_f,max_f;
Real max_sq_err_thresh;
counter chiral_errs;
mutex hMutex;
bool pp_constr;
Real u,v;
parallel_eval_H(
const projective_recon<Real>&recon,
const static_matrix<4,4,Real>&H,
const feature_observations<Feature>&observations,
Real min_f,Real max_f,bool pp_constr,Real u,Real v,
Real max_sq_err_thresh)
:recon(recon),H(H),observations(observations),
error_sum(0),min_f(min_f),max_f(max_f),pp_constr(pp_constr),u(u),v(v),
max_sq_err_thresh(max_sq_err_thresh)
{
Hinv=inverse(H);
*chiral_errs=0;
}
unsigned problem_size()const
{
return recon.pmats.size();
}
void prepare_threads(unsigned num_threads){}
void begin(unsigned start,unsigned end,unsigned thread_id)
{
Real err=0;
static_matrix<3,3,Real>K,R;
static_matrix<3,1,Real>t;
static_matrix<3,4,Real>P;
std::vector<static_matrix<3,4,Real> >fixed_projs(end-start);
std::vector<depth_measure<Real> >measure(end-start);
for(unsigned j=start;j<end;++j)
{
factor_projection_matrix(K,R,t,recon.pmats[j]*H);
std::cout<<"P=\n"<<recon.pmats[j]*H<<"\n";
std::cout<<"K=\n"<<K<<"\n\n";
K(0,1)=0;
Real f=(K(0,0)+K(1,1))/2;
K(0,0)=K(1,1)=f;
if(pp_constr)
{
K(0,2)=u;
K(1,2)=v;
}
std::cout<<"K'=\n"<<K<<"\n";
form_projection_matrix(fixed_projs[j-start],K,R,t);
system("pause");
measure[j-start].set_camera(fixed_projs[j-start]);
}
for(unsigned j=start;j<end;++j)
{
for(unsigned i=0;i<recon.pointIDs.size();++i)
{
const Feature*o=observations.get_observation(recon.pointIDs[i],recon.viewIDs[j]);
if(o)
{
static_matrix<4,1,Real>X=Hinv*recon.points[i];
static_matrix<2,1,Real>pr=realize(fixed_projs[j-start]*X);
err+=std::min(distance_sq(image_point<Real>(*o),pr),max_sq_err_thresh);
if(measure[j-start].chirality(X)<0)
chiral_errs.increment();
}
}
}
hMutex.wait();
error_sum+=err;
hMutex.release();
}
void join(unsigned start,unsigned end,unsigned thread_id)
{
}
};
template<class Real,class Feature>
struct ML_autocalibration_helper
{
static const unsigned Dim=16;
const projective_recon<Real>&recon;
const feature_observations<Feature>&observations;
Real min_f,max_f,mean_u,mean_v;
Real max_sq_err_thresh;
unsigned Views;
ML_autocalibration_helper(
const projective_recon<Real>&recon,
const feature_observations<Feature>&observations,
Real min_f,Real max_f,
Real mean_u,Real mean_v,
Real max_sq_err_thresh)
:recon(recon),observations(observations),min_f(min_f),max_f(max_f),mean_u(mean_u),mean_v(mean_v),max_sq_err_thresh(max_sq_err_thresh)
{
Views=recon.pmats.size();
}
Real evaluate_H(const static_matrix<4,4,Real>&H)const
{
camera_view<Real>view;
camera_intrinsics<Real>intrinsics(0,1,1);
view.intrinsics=&intrinsics;
static_matrix<4,4,Real>Hinv=inverse(H);
static_matrix<2,1,Real>pp={mean_u,mean_v};
static_matrix<3,4,Real>P;
Real err=0;
for(unsigned j=0;j<Views;++j)
{
view.from_projection_matrix(recon.pmats[j]*H);
view.intrinsics->enforce_zero_skew();
view.intrinsics->enforce_aspect_ratio();
P=view.get_projection_matrix();
for(unsigned i=0;i<recon.pointIDs.size();++i)
{
const Feature*o=observations.get_observation(recon.pointIDs[i],recon.viewIDs[j]);
if(o)
{
static_matrix<4,1,Real>X=Hinv*recon.points[i];
static_matrix<2,1,Real>pr=realize(P*X);
err+=std::min(distance_sq(image_point<Real>(*o),pr),max_sq_err_thresh);
}
}
}
return err;
}
Real evaluate_params(const static_matrix<Dim,1,Real>&hParams)
{
static_matrix<4,4,Real>H=homography_from_params(hParams);
return evaluate_H(H);
}
static_matrix<4,4,Real>homography_from_params(const static_matrix<Dim,1,Real>&h)const
{
static_matrix<4,4,Real>H;
matrix_copy(H,h,16);
return H;
}
static_matrix<Dim,1,Real>params_from_homography(const static_matrix<4,4,Real>&H)
{
static_matrix<Dim,1,Real>hParams;
matrix_copy(hParams,H,16);
return hParams;
}
void random_K(static_matrix<3,3,Real>&K)const
{
fill(K,0);
K(2,2)=1;
K(0,0)=K(1,1)=random<Real>::uniform(min_f,max_f);
K(0,2)=mean_u;
K(1,2)=mean_v;
}
template<int Loud>
Real DS_MC_ML_init_H(static_matrix<4,4,Real>&H,unsigned max_bad_steps=300)
{
static_matrix<3,3,Real>K;
static_matrix<4,4,Real>testH;
Real lowest_err=evaluate_H(H);
if(Loud>0)std::cout<<"DS-MC-ML: Initial error = "<<lowest_err<<"\n";
unsigned bad_steps=0;
while(bad_steps<max_bad_steps)
{
unsigned i=rand()%Views,j=rand()%Views;
while(j==i)j=rand()%Views;
const static_matrix<3,4,Real>&P1=recon.pmats[i],
&P2=recon.pmats[j];
random_K(K);
dual_stratified_pair<0>(testH,K,P1,K,P2);
Real err=evaluate_H(testH);
if(err<lowest_err)
{
lowest_err=err;
if(Loud>0)std::cout<<"lowest err = "<<err<<", bad_steps = "<<bad_steps<<"\n";
H=testH;
bad_steps=0;
}else++bad_steps;
}
return lowest_err;
}
template<int Loud>
Real DS_ML_init_H(static_matrix<4,4,Real>&H,unsigned focal_steps=100)
{
static_matrix<4,4,Real>testH;
Real lowest_err=evaluate_H(H);
if(Loud>0)std::cout<<"DS-ML: Initial error = "<<lowest_err<<"\n";
static_matrix<3,3,Real>K={0,0,mean_u,
0,0,mean_v,
0,0,1
};
for(unsigned j=1;j<Views;++j)
{
for(unsigned i=0;i<j;++i)
{
const static_matrix<3,4,Real>&P1=recon.pmats[i],
&P2=recon.pmats[j];
if(max_f<=min_f)
{
K(0,0)=K(1,1)=min_f;
dual_stratified_pair<0>(testH,K,P1,K,P2);
Real err=evaluate_H(testH);
if(err<lowest_err)
{
lowest_err=err;
if(Loud>0)std::cout<<"lowest err = "<<err<<"\n";
H=testH;
}else if(Loud>1)std::cout<<"test err = "<<err<<"\n";
}else
{
for(unsigned fi=0;fi<=focal_steps;++fi)
{
Real f=min_f+(max_f-min_f)*fi/(float)focal_steps;
K(0,0)=K(1,1)=f;
dual_stratified_pair<0>(testH,K,P1,K,P2);
Real err=evaluate_H(testH);
if(err<lowest_err)
{
lowest_err=err;
if(Loud>0)std::cout<<"lowest err = "<<err<<"\n";
H=testH;
}else if(Loud>1)std::cout<<"test err = "<<err<<"\n";
}
}
}
}
return lowest_err;
}
bool operator()(const static_matrix<Dim,1,Real>&Params,dynamic_matrix<Real>&Errors)
{
static_matrix<4,4,Real>H=homography_from_params(Params);
unsigned k=0;
camera_view<Real>view;
camera_intrinsics<Real>intrinsics(0,1,1);
view.intrinsics=&intrinsics;
static_matrix<4,4,Real>Hinv=inverse(H);
static_matrix<2,1,Real>pp={mean_u,mean_v};
static_matrix<3,4,Real>P;
for(unsigned j=0;j<Views;++j)
{
view.from_projection_matrix(recon.pmats[j]*H);
view.intrinsics->enforce_zero_skew();
view.intrinsics->enforce_aspect_ratio();
P=view.get_projection_matrix();
for(unsigned i=0;i<recon.pointIDs.size();++i)
{
const Feature*o=observations.get_observation(recon.pointIDs[i],recon.viewIDs[j]);
if(o)
{
static_matrix<2,1,Real>err=realize(P*Hinv*recon.points[i])-image_point<Real>(*o);
Errors[k++]=err.x();
Errors[k++]=err.y();
}
}
}
return true;
}
};
template<int Loud,class Real,class Feature>
void ML_autocalibrate(
static_matrix<4,4,Real>&H,
const projective_recon<Real>&recon,
const feature_observations<Feature>&observations,
Real min_f,Real max_f,
Real u,Real v,
Real max_sq_err_thresh=sq(5.0),
bool use_init=false,
unsigned focal_steps=100,
bool nonlinear=true)
{
ML_autocalibration_helper<Real,Feature>helper(recon,observations,min_f,max_f,u,v,max_sq_err_thresh);
static const unsigned Dim=ML_autocalibration_helper<Real,Feature>::Dim;
if(!use_init)
{
fill_identity(H);
helper.template DS_ML_init_H<Loud-1>(H,focal_steps);
}
if(nonlinear)
{
unsigned GoalSize=0;
for(unsigned j=0;j<recon.pmats.size();++j)
{
for(unsigned i=0;i<recon.pointIDs.size();++i)
{
const Feature*o=observations.get_observation(recon.pointIDs[i],recon.viewIDs[j]);
if(o)GoalSize+=2;
}
}
dynamic_matrix<Real>Goal(GoalSize);
fill(Goal,0);
if(Loud>1)std::cout<<"Nonlinear improving:\n";
static_matrix<Dim,1,Real>Params=helper.params_from_homography(H);
levenberg_marquardt_generic<Loud-1>(Goal,Params,helper,20,0.001);
H=helper.homography_from_params(Params);
}
}
template<int Loud,class Real,class Feature>
void MC_ML_autocalibrate(
static_matrix<4,4,Real>&H,
const projective_recon<Real>&recon,
const feature_observations<Feature>&observations,
Real min_f,Real max_f,
Real u,Real v,
Real max_sq_err_thresh=sq(5.0),
bool use_init=false,
unsigned mad_bad_steps=300,
bool nonlinear=true)
{
if(Loud>0)std::cout<<"MC ML Autocalibration\n";
ML_autocalibration_helper<Real,Feature>helper(recon,observations,min_f,max_f,u,v,max_sq_err_thresh);
static const unsigned Dim=ML_autocalibration_helper<Real,Feature>::Dim;
if(!use_init)
{
fill_identity(H);
helper.template DS_MC_ML_init_H<Loud>(H,mad_bad_steps);
}
if(nonlinear)
{
unsigned GoalSize=0;
for(unsigned j=0;j<recon.pmats.size();++j)
{
for(unsigned i=0;i<recon.pointIDs.size();++i)
{
const Feature*o=observations.get_observation(recon.pointIDs[i],recon.viewIDs[j]);
if(o)GoalSize+=2;
}
}
dynamic_matrix<Real>Goal(GoalSize);
fill(Goal,0);
if(Loud>1)std::cout<<"Nonlinear improving:\n";
static_matrix<Dim,1,Real>Params=helper.params_from_homography(H);
levenberg_marquardt_generic<Loud-1>(Goal,Params,helper,20,0.001);
H=helper.homography_from_params(Params);
}
}
}
#pragma once
#include<string>
#include<fstream>
#pragma once
#pragma once
namespace heinlib
{
template<class Matrix,class Distrib>
typename enable_if<is_matrix<Matrix>,void>::type
fill_random(Matrix&A,const Distrib&noise,unsigned row_start=0,unsigned col_start=0,unsigned row_end=0,unsigned col_end=0)
{
if(row_end<=row_start)row_end=A.rows;
if(col_end<=col_start)col_end=A.cols;
for(unsigned i=row_start;i<row_end;++i)
for(unsigned j=col_start;j<col_end;++j)
A(i,j)=noise.sample();
}
template<class Real,class Distrib>
dynamic_matrix<Real>random_matrix(unsigned rows,unsigned cols,const Distrib&noise)
{
dynamic_matrix<Real>A(rows,cols);
fill_random(A,noise);
return A;
}
template<typename MxN>
void fill_random(MxN&A,typename MxN::real_type minv=-1,typename MxN::real_type maxv=1)
{
unsigned elts=num_elements(A);
for(unsigned i=0;i<elts;++i)
A[i]=random<typename MxN::real_type>::uniform(minv,maxv);
}
template<unsigned M,typename Real>
static_matrix<M,1,Real>random_vector(Real minv=-1,Real maxv=1)
{
static_matrix<M,1,Real>x;
fill_random(x,minv,maxv);
return x;
}
template<unsigned M,typename Real,class Distrib>
static_matrix<M,1,Real>random_vector(const Distrib&noise)
{
static_matrix<M,1,Real>x;
fill_random(x,noise);
return x;
}
template<typename Nx1>
inline typename square_result<Nx1>::result_type matrix_from_eigenvalues(const Nx1&eigs)
{
unsigned N=eigs.rows;
typedef typename square_result<Nx1>::result_type NxN;
NxN x,xinv;
resize_if_dynamic(x,N,N);
resize_if_dynamic(xinv,N,N);
while(true)
{
fill_random(x);
if(matrix_inverse(x,xinv))
break;
}
return x*diagonal(eigs)*xinv;
}
template<class Real>
bool matrix_from_left_right_null_spaces(static_matrix<3,3,Real>&M,
const static_matrix<1,3,Real>&L,
const static_matrix<3,1,Real>&R)
{
static_matrix<6,9,Real>C=
{
R[0],R[1],R[2],0,0,0,0,0,0,
0,0,0,R[0],R[1],R[2],0,0,0,
0,0,0,0,0,0,R[0],R[1],R[2],
L[0],0,0,L[1],0,0,L[2],0,0,
0,L[0],0,0,L[1],0,0,L[2],0,
0,0,L[0],0,0,L[1],0,0,L[2]
};
static_matrix<9,1,Real>m;
if(!null_space_SVD(C,m))return false;
matrix_copy(M,m);
return true;
}
template<class Real>
bool matrix_from_right_null_space(static_matrix<3,3,Real>&M,
const static_matrix<3,1,Real>&R)
{
static_matrix<3,9,Real>C=
{
R[0],R[1],R[2],0,0,0,0,0,0,
0,0,0,R[0],R[1],R[2],0,0,0,
0,0,0,0,0,0,R[0],R[1],R[2]
};
static_matrix<9,1,Real>m;
if(!null_space_SVD(C,m))return false;
matrix_copy(M,m);
return true;
}
template<class Real>
bool matrix_from_left_null_space(static_matrix<3,3,Real>&M,
const static_matrix<1,3,Real>&L)
{
static_matrix<3,9,Real>C=
{
L[0],0,0,L[1],0,0,L[2],0,0,
0,L[0],0,0,L[1],0,0,L[2],0,
0,0,L[0],0,0,L[1],0,0,L[2]
};
static_matrix<9,1,Real>m;
if(!null_space_SVD(C,m))return false;
matrix_copy(M,m);
return true;
}
template<unsigned N,unsigned B,class Real>
bool matrix_from_null_space(static_matrix<N,N,Real>&M,const static_matrix<N,B,Real>&Null)
{
for(unsigned i=0;i<B;++i)
if(length_sq(Null.get_column(i))==0)
{
fill(M,0);
return false;
}
for(unsigned i=0;i<B;++i)
for(unsigned j=0;j<N;++j)
M(i,j)=0;
static_matrix<N,1,Real>vec;
for(unsigned row=B;row<N;++row)
{
Real norm=0;
do
{
fill_random(vec);
for(unsigned i=0;i<B;++i){
vec-=project(vec,Null.get_column(i));
}
for(unsigned i=B;i<row;++i){
vec-=project(vec,transpose(M.get_row(i)));
}
norm=length(vec);
}while(norm==0);
vec/=norm;
M.block_insert(row,0,transpose(vec));
}
}
}
#pragma once
#pragma once
#include<vector>
#include<cstdio>
#pragma once
#include<cstdlib>
#include<cmath>
#include<limits>
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif
#ifndef M_SQRT2
#define M_SQRT2 1.4142135623730950488016887
#endif
#ifndef M_SQRT2PI
#define M_SQRT2PI 2.50662827463100
#endif
#ifndef M_1_SQRTPI
#define M_1_SQRTPI 0.56418958354775628694807945156077258584405062932900L
#endif
namespace heinlib
{
template<class Real>
__forceinline Real random_normal()
{
Real x,y,r;
do{
x=random<Real>::uniform(-1,1);
y=random<Real>::uniform(-1,1);
r=x*x+y*y;
}while(r>1||r==0);
return y*sqrt(-2*ln(r)/r);
};
template<class Real>
__forceinline Real stdnormal_pdf(Real u)
{
return(Real)(exp(-u*u/2)/M_SQRT2PI);
};
#define LEVMAX 10
template<class Real>
__forceinline Real quad8_stdnormal_pdf(Real a,Real b,Real Q=1.0)
{
const int w[9]={3956,23552,-3712,41984,-18160,41984,-3712,23552,
3956};
const int dw=14175;
static int level=-1;
static Real tol=1e-30;
register Real h,Q1=0.0,Q2=0.0;
register int i;
level++;
h=(b-a)/16.0;
for(i=0;i<9;i++){
Q1+=h*w[i]*stdnormal_pdf(a+i*h)/dw;
Q2+=h*w[i]*stdnormal_pdf(a+(i+8)*h)/dw;
};
if(fabs(Q1+Q2-Q)>tol*fabs(Q1+Q2)&&level<=LEVMAX){
tol=tol/2;
Q1=quad8_stdnormal_pdf(a,(a+b)/2,Q1);
Q2=quad8_stdnormal_pdf((a+b)/2,b,Q2);
tol=tol*2;
}
level--;
return Q1+Q2;
}
template<class Real>
__forceinline Real stdnormal_cdf(Real u)
{
const Real a[5]={
1.161110663653770e-002,3.951404679838207e-001,2.846603853776254e+001,
1.887426188426510e+002,3.209377589138469e+003
};
const Real b[5]={
1.767766952966369e-001,8.344316438579620e+000,1.725514762600375e+002,
1.813893686502485e+003,8.044716608901563e+003
};
const Real c[9]={
2.15311535474403846e-8,5.64188496988670089e-1,8.88314979438837594e00,
6.61191906371416295e01,2.98635138197400131e02,8.81952221241769090e02,
1.71204761263407058e03,2.05107837782607147e03,1.23033935479799725E03
};
const Real d[9]={
1.00000000000000000e00,1.57449261107098347e01,1.17693950891312499e02,
5.37181101862009858e02,1.62138957456669019e03,3.29079923573345963e03,
4.36261909014324716e03,3.43936767414372164e03,1.23033935480374942e03
};
const Real p[6]={
1.63153871373020978e-2,3.05326634961232344e-1,3.60344899949804439e-1,
1.25781726111229246e-1,1.60837851487422766e-2,6.58749161529837803e-4
};
const Real q[6]={
1.00000000000000000e00,2.56852019228982242e00,1.87295284992346047e00,
5.27905102951428412e-1,6.05183413124413191e-2,2.33520497626869185e-3
};
register Real y,z;
y=fabs(u);
if(y<=0.46875*M_SQRT2){
z=y*y;
y=u*((((a[0]*z+a[1])*z+a[2])*z+a[3])*z+a[4])
/((((b[0]*z+b[1])*z+b[2])*z+b[3])*z+b[4]);
return 0.5+y;
}
z=exp(-y*y/2)/2;
if(y<=4.0){
y=y/M_SQRT2;
y=
((((((((c[0]*y+c[1])*y+c[2])*y+c[3])*y+c[4])*y+c[5])*y+c[6])*y+c[7])*y+c[8])
/((((((((d[0]*y+d[1])*y+d[2])*y+d[3])*y+d[4])*y+d[5])*y+d[6])*y+d[7])*y+d[8]);
y=z*y;
}else{
z=z*M_SQRT2/y;
y=2/(y*y);
y=y*(((((p[0]*y+p[1])*y+p[2])*y+p[3])*y+p[4])*y+p[5])
/(((((q[0]*y+q[1])*y+q[2])*y+q[3])*y+q[4])*y+q[5]);
y=z*(M_1_SQRTPI-y);
}
return(u<0.0?y:1-y);
};
template<class Real>
__forceinline Real probit(Real p)
{
const Real a[6]={
-3.969683028665376e+01,2.209460984245205e+02,
-2.759285104469687e+02,1.383577518672690e+02,
-3.066479806614716e+01,2.506628277459239e+00
};
const Real b[5]={
-5.447609879822406e+01,1.615858368580409e+02,
-1.556989798598866e+02,6.680131188771972e+01,
-1.328068155288572e+01
};
const Real c[6]={
-7.784894002430293e-03,-3.223964580411365e-01,
-2.400758277161838e+00,-2.549732539343734e+00,
4.374664141464968e+00,2.938163982698783e+00
};
const Real d[4]={
7.784695709041462e-03,3.224671290700398e-01,
2.445134137142996e+00,3.754408661907416e+00
};
register Real q,t,u;
if(p==0.0)
return-std::numeric_limits<Real>::infinity();
if(p==1.0)
return std::numeric_limits<Real>::infinity();
q=std::min(p,1-p);
if(q>0.02425){
u=q-0.5;
t=u*u;
u=u*(((((a[0]*t+a[1])*t+a[2])*t+a[3])*t+a[4])*t+a[5])
/(((((b[0]*t+b[1])*t+b[2])*t+b[3])*t+b[4])*t+1);
}else{
t=sqrt(-2*log(q));
u=(((((c[0]*t+c[1])*t+c[2])*t+c[3])*t+c[4])*t+c[5])
/((((d[0]*t+d[1])*t+d[2])*t+d[3])*t+1);
}
t=stdnormal_cdf(u)-q;
t=t*M_SQRT2PI*exp(u*u/2);
u=u-t/(1+u*t/2);
return(p>0.5?-u:u);
};
}
namespace heinlib
{
template<class Real>
Real vector_lerp(const std::vector<Real>&samples,Real i)
{
Real i0=floor(i);
Real i1=ceil(i);
Real v0=samples[(int)i0];
Real v1=samples[(int)i1];
return v0+(i-i0)*(v1-v0)/(i1-i0);
}
template<class Real>
void quartiles(Real&median,Real&first_quartile,Real&third_quartile,std::vector<Real>&samples)
{
unsigned N=samples.size();
if(N==0){
return;
}
std::sort(samples.begin(),samples.end());
Real*mv=&samples[N>>1];
median=(N%2)?*mv:(*mv+*(mv-1))/2;
first_quartile=((N-1)%4)?vector_lerp(samples,(N-1)*Real(0.25f)):samples[N>>2];
third_quartile=((3*(N-1))%4)?vector_lerp(samples,(N-1)*Real(0.75f)):samples[(N*3)>>2];
}
template<class Real>
void robust_stats(Real&median,Real&IQR,std::vector<Real>&samples)
{
unsigned N=samples.size();
if(N==0){
median=std::numeric_limits<Real>::signaling_NaN();
IQR=std::numeric_limits<Real>::signaling_NaN();
return;
}
std::sort(samples.begin(),samples.end());
Real*mv=&samples[N>>1];
median=(N%2)?*mv:(*mv+*(mv-1))/2;
Real first_quartile=((N-1)%4)?vector_lerp(samples,(N-1)*Real(0.25f)):samples[N>>2];
Real third_quartile=((3*(N-1))%4)?vector_lerp(samples,(N-1)*Real(0.75f)):samples[(N*3)>>2];
IQR=third_quartile-first_quartile;
}
template<class Real>
void min_max(Real&minval,Real&maxval,const std::vector<Real>&samples)
{
minval=samples[0];
maxval=samples[0];
for(unsigned i=1;i<samples.size();++i)
{
if(samples[i]<minval)minval=samples[i];
if(samples[i]>maxval)maxval=samples[i];
}
}
template<class Real>
void med_min_max(Real&median,Real&minval,Real&maxval,std::vector<Real>&samples)
{
unsigned N=samples.size();
if(N==0){
median=std::numeric_limits<Real>::signaling_NaN();
minval=std::numeric_limits<Real>::signaling_NaN();
maxval=std::numeric_limits<Real>::signaling_NaN();
return;
}
std::sort(samples.begin(),samples.end());
Real*mv=&samples[N>>1];
median=(N%2)?*mv:(*mv+*(mv-1))/2;
minval=samples.front();
maxval=samples.back();
}
template<class Real>
void sample_median(Real&median,std::vector<Real>&samples)
{
if(samples.empty()){
median=std::numeric_limits<Real>::signaling_NaN();
return;
}
std::sort(samples.begin(),samples.end());
unsigned mid=(unsigned)samples.size()/2;
if(even(samples.size()))
{
median=(samples[mid]+samples[mid-1])/2;
}else{
median=samples[mid];
}
}
template<class Real>
Real median2(std::vector<Real>&samples)
{
if(samples.empty()){
return std::numeric_limits<Real>::signaling_NaN();
}
std::sort(samples.begin(),samples.end());
unsigned mid=(unsigned)samples.size()/2;
return samples[mid];
}
template<class Real>
Real median(std::vector<Real>&samples)
{
Real m;
sample_median(m,samples);
return m;
}
template<class Real>
void median_absolute_deviation(Real&median,Real&mad,std::vector<Real>&samples)
{
sample_median(median,samples);
std::vector<Real>devs(samples.size());
for(unsigned i=0;i<samples.size();++i)
devs[i]=abs(samples[i]-median);
sample_median(mad,devs);
}
template<class Real>
Real MAD(std::vector<Real>&samples)
{
Real med=median(samples);
std::vector<Real>devs(samples.size());
for(unsigned i=0;i<samples.size();++i)
devs[i]=abs(samples[i]-med);
return median(devs);
}
template<class Real>
Real weighted_percentile(std::vector<std::pair<Real,Real> >&samples,Real p)
{
std::sort(samples.begin(),samples.end(),cmp_pair_first<Real,Real>());
Real hwsum=0;
for(unsigned i=0;i<samples.size();++i)
hwsum+=samples[i].second;
hwsum*=p;
Real sum2=0;
for(unsigned i=0;i<samples.size();++i)
{
sum2+=samples[i].second;
if(sum2>=hwsum)
return samples[i].first;
}
return samples.back().first;
}
template<class Real>
Real weighted_median(std::vector<std::pair<Real,Real> >&samples)
{
return weighted_percentile(samples,(Real)0.5);
}
template<class Real>
Real WMAD(std::vector<std::pair<Real,Real> >&samples)
{
Real wm=weighted_median(samples);
std::vector<std::pair<Real,Real> >samples2=samples;
for(unsigned i=0;i<samples.size();++i)
samples2[i].first=abs(samples2[i].first-wm);
return weighted_median(samples2);
}
template<class Real,class Iter>
void sample_mean_var(Real&mean,Real&var,const Iter&begin,const Iter&end)
{
iter_container<Iter>samples(begin,end);
unsigned n=samples.size();
mean=0;
for(unsigned i=0;i<n;++i)
mean+=samples[i];
mean/=n;
var=0;
for(unsigned i=0;i<n;++i)
var+=sq(samples[i]-mean);
var/=n;
}
template<class Real>
Real variance(const std::vector<Real>&samples)
{
unsigned n=samples.size();
Real mean=0;
for(unsigned i=0;i<n;++i)
mean+=samples[i];
mean/=n;
Real var=0;
for(unsigned i=0;i<n;++i)
var+=sq(samples[i]-mean);
var/=n;
return var;
}
template<class Real,class Iter>
Real variance(const Iter&begin,const Iter&end)
{
iter_container<Iter>samples(begin,end);
Real m=0;
unsigned n=samples.size();
for(unsigned i=0;i<n;++i)
m+=samples[i];
m/=n;
Real var=0;
for(unsigned i=0;i<n;++i)
var+=sq(samples[i]-m);
var/=n;
return var;
}
template<class Real,class Iter>
Real mean(const Iter&begin,const Iter&end)
{
Real m=0;
iter_container<Iter>samples(begin,end);
unsigned n=samples.size();
m=0;
for(unsigned i=0;i<n;++i)
m+=samples[i];
m/=n;
return m;
}
template<class Real>
Real mean(const std::vector<Real>&samples)
{
Real m={};
unsigned n=samples.size();
m=0;
for(unsigned i=0;i<n;++i)
m+=samples[i];
m/=n;
return m;
}
template<class Real>
void sample_central_moments(Real&mean,Real&m2,Real&m3,Real&m4,
const std::vector<Real>&samples)
{
unsigned n=samples.size();
mean=0;
for(unsigned i=0;i<n;++i)
mean+=samples[i];
mean/=n;
m2=0;m3=0;m4=0;
for(unsigned i=0;i<n;++i)
{
Real x=samples[i]-mean;
Real x2=x*x;
m2+=x2;
m3+=x2*x;
m4+=x2*x2;
}
m2/=n;m3/=n;m4/=n;
}
template<class Real>
void robust_central_moments(Real&m1,Real&m2,Real&m3,Real&m4,
std::vector<Real>&samples)
{
unsigned n=samples.size();
m1=median(samples);
std::vector<Real>m2s(n),m3s(n),m4s(n);
for(unsigned i=0;i<n;++i)
{
Real x=samples[i]-m1;
Real x2=x*x;
m2s[i]=x2;
m3s[i]=x2*x;
m4s[i]=x2*x2;
}
m2=median(m2s)/sq(probit(0.75));
m3=median(m3s);
m4=median(m4s)*14.5185;
}
template<class Real>
void k_statistics(Real&k1,Real&k2,Real&k3,Real&k4,
const std::vector<Real>&samples)
{
Real mean,m2,m3,m4;
sample_central_moments(mean,m2,m3,m4,samples);
Real n(samples.size());
k1=mean;
k2=n*m2/(n-1);
k3=n*n*m3/((n-1)*(n-2));
k4=n*n*((n+1)*m4-3*(n-1)*m2*m2)/((n-1)*(n-2)*(n-3));
printf("k4 is broken!!!\n");
}
template<class Real>
void sample_skewness_and_kurtosis(Real&mean,Real&skewness,Real&kurtosis,
const std::vector<Real>&samples)
{
Real mu2,mu3,mu4;
sample_central_moments(mean,mu2,mu3,mu4,samples);
skewness=mu3/pow(mu2,Real(1.5));
kurtosis=mu4/(mu2*mu2);
}
template<class Real>
void unbiased_skewness_and_kurtosis(Real&mean,Real&skewness,Real&kurtosis,
const std::vector<Real>&samples)
{
Real k2,k3,k4;
k_statistics(mean,k2,k3,k4,samples);
skewness=k3/pow(k2,Real(1.5));
kurtosis=k4/(k2*k2);
}
}
#pragma once
#include<vector>
#include<cassert>
#include<stdexcept>
namespace heinlib
{
namespace distributions
{
template<class Real>
struct generic_distribution
{
virtual generic_distribution*clone()const
{
throw std::runtime_error("Did not implement clone for this distribution!");
}
virtual void estimate(const std::vector<Real>&samples)
{
throw std::runtime_error("Did not implement estimation for this distribution!");
}
virtual void weighted_estimate(const std::vector<Real>&samples,const std::vector<Real>&weights)
{
throw std::runtime_error("Did not implement weighted estimation for this distribution!");
}
virtual Real sample()const
{
throw std::runtime_error("Did not implement sampling for this distribution!");
}
virtual Real pdf(Real x)const
{
throw std::runtime_error("Did not implement pdf for this distribution!");
}
virtual Real cdf(Real x)const
{
throw std::runtime_error("Did not implement cdf for this distribution!");
}
virtual Real get_mean()const
{
throw std::runtime_error("Did not implement mean value for this distribution!");
}
virtual Real inverse_cdf(Real p)const
{
throw std::runtime_error("Did not implement inverse-cdf for this distribution!");
}
};
}
}
#include<vector>
#include<cassert>
namespace heinlib
{
namespace distributions
{
template<class Real>
class normal:public distributions::generic_distribution<Real>
{
public:
Real mu,sigma;
normal(Real sigma=1,Real mu=0)
:mu(mu),sigma(sigma)
{
}
normal(const std::vector<Real>&samples)
{
estimate(samples);
}
generic_distribution<Real>*clone()const
{
return(generic_distribution<Real>*)(new normal(*this));
}
void estimate(const std::vector<Real>&samples)
{
unsigned n=samples.size();
mu=0;
for(unsigned i=0;i<n;++i)
mu+=samples[i];
mu/=n;
sigma=0;
for(unsigned i=0;i<n;++i)
sigma+=sq(samples[i]-mu);
sigma=sqrt(sigma/n);
}
void weighted_estimate(const std::vector<Real>&samples,const std::vector<Real>&weights)
{
unsigned n=samples.size();
mu=0;
Real wsum=0;
for(unsigned i=0;i<n;++i){
mu+=samples[i]*weights[i];
wsum+=weights[i];
}
mu/=wsum;
sigma=0;
for(unsigned i=0;i<n;++i)
sigma+=sq(samples[i]-mu)*weights[i];
sigma=sqrt(sigma/wsum);
}
__forceinline Real mean()const
{
return mu;
}
__forceinline Real sample()const
{
return mu+random_normal<Real>()*sigma;
}
__forceinline Real pdf(Real x)const
{
return stdnormal_pdf((x-mu)/sigma)/sigma;
}
__forceinline Real negative_log_likelihood(Real x)const
{
return sq((x-mu)/sigma)*0.5;
}
__forceinline Real cdf(Real x)const
{
return stdnormal_cdf((x-mu)/sigma);
}
__forceinline Real inverse_cdf(Real p)const
{
return mu+sigma*probit(p);
}
normal operator*(const normal&d)const
{
return product_normal_approx(*this,d);
}
normal operator+(const normal&d)const
{
return linear_combination(*this,d);
}
};
template<class Real>
normal<Real>linear_transform(const normal<Real>&X,Real a,Real b)
{
return normal<Real>(X.sigma*a,X.mu+b);
}
template<class Real>
normal<Real>linear_combination(const normal<Real>&X,const normal<Real>&Y,Real wX=1,Real wY=1)
{
return normal<Real>(sqrt(sq(wX*X.sigma)+sq(wY*Y.sigma)),wX*X.mu+wY*Y.mu);
}
template<class Real>
normal<Real>intersection_distribution(const normal<Real>&X,const normal<Real>&Y)
{
Real sXX=sq(X.sigma),sYY=sq(Y.sigma);
Real new_sigma=sqrt(2*sXX*sYY/(sXX+sYY));
Real new_mean=(X.mu*sYY+Y.mu*sXX)/(sXX+sYY);
return normal<Real>(new_sigma,new_mean);
}
template<class Real>
normal<Real>product_normal_approx(const normal<Real>&X,const normal<Real>&Y)
{
if(Y.sigma>X.sigma)return product_normal_approx(Y,X);
Real sigmaZ=sqrt(sq(Y.sigma)+sq(X.sigma)+sq(X.mu)+sq(Y.mu)-2*X.mu*Y.mu);
return normal<Real>(sigmaZ,Y.mu);
}
template<class Real>
normal<Real>random_field_union(const normal<Real>&X,const normal<Real>&Y,Real n=1,Real m=1)
{
Real uW=(n*X.mu+m*Y.mu)/(n+m);
Real sW=sqrt((n*(sq(X.sigma)+sq(uW-X.mu))+m*(sq(Y.sigma)+sq(uW-Y.mu)))/(n+m));
return normal<Real>(sW,uW);
}
template<class Real>
std::ostream&operator<<(std::ostream&os,const normal<Real>&distrib)
{
os<<"normal{ sigma="<<distrib.sigma<<", mu="<<distrib.mu<<" }";
return os;
}
}
}
#pragma once
#pragma once
namespace heinlib
{
template<class Nx1>
void sample_mean(Nx1&mean,const std::vector<Nx1>&samples)
{
typedef typename Nx1::real_type Real;
resize_if_dynamic(mean,samples[0].rows,samples[0].cols);
fill(mean,Real(0));
for(unsigned i=0;i<samples.size();++i)
mean+=samples[i];
mean/=(Real)samples.size();
}
template<class NxN,class Nx1>
void sample_covariance_matrix(NxN&covar,Nx1&mean,const std::vector<Nx1>&samples)
{
typedef typename NxN::real_type Real;
sample_mean(mean,samples);
resize_if_dynamic(covar,mean.rows,mean.rows);
fill(covar,Real(0));
Nx1 diff;
for(unsigned i=0;i<samples.size();++i)
{
diff=(samples[i]-mean);
covar+=diff*transpose(diff);
}
covar/=(Real)samples.size();
}
template<unsigned N,class Real>
void sample_covariance_known_mean(static_matrix<N,N,Real>&covar,
const static_matrix<N,1,Real>&mean,
const std::vector<static_matrix<N,1,Real> >&samples)
{
static_matrix<N,1,Real>diff;
for(unsigned i=0;i<samples.size();++i)
{
diff=(samples[i]-mean);
covar+=diff*transpose(diff);
}
covar/=(Real)samples.size();
}
template<unsigned Dim,class Real>
Real sq_mahalanobis_distance(const static_matrix<Dim,1,Real>&X,
const static_matrix<Dim,Dim,Real>&SigmaInv,
const static_matrix<Dim,1,Real>&Mean)
{
static_matrix<Dim,1,Real>Y=X-Mean;
return(transpose(Y)*SigmaInv*Y)[0];
}
template<unsigned Dim,class Real>
Real mahalanobis_distance(const static_matrix<Dim,1,Real>&X,
const static_matrix<Dim,Dim,Real>&SigmaInv,
const static_matrix<Dim,1,Real>&Mean)
{
static_matrix<Dim,1,Real>Y=X-Mean;
return sqrt((transpose(Y)*SigmaInv*Y)[0]);
}
}
#include<vector>
namespace heinlib
{
namespace distributions
{
template<unsigned N,class Real>
class multivariate_normal:distributions::generic_distribution<static_matrix<N,1,Real> >
{
Real mult;
public:
static_matrix<N,N,Real>L;
bool no_variance;
bool init(Real minvar=0)
{
if(minvar>0)
{
for(unsigned i=0;i<N;++i)
if(this->covar(i,i)<minvar)this->covar(i,i)=minvar;
}
if(!no_variance)
{
if(!cholesky_decomposition(covar,L))
{
fill(L,0);
no_variance=true;
}
}else
{
fill(L,0);
}
if(!no_variance)
{
Real det;
if(!matrix_inverse_sym(covar,covar_inv,&det))
{
no_variance=true;
}
Real two_pi_nth=ipow<N,Real>::eval(constants<Real>::two_pi());
mult=1/sqrt(two_pi_nth*det);
}
return true;
}
static_matrix<N,1,Real>mean;
static_matrix<N,N,Real>covar,covar_inv;
multivariate_normal(Real var=1)
{
fill(mean,0);
fill(covar,0);
for(unsigned i=0;i<N;++i)
covar(i,i)=var;
no_variance=(var==0);
if(!init())throw std::exception("multivariate_normal init failed!");
}
generic_distribution<static_matrix<N,1,Real> >*clone()const
{
return(generic_distribution<static_matrix<N,1,Real> >*)(new multivariate_normal(*this));
}
void set_covar(const static_matrix<N,N,Real>&_covar,Real minvar=0)
{
covar=_covar;
if(!init(minvar))throw std::exception("multivariate_normal init failed!");
}
multivariate_normal(const static_matrix<N,1,Real>&mean,const static_matrix<N,N,Real>&covar,Real minvar=0)
:mean(mean),covar(covar),no_variance(false)
{
if(!init(minvar))throw std::exception("multivariate_normal init failed!");
}
multivariate_normal(const static_matrix<N,N,Real>&covar,Real minvar=0)
:covar(covar),no_variance(false)
{
fill(mean,0);
if(!init(minvar))throw std::exception("multivariate_normal init failed!");
}
multivariate_normal(const static_matrix<N,1,Real>&mean,Real var=1)
:mean(mean)
{
no_variance=(var==0);
fill(covar,0);
for(unsigned i=0;i<N;++i)
covar(i,i)=var;
if(!init())throw std::exception("multivariate_normal init failed!");
}
multivariate_normal(const std::vector<static_matrix<N,1,Real> >&samples,Real minvar=0)
{
estimate(samples,minvar);
}
void estimate(const std::vector<static_matrix<N,1,Real> >&samples,Real minvar=0)
{
no_variance=false;
sample_covariance_matrix(covar,mean,samples);
if(!init(minvar))throw std::exception("multivariate_normal init failed!");
}
void estimate(const std::vector<static_matrix<N,1,Real> >&samples,const std::vector<Real>&weights,Real minvar=0)
{
no_variance=false;
fill(mean,Real(0));
Real wsum=0;
for(unsigned i=0;i<samples.size();++i){
Real w=weights[i];
mean+=samples[i]*w;
wsum+=w;
}
mean/=wsum;
fill(covar,Real(0));
static_matrix<N,1,Real>diff;
for(unsigned i=0;i<samples.size();++i)
{
diff=(samples[i]-mean);
covar+=diff*transpose(diff)*weights[i];
}
covar/=wsum;
if(!init(minvar))throw std::exception("multivariate_normal init failed!");
}
__forceinline static_matrix<N,1,Real>sample()const
{
static_matrix<N,1,Real>X;
for(unsigned i=0;i<N;++i)
X[i]=random_normal<Real>();
return L*X+mean;
}
__forceinline void sample(static_matrix<N,1,Real>&X)const
{
for(unsigned i=0;i<N;++i)
X[i]=random_normal<Real>();
X=L*X+mean;
}
__forceinline Real pdf(const static_matrix<N,1,Real>&X)const
{
static_matrix<N,1,Real>S=X-mean;
return mult*exp(-Real(0.5)*(transpose(S)*covar_inv*S)[0]);
}
__forceinline Real negative_log_likelihood(const static_matrix<N,1,Real>&X)const
{
static_matrix<N,1,Real>S=X-mean;
return(transpose(S)*covar_inv*S)[0];
}
__forceinline Real mahalanobis_distance(const static_matrix<N,1,Real>&X)const
{
static_matrix<N,1,Real>S=X-mean;
return sqrt((transpose(S)*covar_inv*S)[0]);
}
};
template<class Real>
class dynamic_multivariate_normal:distributions::generic_distribution<dynamic_matrix<Real> >
{
dynamic_matrix<Real>L;
Real mult;
public:
unsigned N;
bool no_variance;
bool init()
{
no_variance=true;
if(mean.cols!=1||mean.rows!=covar.rows||!is_square(covar))
return false;
if(!cholesky_decomposition(covar,L))
{
std::cout<<"covar failed = \n"<<covar<<"\n";
return false;
}
Real det;
if(!matrix_inverse(covar,covar_inv,&det))
{
std::cout<<"no inverse? \n"<<covar<<"\n";
return false;
}
Real two_pi_nth=pow(constants<Real>::two_pi(),Real(N));
mult=1/sqrt(two_pi_nth*det);
no_variance=false;
return true;
}
dynamic_matrix<Real>mean,covar,covar_inv;
void set_covar(const dynamic_matrix<Real>&_covar)
{
covar=_covar;
if(!init())throw std::exception("multivariate_normal init failed!");
}
dynamic_multivariate_normal(){}
dynamic_multivariate_normal(const dynamic_matrix<Real>&mean,const dynamic_matrix<Real>&covar)
:mean(mean),covar(covar)
{
N=mean.rows;
if(!init())throw std::exception("multivariate_normal init failed!");
}
dynamic_multivariate_normal(const dynamic_matrix<Real>&mean,Real var=1)
:mean(mean)
{
N=mean.rows;
covar.resize(N,N);
fill(covar,0);
for(unsigned i=0;i<N;++i)
covar(i,i)=var;
if(!init())throw std::exception("multivariate_normal init failed!");
}
void estimate(const std::vector<dynamic_matrix<Real> >&samples)
{
N=samples[0].rows;
mean.resize(N,1);
covar.resize(N,N);
sample_covariance_matrix(covar,mean,samples);
if(!init())throw std::exception("multivariate_normal init failed!");
}
__forceinline dynamic_matrix<Real>sample()const
{
if(no_variance)
return mean;
else
{
dynamic_matrix<Real>X;
for(unsigned i=0;i<N;++i)
X[i]=random_normal<Real>();
return L*X+mean;
}
}
__forceinline void sample(dynamic_matrix<Real>&X)const
{
if(no_variance)
return mean;
else
{
for(unsigned i=0;i<N;++i)
X[i]=random_normal<Real>();
X=L*X+mean;
}
}
__forceinline Real pdf(const dynamic_matrix<Real>&X)const
{
if(no_variance)
{
if(X==mean)
return 1;
else return 0;
}else
{
dynamic_matrix<Real>S=X-mean;
return mult*exp(-Real(0.5)*(transpose(S)*covar_inv*S)[0]);
}
}
__forceinline Real sq_mahalanobis_distance(const dynamic_matrix<Real>&X)const
{
dynamic_matrix<Real>S=X-mean;
return(transpose(S)*covar_inv*S)[0];
}
};
template<unsigned N,class Real>
static_matrix<N,1,Real>argmax_mutual_probability(
const multivariate_normal<N,Real>&d1,
const multivariate_normal<N,Real>&d2)
{
static_matrix<N,1,Real>v=d1.mean-d2.mean;
Real var1=(transpose(v)*d1.covar*v)[0];
Real var2=(transpose(v)*d2.covar*v)[0];
return(var2*d1.mean+var1*d2.mean)/(var1+var2);
}
template<unsigned N,class Real>
multivariate_normal<N,Real>mutual_distribution(
const multivariate_normal<N,Real>&d1,
const multivariate_normal<N,Real>&d2)
{
static_matrix<N,1,Real>v=d1.mean-d2.mean;
Real var1=(transpose(v)*d1.covar*v)[0];
Real var2=(transpose(v)*d2.covar*v)[0];
multivariate_normal<N,Real>d(
(var2*d1.mean+var1*d2.mean)/(var1+var2),
(var2*d1.covar+var1*d2.covar)/(var1+var2));
return d;
}
template<unsigned Dim,class Real>
std::ostream&operator<<(std::ostream&os,const multivariate_normal<Dim,Real>&distrib)
{
os<<"mv_normal{ covar=\n"<<distrib.covar<<", mean="<<distrib.mean<<" }";
return os;
}
}
}
namespace heinlib
{
template<class Real,class Recon,class Feature>
bool triangulate_region(
distributions::multivariate_normal<3,Real>&distrib,
const Recon&recon,
unsigned pointID,
const feature_observations<Feature>&observations,
Real img_noise=1.0,
unsigned trials=100)
{
if(observations.count_observations_of_point(pointID)<2)
return false;
std::vector<std::pair<unsigned,static_matrix<2,1,Real> > >image_points,perturbed;
for(unsigned j=0;j<recon.viewIDs.size();++j)
{
unsigned viewID=recon.viewIDs[j];
const Feature*o=observations.get_observation(pointID,viewID);
if(o)image_points.push_back(std::make_pair(viewID,image_point(o)));
}
perturbed=image_points;
std::vector<static_matrix<3,1,Real> >samples(trials);
distributions::normal<Real>noise(img_noise);
for(unsigned trial=0;trial<trials;++trial)
{
for(unsigned j=0;j<perturbed.size();++j)
perturbed[j].second=image_points[j].second+random_vector<2,Real>(noise);
static_matrix<4,1,Real>X;
triangulate(X,perturbed,recon.pmats,recon.viewIDs,perturbed.size());
samples[trial]=realize(X);
}
distrib.estimate(samples);
}
template<class Real>
bool error_ellipsoid_volume(
Real&volume,
const distributions::multivariate_normal<3,Real>&distrib)
{
static_matrix<3,3,Real>U,S,V;
if(!SVD<true,true>(distrib.covar,U,S,V))
return false;
Real a=S(0,0),
b=S(1,1),
c=S(2,2);
volume=4*constants<Real>::pi()/3*a*b*c*2.447;
return true;
}
}
#pragma once
#pragma once
namespace heinlib
{
template<unsigned N,class Real,class Iter>
bool linear_similarity_transform(
static_matrix<N,N,Real>&R,
static_matrix<N,1,Real>&t,
Real&c,
const Iter&begin,const Iter&end,
bool allow_reflections=true)
{
iter_container<Iter>corrs(begin,end);
unsigned n=corrs.size();
static_matrix<N,1,Real>meanA={},meanB={};
for(unsigned i=0;i<n;++i)
{
meanA+=corrs[i][0];
meanB+=corrs[i][1];
}
meanA/=n;
meanB/=n;
static_matrix<N,N,Real>covAB={};
Real varA=0,varB=0;
for(unsigned i=0;i<n;++i)
{
const static_matrix<N,1,Real>&A=corrs[i][0],&B=corrs[i][1];
varA+=length_sq(A-meanA);
varB+=length_sq(B-meanB);
covAB+=(B-meanB)*transpose(A-meanA);
}
varA/=n;
varB/=n;
covAB/=n;
static_matrix<N,N,Real>U,D,V;
if(!SVD<true,true>(covAB,U,D,V))
return false;
if(!allow_reflections)
{
static_matrix<N,N,Real>S;
fill_identity(S);
if(determinant(covAB)<0)
S(N-1,N-1)=-1;
R=U*S*transpose(V);
c=trace(D*S)/varA;
t=meanB-c*R*meanA;
}else{
R=U*transpose(V);
c=trace(D)/varA;
t=meanB-c*R*meanA;
}
return true;
}
template<unsigned N,class Real,class Iter>
bool linear_rotation(
static_matrix<N,N,Real>&R,
const Iter&begin,const Iter&end)
{
iter_container<Iter>corrs(begin,end);
unsigned n=corrs.size();
static_matrix<N,N,Real>M={};
for(unsigned i=0;i<n;++i)
{
const static_matrix<N,1,Real>&A=corrs[i][0],&B=corrs[i][1];
M+=B*transpose(A);
}
M/=(float)n;
static_matrix<N,N,Real>U,D,V;
if(!SVD<true,true>(M,U,D,V))
return false;
static_matrix<N,N,Real>S;
fill_identity(S);
if(determinant(M)<0)
S(N-1,N-1)=-1;
R=U*S*transpose(V);
return true;
}
template<class Real,class Iter>
bool linear_similarity_transform(
similarity_transform<Real>&sim,
const Iter&begin,const Iter&end,
bool allow_reflections=true)
{
static_matrix<3,3,Real>R;
if(!linear_similarity_transform(R,sim.translation,sim.scale,begin,end,allow_reflections))
return false;
sim.qrot=make_quaternion(R,100);
sim.scale*=matrix_scale(sim.qrot.to_matrix(),R);
return true;
}
}
namespace heinlib
{
template<class MetricRecon>
typename enable_if<is_metric_recon<MetricRecon>,void>::type
normalize_scale(MetricRecon&rec1)
{
typedef typename MetricRecon::real_type Real;
static_matrix<3,1,Real>center={};
for(unsigned i=0;i<rec1.points.size();++i)
center+=realize(rec1.points[i]);
center/=rec1.points.size();
Real mean_radius=0;
for(unsigned i=0;i<rec1.points.size();++i)
mean_radius+=distance(realize(rec1.points[i]),center);
mean_radius/=rec1.points.size();
similarity_transform<Real>xform;
xform.scale=1/mean_radius;
align_reconstruction_struct(rec1,xform);
}
template<class Real>
bool find_metric_alignment(
similarity_transform<Real>&H,
const metric_recon<Real>&Test,
const metric_recon<Real>&True,
bool use_cameras_too=true)
{
assert(Test.points.size()==True.points.size());
if(Test.points.size()!=True.points.size())
{
return false;
}
std::vector<tuple<2,static_matrix<3,1,Real> > >corrs;
for(unsigned i=0;i<True.points.size();++i)
corrs.push_back(make_tuple(Test.points[i],True.points[i]));
if(use_cameras_too)
{
for(unsigned i=0;i<True.camera_views.size();++i)
corrs.push_back(make_tuple(Test.camera_views[i].get_position(),True.camera_views[i].get_position()));
}
if(!linear_similarity_transform(H,corrs.begin(),corrs.end()))
{
std::cout<<"Metric alignment failed!\n";
for(unsigned i=0;i<corrs.size();++i)
{
std::cout<<corrs[i][0]<<" == "<<corrs[i][1]<<"\n";
}
system("pause");
return false;
}
return true;
}
template<class Real,class MetricRecon,class MetricRecon2>
typename enable_if_c<(is_metric_recon<MetricRecon>::value&&is_metric_recon<MetricRecon2>::value),bool>::type
find_partial_metric_alignment(
similarity_transform<Real>&H,
const MetricRecon&Test,
const MetricRecon2&True,
bool use_cameras_too=true)
{
std::vector<tuple<2,static_matrix<3,1,Real> > >corrs;
for(unsigned i=0;i<True.pointIDs.size();++i)
{
const static_matrix<3,1,Real>*pt=Test.get_point(True.pointIDs[i]);
if(pt)
{
corrs.push_back(make_tuple(*pt,True.points[i]));
}
}
if(use_cameras_too)
{
std::cout<<"Using cameras\n";
for(unsigned i=0;i<True.camera_views.size();++i)
{
const camera_view<Real>*v=Test.get_view(True.viewIDs[i]);
if(v)
{
corrs.push_back(make_tuple(v->get_position(),True.camera_views[i].get_position()));
}
}
}else
std::cout<<"Not using cameras\n";
if(!linear_similarity_transform(H,corrs.begin(),corrs.end()))
{
std::cout<<"Metric alignment from "<<corrs.size()<<" corrs failed!\n";
for(unsigned i=0;i<corrs.size();++i)
{
std::cout<<corrs[i][0]<<" == "<<corrs[i][1]<<"\n";
}
system("pause");
return false;
}
return true;
}
template<int Loud,class Real,class MetricRecon,class MetricRecon2>
typename enable_if_c<(is_metric_recon<MetricRecon>::value&&is_metric_recon<MetricRecon2>::value),void>::type
structural_difference(Real&struct_err,Real&cam_err,const MetricRecon&Test,const MetricRecon2&True)
{
if(!(True.points.size()==Test.points.size())&&(True.camera_views.size()==Test.camera_views.size()))
{
std::cout<<"Error! Structural difference is only intended for comparing recons that are structurally isomorphic..\n";
}
similarity_transform<Real>sim;
find_metric_alignment(sim,Test,True);
MetricRecon2 Test2(Test);
align_reconstruction_struct(Test2,sim);
unsigned n=True.points.size();
struct_err=0;
for(unsigned i=0;i<n;++i)
struct_err+=distance_sq(realize(Test2.points[i]),realize(True.points[i]));
struct_err/=n;
cam_err=0;
for(unsigned i=0;i<True.camera_views.size();++i)
{
cam_err+=distance_sq(Test2.camera_views[i].get_position(),True.camera_views[i].get_position());
}
cam_err/=True.camera_views.size();
}
template<int Loud,class Real,class MetricRecon,class MetricRecon2>
typename enable_if_c<(is_metric_recon<MetricRecon>::value&&is_metric_recon<MetricRecon2>::value),void>::type
partial_structural_difference(Real&struct_err,Real&cam_err,const MetricRecon&Test,const MetricRecon2&True)
{
similarity_transform<Real>sim;
find_metric_alignment(sim,Test,True);
MetricRecon2 Test2(Test);
align_reconstruction_struct(Test2,sim);
struct_err=0;
unsigned struct_ct=0;
for(unsigned i=0;i<True.pointIDs.size();++i)
{
static_matrix<3,1,Real>*pt=Test2.get_point(True.pointIDs[i]);
if(pt)
{
Real dist=distance(*pt,True.points[i]);
struct_err+=dist;
++struct_ct;
}
}
struct_err/=struct_ct;
cam_err=0;
unsigned view_ct=0;
for(unsigned i=0;i<True.camera_views.size();++i)
{
camera_view<Real>*v=Test2.get_view(True.viewIDs[i]);
if(v)
{
cam_err+=distance(v->get_position(),True.camera_views[i].get_position());
++view_ct;
}
}
cam_err/=view_ct;
}
template<int Loud,class MetricRecon,class MetricRecon2>
typename enable_if_c<(is_metric_recon<MetricRecon>::value&&is_metric_recon<MetricRecon2>::value),void>::type
export_comparison(const char*filename,const MetricRecon&Test,const MetricRecon2&True,bool align_cams=false)
{
typedef typename MetricRecon::real_type Real;
similarity_transform<Real>sim;
find_metric_alignment(sim,Test,True,align_cams);
MetricRecon2 Test2(Test);
align_reconstruction_struct(Test2,sim);
export_compare_ply(filename,True,Test2);
}
}
namespace heinlib
{
template<class Real>
void export_compare_ply(
const char*filename,
const metric_recon<Real>&True,
const metric_recon<Real>&Test,
bool exportCams=true)
{
std::cout<<"Saving: "<<filename<<"\n";
similarity_transform<Real>sim;
if(!find_partial_metric_alignment(sim,Test,True))
{
std::cout<<"Error: could not find metric alignment.\n";
}
std::cout<<"sim: "<<sim<<"\n";
metric_recon<Real>AlignTest(Test);
align_reconstruction_struct(AlignTest,sim);
unsigned totalPts=True.points.size()+AlignTest.points.size();
unsigned totalFaces=0;
if(exportCams)
{
totalPts+=5*(True.camera_views.size()+AlignTest.camera_views.size());
totalFaces+=5*(True.camera_views.size()+AlignTest.camera_views.size());
}
std::ofstream file(filename);
file<<"ply\n\
format ascii 1.0\n\
element vertex "<<totalPts<<"\n\
property float x\n\
property float y\n\
property float z\n\
property uchar red \n\
property uchar green\n\
property uchar blue\n\
element face "<<totalFaces<<"\n\
property list uchar int vertex_index\n\
end_header \n";
for(unsigned i=0;i<True.points.size();++i)
{
const static_matrix<3,1,Real>&X=True.points[i];
file<<X.x()<<" "<<X.y()<<" "<<X.z()<<" 0 255 0\n";
}
for(unsigned i=0;i<AlignTest.points.size();++i)
{
const static_matrix<3,1,Real>&X=AlignTest.points[i];
file<<X.x()<<" "<<X.y()<<" "<<X.z()<<" 255 0 0\n";
}
if(exportCams)
{
for(unsigned j=0;j<True.camera_views.size();++j)
{
const camera_view<Real>&view=True.camera_views[j];
const rigid_motion<Real>&pose=view.pose;
static_matrix<3,1,Real>pos,right,down,forward;
pose.get_basis(pos,right,down,forward);
Real f=view.focal_length(),Sw=view.intrinsics->Sw,Sh=view.intrinsics->Sh;
static_matrix<3,1,Real>pt1=pos+(f*forward+0.5*Sw*right-0.5*Sh*down);
static_matrix<3,1,Real>pt2=pos+(f*forward+0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt3=pos+(f*forward-0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt4=pos+(f*forward-0.5*Sw*right-0.5*Sh*down);
file<<pos.x()<<" "<<pos.y()<<" "<<pos.z()<<" 0 255 0\n";
file<<pt1.x()<<" "<<pt1.y()<<" "<<pt1.z()<<" 0 255 0\n";
file<<pt2.x()<<" "<<pt2.y()<<" "<<pt2.z()<<" 0 255 0\n";
file<<pt3.x()<<" "<<pt3.y()<<" "<<pt3.z()<<" 0 255 0\n";
file<<pt4.x()<<" "<<pt4.y()<<" "<<pt4.z()<<" 0 255 0\n";
}
for(unsigned j=0;j<AlignTest.camera_views.size();++j)
{
const camera_view<Real>&view=AlignTest.camera_views[j];
const rigid_motion<Real>&pose=view.pose;
static_matrix<3,1,Real>pos,right,down,forward;
pose.get_basis(pos,right,down,forward);
Real f=view.focal_length(),Sw=view.intrinsics->Sw,Sh=view.intrinsics->Sh;
static_matrix<3,1,Real>pt1=pos+(f*forward+0.5*Sw*right-0.5*Sh*down);
static_matrix<3,1,Real>pt2=pos+(f*forward+0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt3=pos+(f*forward-0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt4=pos+(f*forward-0.5*Sw*right-0.5*Sh*down);
file<<pos.x()<<" "<<pos.y()<<" "<<pos.z()<<" 255 0 0\n";
file<<pt1.x()<<" "<<pt1.y()<<" "<<pt1.z()<<" 255 0 0\n";
file<<pt2.x()<<" "<<pt2.y()<<" "<<pt2.z()<<" 255 0 0\n";
file<<pt3.x()<<" "<<pt3.y()<<" "<<pt3.z()<<" 255 0 0\n";
file<<pt4.x()<<" "<<pt4.y()<<" "<<pt4.z()<<" 255 0 0\n";
}
unsigned si=True.points.size()+AlignTest.points.size();
for(unsigned j=0;j<True.camera_views.size();++j)
{
file<<"3 "<<si<<" "<<si+1<<" "<<si+2<<"\n";
file<<"3 "<<si<<" "<<si+2<<" "<<si+3<<"\n";
file<<"3 "<<si<<" "<<si+3<<" "<<si+4<<"\n";
file<<"3 "<<si<<" "<<si+4<<" "<<si+1<<"\n";
file<<"4 "<<si+1<<" "<<si+2<<" "<<si+3<<" "<<si+4<<"\n";
si+=5;
}
for(unsigned j=0;j<AlignTest.camera_views.size();++j)
{
file<<"3 "<<si<<" "<<si+1<<" "<<si+2<<"\n";
file<<"3 "<<si<<" "<<si+2<<" "<<si+3<<"\n";
file<<"3 "<<si<<" "<<si+3<<" "<<si+4<<"\n";
file<<"3 "<<si<<" "<<si+4<<" "<<si+1<<"\n";
file<<"4 "<<si+1<<" "<<si+2<<" "<<si+3<<" "<<si+4<<"\n";
si+=5;
}
}
file.close();
}
template<class Real>
void export_compare_ply(
const char*filename,
const metric_recon<Real>&True,
const metric_recon<Real>&Test,
const metric_recon<Real>&Test2,
bool exportCams=true)
{
std::cout<<"Saving: "<<filename<<"\n";
if(True.points.size()!=Test.points.size()||
True.pmats.size()!=Test.pmats.size()||
True.points.size()!=Test2.points.size()||
True.pmats.size()!=Test2.pmats.size())
{
std::cout<<"export_compare_ply : reconstructions are not compatible!\n";
return;
}
similarity_transform<Real>sim;
find_metric_alignment(sim,Test,True);
metric_recon<Real>AlignTest(Test);
align_reconstruction_struct(AlignTest,sim);
find_metric_alignment(sim,Test2,True);
metric_recon<Real>AlignTest2(Test2);
align_reconstruction_struct(AlignTest2,sim);
unsigned totalPts=True.points.size()+AlignTest.points.size()+AlignTest2.points.size();
unsigned totalFaces=0;
if(exportCams)
{
unsigned pm=True.pmats.size()+AlignTest.pmats.size()+AlignTest2.pmats.size();
totalPts+=5*pm;
totalFaces+=5*pm;
}
std::ofstream file(filename);
file<<"ply\n\
format ascii 1.0\n\
element vertex "<<totalPts<<"\n\
property float x\n\
property float y\n\
property float z\n\
property uchar red \n\
property uchar green\n\
property uchar blue\n\
element face "<<totalFaces<<"\n\
property list uchar int vertex_index\n\
end_header \n";
for(unsigned i=0;i<True.points.size();++i)
{
static_matrix<3,1,Real>X=realize(True.points[i]);
file<<X.x()<<" "<<X.y()<<" "<<X.z()<<" 0 255 0\n";
}
for(unsigned i=0;i<AlignTest.points.size();++i)
{
static_matrix<3,1,Real>X=realize(AlignTest.points[i]);
file<<X.x()<<" "<<X.y()<<" "<<X.z()<<" 255 0 0\n";
}
for(unsigned i=0;i<AlignTest2.points.size();++i)
{
static_matrix<3,1,Real>X=realize(AlignTest2.points[i]);
file<<X.x()<<" "<<X.y()<<" "<<X.z()<<" 0 0 255\n";
}
if(exportCams)
{
for(unsigned j=0;j<True.camera_views.size();++j)
{
const camera_view<Real>&view=True.camera_views[j];
const rigid_motion<Real>&pose=view.pose;
static_matrix<3,1,Real>pos,right,down,forward;
pose.get_basis(pos,right,down,forward);
Real f=view.focal_length(),Sw=view.intrinsics->Sw,Sh=view.intrinsics->Sh;
static_matrix<3,1,Real>pt1=pos+(f*forward+0.5*Sw*right-0.5*Sh*down);
static_matrix<3,1,Real>pt2=pos+(f*forward+0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt3=pos+(f*forward-0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt4=pos+(f*forward-0.5*Sw*right-0.5*Sh*down);
file<<pos.x()<<" "<<pos.y()<<" "<<pos.z()<<" 0 255 0\n";
file<<pt1.x()<<" "<<pt1.y()<<" "<<pt1.z()<<" 0 255 0\n";
file<<pt2.x()<<" "<<pt2.y()<<" "<<pt2.z()<<" 0 255 0\n";
file<<pt3.x()<<" "<<pt3.y()<<" "<<pt3.z()<<" 0 255 0\n";
file<<pt4.x()<<" "<<pt4.y()<<" "<<pt4.z()<<" 0 255 0\n";
}
for(unsigned j=0;j<AlignTest.camera_views.size();++j)
{
const camera_view<Real>&view=AlignTest.camera_views[j];
const rigid_motion<Real>&pose=view.pose;
static_matrix<3,1,Real>pos,right,down,forward;
pose.get_basis(pos,right,down,forward);
Real f=view.focal_length(),Sw=view.intrinsics->Sw,Sh=view.intrinsics->Sh;
static_matrix<3,1,Real>pt1=pos+(f*forward+0.5*Sw*right-0.5*Sh*down);
static_matrix<3,1,Real>pt2=pos+(f*forward+0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt3=pos+(f*forward-0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt4=pos+(f*forward-0.5*Sw*right-0.5*Sh*down);
file<<pos.x()<<" "<<pos.y()<<" "<<pos.z()<<" 255 0 0\n";
file<<pt1.x()<<" "<<pt1.y()<<" "<<pt1.z()<<" 255 0 0\n";
file<<pt2.x()<<" "<<pt2.y()<<" "<<pt2.z()<<" 255 0 0\n";
file<<pt3.x()<<" "<<pt3.y()<<" "<<pt3.z()<<" 255 0 0\n";
file<<pt4.x()<<" "<<pt4.y()<<" "<<pt4.z()<<" 255 0 0\n";
}
for(unsigned j=0;j<AlignTest2.camera_views.size();++j)
{
const camera_view<Real>&view=AlignTest2.camera_views[j];
const rigid_motion<Real>&pose=view.pose;
static_matrix<3,1,Real>pos,right,down,forward;
pose.get_basis(pos,right,down,forward);
Real f=view.focal_length(),Sw=view.intrinsics->Sw,Sh=view.intrinsics->Sh;
static_matrix<3,1,Real>pt1=pos+(f*forward+0.5*Sw*right-0.5*Sh*down);
static_matrix<3,1,Real>pt2=pos+(f*forward+0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt3=pos+(f*forward-0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt4=pos+(f*forward-0.5*Sw*right-0.5*Sh*down);
file<<pos.x()<<" "<<pos.y()<<" "<<pos.z()<<" 0 0 255\n";
file<<pt1.x()<<" "<<pt1.y()<<" "<<pt1.z()<<" 0 0 255\n";
file<<pt2.x()<<" "<<pt2.y()<<" "<<pt2.z()<<" 0 0 255\n";
file<<pt3.x()<<" "<<pt3.y()<<" "<<pt3.z()<<" 0 0 255\n";
file<<pt4.x()<<" "<<pt4.y()<<" "<<pt4.z()<<" 0 0 255\n";
}
unsigned si=True.points.size()+AlignTest.points.size()+AlignTest2.points.size();
for(unsigned j=0;j<True.camera_views.size();++j)
{
file<<"3 "<<si<<" "<<si+1<<" "<<si+2<<"\n";
file<<"3 "<<si<<" "<<si+2<<" "<<si+3<<"\n";
file<<"3 "<<si<<" "<<si+3<<" "<<si+4<<"\n";
file<<"3 "<<si<<" "<<si+4<<" "<<si+1<<"\n";
file<<"4 "<<si+1<<" "<<si+2<<" "<<si+3<<" "<<si+4<<"\n";
si+=5;
}
for(unsigned j=0;j<AlignTest.camera_views.size();++j)
{
file<<"3 "<<si<<" "<<si+1<<" "<<si+2<<"\n";
file<<"3 "<<si<<" "<<si+2<<" "<<si+3<<"\n";
file<<"3 "<<si<<" "<<si+3<<" "<<si+4<<"\n";
file<<"3 "<<si<<" "<<si+4<<" "<<si+1<<"\n";
file<<"4 "<<si+1<<" "<<si+2<<" "<<si+3<<" "<<si+4<<"\n";
si+=5;
}
for(unsigned j=0;j<AlignTest2.camera_views.size();++j)
{
file<<"3 "<<si<<" "<<si+1<<" "<<si+2<<"\n";
file<<"3 "<<si<<" "<<si+2<<" "<<si+3<<"\n";
file<<"3 "<<si<<" "<<si+3<<" "<<si+4<<"\n";
file<<"3 "<<si<<" "<<si+4<<" "<<si+1<<"\n";
file<<"4 "<<si+1<<" "<<si+2<<" "<<si+3<<" "<<si+4<<"\n";
si+=5;
}
}
file.close();
}
template<class Real>
void export_ply(const char*filename,const metric_recon<Real>&recon,bool exportCams=true)
{
std::cout<<"Saving: "<<filename<<"\n";
unsigned totalPts=recon.points.size();
unsigned totalFaces=0;
if(exportCams)
{
totalPts+=5*recon.camera_views.size();
totalFaces+=5*recon.camera_views.size();
}
std::ofstream file(filename);
file<<"ply\n\
format ascii 1.0\n\
element vertex "<<totalPts<<"\n\
property float x\n\
property float y\n\
property float z\n\
element face "<<totalFaces<<"\n\
property list uchar int vertex_index\n\
end_header \n";
for(unsigned i=0;i<recon.points.size();++i)
{
static_matrix<3,1,Real>X=recon.points[i];
file<<X.x()<<" "<<X.y()<<" "<<X.z()<<"\n";
}
if(exportCams)
{
for(unsigned j=0;j<recon.camera_views.size();++j)
{
const camera_view<Real>&view=recon.camera_views[j];
const rigid_motion<Real>&pose=view.pose;
static_matrix<3,1,Real>pos,right,down,forward;
pose.get_basis(pos,right,down,forward);
Real f=view.focal_length();
Real Sw=view.intrinsics->Sw,Sh=view.intrinsics->Sh;
static_matrix<3,1,Real>pt1=pos+(f*forward+0.5*Sw*right-0.5*Sh*down);
static_matrix<3,1,Real>pt2=pos+(f*forward+0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt3=pos+(f*forward-0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt4=pos+(f*forward-0.5*Sw*right-0.5*Sh*down);
file<<pos.x()<<" "<<pos.y()<<" "<<pos.z()<<"\n";
file<<pt1.x()<<" "<<pt1.y()<<" "<<pt1.z()<<"\n";
file<<pt2.x()<<" "<<pt2.y()<<" "<<pt2.z()<<"\n";
file<<pt3.x()<<" "<<pt3.y()<<" "<<pt3.z()<<"\n";
file<<pt4.x()<<" "<<pt4.y()<<" "<<pt4.z()<<"\n";
}
unsigned si=recon.points.size();
for(unsigned j=0;j<recon.camera_views.size();++j)
{
file<<"3 "<<si<<" "<<si+1<<" "<<si+2<<"\n";
file<<"3 "<<si<<" "<<si+2<<" "<<si+3<<"\n";
file<<"3 "<<si<<" "<<si+3<<" "<<si+4<<"\n";
file<<"3 "<<si<<" "<<si+4<<" "<<si+1<<"\n";
file<<"4 "<<si+1<<" "<<si+2<<" "<<si+3<<" "<<si+4<<"\n";
si+=5;
}
}
file.close();
}
template<class Real,class Keypoint>
void export_ply_colored(const char*filename,
const metric_recon<Real>&recon,
const feature_observations<Keypoint>&observations,
bool exportCams=true)
{
std::cout<<"Saving: "<<filename<<"\n";
if(recon.points.empty())return;
unsigned totalPts=recon.points.size();
unsigned totalFaces=0;
if(exportCams)
{
totalPts+=5*recon.camera_views.size();
totalFaces+=5*recon.camera_views.size();
}
std::ofstream file(filename);
file<<"ply\n\
format ascii 1.0\n\
element vertex "<<totalPts<<"\n\
property float x\n\
property float y\n\
property float z\n\
property uchar red \n\
property uchar green\n\
property uchar blue\n\
element face "<<totalFaces<<"\n\
property list uchar int vertex_index\n\
end_header \n";
for(unsigned i=0;i<recon.points.size();++i)
{
static_matrix<3,1,Real>X=realize(recon.points[i]);
file<<X.x()<<" "<<X.y()<<" "<<X.z()<<" ";
unsigned count=observations.count_observations_of_point(recon.pointIDs[i]);
if(count==2)
file<<"255 0 0\n";
else if(count==3)
file<<"255 108 0\n";
else if(count==4)
file<<"255 216 0\n";
else if(count==5)
file<<"66 255 0\n";
else if(count==6)
file<<"0 192 255\n";
else file<<"12 0 255\n";
}
if(exportCams)
{
for(unsigned j=0;j<recon.camera_views.size();++j)
{
const camera_view<Real>&view=recon.camera_views[j];
const rigid_motion<Real>&pose=view.pose;
static_matrix<3,1,Real>pos,right,down,forward;
pose.get_basis(pos,right,down,forward);
Real f=view.focal_length();
Real Sw=view.intrinsics->Sw,Sh=view.intrinsics->Sh;
static_matrix<3,1,Real>pt1=pos+(f*forward+0.5*Sw*right-0.5*Sh*down);
static_matrix<3,1,Real>pt2=pos+(f*forward+0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt3=pos+(f*forward-0.5*Sw*right+0.5*Sh*down);
static_matrix<3,1,Real>pt4=pos+(f*forward-0.5*Sw*right-0.5*Sh*down);
file<<pos.x()<<" "<<pos.y()<<" "<<pos.z()<<" 255 255 255\n";
file<<pt1.x()<<" "<<pt1.y()<<" "<<pt1.z()<<" 255 255 255\n";
file<<pt2.x()<<" "<<pt2.y()<<" "<<pt2.z()<<" 255 255 255\n";
file<<pt3.x()<<" "<<pt3.y()<<" "<<pt3.z()<<" 255 255 255\n";
file<<pt4.x()<<" "<<pt4.y()<<" "<<pt4.z()<<" 255 255 255\n";
}
unsigned si=recon.points.size();
for(unsigned j=0;j<recon.camera_views.size();++j)
{
file<<"3 "<<si<<" "<<si+1<<" "<<si+2<<"\n";
file<<"3 "<<si<<" "<<si+2<<" "<<si+3<<"\n";
file<<"3 "<<si<<" "<<si+3<<" "<<si+4<<"\n";
file<<"3 "<<si<<" "<<si+4<<" "<<si+1<<"\n";
file<<"4 "<<si+1<<" "<<si+2<<" "<<si+3<<" "<<si+4<<"\n";
si+=5;
}
}
file.close();
}
template<class ProjRecon>
typename enable_if<is_proj_recon<ProjRecon>,void>::type
export_ply(const char*filename,const ProjRecon&recon,bool exportCams=true)
{
std::cout<<"Saving: "<<filename<<"\n";
typedef typename ProjRecon::real_type Real;
if(recon.points.empty())return;
int totalPts=recon.points.size();
if(exportCams)totalPts+=recon.pmats.size();
std::ofstream file(filename);
file<<"ply\n\
format ascii 1.0\n\
element vertex "<<totalPts<<"\n\
property float x\n\
property float y\n\
property float z\n\
element face 0\n\
property list uchar int vertex_index\n\
end_header \n";
for(unsigned i=0;i<recon.points.size();++i)
{
static_matrix<3,1,Real>X=realize(recon.points[i]);
file<<X.x()<<" "<<X.y()<<" "<<X.z()<<"\n";
}
if(exportCams)
{
for(unsigned i=0;i<recon.pmats.size();++i)
{
const static_matrix<3,4,Real>&P=recon.pmats[i];
static_matrix<4,1,Real>C;
null_space_3x4(P,C);
C=homogeneous_divide(C);
file<<C.x()<<" "<<C.y()<<" "<<C.z()<<"\n";
}
}
file.close();
}
template<int Loud,class Recon>
typename enable_if<is_recon<Recon>,void>::type
export_bounding_box_ply(const char*filename,const Recon&recon)
{
std::cout<<"Saving: "<<filename<<"\n";
typedef typename Recon::real_type Real;
static_matrix<4,1,Real>pt_min,pt_max;
pt_min=recon.points[0].second;
pt_max=recon.points[0].second;
for(unsigned i=1;i<recon.points.size();++i)
{
for(unsigned j=0;j<3;++j)
{
if(recon.points[i].second[j]<pt_min[j])
pt_min[j]=recon.points[i].second[j];
if(recon.points[i].second[j]>pt_max[j])
pt_max[j]=recon.points[i].second[j];
}
}
std::ofstream file(filename);
file<<"ply\n\
format ascii 1.0\n\
element vertex 8\n\
property float x\n\
property float y\n\
property float z\n\
element face 6\n\
property list uchar int vertex_index\n\
end_header \n";
file<<pt_min.x()<<" "<<pt_min.y()<<" "<<pt_min.z()<<"\n";
file<<pt_min.x()<<" "<<pt_max.y()<<" "<<pt_min.z()<<"\n";
file<<pt_max.x()<<" "<<pt_max.y()<<" "<<pt_min.z()<<"\n";
file<<pt_max.x()<<" "<<pt_min.y()<<" "<<pt_min.z()<<"\n";
file<<pt_min.x()<<" "<<pt_min.y()<<" "<<pt_max.z()<<"\n";
file<<pt_min.x()<<" "<<pt_max.y()<<" "<<pt_max.z()<<"\n";
file<<pt_max.x()<<" "<<pt_max.y()<<" "<<pt_max.z()<<"\n";
file<<pt_max.x()<<" "<<pt_min.y()<<" "<<pt_max.z()<<"\n";
file<<"4 0 1 2 3\n";
file<<"4 4 5 6 7\n";
file<<"4 0 3 7 4\n";
file<<"4 3 2 6 7\n";
file<<"4 0 1 5 4\n";
file<<"4 1 2 6 5\n";
file.close();
}
}
